// Code generated by go-swagger; DO NOT EDIT.

package application

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewApplicationCollectionGetParams creates a new ApplicationCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewApplicationCollectionGetParams() *ApplicationCollectionGetParams {
	return &ApplicationCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewApplicationCollectionGetParamsWithTimeout creates a new ApplicationCollectionGetParams object
// with the ability to set a timeout on a request.
func NewApplicationCollectionGetParamsWithTimeout(timeout time.Duration) *ApplicationCollectionGetParams {
	return &ApplicationCollectionGetParams{
		timeout: timeout,
	}
}

// NewApplicationCollectionGetParamsWithContext creates a new ApplicationCollectionGetParams object
// with the ability to set a context for a request.
func NewApplicationCollectionGetParamsWithContext(ctx context.Context) *ApplicationCollectionGetParams {
	return &ApplicationCollectionGetParams{
		Context: ctx,
	}
}

// NewApplicationCollectionGetParamsWithHTTPClient creates a new ApplicationCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewApplicationCollectionGetParamsWithHTTPClient(client *http.Client) *ApplicationCollectionGetParams {
	return &ApplicationCollectionGetParams{
		HTTPClient: client,
	}
}

/*
ApplicationCollectionGetParams contains all the parameters to send to the API endpoint

	for the application collection get operation.

	Typically these are written to a http.Request.
*/
type ApplicationCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* Generation.

	   Filter by generation
	*/
	GenerationQueryParameter *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ProtectionGranularity.

	   Filter by protection granularity
	*/
	ProtectionGranularityQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* RpoComponentsName.

	   Filter by rpo.components.name
	*/
	RpoComponentsNameQueryParameter *string

	/* RpoComponentsRpoLocalDescription.

	   Filter by rpo.components.rpo.local.description
	*/
	RpoComponentsRpoLocalDescriptionQueryParameter *string

	/* RpoComponentsRpoLocalName.

	   Filter by rpo.components.rpo.local.name
	*/
	RpoComponentsRpoLocalNameQueryParameter *string

	/* RpoComponentsRpoRemoteDescription.

	   Filter by rpo.components.rpo.remote.description
	*/
	RpoComponentsRpoRemoteDescriptionQueryParameter *string

	/* RpoComponentsRpoRemoteName.

	   Filter by rpo.components.rpo.remote.name
	*/
	RpoComponentsRpoRemoteNameQueryParameter *string

	/* RpoComponentsUUID.

	   Filter by rpo.components.uuid
	*/
	RpoComponentsUUIDQueryParameter *string

	/* RpoIsSupported.

	   Filter by rpo.is_supported
	*/
	RpoIsSupportedQueryParameter *string

	/* RpoLocalDescription.

	   Filter by rpo.local.description
	*/
	RpoLocalDescriptionQueryParameter *string

	/* RpoLocalName.

	   Filter by rpo.local.name
	*/
	RpoLocalNameQueryParameter *string

	/* RpoRemoteDescription.

	   Filter by rpo.remote.description
	*/
	RpoRemoteDescriptionQueryParameter *string

	/* RpoRemoteName.

	   Filter by rpo.remote.name
	*/
	RpoRemoteNameQueryParameter *string

	/* SmartContainer.

	   Filter by smart_container
	*/
	SmartContainerQueryParameter *string

	/* State.

	   Filter by state
	*/
	StateQueryParameter *string

	/* StatisticsComponentsIopsPerTb.

	   Filter by statistics.components.iops.per_tb
	*/
	StatisticsComponentsIopsPerTbQueryParameter *string

	/* StatisticsComponentsIopsTotal.

	   Filter by statistics.components.iops.total
	*/
	StatisticsComponentsIopsTotalQueryParameter *string

	/* StatisticsComponentsLatencyAverage.

	   Filter by statistics.components.latency.average
	*/
	StatisticsComponentsLatencyAverageQueryParameter *string

	/* StatisticsComponentsLatencyRaw.

	   Filter by statistics.components.latency.raw
	*/
	StatisticsComponentsLatencyRawQueryParameter *string

	/* StatisticsComponentsName.

	   Filter by statistics.components.name
	*/
	StatisticsComponentsNameQueryParameter *string

	/* StatisticsComponentsSharedStoragePool.

	   Filter by statistics.components.shared_storage_pool
	*/
	StatisticsComponentsSharedStoragePoolQueryParameter *string

	/* StatisticsComponentsSnapshotReserve.

	   Filter by statistics.components.snapshot.reserve
	*/
	StatisticsComponentsSnapshotReserveQueryParameter *string

	/* StatisticsComponentsSnapshotUsed.

	   Filter by statistics.components.snapshot.used
	*/
	StatisticsComponentsSnapshotUsedQueryParameter *string

	/* StatisticsComponentsSpaceAvailable.

	   Filter by statistics.components.space.available
	*/
	StatisticsComponentsSpaceAvailableQueryParameter *string

	/* StatisticsComponentsSpaceLogicalUsed.

	   Filter by statistics.components.space.logical_used
	*/
	StatisticsComponentsSpaceLogicalUsedQueryParameter *string

	/* StatisticsComponentsSpaceProvisioned.

	   Filter by statistics.components.space.provisioned
	*/
	StatisticsComponentsSpaceProvisionedQueryParameter *string

	/* StatisticsComponentsSpaceReservedUnused.

	   Filter by statistics.components.space.reserved_unused
	*/
	StatisticsComponentsSpaceReservedUnusedQueryParameter *string

	/* StatisticsComponentsSpaceSavings.

	   Filter by statistics.components.space.savings
	*/
	StatisticsComponentsSpaceSavingsQueryParameter *string

	/* StatisticsComponentsSpaceUsed.

	   Filter by statistics.components.space.used
	*/
	StatisticsComponentsSpaceUsedQueryParameter *string

	/* StatisticsComponentsSpaceUsedExcludingReserves.

	   Filter by statistics.components.space.used_excluding_reserves
	*/
	StatisticsComponentsSpaceUsedExcludingReservesQueryParameter *string

	/* StatisticsComponentsSpaceUsedPercent.

	   Filter by statistics.components.space.used_percent
	*/
	StatisticsComponentsSpaceUsedPercentQueryParameter *string

	/* StatisticsComponentsStatisticsIncomplete.

	   Filter by statistics.components.statistics_incomplete
	*/
	StatisticsComponentsStatisticsIncompleteQueryParameter *string

	/* StatisticsComponentsStorageServiceName.

	   Filter by statistics.components.storage_service.name
	*/
	StatisticsComponentsStorageServiceNameQueryParameter *string

	/* StatisticsComponentsUUID.

	   Filter by statistics.components.uuid
	*/
	StatisticsComponentsUUIDQueryParameter *string

	/* StatisticsIopsPerTb.

	   Filter by statistics.iops.per_tb
	*/
	StatisticsIopsPerTbQueryParameter *string

	/* StatisticsIopsTotal.

	   Filter by statistics.iops.total
	*/
	StatisticsIopsTotalQueryParameter *string

	/* StatisticsLatencyAverage.

	   Filter by statistics.latency.average
	*/
	StatisticsLatencyAverageQueryParameter *string

	/* StatisticsLatencyRaw.

	   Filter by statistics.latency.raw
	*/
	StatisticsLatencyRawQueryParameter *string

	/* StatisticsSharedStoragePool.

	   Filter by statistics.shared_storage_pool
	*/
	StatisticsSharedStoragePoolQueryParameter *string

	/* StatisticsSnapshotReserve.

	   Filter by statistics.snapshot.reserve
	*/
	StatisticsSnapshotReserveQueryParameter *string

	/* StatisticsSnapshotUsed.

	   Filter by statistics.snapshot.used
	*/
	StatisticsSnapshotUsedQueryParameter *string

	/* StatisticsSpaceAvailable.

	   Filter by statistics.space.available
	*/
	StatisticsSpaceAvailableQueryParameter *string

	/* StatisticsSpaceLogicalUsed.

	   Filter by statistics.space.logical_used
	*/
	StatisticsSpaceLogicalUsedQueryParameter *string

	/* StatisticsSpaceProvisioned.

	   Filter by statistics.space.provisioned
	*/
	StatisticsSpaceProvisionedQueryParameter *string

	/* StatisticsSpaceReservedUnused.

	   Filter by statistics.space.reserved_unused
	*/
	StatisticsSpaceReservedUnusedQueryParameter *string

	/* StatisticsSpaceSavings.

	   Filter by statistics.space.savings
	*/
	StatisticsSpaceSavingsQueryParameter *string

	/* StatisticsSpaceUsed.

	   Filter by statistics.space.used
	*/
	StatisticsSpaceUsedQueryParameter *string

	/* StatisticsSpaceUsedExcludingReserves.

	   Filter by statistics.space.used_excluding_reserves
	*/
	StatisticsSpaceUsedExcludingReservesQueryParameter *string

	/* StatisticsSpaceUsedPercent.

	   Filter by statistics.space.used_percent
	*/
	StatisticsSpaceUsedPercentQueryParameter *string

	/* StatisticsStatisticsIncomplete.

	   Filter by statistics.statistics_incomplete
	*/
	StatisticsStatisticsIncompleteQueryParameter *string

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	/* TemplateName.

	   Filter by template.name
	*/
	TemplateNameQueryParameter *string

	/* TemplateProtocol.

	   Filter by template.protocol
	*/
	TemplateProtocolQueryParameter *string

	/* TemplateVersion.

	   Filter by template.version
	*/
	TemplateVersionQueryParameter *string

	/* UUID.

	   Filter by UUID
	*/
	UUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the application collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ApplicationCollectionGetParams) WithDefaults() *ApplicationCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the application collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ApplicationCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := ApplicationCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the application collection get params
func (o *ApplicationCollectionGetParams) WithTimeout(timeout time.Duration) *ApplicationCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the application collection get params
func (o *ApplicationCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the application collection get params
func (o *ApplicationCollectionGetParams) WithContext(ctx context.Context) *ApplicationCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the application collection get params
func (o *ApplicationCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the application collection get params
func (o *ApplicationCollectionGetParams) WithHTTPClient(client *http.Client) *ApplicationCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the application collection get params
func (o *ApplicationCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the application collection get params
func (o *ApplicationCollectionGetParams) WithFieldsQueryParameter(fields []string) *ApplicationCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the application collection get params
func (o *ApplicationCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithGenerationQueryParameter adds the generation to the application collection get params
func (o *ApplicationCollectionGetParams) WithGenerationQueryParameter(generation *string) *ApplicationCollectionGetParams {
	o.SetGenerationQueryParameter(generation)
	return o
}

// SetGenerationQueryParameter adds the generation to the application collection get params
func (o *ApplicationCollectionGetParams) SetGenerationQueryParameter(generation *string) {
	o.GenerationQueryParameter = generation
}

// WithMaxRecordsQueryParameter adds the maxRecords to the application collection get params
func (o *ApplicationCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *ApplicationCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the application collection get params
func (o *ApplicationCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the application collection get params
func (o *ApplicationCollectionGetParams) WithNameQueryParameter(name *string) *ApplicationCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the application collection get params
func (o *ApplicationCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the application collection get params
func (o *ApplicationCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *ApplicationCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the application collection get params
func (o *ApplicationCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithProtectionGranularityQueryParameter adds the protectionGranularity to the application collection get params
func (o *ApplicationCollectionGetParams) WithProtectionGranularityQueryParameter(protectionGranularity *string) *ApplicationCollectionGetParams {
	o.SetProtectionGranularityQueryParameter(protectionGranularity)
	return o
}

// SetProtectionGranularityQueryParameter adds the protectionGranularity to the application collection get params
func (o *ApplicationCollectionGetParams) SetProtectionGranularityQueryParameter(protectionGranularity *string) {
	o.ProtectionGranularityQueryParameter = protectionGranularity
}

// WithReturnRecordsQueryParameter adds the returnRecords to the application collection get params
func (o *ApplicationCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *ApplicationCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the application collection get params
func (o *ApplicationCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the application collection get params
func (o *ApplicationCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *ApplicationCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the application collection get params
func (o *ApplicationCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithRpoComponentsNameQueryParameter adds the rpoComponentsName to the application collection get params
func (o *ApplicationCollectionGetParams) WithRpoComponentsNameQueryParameter(rpoComponentsName *string) *ApplicationCollectionGetParams {
	o.SetRpoComponentsNameQueryParameter(rpoComponentsName)
	return o
}

// SetRpoComponentsNameQueryParameter adds the rpoComponentsName to the application collection get params
func (o *ApplicationCollectionGetParams) SetRpoComponentsNameQueryParameter(rpoComponentsName *string) {
	o.RpoComponentsNameQueryParameter = rpoComponentsName
}

// WithRpoComponentsRpoLocalDescriptionQueryParameter adds the rpoComponentsRpoLocalDescription to the application collection get params
func (o *ApplicationCollectionGetParams) WithRpoComponentsRpoLocalDescriptionQueryParameter(rpoComponentsRpoLocalDescription *string) *ApplicationCollectionGetParams {
	o.SetRpoComponentsRpoLocalDescriptionQueryParameter(rpoComponentsRpoLocalDescription)
	return o
}

// SetRpoComponentsRpoLocalDescriptionQueryParameter adds the rpoComponentsRpoLocalDescription to the application collection get params
func (o *ApplicationCollectionGetParams) SetRpoComponentsRpoLocalDescriptionQueryParameter(rpoComponentsRpoLocalDescription *string) {
	o.RpoComponentsRpoLocalDescriptionQueryParameter = rpoComponentsRpoLocalDescription
}

// WithRpoComponentsRpoLocalNameQueryParameter adds the rpoComponentsRpoLocalName to the application collection get params
func (o *ApplicationCollectionGetParams) WithRpoComponentsRpoLocalNameQueryParameter(rpoComponentsRpoLocalName *string) *ApplicationCollectionGetParams {
	o.SetRpoComponentsRpoLocalNameQueryParameter(rpoComponentsRpoLocalName)
	return o
}

// SetRpoComponentsRpoLocalNameQueryParameter adds the rpoComponentsRpoLocalName to the application collection get params
func (o *ApplicationCollectionGetParams) SetRpoComponentsRpoLocalNameQueryParameter(rpoComponentsRpoLocalName *string) {
	o.RpoComponentsRpoLocalNameQueryParameter = rpoComponentsRpoLocalName
}

// WithRpoComponentsRpoRemoteDescriptionQueryParameter adds the rpoComponentsRpoRemoteDescription to the application collection get params
func (o *ApplicationCollectionGetParams) WithRpoComponentsRpoRemoteDescriptionQueryParameter(rpoComponentsRpoRemoteDescription *string) *ApplicationCollectionGetParams {
	o.SetRpoComponentsRpoRemoteDescriptionQueryParameter(rpoComponentsRpoRemoteDescription)
	return o
}

// SetRpoComponentsRpoRemoteDescriptionQueryParameter adds the rpoComponentsRpoRemoteDescription to the application collection get params
func (o *ApplicationCollectionGetParams) SetRpoComponentsRpoRemoteDescriptionQueryParameter(rpoComponentsRpoRemoteDescription *string) {
	o.RpoComponentsRpoRemoteDescriptionQueryParameter = rpoComponentsRpoRemoteDescription
}

// WithRpoComponentsRpoRemoteNameQueryParameter adds the rpoComponentsRpoRemoteName to the application collection get params
func (o *ApplicationCollectionGetParams) WithRpoComponentsRpoRemoteNameQueryParameter(rpoComponentsRpoRemoteName *string) *ApplicationCollectionGetParams {
	o.SetRpoComponentsRpoRemoteNameQueryParameter(rpoComponentsRpoRemoteName)
	return o
}

// SetRpoComponentsRpoRemoteNameQueryParameter adds the rpoComponentsRpoRemoteName to the application collection get params
func (o *ApplicationCollectionGetParams) SetRpoComponentsRpoRemoteNameQueryParameter(rpoComponentsRpoRemoteName *string) {
	o.RpoComponentsRpoRemoteNameQueryParameter = rpoComponentsRpoRemoteName
}

// WithRpoComponentsUUIDQueryParameter adds the rpoComponentsUUID to the application collection get params
func (o *ApplicationCollectionGetParams) WithRpoComponentsUUIDQueryParameter(rpoComponentsUUID *string) *ApplicationCollectionGetParams {
	o.SetRpoComponentsUUIDQueryParameter(rpoComponentsUUID)
	return o
}

// SetRpoComponentsUUIDQueryParameter adds the rpoComponentsUuid to the application collection get params
func (o *ApplicationCollectionGetParams) SetRpoComponentsUUIDQueryParameter(rpoComponentsUUID *string) {
	o.RpoComponentsUUIDQueryParameter = rpoComponentsUUID
}

// WithRpoIsSupportedQueryParameter adds the rpoIsSupported to the application collection get params
func (o *ApplicationCollectionGetParams) WithRpoIsSupportedQueryParameter(rpoIsSupported *string) *ApplicationCollectionGetParams {
	o.SetRpoIsSupportedQueryParameter(rpoIsSupported)
	return o
}

// SetRpoIsSupportedQueryParameter adds the rpoIsSupported to the application collection get params
func (o *ApplicationCollectionGetParams) SetRpoIsSupportedQueryParameter(rpoIsSupported *string) {
	o.RpoIsSupportedQueryParameter = rpoIsSupported
}

// WithRpoLocalDescriptionQueryParameter adds the rpoLocalDescription to the application collection get params
func (o *ApplicationCollectionGetParams) WithRpoLocalDescriptionQueryParameter(rpoLocalDescription *string) *ApplicationCollectionGetParams {
	o.SetRpoLocalDescriptionQueryParameter(rpoLocalDescription)
	return o
}

// SetRpoLocalDescriptionQueryParameter adds the rpoLocalDescription to the application collection get params
func (o *ApplicationCollectionGetParams) SetRpoLocalDescriptionQueryParameter(rpoLocalDescription *string) {
	o.RpoLocalDescriptionQueryParameter = rpoLocalDescription
}

// WithRpoLocalNameQueryParameter adds the rpoLocalName to the application collection get params
func (o *ApplicationCollectionGetParams) WithRpoLocalNameQueryParameter(rpoLocalName *string) *ApplicationCollectionGetParams {
	o.SetRpoLocalNameQueryParameter(rpoLocalName)
	return o
}

// SetRpoLocalNameQueryParameter adds the rpoLocalName to the application collection get params
func (o *ApplicationCollectionGetParams) SetRpoLocalNameQueryParameter(rpoLocalName *string) {
	o.RpoLocalNameQueryParameter = rpoLocalName
}

// WithRpoRemoteDescriptionQueryParameter adds the rpoRemoteDescription to the application collection get params
func (o *ApplicationCollectionGetParams) WithRpoRemoteDescriptionQueryParameter(rpoRemoteDescription *string) *ApplicationCollectionGetParams {
	o.SetRpoRemoteDescriptionQueryParameter(rpoRemoteDescription)
	return o
}

// SetRpoRemoteDescriptionQueryParameter adds the rpoRemoteDescription to the application collection get params
func (o *ApplicationCollectionGetParams) SetRpoRemoteDescriptionQueryParameter(rpoRemoteDescription *string) {
	o.RpoRemoteDescriptionQueryParameter = rpoRemoteDescription
}

// WithRpoRemoteNameQueryParameter adds the rpoRemoteName to the application collection get params
func (o *ApplicationCollectionGetParams) WithRpoRemoteNameQueryParameter(rpoRemoteName *string) *ApplicationCollectionGetParams {
	o.SetRpoRemoteNameQueryParameter(rpoRemoteName)
	return o
}

// SetRpoRemoteNameQueryParameter adds the rpoRemoteName to the application collection get params
func (o *ApplicationCollectionGetParams) SetRpoRemoteNameQueryParameter(rpoRemoteName *string) {
	o.RpoRemoteNameQueryParameter = rpoRemoteName
}

// WithSmartContainerQueryParameter adds the smartContainer to the application collection get params
func (o *ApplicationCollectionGetParams) WithSmartContainerQueryParameter(smartContainer *string) *ApplicationCollectionGetParams {
	o.SetSmartContainerQueryParameter(smartContainer)
	return o
}

// SetSmartContainerQueryParameter adds the smartContainer to the application collection get params
func (o *ApplicationCollectionGetParams) SetSmartContainerQueryParameter(smartContainer *string) {
	o.SmartContainerQueryParameter = smartContainer
}

// WithStateQueryParameter adds the state to the application collection get params
func (o *ApplicationCollectionGetParams) WithStateQueryParameter(state *string) *ApplicationCollectionGetParams {
	o.SetStateQueryParameter(state)
	return o
}

// SetStateQueryParameter adds the state to the application collection get params
func (o *ApplicationCollectionGetParams) SetStateQueryParameter(state *string) {
	o.StateQueryParameter = state
}

// WithStatisticsComponentsIopsPerTbQueryParameter adds the statisticsComponentsIopsPerTb to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsIopsPerTbQueryParameter(statisticsComponentsIopsPerTb *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsIopsPerTbQueryParameter(statisticsComponentsIopsPerTb)
	return o
}

// SetStatisticsComponentsIopsPerTbQueryParameter adds the statisticsComponentsIopsPerTb to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsIopsPerTbQueryParameter(statisticsComponentsIopsPerTb *string) {
	o.StatisticsComponentsIopsPerTbQueryParameter = statisticsComponentsIopsPerTb
}

// WithStatisticsComponentsIopsTotalQueryParameter adds the statisticsComponentsIopsTotal to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsIopsTotalQueryParameter(statisticsComponentsIopsTotal *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsIopsTotalQueryParameter(statisticsComponentsIopsTotal)
	return o
}

// SetStatisticsComponentsIopsTotalQueryParameter adds the statisticsComponentsIopsTotal to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsIopsTotalQueryParameter(statisticsComponentsIopsTotal *string) {
	o.StatisticsComponentsIopsTotalQueryParameter = statisticsComponentsIopsTotal
}

// WithStatisticsComponentsLatencyAverageQueryParameter adds the statisticsComponentsLatencyAverage to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsLatencyAverageQueryParameter(statisticsComponentsLatencyAverage *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsLatencyAverageQueryParameter(statisticsComponentsLatencyAverage)
	return o
}

// SetStatisticsComponentsLatencyAverageQueryParameter adds the statisticsComponentsLatencyAverage to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsLatencyAverageQueryParameter(statisticsComponentsLatencyAverage *string) {
	o.StatisticsComponentsLatencyAverageQueryParameter = statisticsComponentsLatencyAverage
}

// WithStatisticsComponentsLatencyRawQueryParameter adds the statisticsComponentsLatencyRaw to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsLatencyRawQueryParameter(statisticsComponentsLatencyRaw *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsLatencyRawQueryParameter(statisticsComponentsLatencyRaw)
	return o
}

// SetStatisticsComponentsLatencyRawQueryParameter adds the statisticsComponentsLatencyRaw to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsLatencyRawQueryParameter(statisticsComponentsLatencyRaw *string) {
	o.StatisticsComponentsLatencyRawQueryParameter = statisticsComponentsLatencyRaw
}

// WithStatisticsComponentsNameQueryParameter adds the statisticsComponentsName to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsNameQueryParameter(statisticsComponentsName *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsNameQueryParameter(statisticsComponentsName)
	return o
}

// SetStatisticsComponentsNameQueryParameter adds the statisticsComponentsName to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsNameQueryParameter(statisticsComponentsName *string) {
	o.StatisticsComponentsNameQueryParameter = statisticsComponentsName
}

// WithStatisticsComponentsSharedStoragePoolQueryParameter adds the statisticsComponentsSharedStoragePool to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsSharedStoragePoolQueryParameter(statisticsComponentsSharedStoragePool *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsSharedStoragePoolQueryParameter(statisticsComponentsSharedStoragePool)
	return o
}

// SetStatisticsComponentsSharedStoragePoolQueryParameter adds the statisticsComponentsSharedStoragePool to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsSharedStoragePoolQueryParameter(statisticsComponentsSharedStoragePool *string) {
	o.StatisticsComponentsSharedStoragePoolQueryParameter = statisticsComponentsSharedStoragePool
}

// WithStatisticsComponentsSnapshotReserveQueryParameter adds the statisticsComponentsSnapshotReserve to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsSnapshotReserveQueryParameter(statisticsComponentsSnapshotReserve *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsSnapshotReserveQueryParameter(statisticsComponentsSnapshotReserve)
	return o
}

// SetStatisticsComponentsSnapshotReserveQueryParameter adds the statisticsComponentsSnapshotReserve to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsSnapshotReserveQueryParameter(statisticsComponentsSnapshotReserve *string) {
	o.StatisticsComponentsSnapshotReserveQueryParameter = statisticsComponentsSnapshotReserve
}

// WithStatisticsComponentsSnapshotUsedQueryParameter adds the statisticsComponentsSnapshotUsed to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsSnapshotUsedQueryParameter(statisticsComponentsSnapshotUsed *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsSnapshotUsedQueryParameter(statisticsComponentsSnapshotUsed)
	return o
}

// SetStatisticsComponentsSnapshotUsedQueryParameter adds the statisticsComponentsSnapshotUsed to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsSnapshotUsedQueryParameter(statisticsComponentsSnapshotUsed *string) {
	o.StatisticsComponentsSnapshotUsedQueryParameter = statisticsComponentsSnapshotUsed
}

// WithStatisticsComponentsSpaceAvailableQueryParameter adds the statisticsComponentsSpaceAvailable to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsSpaceAvailableQueryParameter(statisticsComponentsSpaceAvailable *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsSpaceAvailableQueryParameter(statisticsComponentsSpaceAvailable)
	return o
}

// SetStatisticsComponentsSpaceAvailableQueryParameter adds the statisticsComponentsSpaceAvailable to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsSpaceAvailableQueryParameter(statisticsComponentsSpaceAvailable *string) {
	o.StatisticsComponentsSpaceAvailableQueryParameter = statisticsComponentsSpaceAvailable
}

// WithStatisticsComponentsSpaceLogicalUsedQueryParameter adds the statisticsComponentsSpaceLogicalUsed to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsSpaceLogicalUsedQueryParameter(statisticsComponentsSpaceLogicalUsed *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsSpaceLogicalUsedQueryParameter(statisticsComponentsSpaceLogicalUsed)
	return o
}

// SetStatisticsComponentsSpaceLogicalUsedQueryParameter adds the statisticsComponentsSpaceLogicalUsed to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsSpaceLogicalUsedQueryParameter(statisticsComponentsSpaceLogicalUsed *string) {
	o.StatisticsComponentsSpaceLogicalUsedQueryParameter = statisticsComponentsSpaceLogicalUsed
}

// WithStatisticsComponentsSpaceProvisionedQueryParameter adds the statisticsComponentsSpaceProvisioned to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsSpaceProvisionedQueryParameter(statisticsComponentsSpaceProvisioned *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsSpaceProvisionedQueryParameter(statisticsComponentsSpaceProvisioned)
	return o
}

// SetStatisticsComponentsSpaceProvisionedQueryParameter adds the statisticsComponentsSpaceProvisioned to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsSpaceProvisionedQueryParameter(statisticsComponentsSpaceProvisioned *string) {
	o.StatisticsComponentsSpaceProvisionedQueryParameter = statisticsComponentsSpaceProvisioned
}

// WithStatisticsComponentsSpaceReservedUnusedQueryParameter adds the statisticsComponentsSpaceReservedUnused to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsSpaceReservedUnusedQueryParameter(statisticsComponentsSpaceReservedUnused *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsSpaceReservedUnusedQueryParameter(statisticsComponentsSpaceReservedUnused)
	return o
}

// SetStatisticsComponentsSpaceReservedUnusedQueryParameter adds the statisticsComponentsSpaceReservedUnused to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsSpaceReservedUnusedQueryParameter(statisticsComponentsSpaceReservedUnused *string) {
	o.StatisticsComponentsSpaceReservedUnusedQueryParameter = statisticsComponentsSpaceReservedUnused
}

// WithStatisticsComponentsSpaceSavingsQueryParameter adds the statisticsComponentsSpaceSavings to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsSpaceSavingsQueryParameter(statisticsComponentsSpaceSavings *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsSpaceSavingsQueryParameter(statisticsComponentsSpaceSavings)
	return o
}

// SetStatisticsComponentsSpaceSavingsQueryParameter adds the statisticsComponentsSpaceSavings to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsSpaceSavingsQueryParameter(statisticsComponentsSpaceSavings *string) {
	o.StatisticsComponentsSpaceSavingsQueryParameter = statisticsComponentsSpaceSavings
}

// WithStatisticsComponentsSpaceUsedQueryParameter adds the statisticsComponentsSpaceUsed to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsSpaceUsedQueryParameter(statisticsComponentsSpaceUsed *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsSpaceUsedQueryParameter(statisticsComponentsSpaceUsed)
	return o
}

// SetStatisticsComponentsSpaceUsedQueryParameter adds the statisticsComponentsSpaceUsed to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsSpaceUsedQueryParameter(statisticsComponentsSpaceUsed *string) {
	o.StatisticsComponentsSpaceUsedQueryParameter = statisticsComponentsSpaceUsed
}

// WithStatisticsComponentsSpaceUsedExcludingReservesQueryParameter adds the statisticsComponentsSpaceUsedExcludingReserves to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsSpaceUsedExcludingReservesQueryParameter(statisticsComponentsSpaceUsedExcludingReserves *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsSpaceUsedExcludingReservesQueryParameter(statisticsComponentsSpaceUsedExcludingReserves)
	return o
}

// SetStatisticsComponentsSpaceUsedExcludingReservesQueryParameter adds the statisticsComponentsSpaceUsedExcludingReserves to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsSpaceUsedExcludingReservesQueryParameter(statisticsComponentsSpaceUsedExcludingReserves *string) {
	o.StatisticsComponentsSpaceUsedExcludingReservesQueryParameter = statisticsComponentsSpaceUsedExcludingReserves
}

// WithStatisticsComponentsSpaceUsedPercentQueryParameter adds the statisticsComponentsSpaceUsedPercent to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsSpaceUsedPercentQueryParameter(statisticsComponentsSpaceUsedPercent *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsSpaceUsedPercentQueryParameter(statisticsComponentsSpaceUsedPercent)
	return o
}

// SetStatisticsComponentsSpaceUsedPercentQueryParameter adds the statisticsComponentsSpaceUsedPercent to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsSpaceUsedPercentQueryParameter(statisticsComponentsSpaceUsedPercent *string) {
	o.StatisticsComponentsSpaceUsedPercentQueryParameter = statisticsComponentsSpaceUsedPercent
}

// WithStatisticsComponentsStatisticsIncompleteQueryParameter adds the statisticsComponentsStatisticsIncomplete to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsStatisticsIncompleteQueryParameter(statisticsComponentsStatisticsIncomplete *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsStatisticsIncompleteQueryParameter(statisticsComponentsStatisticsIncomplete)
	return o
}

// SetStatisticsComponentsStatisticsIncompleteQueryParameter adds the statisticsComponentsStatisticsIncomplete to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsStatisticsIncompleteQueryParameter(statisticsComponentsStatisticsIncomplete *string) {
	o.StatisticsComponentsStatisticsIncompleteQueryParameter = statisticsComponentsStatisticsIncomplete
}

// WithStatisticsComponentsStorageServiceNameQueryParameter adds the statisticsComponentsStorageServiceName to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsStorageServiceNameQueryParameter(statisticsComponentsStorageServiceName *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsStorageServiceNameQueryParameter(statisticsComponentsStorageServiceName)
	return o
}

// SetStatisticsComponentsStorageServiceNameQueryParameter adds the statisticsComponentsStorageServiceName to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsStorageServiceNameQueryParameter(statisticsComponentsStorageServiceName *string) {
	o.StatisticsComponentsStorageServiceNameQueryParameter = statisticsComponentsStorageServiceName
}

// WithStatisticsComponentsUUIDQueryParameter adds the statisticsComponentsUUID to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsComponentsUUIDQueryParameter(statisticsComponentsUUID *string) *ApplicationCollectionGetParams {
	o.SetStatisticsComponentsUUIDQueryParameter(statisticsComponentsUUID)
	return o
}

// SetStatisticsComponentsUUIDQueryParameter adds the statisticsComponentsUuid to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsComponentsUUIDQueryParameter(statisticsComponentsUUID *string) {
	o.StatisticsComponentsUUIDQueryParameter = statisticsComponentsUUID
}

// WithStatisticsIopsPerTbQueryParameter adds the statisticsIopsPerTb to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsIopsPerTbQueryParameter(statisticsIopsPerTb *string) *ApplicationCollectionGetParams {
	o.SetStatisticsIopsPerTbQueryParameter(statisticsIopsPerTb)
	return o
}

// SetStatisticsIopsPerTbQueryParameter adds the statisticsIopsPerTb to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsIopsPerTbQueryParameter(statisticsIopsPerTb *string) {
	o.StatisticsIopsPerTbQueryParameter = statisticsIopsPerTb
}

// WithStatisticsIopsTotalQueryParameter adds the statisticsIopsTotal to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsIopsTotalQueryParameter(statisticsIopsTotal *string) *ApplicationCollectionGetParams {
	o.SetStatisticsIopsTotalQueryParameter(statisticsIopsTotal)
	return o
}

// SetStatisticsIopsTotalQueryParameter adds the statisticsIopsTotal to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsIopsTotalQueryParameter(statisticsIopsTotal *string) {
	o.StatisticsIopsTotalQueryParameter = statisticsIopsTotal
}

// WithStatisticsLatencyAverageQueryParameter adds the statisticsLatencyAverage to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsLatencyAverageQueryParameter(statisticsLatencyAverage *string) *ApplicationCollectionGetParams {
	o.SetStatisticsLatencyAverageQueryParameter(statisticsLatencyAverage)
	return o
}

// SetStatisticsLatencyAverageQueryParameter adds the statisticsLatencyAverage to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsLatencyAverageQueryParameter(statisticsLatencyAverage *string) {
	o.StatisticsLatencyAverageQueryParameter = statisticsLatencyAverage
}

// WithStatisticsLatencyRawQueryParameter adds the statisticsLatencyRaw to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsLatencyRawQueryParameter(statisticsLatencyRaw *string) *ApplicationCollectionGetParams {
	o.SetStatisticsLatencyRawQueryParameter(statisticsLatencyRaw)
	return o
}

// SetStatisticsLatencyRawQueryParameter adds the statisticsLatencyRaw to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsLatencyRawQueryParameter(statisticsLatencyRaw *string) {
	o.StatisticsLatencyRawQueryParameter = statisticsLatencyRaw
}

// WithStatisticsSharedStoragePoolQueryParameter adds the statisticsSharedStoragePool to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsSharedStoragePoolQueryParameter(statisticsSharedStoragePool *string) *ApplicationCollectionGetParams {
	o.SetStatisticsSharedStoragePoolQueryParameter(statisticsSharedStoragePool)
	return o
}

// SetStatisticsSharedStoragePoolQueryParameter adds the statisticsSharedStoragePool to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsSharedStoragePoolQueryParameter(statisticsSharedStoragePool *string) {
	o.StatisticsSharedStoragePoolQueryParameter = statisticsSharedStoragePool
}

// WithStatisticsSnapshotReserveQueryParameter adds the statisticsSnapshotReserve to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsSnapshotReserveQueryParameter(statisticsSnapshotReserve *string) *ApplicationCollectionGetParams {
	o.SetStatisticsSnapshotReserveQueryParameter(statisticsSnapshotReserve)
	return o
}

// SetStatisticsSnapshotReserveQueryParameter adds the statisticsSnapshotReserve to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsSnapshotReserveQueryParameter(statisticsSnapshotReserve *string) {
	o.StatisticsSnapshotReserveQueryParameter = statisticsSnapshotReserve
}

// WithStatisticsSnapshotUsedQueryParameter adds the statisticsSnapshotUsed to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsSnapshotUsedQueryParameter(statisticsSnapshotUsed *string) *ApplicationCollectionGetParams {
	o.SetStatisticsSnapshotUsedQueryParameter(statisticsSnapshotUsed)
	return o
}

// SetStatisticsSnapshotUsedQueryParameter adds the statisticsSnapshotUsed to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsSnapshotUsedQueryParameter(statisticsSnapshotUsed *string) {
	o.StatisticsSnapshotUsedQueryParameter = statisticsSnapshotUsed
}

// WithStatisticsSpaceAvailableQueryParameter adds the statisticsSpaceAvailable to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsSpaceAvailableQueryParameter(statisticsSpaceAvailable *string) *ApplicationCollectionGetParams {
	o.SetStatisticsSpaceAvailableQueryParameter(statisticsSpaceAvailable)
	return o
}

// SetStatisticsSpaceAvailableQueryParameter adds the statisticsSpaceAvailable to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsSpaceAvailableQueryParameter(statisticsSpaceAvailable *string) {
	o.StatisticsSpaceAvailableQueryParameter = statisticsSpaceAvailable
}

// WithStatisticsSpaceLogicalUsedQueryParameter adds the statisticsSpaceLogicalUsed to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsSpaceLogicalUsedQueryParameter(statisticsSpaceLogicalUsed *string) *ApplicationCollectionGetParams {
	o.SetStatisticsSpaceLogicalUsedQueryParameter(statisticsSpaceLogicalUsed)
	return o
}

// SetStatisticsSpaceLogicalUsedQueryParameter adds the statisticsSpaceLogicalUsed to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsSpaceLogicalUsedQueryParameter(statisticsSpaceLogicalUsed *string) {
	o.StatisticsSpaceLogicalUsedQueryParameter = statisticsSpaceLogicalUsed
}

// WithStatisticsSpaceProvisionedQueryParameter adds the statisticsSpaceProvisioned to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsSpaceProvisionedQueryParameter(statisticsSpaceProvisioned *string) *ApplicationCollectionGetParams {
	o.SetStatisticsSpaceProvisionedQueryParameter(statisticsSpaceProvisioned)
	return o
}

// SetStatisticsSpaceProvisionedQueryParameter adds the statisticsSpaceProvisioned to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsSpaceProvisionedQueryParameter(statisticsSpaceProvisioned *string) {
	o.StatisticsSpaceProvisionedQueryParameter = statisticsSpaceProvisioned
}

// WithStatisticsSpaceReservedUnusedQueryParameter adds the statisticsSpaceReservedUnused to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsSpaceReservedUnusedQueryParameter(statisticsSpaceReservedUnused *string) *ApplicationCollectionGetParams {
	o.SetStatisticsSpaceReservedUnusedQueryParameter(statisticsSpaceReservedUnused)
	return o
}

// SetStatisticsSpaceReservedUnusedQueryParameter adds the statisticsSpaceReservedUnused to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsSpaceReservedUnusedQueryParameter(statisticsSpaceReservedUnused *string) {
	o.StatisticsSpaceReservedUnusedQueryParameter = statisticsSpaceReservedUnused
}

// WithStatisticsSpaceSavingsQueryParameter adds the statisticsSpaceSavings to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsSpaceSavingsQueryParameter(statisticsSpaceSavings *string) *ApplicationCollectionGetParams {
	o.SetStatisticsSpaceSavingsQueryParameter(statisticsSpaceSavings)
	return o
}

// SetStatisticsSpaceSavingsQueryParameter adds the statisticsSpaceSavings to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsSpaceSavingsQueryParameter(statisticsSpaceSavings *string) {
	o.StatisticsSpaceSavingsQueryParameter = statisticsSpaceSavings
}

// WithStatisticsSpaceUsedQueryParameter adds the statisticsSpaceUsed to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsSpaceUsedQueryParameter(statisticsSpaceUsed *string) *ApplicationCollectionGetParams {
	o.SetStatisticsSpaceUsedQueryParameter(statisticsSpaceUsed)
	return o
}

// SetStatisticsSpaceUsedQueryParameter adds the statisticsSpaceUsed to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsSpaceUsedQueryParameter(statisticsSpaceUsed *string) {
	o.StatisticsSpaceUsedQueryParameter = statisticsSpaceUsed
}

// WithStatisticsSpaceUsedExcludingReservesQueryParameter adds the statisticsSpaceUsedExcludingReserves to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsSpaceUsedExcludingReservesQueryParameter(statisticsSpaceUsedExcludingReserves *string) *ApplicationCollectionGetParams {
	o.SetStatisticsSpaceUsedExcludingReservesQueryParameter(statisticsSpaceUsedExcludingReserves)
	return o
}

// SetStatisticsSpaceUsedExcludingReservesQueryParameter adds the statisticsSpaceUsedExcludingReserves to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsSpaceUsedExcludingReservesQueryParameter(statisticsSpaceUsedExcludingReserves *string) {
	o.StatisticsSpaceUsedExcludingReservesQueryParameter = statisticsSpaceUsedExcludingReserves
}

// WithStatisticsSpaceUsedPercentQueryParameter adds the statisticsSpaceUsedPercent to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsSpaceUsedPercentQueryParameter(statisticsSpaceUsedPercent *string) *ApplicationCollectionGetParams {
	o.SetStatisticsSpaceUsedPercentQueryParameter(statisticsSpaceUsedPercent)
	return o
}

// SetStatisticsSpaceUsedPercentQueryParameter adds the statisticsSpaceUsedPercent to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsSpaceUsedPercentQueryParameter(statisticsSpaceUsedPercent *string) {
	o.StatisticsSpaceUsedPercentQueryParameter = statisticsSpaceUsedPercent
}

// WithStatisticsStatisticsIncompleteQueryParameter adds the statisticsStatisticsIncomplete to the application collection get params
func (o *ApplicationCollectionGetParams) WithStatisticsStatisticsIncompleteQueryParameter(statisticsStatisticsIncomplete *string) *ApplicationCollectionGetParams {
	o.SetStatisticsStatisticsIncompleteQueryParameter(statisticsStatisticsIncomplete)
	return o
}

// SetStatisticsStatisticsIncompleteQueryParameter adds the statisticsStatisticsIncomplete to the application collection get params
func (o *ApplicationCollectionGetParams) SetStatisticsStatisticsIncompleteQueryParameter(statisticsStatisticsIncomplete *string) {
	o.StatisticsStatisticsIncompleteQueryParameter = statisticsStatisticsIncomplete
}

// WithSVMNameQueryParameter adds the svmName to the application collection get params
func (o *ApplicationCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *ApplicationCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the application collection get params
func (o *ApplicationCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the application collection get params
func (o *ApplicationCollectionGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *ApplicationCollectionGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the application collection get params
func (o *ApplicationCollectionGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WithTemplateNameQueryParameter adds the templateName to the application collection get params
func (o *ApplicationCollectionGetParams) WithTemplateNameQueryParameter(templateName *string) *ApplicationCollectionGetParams {
	o.SetTemplateNameQueryParameter(templateName)
	return o
}

// SetTemplateNameQueryParameter adds the templateName to the application collection get params
func (o *ApplicationCollectionGetParams) SetTemplateNameQueryParameter(templateName *string) {
	o.TemplateNameQueryParameter = templateName
}

// WithTemplateProtocolQueryParameter adds the templateProtocol to the application collection get params
func (o *ApplicationCollectionGetParams) WithTemplateProtocolQueryParameter(templateProtocol *string) *ApplicationCollectionGetParams {
	o.SetTemplateProtocolQueryParameter(templateProtocol)
	return o
}

// SetTemplateProtocolQueryParameter adds the templateProtocol to the application collection get params
func (o *ApplicationCollectionGetParams) SetTemplateProtocolQueryParameter(templateProtocol *string) {
	o.TemplateProtocolQueryParameter = templateProtocol
}

// WithTemplateVersionQueryParameter adds the templateVersion to the application collection get params
func (o *ApplicationCollectionGetParams) WithTemplateVersionQueryParameter(templateVersion *string) *ApplicationCollectionGetParams {
	o.SetTemplateVersionQueryParameter(templateVersion)
	return o
}

// SetTemplateVersionQueryParameter adds the templateVersion to the application collection get params
func (o *ApplicationCollectionGetParams) SetTemplateVersionQueryParameter(templateVersion *string) {
	o.TemplateVersionQueryParameter = templateVersion
}

// WithUUIDQueryParameter adds the uuid to the application collection get params
func (o *ApplicationCollectionGetParams) WithUUIDQueryParameter(uuid *string) *ApplicationCollectionGetParams {
	o.SetUUIDQueryParameter(uuid)
	return o
}

// SetUUIDQueryParameter adds the uuid to the application collection get params
func (o *ApplicationCollectionGetParams) SetUUIDQueryParameter(uuid *string) {
	o.UUIDQueryParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *ApplicationCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.GenerationQueryParameter != nil {

		// query param generation
		var qrGeneration string

		if o.GenerationQueryParameter != nil {
			qrGeneration = *o.GenerationQueryParameter
		}
		qGeneration := qrGeneration
		if qGeneration != "" {

			if err := r.SetQueryParam("generation", qGeneration); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ProtectionGranularityQueryParameter != nil {

		// query param protection_granularity
		var qrProtectionGranularity string

		if o.ProtectionGranularityQueryParameter != nil {
			qrProtectionGranularity = *o.ProtectionGranularityQueryParameter
		}
		qProtectionGranularity := qrProtectionGranularity
		if qProtectionGranularity != "" {

			if err := r.SetQueryParam("protection_granularity", qProtectionGranularity); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.RpoComponentsNameQueryParameter != nil {

		// query param rpo.components.name
		var qrRpoComponentsName string

		if o.RpoComponentsNameQueryParameter != nil {
			qrRpoComponentsName = *o.RpoComponentsNameQueryParameter
		}
		qRpoComponentsName := qrRpoComponentsName
		if qRpoComponentsName != "" {

			if err := r.SetQueryParam("rpo.components.name", qRpoComponentsName); err != nil {
				return err
			}
		}
	}

	if o.RpoComponentsRpoLocalDescriptionQueryParameter != nil {

		// query param rpo.components.rpo.local.description
		var qrRpoComponentsRpoLocalDescription string

		if o.RpoComponentsRpoLocalDescriptionQueryParameter != nil {
			qrRpoComponentsRpoLocalDescription = *o.RpoComponentsRpoLocalDescriptionQueryParameter
		}
		qRpoComponentsRpoLocalDescription := qrRpoComponentsRpoLocalDescription
		if qRpoComponentsRpoLocalDescription != "" {

			if err := r.SetQueryParam("rpo.components.rpo.local.description", qRpoComponentsRpoLocalDescription); err != nil {
				return err
			}
		}
	}

	if o.RpoComponentsRpoLocalNameQueryParameter != nil {

		// query param rpo.components.rpo.local.name
		var qrRpoComponentsRpoLocalName string

		if o.RpoComponentsRpoLocalNameQueryParameter != nil {
			qrRpoComponentsRpoLocalName = *o.RpoComponentsRpoLocalNameQueryParameter
		}
		qRpoComponentsRpoLocalName := qrRpoComponentsRpoLocalName
		if qRpoComponentsRpoLocalName != "" {

			if err := r.SetQueryParam("rpo.components.rpo.local.name", qRpoComponentsRpoLocalName); err != nil {
				return err
			}
		}
	}

	if o.RpoComponentsRpoRemoteDescriptionQueryParameter != nil {

		// query param rpo.components.rpo.remote.description
		var qrRpoComponentsRpoRemoteDescription string

		if o.RpoComponentsRpoRemoteDescriptionQueryParameter != nil {
			qrRpoComponentsRpoRemoteDescription = *o.RpoComponentsRpoRemoteDescriptionQueryParameter
		}
		qRpoComponentsRpoRemoteDescription := qrRpoComponentsRpoRemoteDescription
		if qRpoComponentsRpoRemoteDescription != "" {

			if err := r.SetQueryParam("rpo.components.rpo.remote.description", qRpoComponentsRpoRemoteDescription); err != nil {
				return err
			}
		}
	}

	if o.RpoComponentsRpoRemoteNameQueryParameter != nil {

		// query param rpo.components.rpo.remote.name
		var qrRpoComponentsRpoRemoteName string

		if o.RpoComponentsRpoRemoteNameQueryParameter != nil {
			qrRpoComponentsRpoRemoteName = *o.RpoComponentsRpoRemoteNameQueryParameter
		}
		qRpoComponentsRpoRemoteName := qrRpoComponentsRpoRemoteName
		if qRpoComponentsRpoRemoteName != "" {

			if err := r.SetQueryParam("rpo.components.rpo.remote.name", qRpoComponentsRpoRemoteName); err != nil {
				return err
			}
		}
	}

	if o.RpoComponentsUUIDQueryParameter != nil {

		// query param rpo.components.uuid
		var qrRpoComponentsUUID string

		if o.RpoComponentsUUIDQueryParameter != nil {
			qrRpoComponentsUUID = *o.RpoComponentsUUIDQueryParameter
		}
		qRpoComponentsUUID := qrRpoComponentsUUID
		if qRpoComponentsUUID != "" {

			if err := r.SetQueryParam("rpo.components.uuid", qRpoComponentsUUID); err != nil {
				return err
			}
		}
	}

	if o.RpoIsSupportedQueryParameter != nil {

		// query param rpo.is_supported
		var qrRpoIsSupported string

		if o.RpoIsSupportedQueryParameter != nil {
			qrRpoIsSupported = *o.RpoIsSupportedQueryParameter
		}
		qRpoIsSupported := qrRpoIsSupported
		if qRpoIsSupported != "" {

			if err := r.SetQueryParam("rpo.is_supported", qRpoIsSupported); err != nil {
				return err
			}
		}
	}

	if o.RpoLocalDescriptionQueryParameter != nil {

		// query param rpo.local.description
		var qrRpoLocalDescription string

		if o.RpoLocalDescriptionQueryParameter != nil {
			qrRpoLocalDescription = *o.RpoLocalDescriptionQueryParameter
		}
		qRpoLocalDescription := qrRpoLocalDescription
		if qRpoLocalDescription != "" {

			if err := r.SetQueryParam("rpo.local.description", qRpoLocalDescription); err != nil {
				return err
			}
		}
	}

	if o.RpoLocalNameQueryParameter != nil {

		// query param rpo.local.name
		var qrRpoLocalName string

		if o.RpoLocalNameQueryParameter != nil {
			qrRpoLocalName = *o.RpoLocalNameQueryParameter
		}
		qRpoLocalName := qrRpoLocalName
		if qRpoLocalName != "" {

			if err := r.SetQueryParam("rpo.local.name", qRpoLocalName); err != nil {
				return err
			}
		}
	}

	if o.RpoRemoteDescriptionQueryParameter != nil {

		// query param rpo.remote.description
		var qrRpoRemoteDescription string

		if o.RpoRemoteDescriptionQueryParameter != nil {
			qrRpoRemoteDescription = *o.RpoRemoteDescriptionQueryParameter
		}
		qRpoRemoteDescription := qrRpoRemoteDescription
		if qRpoRemoteDescription != "" {

			if err := r.SetQueryParam("rpo.remote.description", qRpoRemoteDescription); err != nil {
				return err
			}
		}
	}

	if o.RpoRemoteNameQueryParameter != nil {

		// query param rpo.remote.name
		var qrRpoRemoteName string

		if o.RpoRemoteNameQueryParameter != nil {
			qrRpoRemoteName = *o.RpoRemoteNameQueryParameter
		}
		qRpoRemoteName := qrRpoRemoteName
		if qRpoRemoteName != "" {

			if err := r.SetQueryParam("rpo.remote.name", qRpoRemoteName); err != nil {
				return err
			}
		}
	}

	if o.SmartContainerQueryParameter != nil {

		// query param smart_container
		var qrSmartContainer string

		if o.SmartContainerQueryParameter != nil {
			qrSmartContainer = *o.SmartContainerQueryParameter
		}
		qSmartContainer := qrSmartContainer
		if qSmartContainer != "" {

			if err := r.SetQueryParam("smart_container", qSmartContainer); err != nil {
				return err
			}
		}
	}

	if o.StateQueryParameter != nil {

		// query param state
		var qrState string

		if o.StateQueryParameter != nil {
			qrState = *o.StateQueryParameter
		}
		qState := qrState
		if qState != "" {

			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsIopsPerTbQueryParameter != nil {

		// query param statistics.components.iops.per_tb
		var qrStatisticsComponentsIopsPerTb string

		if o.StatisticsComponentsIopsPerTbQueryParameter != nil {
			qrStatisticsComponentsIopsPerTb = *o.StatisticsComponentsIopsPerTbQueryParameter
		}
		qStatisticsComponentsIopsPerTb := qrStatisticsComponentsIopsPerTb
		if qStatisticsComponentsIopsPerTb != "" {

			if err := r.SetQueryParam("statistics.components.iops.per_tb", qStatisticsComponentsIopsPerTb); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsIopsTotalQueryParameter != nil {

		// query param statistics.components.iops.total
		var qrStatisticsComponentsIopsTotal string

		if o.StatisticsComponentsIopsTotalQueryParameter != nil {
			qrStatisticsComponentsIopsTotal = *o.StatisticsComponentsIopsTotalQueryParameter
		}
		qStatisticsComponentsIopsTotal := qrStatisticsComponentsIopsTotal
		if qStatisticsComponentsIopsTotal != "" {

			if err := r.SetQueryParam("statistics.components.iops.total", qStatisticsComponentsIopsTotal); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsLatencyAverageQueryParameter != nil {

		// query param statistics.components.latency.average
		var qrStatisticsComponentsLatencyAverage string

		if o.StatisticsComponentsLatencyAverageQueryParameter != nil {
			qrStatisticsComponentsLatencyAverage = *o.StatisticsComponentsLatencyAverageQueryParameter
		}
		qStatisticsComponentsLatencyAverage := qrStatisticsComponentsLatencyAverage
		if qStatisticsComponentsLatencyAverage != "" {

			if err := r.SetQueryParam("statistics.components.latency.average", qStatisticsComponentsLatencyAverage); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsLatencyRawQueryParameter != nil {

		// query param statistics.components.latency.raw
		var qrStatisticsComponentsLatencyRaw string

		if o.StatisticsComponentsLatencyRawQueryParameter != nil {
			qrStatisticsComponentsLatencyRaw = *o.StatisticsComponentsLatencyRawQueryParameter
		}
		qStatisticsComponentsLatencyRaw := qrStatisticsComponentsLatencyRaw
		if qStatisticsComponentsLatencyRaw != "" {

			if err := r.SetQueryParam("statistics.components.latency.raw", qStatisticsComponentsLatencyRaw); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsNameQueryParameter != nil {

		// query param statistics.components.name
		var qrStatisticsComponentsName string

		if o.StatisticsComponentsNameQueryParameter != nil {
			qrStatisticsComponentsName = *o.StatisticsComponentsNameQueryParameter
		}
		qStatisticsComponentsName := qrStatisticsComponentsName
		if qStatisticsComponentsName != "" {

			if err := r.SetQueryParam("statistics.components.name", qStatisticsComponentsName); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsSharedStoragePoolQueryParameter != nil {

		// query param statistics.components.shared_storage_pool
		var qrStatisticsComponentsSharedStoragePool string

		if o.StatisticsComponentsSharedStoragePoolQueryParameter != nil {
			qrStatisticsComponentsSharedStoragePool = *o.StatisticsComponentsSharedStoragePoolQueryParameter
		}
		qStatisticsComponentsSharedStoragePool := qrStatisticsComponentsSharedStoragePool
		if qStatisticsComponentsSharedStoragePool != "" {

			if err := r.SetQueryParam("statistics.components.shared_storage_pool", qStatisticsComponentsSharedStoragePool); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsSnapshotReserveQueryParameter != nil {

		// query param statistics.components.snapshot.reserve
		var qrStatisticsComponentsSnapshotReserve string

		if o.StatisticsComponentsSnapshotReserveQueryParameter != nil {
			qrStatisticsComponentsSnapshotReserve = *o.StatisticsComponentsSnapshotReserveQueryParameter
		}
		qStatisticsComponentsSnapshotReserve := qrStatisticsComponentsSnapshotReserve
		if qStatisticsComponentsSnapshotReserve != "" {

			if err := r.SetQueryParam("statistics.components.snapshot.reserve", qStatisticsComponentsSnapshotReserve); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsSnapshotUsedQueryParameter != nil {

		// query param statistics.components.snapshot.used
		var qrStatisticsComponentsSnapshotUsed string

		if o.StatisticsComponentsSnapshotUsedQueryParameter != nil {
			qrStatisticsComponentsSnapshotUsed = *o.StatisticsComponentsSnapshotUsedQueryParameter
		}
		qStatisticsComponentsSnapshotUsed := qrStatisticsComponentsSnapshotUsed
		if qStatisticsComponentsSnapshotUsed != "" {

			if err := r.SetQueryParam("statistics.components.snapshot.used", qStatisticsComponentsSnapshotUsed); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsSpaceAvailableQueryParameter != nil {

		// query param statistics.components.space.available
		var qrStatisticsComponentsSpaceAvailable string

		if o.StatisticsComponentsSpaceAvailableQueryParameter != nil {
			qrStatisticsComponentsSpaceAvailable = *o.StatisticsComponentsSpaceAvailableQueryParameter
		}
		qStatisticsComponentsSpaceAvailable := qrStatisticsComponentsSpaceAvailable
		if qStatisticsComponentsSpaceAvailable != "" {

			if err := r.SetQueryParam("statistics.components.space.available", qStatisticsComponentsSpaceAvailable); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsSpaceLogicalUsedQueryParameter != nil {

		// query param statistics.components.space.logical_used
		var qrStatisticsComponentsSpaceLogicalUsed string

		if o.StatisticsComponentsSpaceLogicalUsedQueryParameter != nil {
			qrStatisticsComponentsSpaceLogicalUsed = *o.StatisticsComponentsSpaceLogicalUsedQueryParameter
		}
		qStatisticsComponentsSpaceLogicalUsed := qrStatisticsComponentsSpaceLogicalUsed
		if qStatisticsComponentsSpaceLogicalUsed != "" {

			if err := r.SetQueryParam("statistics.components.space.logical_used", qStatisticsComponentsSpaceLogicalUsed); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsSpaceProvisionedQueryParameter != nil {

		// query param statistics.components.space.provisioned
		var qrStatisticsComponentsSpaceProvisioned string

		if o.StatisticsComponentsSpaceProvisionedQueryParameter != nil {
			qrStatisticsComponentsSpaceProvisioned = *o.StatisticsComponentsSpaceProvisionedQueryParameter
		}
		qStatisticsComponentsSpaceProvisioned := qrStatisticsComponentsSpaceProvisioned
		if qStatisticsComponentsSpaceProvisioned != "" {

			if err := r.SetQueryParam("statistics.components.space.provisioned", qStatisticsComponentsSpaceProvisioned); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsSpaceReservedUnusedQueryParameter != nil {

		// query param statistics.components.space.reserved_unused
		var qrStatisticsComponentsSpaceReservedUnused string

		if o.StatisticsComponentsSpaceReservedUnusedQueryParameter != nil {
			qrStatisticsComponentsSpaceReservedUnused = *o.StatisticsComponentsSpaceReservedUnusedQueryParameter
		}
		qStatisticsComponentsSpaceReservedUnused := qrStatisticsComponentsSpaceReservedUnused
		if qStatisticsComponentsSpaceReservedUnused != "" {

			if err := r.SetQueryParam("statistics.components.space.reserved_unused", qStatisticsComponentsSpaceReservedUnused); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsSpaceSavingsQueryParameter != nil {

		// query param statistics.components.space.savings
		var qrStatisticsComponentsSpaceSavings string

		if o.StatisticsComponentsSpaceSavingsQueryParameter != nil {
			qrStatisticsComponentsSpaceSavings = *o.StatisticsComponentsSpaceSavingsQueryParameter
		}
		qStatisticsComponentsSpaceSavings := qrStatisticsComponentsSpaceSavings
		if qStatisticsComponentsSpaceSavings != "" {

			if err := r.SetQueryParam("statistics.components.space.savings", qStatisticsComponentsSpaceSavings); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsSpaceUsedQueryParameter != nil {

		// query param statistics.components.space.used
		var qrStatisticsComponentsSpaceUsed string

		if o.StatisticsComponentsSpaceUsedQueryParameter != nil {
			qrStatisticsComponentsSpaceUsed = *o.StatisticsComponentsSpaceUsedQueryParameter
		}
		qStatisticsComponentsSpaceUsed := qrStatisticsComponentsSpaceUsed
		if qStatisticsComponentsSpaceUsed != "" {

			if err := r.SetQueryParam("statistics.components.space.used", qStatisticsComponentsSpaceUsed); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsSpaceUsedExcludingReservesQueryParameter != nil {

		// query param statistics.components.space.used_excluding_reserves
		var qrStatisticsComponentsSpaceUsedExcludingReserves string

		if o.StatisticsComponentsSpaceUsedExcludingReservesQueryParameter != nil {
			qrStatisticsComponentsSpaceUsedExcludingReserves = *o.StatisticsComponentsSpaceUsedExcludingReservesQueryParameter
		}
		qStatisticsComponentsSpaceUsedExcludingReserves := qrStatisticsComponentsSpaceUsedExcludingReserves
		if qStatisticsComponentsSpaceUsedExcludingReserves != "" {

			if err := r.SetQueryParam("statistics.components.space.used_excluding_reserves", qStatisticsComponentsSpaceUsedExcludingReserves); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsSpaceUsedPercentQueryParameter != nil {

		// query param statistics.components.space.used_percent
		var qrStatisticsComponentsSpaceUsedPercent string

		if o.StatisticsComponentsSpaceUsedPercentQueryParameter != nil {
			qrStatisticsComponentsSpaceUsedPercent = *o.StatisticsComponentsSpaceUsedPercentQueryParameter
		}
		qStatisticsComponentsSpaceUsedPercent := qrStatisticsComponentsSpaceUsedPercent
		if qStatisticsComponentsSpaceUsedPercent != "" {

			if err := r.SetQueryParam("statistics.components.space.used_percent", qStatisticsComponentsSpaceUsedPercent); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsStatisticsIncompleteQueryParameter != nil {

		// query param statistics.components.statistics_incomplete
		var qrStatisticsComponentsStatisticsIncomplete string

		if o.StatisticsComponentsStatisticsIncompleteQueryParameter != nil {
			qrStatisticsComponentsStatisticsIncomplete = *o.StatisticsComponentsStatisticsIncompleteQueryParameter
		}
		qStatisticsComponentsStatisticsIncomplete := qrStatisticsComponentsStatisticsIncomplete
		if qStatisticsComponentsStatisticsIncomplete != "" {

			if err := r.SetQueryParam("statistics.components.statistics_incomplete", qStatisticsComponentsStatisticsIncomplete); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsStorageServiceNameQueryParameter != nil {

		// query param statistics.components.storage_service.name
		var qrStatisticsComponentsStorageServiceName string

		if o.StatisticsComponentsStorageServiceNameQueryParameter != nil {
			qrStatisticsComponentsStorageServiceName = *o.StatisticsComponentsStorageServiceNameQueryParameter
		}
		qStatisticsComponentsStorageServiceName := qrStatisticsComponentsStorageServiceName
		if qStatisticsComponentsStorageServiceName != "" {

			if err := r.SetQueryParam("statistics.components.storage_service.name", qStatisticsComponentsStorageServiceName); err != nil {
				return err
			}
		}
	}

	if o.StatisticsComponentsUUIDQueryParameter != nil {

		// query param statistics.components.uuid
		var qrStatisticsComponentsUUID string

		if o.StatisticsComponentsUUIDQueryParameter != nil {
			qrStatisticsComponentsUUID = *o.StatisticsComponentsUUIDQueryParameter
		}
		qStatisticsComponentsUUID := qrStatisticsComponentsUUID
		if qStatisticsComponentsUUID != "" {

			if err := r.SetQueryParam("statistics.components.uuid", qStatisticsComponentsUUID); err != nil {
				return err
			}
		}
	}

	if o.StatisticsIopsPerTbQueryParameter != nil {

		// query param statistics.iops.per_tb
		var qrStatisticsIopsPerTb string

		if o.StatisticsIopsPerTbQueryParameter != nil {
			qrStatisticsIopsPerTb = *o.StatisticsIopsPerTbQueryParameter
		}
		qStatisticsIopsPerTb := qrStatisticsIopsPerTb
		if qStatisticsIopsPerTb != "" {

			if err := r.SetQueryParam("statistics.iops.per_tb", qStatisticsIopsPerTb); err != nil {
				return err
			}
		}
	}

	if o.StatisticsIopsTotalQueryParameter != nil {

		// query param statistics.iops.total
		var qrStatisticsIopsTotal string

		if o.StatisticsIopsTotalQueryParameter != nil {
			qrStatisticsIopsTotal = *o.StatisticsIopsTotalQueryParameter
		}
		qStatisticsIopsTotal := qrStatisticsIopsTotal
		if qStatisticsIopsTotal != "" {

			if err := r.SetQueryParam("statistics.iops.total", qStatisticsIopsTotal); err != nil {
				return err
			}
		}
	}

	if o.StatisticsLatencyAverageQueryParameter != nil {

		// query param statistics.latency.average
		var qrStatisticsLatencyAverage string

		if o.StatisticsLatencyAverageQueryParameter != nil {
			qrStatisticsLatencyAverage = *o.StatisticsLatencyAverageQueryParameter
		}
		qStatisticsLatencyAverage := qrStatisticsLatencyAverage
		if qStatisticsLatencyAverage != "" {

			if err := r.SetQueryParam("statistics.latency.average", qStatisticsLatencyAverage); err != nil {
				return err
			}
		}
	}

	if o.StatisticsLatencyRawQueryParameter != nil {

		// query param statistics.latency.raw
		var qrStatisticsLatencyRaw string

		if o.StatisticsLatencyRawQueryParameter != nil {
			qrStatisticsLatencyRaw = *o.StatisticsLatencyRawQueryParameter
		}
		qStatisticsLatencyRaw := qrStatisticsLatencyRaw
		if qStatisticsLatencyRaw != "" {

			if err := r.SetQueryParam("statistics.latency.raw", qStatisticsLatencyRaw); err != nil {
				return err
			}
		}
	}

	if o.StatisticsSharedStoragePoolQueryParameter != nil {

		// query param statistics.shared_storage_pool
		var qrStatisticsSharedStoragePool string

		if o.StatisticsSharedStoragePoolQueryParameter != nil {
			qrStatisticsSharedStoragePool = *o.StatisticsSharedStoragePoolQueryParameter
		}
		qStatisticsSharedStoragePool := qrStatisticsSharedStoragePool
		if qStatisticsSharedStoragePool != "" {

			if err := r.SetQueryParam("statistics.shared_storage_pool", qStatisticsSharedStoragePool); err != nil {
				return err
			}
		}
	}

	if o.StatisticsSnapshotReserveQueryParameter != nil {

		// query param statistics.snapshot.reserve
		var qrStatisticsSnapshotReserve string

		if o.StatisticsSnapshotReserveQueryParameter != nil {
			qrStatisticsSnapshotReserve = *o.StatisticsSnapshotReserveQueryParameter
		}
		qStatisticsSnapshotReserve := qrStatisticsSnapshotReserve
		if qStatisticsSnapshotReserve != "" {

			if err := r.SetQueryParam("statistics.snapshot.reserve", qStatisticsSnapshotReserve); err != nil {
				return err
			}
		}
	}

	if o.StatisticsSnapshotUsedQueryParameter != nil {

		// query param statistics.snapshot.used
		var qrStatisticsSnapshotUsed string

		if o.StatisticsSnapshotUsedQueryParameter != nil {
			qrStatisticsSnapshotUsed = *o.StatisticsSnapshotUsedQueryParameter
		}
		qStatisticsSnapshotUsed := qrStatisticsSnapshotUsed
		if qStatisticsSnapshotUsed != "" {

			if err := r.SetQueryParam("statistics.snapshot.used", qStatisticsSnapshotUsed); err != nil {
				return err
			}
		}
	}

	if o.StatisticsSpaceAvailableQueryParameter != nil {

		// query param statistics.space.available
		var qrStatisticsSpaceAvailable string

		if o.StatisticsSpaceAvailableQueryParameter != nil {
			qrStatisticsSpaceAvailable = *o.StatisticsSpaceAvailableQueryParameter
		}
		qStatisticsSpaceAvailable := qrStatisticsSpaceAvailable
		if qStatisticsSpaceAvailable != "" {

			if err := r.SetQueryParam("statistics.space.available", qStatisticsSpaceAvailable); err != nil {
				return err
			}
		}
	}

	if o.StatisticsSpaceLogicalUsedQueryParameter != nil {

		// query param statistics.space.logical_used
		var qrStatisticsSpaceLogicalUsed string

		if o.StatisticsSpaceLogicalUsedQueryParameter != nil {
			qrStatisticsSpaceLogicalUsed = *o.StatisticsSpaceLogicalUsedQueryParameter
		}
		qStatisticsSpaceLogicalUsed := qrStatisticsSpaceLogicalUsed
		if qStatisticsSpaceLogicalUsed != "" {

			if err := r.SetQueryParam("statistics.space.logical_used", qStatisticsSpaceLogicalUsed); err != nil {
				return err
			}
		}
	}

	if o.StatisticsSpaceProvisionedQueryParameter != nil {

		// query param statistics.space.provisioned
		var qrStatisticsSpaceProvisioned string

		if o.StatisticsSpaceProvisionedQueryParameter != nil {
			qrStatisticsSpaceProvisioned = *o.StatisticsSpaceProvisionedQueryParameter
		}
		qStatisticsSpaceProvisioned := qrStatisticsSpaceProvisioned
		if qStatisticsSpaceProvisioned != "" {

			if err := r.SetQueryParam("statistics.space.provisioned", qStatisticsSpaceProvisioned); err != nil {
				return err
			}
		}
	}

	if o.StatisticsSpaceReservedUnusedQueryParameter != nil {

		// query param statistics.space.reserved_unused
		var qrStatisticsSpaceReservedUnused string

		if o.StatisticsSpaceReservedUnusedQueryParameter != nil {
			qrStatisticsSpaceReservedUnused = *o.StatisticsSpaceReservedUnusedQueryParameter
		}
		qStatisticsSpaceReservedUnused := qrStatisticsSpaceReservedUnused
		if qStatisticsSpaceReservedUnused != "" {

			if err := r.SetQueryParam("statistics.space.reserved_unused", qStatisticsSpaceReservedUnused); err != nil {
				return err
			}
		}
	}

	if o.StatisticsSpaceSavingsQueryParameter != nil {

		// query param statistics.space.savings
		var qrStatisticsSpaceSavings string

		if o.StatisticsSpaceSavingsQueryParameter != nil {
			qrStatisticsSpaceSavings = *o.StatisticsSpaceSavingsQueryParameter
		}
		qStatisticsSpaceSavings := qrStatisticsSpaceSavings
		if qStatisticsSpaceSavings != "" {

			if err := r.SetQueryParam("statistics.space.savings", qStatisticsSpaceSavings); err != nil {
				return err
			}
		}
	}

	if o.StatisticsSpaceUsedQueryParameter != nil {

		// query param statistics.space.used
		var qrStatisticsSpaceUsed string

		if o.StatisticsSpaceUsedQueryParameter != nil {
			qrStatisticsSpaceUsed = *o.StatisticsSpaceUsedQueryParameter
		}
		qStatisticsSpaceUsed := qrStatisticsSpaceUsed
		if qStatisticsSpaceUsed != "" {

			if err := r.SetQueryParam("statistics.space.used", qStatisticsSpaceUsed); err != nil {
				return err
			}
		}
	}

	if o.StatisticsSpaceUsedExcludingReservesQueryParameter != nil {

		// query param statistics.space.used_excluding_reserves
		var qrStatisticsSpaceUsedExcludingReserves string

		if o.StatisticsSpaceUsedExcludingReservesQueryParameter != nil {
			qrStatisticsSpaceUsedExcludingReserves = *o.StatisticsSpaceUsedExcludingReservesQueryParameter
		}
		qStatisticsSpaceUsedExcludingReserves := qrStatisticsSpaceUsedExcludingReserves
		if qStatisticsSpaceUsedExcludingReserves != "" {

			if err := r.SetQueryParam("statistics.space.used_excluding_reserves", qStatisticsSpaceUsedExcludingReserves); err != nil {
				return err
			}
		}
	}

	if o.StatisticsSpaceUsedPercentQueryParameter != nil {

		// query param statistics.space.used_percent
		var qrStatisticsSpaceUsedPercent string

		if o.StatisticsSpaceUsedPercentQueryParameter != nil {
			qrStatisticsSpaceUsedPercent = *o.StatisticsSpaceUsedPercentQueryParameter
		}
		qStatisticsSpaceUsedPercent := qrStatisticsSpaceUsedPercent
		if qStatisticsSpaceUsedPercent != "" {

			if err := r.SetQueryParam("statistics.space.used_percent", qStatisticsSpaceUsedPercent); err != nil {
				return err
			}
		}
	}

	if o.StatisticsStatisticsIncompleteQueryParameter != nil {

		// query param statistics.statistics_incomplete
		var qrStatisticsStatisticsIncomplete string

		if o.StatisticsStatisticsIncompleteQueryParameter != nil {
			qrStatisticsStatisticsIncomplete = *o.StatisticsStatisticsIncompleteQueryParameter
		}
		qStatisticsStatisticsIncomplete := qrStatisticsStatisticsIncomplete
		if qStatisticsStatisticsIncomplete != "" {

			if err := r.SetQueryParam("statistics.statistics_incomplete", qStatisticsStatisticsIncomplete); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if o.TemplateNameQueryParameter != nil {

		// query param template.name
		var qrTemplateName string

		if o.TemplateNameQueryParameter != nil {
			qrTemplateName = *o.TemplateNameQueryParameter
		}
		qTemplateName := qrTemplateName
		if qTemplateName != "" {

			if err := r.SetQueryParam("template.name", qTemplateName); err != nil {
				return err
			}
		}
	}

	if o.TemplateProtocolQueryParameter != nil {

		// query param template.protocol
		var qrTemplateProtocol string

		if o.TemplateProtocolQueryParameter != nil {
			qrTemplateProtocol = *o.TemplateProtocolQueryParameter
		}
		qTemplateProtocol := qrTemplateProtocol
		if qTemplateProtocol != "" {

			if err := r.SetQueryParam("template.protocol", qTemplateProtocol); err != nil {
				return err
			}
		}
	}

	if o.TemplateVersionQueryParameter != nil {

		// query param template.version
		var qrTemplateVersion string

		if o.TemplateVersionQueryParameter != nil {
			qrTemplateVersion = *o.TemplateVersionQueryParameter
		}
		qTemplateVersion := qrTemplateVersion
		if qTemplateVersion != "" {

			if err := r.SetQueryParam("template.version", qTemplateVersion); err != nil {
				return err
			}
		}
	}

	if o.UUIDQueryParameter != nil {

		// query param uuid
		var qrUUID string

		if o.UUIDQueryParameter != nil {
			qrUUID = *o.UUIDQueryParameter
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamApplicationCollectionGet binds the parameter fields
func (o *ApplicationCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamApplicationCollectionGet binds the parameter order_by
func (o *ApplicationCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
