// Code generated by go-swagger; DO NOT EDIT.

package application

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewApplicationSnapshotCollectionGetParams creates a new ApplicationSnapshotCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewApplicationSnapshotCollectionGetParams() *ApplicationSnapshotCollectionGetParams {
	return &ApplicationSnapshotCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewApplicationSnapshotCollectionGetParamsWithTimeout creates a new ApplicationSnapshotCollectionGetParams object
// with the ability to set a timeout on a request.
func NewApplicationSnapshotCollectionGetParamsWithTimeout(timeout time.Duration) *ApplicationSnapshotCollectionGetParams {
	return &ApplicationSnapshotCollectionGetParams{
		timeout: timeout,
	}
}

// NewApplicationSnapshotCollectionGetParamsWithContext creates a new ApplicationSnapshotCollectionGetParams object
// with the ability to set a context for a request.
func NewApplicationSnapshotCollectionGetParamsWithContext(ctx context.Context) *ApplicationSnapshotCollectionGetParams {
	return &ApplicationSnapshotCollectionGetParams{
		Context: ctx,
	}
}

// NewApplicationSnapshotCollectionGetParamsWithHTTPClient creates a new ApplicationSnapshotCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewApplicationSnapshotCollectionGetParamsWithHTTPClient(client *http.Client) *ApplicationSnapshotCollectionGetParams {
	return &ApplicationSnapshotCollectionGetParams{
		HTTPClient: client,
	}
}

/*
ApplicationSnapshotCollectionGetParams contains all the parameters to send to the API endpoint

	for the application snapshot collection get operation.

	Typically these are written to a http.Request.
*/
type ApplicationSnapshotCollectionGetParams struct {

	/* ApplicationUUID.

	   Application UUID
	*/
	ApplicationUUIDPathParameter string

	/* Comment.

	   Filter by comment
	*/
	CommentQueryParameter *string

	/* ComponentsName.

	   Filter by components.name
	*/
	ComponentsNameQueryParameter *string

	/* ComponentsUUID.

	   Filter by components.uuid
	*/
	ComponentsUUIDQueryParameter *string

	/* ConsistencyType.

	   Filter by consistency_type
	*/
	ConsistencyTypeQueryParameter *string

	/* CreateTime.

	   Filter by create_time
	*/
	CreateTimeQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* IsPartial.

	   Filter by is_partial
	*/
	IsPartialQueryParameter *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* UUID.

	   Filter by UUID
	*/
	UUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the application snapshot collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ApplicationSnapshotCollectionGetParams) WithDefaults() *ApplicationSnapshotCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the application snapshot collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ApplicationSnapshotCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := ApplicationSnapshotCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithTimeout(timeout time.Duration) *ApplicationSnapshotCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithContext(ctx context.Context) *ApplicationSnapshotCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithHTTPClient(client *http.Client) *ApplicationSnapshotCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithApplicationUUIDPathParameter adds the applicationUUID to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithApplicationUUIDPathParameter(applicationUUID string) *ApplicationSnapshotCollectionGetParams {
	o.SetApplicationUUIDPathParameter(applicationUUID)
	return o
}

// SetApplicationUUIDPathParameter adds the applicationUuid to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetApplicationUUIDPathParameter(applicationUUID string) {
	o.ApplicationUUIDPathParameter = applicationUUID
}

// WithCommentQueryParameter adds the comment to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithCommentQueryParameter(comment *string) *ApplicationSnapshotCollectionGetParams {
	o.SetCommentQueryParameter(comment)
	return o
}

// SetCommentQueryParameter adds the comment to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetCommentQueryParameter(comment *string) {
	o.CommentQueryParameter = comment
}

// WithComponentsNameQueryParameter adds the componentsName to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithComponentsNameQueryParameter(componentsName *string) *ApplicationSnapshotCollectionGetParams {
	o.SetComponentsNameQueryParameter(componentsName)
	return o
}

// SetComponentsNameQueryParameter adds the componentsName to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetComponentsNameQueryParameter(componentsName *string) {
	o.ComponentsNameQueryParameter = componentsName
}

// WithComponentsUUIDQueryParameter adds the componentsUUID to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithComponentsUUIDQueryParameter(componentsUUID *string) *ApplicationSnapshotCollectionGetParams {
	o.SetComponentsUUIDQueryParameter(componentsUUID)
	return o
}

// SetComponentsUUIDQueryParameter adds the componentsUuid to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetComponentsUUIDQueryParameter(componentsUUID *string) {
	o.ComponentsUUIDQueryParameter = componentsUUID
}

// WithConsistencyTypeQueryParameter adds the consistencyType to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithConsistencyTypeQueryParameter(consistencyType *string) *ApplicationSnapshotCollectionGetParams {
	o.SetConsistencyTypeQueryParameter(consistencyType)
	return o
}

// SetConsistencyTypeQueryParameter adds the consistencyType to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetConsistencyTypeQueryParameter(consistencyType *string) {
	o.ConsistencyTypeQueryParameter = consistencyType
}

// WithCreateTimeQueryParameter adds the createTime to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithCreateTimeQueryParameter(createTime *string) *ApplicationSnapshotCollectionGetParams {
	o.SetCreateTimeQueryParameter(createTime)
	return o
}

// SetCreateTimeQueryParameter adds the createTime to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetCreateTimeQueryParameter(createTime *string) {
	o.CreateTimeQueryParameter = createTime
}

// WithFieldsQueryParameter adds the fields to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithFieldsQueryParameter(fields []string) *ApplicationSnapshotCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIsPartialQueryParameter adds the isPartial to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithIsPartialQueryParameter(isPartial *string) *ApplicationSnapshotCollectionGetParams {
	o.SetIsPartialQueryParameter(isPartial)
	return o
}

// SetIsPartialQueryParameter adds the isPartial to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetIsPartialQueryParameter(isPartial *string) {
	o.IsPartialQueryParameter = isPartial
}

// WithMaxRecordsQueryParameter adds the maxRecords to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *ApplicationSnapshotCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithNameQueryParameter(name *string) *ApplicationSnapshotCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *ApplicationSnapshotCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *ApplicationSnapshotCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *ApplicationSnapshotCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithUUIDQueryParameter adds the uuid to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) WithUUIDQueryParameter(uuid *string) *ApplicationSnapshotCollectionGetParams {
	o.SetUUIDQueryParameter(uuid)
	return o
}

// SetUUIDQueryParameter adds the uuid to the application snapshot collection get params
func (o *ApplicationSnapshotCollectionGetParams) SetUUIDQueryParameter(uuid *string) {
	o.UUIDQueryParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *ApplicationSnapshotCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param application.uuid
	if err := r.SetPathParam("application.uuid", o.ApplicationUUIDPathParameter); err != nil {
		return err
	}

	if o.CommentQueryParameter != nil {

		// query param comment
		var qrComment string

		if o.CommentQueryParameter != nil {
			qrComment = *o.CommentQueryParameter
		}
		qComment := qrComment
		if qComment != "" {

			if err := r.SetQueryParam("comment", qComment); err != nil {
				return err
			}
		}
	}

	if o.ComponentsNameQueryParameter != nil {

		// query param components.name
		var qrComponentsName string

		if o.ComponentsNameQueryParameter != nil {
			qrComponentsName = *o.ComponentsNameQueryParameter
		}
		qComponentsName := qrComponentsName
		if qComponentsName != "" {

			if err := r.SetQueryParam("components.name", qComponentsName); err != nil {
				return err
			}
		}
	}

	if o.ComponentsUUIDQueryParameter != nil {

		// query param components.uuid
		var qrComponentsUUID string

		if o.ComponentsUUIDQueryParameter != nil {
			qrComponentsUUID = *o.ComponentsUUIDQueryParameter
		}
		qComponentsUUID := qrComponentsUUID
		if qComponentsUUID != "" {

			if err := r.SetQueryParam("components.uuid", qComponentsUUID); err != nil {
				return err
			}
		}
	}

	if o.ConsistencyTypeQueryParameter != nil {

		// query param consistency_type
		var qrConsistencyType string

		if o.ConsistencyTypeQueryParameter != nil {
			qrConsistencyType = *o.ConsistencyTypeQueryParameter
		}
		qConsistencyType := qrConsistencyType
		if qConsistencyType != "" {

			if err := r.SetQueryParam("consistency_type", qConsistencyType); err != nil {
				return err
			}
		}
	}

	if o.CreateTimeQueryParameter != nil {

		// query param create_time
		var qrCreateTime string

		if o.CreateTimeQueryParameter != nil {
			qrCreateTime = *o.CreateTimeQueryParameter
		}
		qCreateTime := qrCreateTime
		if qCreateTime != "" {

			if err := r.SetQueryParam("create_time", qCreateTime); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.IsPartialQueryParameter != nil {

		// query param is_partial
		var qrIsPartial string

		if o.IsPartialQueryParameter != nil {
			qrIsPartial = *o.IsPartialQueryParameter
		}
		qIsPartial := qrIsPartial
		if qIsPartial != "" {

			if err := r.SetQueryParam("is_partial", qIsPartial); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.UUIDQueryParameter != nil {

		// query param uuid
		var qrUUID string

		if o.UUIDQueryParameter != nil {
			qrUUID = *o.UUIDQueryParameter
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamApplicationSnapshotCollectionGet binds the parameter fields
func (o *ApplicationSnapshotCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamApplicationSnapshotCollectionGet binds the parameter order_by
func (o *ApplicationSnapshotCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
