// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewCapacityPoolGetParams creates a new CapacityPoolGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCapacityPoolGetParams() *CapacityPoolGetParams {
	return &CapacityPoolGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCapacityPoolGetParamsWithTimeout creates a new CapacityPoolGetParams object
// with the ability to set a timeout on a request.
func NewCapacityPoolGetParamsWithTimeout(timeout time.Duration) *CapacityPoolGetParams {
	return &CapacityPoolGetParams{
		timeout: timeout,
	}
}

// NewCapacityPoolGetParamsWithContext creates a new CapacityPoolGetParams object
// with the ability to set a context for a request.
func NewCapacityPoolGetParamsWithContext(ctx context.Context) *CapacityPoolGetParams {
	return &CapacityPoolGetParams{
		Context: ctx,
	}
}

// NewCapacityPoolGetParamsWithHTTPClient creates a new CapacityPoolGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewCapacityPoolGetParamsWithHTTPClient(client *http.Client) *CapacityPoolGetParams {
	return &CapacityPoolGetParams{
		HTTPClient: client,
	}
}

/*
CapacityPoolGetParams contains all the parameters to send to the API endpoint

	for the capacity pool get operation.

	Typically these are written to a http.Request.
*/
type CapacityPoolGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* LicenseManagerUUID.

	   Filter by license_manager.uuid
	*/
	LicenseManagerUUIDQueryParameter *string

	/* NodesNodeName.

	   Filter by nodes.node.name
	*/
	NodesNodeNameQueryParameter *string

	/* NodesNodeUUID.

	   Filter by nodes.node.uuid
	*/
	NodesNodeUUIDQueryParameter *string

	/* NodesUsedSize.

	   Filter by nodes.used_size
	*/
	NodesUsedSizeQueryParameter *int64

	/* SerialNumber.

	   Serial number of the capacity pool license.
	*/
	SerialNumberPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the capacity pool get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CapacityPoolGetParams) WithDefaults() *CapacityPoolGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the capacity pool get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CapacityPoolGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the capacity pool get params
func (o *CapacityPoolGetParams) WithTimeout(timeout time.Duration) *CapacityPoolGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the capacity pool get params
func (o *CapacityPoolGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the capacity pool get params
func (o *CapacityPoolGetParams) WithContext(ctx context.Context) *CapacityPoolGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the capacity pool get params
func (o *CapacityPoolGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the capacity pool get params
func (o *CapacityPoolGetParams) WithHTTPClient(client *http.Client) *CapacityPoolGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the capacity pool get params
func (o *CapacityPoolGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the capacity pool get params
func (o *CapacityPoolGetParams) WithFieldsQueryParameter(fields []string) *CapacityPoolGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the capacity pool get params
func (o *CapacityPoolGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithLicenseManagerUUIDQueryParameter adds the licenseManagerUUID to the capacity pool get params
func (o *CapacityPoolGetParams) WithLicenseManagerUUIDQueryParameter(licenseManagerUUID *string) *CapacityPoolGetParams {
	o.SetLicenseManagerUUIDQueryParameter(licenseManagerUUID)
	return o
}

// SetLicenseManagerUUIDQueryParameter adds the licenseManagerUuid to the capacity pool get params
func (o *CapacityPoolGetParams) SetLicenseManagerUUIDQueryParameter(licenseManagerUUID *string) {
	o.LicenseManagerUUIDQueryParameter = licenseManagerUUID
}

// WithNodesNodeNameQueryParameter adds the nodesNodeName to the capacity pool get params
func (o *CapacityPoolGetParams) WithNodesNodeNameQueryParameter(nodesNodeName *string) *CapacityPoolGetParams {
	o.SetNodesNodeNameQueryParameter(nodesNodeName)
	return o
}

// SetNodesNodeNameQueryParameter adds the nodesNodeName to the capacity pool get params
func (o *CapacityPoolGetParams) SetNodesNodeNameQueryParameter(nodesNodeName *string) {
	o.NodesNodeNameQueryParameter = nodesNodeName
}

// WithNodesNodeUUIDQueryParameter adds the nodesNodeUUID to the capacity pool get params
func (o *CapacityPoolGetParams) WithNodesNodeUUIDQueryParameter(nodesNodeUUID *string) *CapacityPoolGetParams {
	o.SetNodesNodeUUIDQueryParameter(nodesNodeUUID)
	return o
}

// SetNodesNodeUUIDQueryParameter adds the nodesNodeUuid to the capacity pool get params
func (o *CapacityPoolGetParams) SetNodesNodeUUIDQueryParameter(nodesNodeUUID *string) {
	o.NodesNodeUUIDQueryParameter = nodesNodeUUID
}

// WithNodesUsedSizeQueryParameter adds the nodesUsedSize to the capacity pool get params
func (o *CapacityPoolGetParams) WithNodesUsedSizeQueryParameter(nodesUsedSize *int64) *CapacityPoolGetParams {
	o.SetNodesUsedSizeQueryParameter(nodesUsedSize)
	return o
}

// SetNodesUsedSizeQueryParameter adds the nodesUsedSize to the capacity pool get params
func (o *CapacityPoolGetParams) SetNodesUsedSizeQueryParameter(nodesUsedSize *int64) {
	o.NodesUsedSizeQueryParameter = nodesUsedSize
}

// WithSerialNumberPathParameter adds the serialNumber to the capacity pool get params
func (o *CapacityPoolGetParams) WithSerialNumberPathParameter(serialNumber string) *CapacityPoolGetParams {
	o.SetSerialNumberPathParameter(serialNumber)
	return o
}

// SetSerialNumberPathParameter adds the serialNumber to the capacity pool get params
func (o *CapacityPoolGetParams) SetSerialNumberPathParameter(serialNumber string) {
	o.SerialNumberPathParameter = serialNumber
}

// WriteToRequest writes these params to a swagger request
func (o *CapacityPoolGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.LicenseManagerUUIDQueryParameter != nil {

		// query param license_manager.uuid
		var qrLicenseManagerUUID string

		if o.LicenseManagerUUIDQueryParameter != nil {
			qrLicenseManagerUUID = *o.LicenseManagerUUIDQueryParameter
		}
		qLicenseManagerUUID := qrLicenseManagerUUID
		if qLicenseManagerUUID != "" {

			if err := r.SetQueryParam("license_manager.uuid", qLicenseManagerUUID); err != nil {
				return err
			}
		}
	}

	if o.NodesNodeNameQueryParameter != nil {

		// query param nodes.node.name
		var qrNodesNodeName string

		if o.NodesNodeNameQueryParameter != nil {
			qrNodesNodeName = *o.NodesNodeNameQueryParameter
		}
		qNodesNodeName := qrNodesNodeName
		if qNodesNodeName != "" {

			if err := r.SetQueryParam("nodes.node.name", qNodesNodeName); err != nil {
				return err
			}
		}
	}

	if o.NodesNodeUUIDQueryParameter != nil {

		// query param nodes.node.uuid
		var qrNodesNodeUUID string

		if o.NodesNodeUUIDQueryParameter != nil {
			qrNodesNodeUUID = *o.NodesNodeUUIDQueryParameter
		}
		qNodesNodeUUID := qrNodesNodeUUID
		if qNodesNodeUUID != "" {

			if err := r.SetQueryParam("nodes.node.uuid", qNodesNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.NodesUsedSizeQueryParameter != nil {

		// query param nodes.used_size
		var qrNodesUsedSize int64

		if o.NodesUsedSizeQueryParameter != nil {
			qrNodesUsedSize = *o.NodesUsedSizeQueryParameter
		}
		qNodesUsedSize := swag.FormatInt64(qrNodesUsedSize)
		if qNodesUsedSize != "" {

			if err := r.SetQueryParam("nodes.used_size", qNodesUsedSize); err != nil {
				return err
			}
		}
	}

	// path param serial_number
	if err := r.SetPathParam("serial_number", o.SerialNumberPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamCapacityPoolGet binds the parameter fields
func (o *CapacityPoolGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
