// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewClusterCreateParams creates a new ClusterCreateParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewClusterCreateParams() *ClusterCreateParams {
	return &ClusterCreateParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewClusterCreateParamsWithTimeout creates a new ClusterCreateParams object
// with the ability to set a timeout on a request.
func NewClusterCreateParamsWithTimeout(timeout time.Duration) *ClusterCreateParams {
	return &ClusterCreateParams{
		timeout: timeout,
	}
}

// NewClusterCreateParamsWithContext creates a new ClusterCreateParams object
// with the ability to set a context for a request.
func NewClusterCreateParamsWithContext(ctx context.Context) *ClusterCreateParams {
	return &ClusterCreateParams{
		Context: ctx,
	}
}

// NewClusterCreateParamsWithHTTPClient creates a new ClusterCreateParams object
// with the ability to set a custom HTTPClient for a request.
func NewClusterCreateParamsWithHTTPClient(client *http.Client) *ClusterCreateParams {
	return &ClusterCreateParams{
		HTTPClient: client,
	}
}

/*
ClusterCreateParams contains all the parameters to send to the API endpoint

	for the cluster create operation.

	Typically these are written to a http.Request.
*/
type ClusterCreateParams struct {

	/* CreateRecommendedAggregates.

	   Create aggregates based on an optimal layout recommended by the system.
	*/
	CreateRecommendedAggregatesQueryParameter *bool

	/* Info.

	   Cluster information
	*/
	Info *models.Cluster

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning. When doing a POST, PATCH, or DELETE operation on a single record, the default is 0 seconds.  This means that if an asynchronous operation is started, the server immediately returns HTTP code 202 (Accepted) along with a link to the job.  If a non-zero value is specified for POST, PATCH, or DELETE operations, ONTAP waits that length of time to see if the job completes so it can return something other than 202.
	*/
	ReturnTimeoutQueryParameter *int64

	/* SingleNodeCluster.

	   Configures a single node cluster.  All cluster ports are reassigned to the default network. The storage failover settings are configured to non-HA. The node reboots during this operation.
	*/
	SingleNodeClusterQueryParameter *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the cluster create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ClusterCreateParams) WithDefaults() *ClusterCreateParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the cluster create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ClusterCreateParams) SetDefaults() {
	var (
		createRecommendedAggregatesQueryParameterDefault = bool(false)

		returnTimeoutQueryParameterDefault = int64(0)
	)

	val := ClusterCreateParams{
		CreateRecommendedAggregatesQueryParameter: &createRecommendedAggregatesQueryParameterDefault,
		ReturnTimeoutQueryParameter:               &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the cluster create params
func (o *ClusterCreateParams) WithTimeout(timeout time.Duration) *ClusterCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the cluster create params
func (o *ClusterCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the cluster create params
func (o *ClusterCreateParams) WithContext(ctx context.Context) *ClusterCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the cluster create params
func (o *ClusterCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the cluster create params
func (o *ClusterCreateParams) WithHTTPClient(client *http.Client) *ClusterCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the cluster create params
func (o *ClusterCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCreateRecommendedAggregatesQueryParameter adds the createRecommendedAggregates to the cluster create params
func (o *ClusterCreateParams) WithCreateRecommendedAggregatesQueryParameter(createRecommendedAggregates *bool) *ClusterCreateParams {
	o.SetCreateRecommendedAggregatesQueryParameter(createRecommendedAggregates)
	return o
}

// SetCreateRecommendedAggregatesQueryParameter adds the createRecommendedAggregates to the cluster create params
func (o *ClusterCreateParams) SetCreateRecommendedAggregatesQueryParameter(createRecommendedAggregates *bool) {
	o.CreateRecommendedAggregatesQueryParameter = createRecommendedAggregates
}

// WithInfo adds the info to the cluster create params
func (o *ClusterCreateParams) WithInfo(info *models.Cluster) *ClusterCreateParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the cluster create params
func (o *ClusterCreateParams) SetInfo(info *models.Cluster) {
	o.Info = info
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the cluster create params
func (o *ClusterCreateParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *ClusterCreateParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the cluster create params
func (o *ClusterCreateParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSingleNodeClusterQueryParameter adds the singleNodeCluster to the cluster create params
func (o *ClusterCreateParams) WithSingleNodeClusterQueryParameter(singleNodeCluster *bool) *ClusterCreateParams {
	o.SetSingleNodeClusterQueryParameter(singleNodeCluster)
	return o
}

// SetSingleNodeClusterQueryParameter adds the singleNodeCluster to the cluster create params
func (o *ClusterCreateParams) SetSingleNodeClusterQueryParameter(singleNodeCluster *bool) {
	o.SingleNodeClusterQueryParameter = singleNodeCluster
}

// WriteToRequest writes these params to a swagger request
func (o *ClusterCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CreateRecommendedAggregatesQueryParameter != nil {

		// query param create_recommended_aggregates
		var qrCreateRecommendedAggregates bool

		if o.CreateRecommendedAggregatesQueryParameter != nil {
			qrCreateRecommendedAggregates = *o.CreateRecommendedAggregatesQueryParameter
		}
		qCreateRecommendedAggregates := swag.FormatBool(qrCreateRecommendedAggregates)
		if qCreateRecommendedAggregates != "" {

			if err := r.SetQueryParam("create_recommended_aggregates", qCreateRecommendedAggregates); err != nil {
				return err
			}
		}
	}
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SingleNodeClusterQueryParameter != nil {

		// query param single_node_cluster
		var qrSingleNodeCluster bool

		if o.SingleNodeClusterQueryParameter != nil {
			qrSingleNodeCluster = *o.SingleNodeClusterQueryParameter
		}
		qSingleNodeCluster := swag.FormatBool(qrSingleNodeCluster)
		if qSingleNodeCluster != "" {

			if err := r.SetQueryParam("single_node_cluster", qSingleNodeCluster); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
