// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewClusterNtpKeysCollectionGetParams creates a new ClusterNtpKeysCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewClusterNtpKeysCollectionGetParams() *ClusterNtpKeysCollectionGetParams {
	return &ClusterNtpKeysCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewClusterNtpKeysCollectionGetParamsWithTimeout creates a new ClusterNtpKeysCollectionGetParams object
// with the ability to set a timeout on a request.
func NewClusterNtpKeysCollectionGetParamsWithTimeout(timeout time.Duration) *ClusterNtpKeysCollectionGetParams {
	return &ClusterNtpKeysCollectionGetParams{
		timeout: timeout,
	}
}

// NewClusterNtpKeysCollectionGetParamsWithContext creates a new ClusterNtpKeysCollectionGetParams object
// with the ability to set a context for a request.
func NewClusterNtpKeysCollectionGetParamsWithContext(ctx context.Context) *ClusterNtpKeysCollectionGetParams {
	return &ClusterNtpKeysCollectionGetParams{
		Context: ctx,
	}
}

// NewClusterNtpKeysCollectionGetParamsWithHTTPClient creates a new ClusterNtpKeysCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewClusterNtpKeysCollectionGetParamsWithHTTPClient(client *http.Client) *ClusterNtpKeysCollectionGetParams {
	return &ClusterNtpKeysCollectionGetParams{
		HTTPClient: client,
	}
}

/*
ClusterNtpKeysCollectionGetParams contains all the parameters to send to the API endpoint

	for the cluster ntp keys collection get operation.

	Typically these are written to a http.Request.
*/
type ClusterNtpKeysCollectionGetParams struct {

	/* DigestType.

	   Filter by digest_type
	*/
	DigestTypeQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* ID.

	   Filter by id
	*/
	IDQueryParameter *int64

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* Value.

	   Filter by value
	*/
	ValueQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the cluster ntp keys collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ClusterNtpKeysCollectionGetParams) WithDefaults() *ClusterNtpKeysCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the cluster ntp keys collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ClusterNtpKeysCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := ClusterNtpKeysCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) WithTimeout(timeout time.Duration) *ClusterNtpKeysCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) WithContext(ctx context.Context) *ClusterNtpKeysCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) WithHTTPClient(client *http.Client) *ClusterNtpKeysCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDigestTypeQueryParameter adds the digestType to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) WithDigestTypeQueryParameter(digestType *string) *ClusterNtpKeysCollectionGetParams {
	o.SetDigestTypeQueryParameter(digestType)
	return o
}

// SetDigestTypeQueryParameter adds the digestType to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) SetDigestTypeQueryParameter(digestType *string) {
	o.DigestTypeQueryParameter = digestType
}

// WithFieldsQueryParameter adds the fields to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) WithFieldsQueryParameter(fields []string) *ClusterNtpKeysCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIDQueryParameter adds the id to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) WithIDQueryParameter(id *int64) *ClusterNtpKeysCollectionGetParams {
	o.SetIDQueryParameter(id)
	return o
}

// SetIDQueryParameter adds the id to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) SetIDQueryParameter(id *int64) {
	o.IDQueryParameter = id
}

// WithMaxRecordsQueryParameter adds the maxRecords to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *ClusterNtpKeysCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *ClusterNtpKeysCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *ClusterNtpKeysCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *ClusterNtpKeysCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithValueQueryParameter adds the value to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) WithValueQueryParameter(value *string) *ClusterNtpKeysCollectionGetParams {
	o.SetValueQueryParameter(value)
	return o
}

// SetValueQueryParameter adds the value to the cluster ntp keys collection get params
func (o *ClusterNtpKeysCollectionGetParams) SetValueQueryParameter(value *string) {
	o.ValueQueryParameter = value
}

// WriteToRequest writes these params to a swagger request
func (o *ClusterNtpKeysCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.DigestTypeQueryParameter != nil {

		// query param digest_type
		var qrDigestType string

		if o.DigestTypeQueryParameter != nil {
			qrDigestType = *o.DigestTypeQueryParameter
		}
		qDigestType := qrDigestType
		if qDigestType != "" {

			if err := r.SetQueryParam("digest_type", qDigestType); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.IDQueryParameter != nil {

		// query param id
		var qrID int64

		if o.IDQueryParameter != nil {
			qrID = *o.IDQueryParameter
		}
		qID := swag.FormatInt64(qrID)
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.ValueQueryParameter != nil {

		// query param value
		var qrValue string

		if o.ValueQueryParameter != nil {
			qrValue = *o.ValueQueryParameter
		}
		qValue := qrValue
		if qValue != "" {

			if err := r.SetQueryParam("value", qValue); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamClusterNtpKeysCollectionGet binds the parameter fields
func (o *ClusterNtpKeysCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamClusterNtpKeysCollectionGet binds the parameter order_by
func (o *ClusterNtpKeysCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
