// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewLicenseManagerCollectionGetParams creates a new LicenseManagerCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLicenseManagerCollectionGetParams() *LicenseManagerCollectionGetParams {
	return &LicenseManagerCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLicenseManagerCollectionGetParamsWithTimeout creates a new LicenseManagerCollectionGetParams object
// with the ability to set a timeout on a request.
func NewLicenseManagerCollectionGetParamsWithTimeout(timeout time.Duration) *LicenseManagerCollectionGetParams {
	return &LicenseManagerCollectionGetParams{
		timeout: timeout,
	}
}

// NewLicenseManagerCollectionGetParamsWithContext creates a new LicenseManagerCollectionGetParams object
// with the ability to set a context for a request.
func NewLicenseManagerCollectionGetParamsWithContext(ctx context.Context) *LicenseManagerCollectionGetParams {
	return &LicenseManagerCollectionGetParams{
		Context: ctx,
	}
}

// NewLicenseManagerCollectionGetParamsWithHTTPClient creates a new LicenseManagerCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewLicenseManagerCollectionGetParamsWithHTTPClient(client *http.Client) *LicenseManagerCollectionGetParams {
	return &LicenseManagerCollectionGetParams{
		HTTPClient: client,
	}
}

/*
LicenseManagerCollectionGetParams contains all the parameters to send to the API endpoint

	for the license manager collection get operation.

	Typically these are written to a http.Request.
*/
type LicenseManagerCollectionGetParams struct {

	/* Default.

	   Filter by default
	*/
	DefaultQueryParameter *bool

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* URIHost.

	   Filter by uri.host
	*/
	URIHostQueryParameter *string

	/* UUID.

	   Filter by uuid
	*/
	UUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the license manager collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LicenseManagerCollectionGetParams) WithDefaults() *LicenseManagerCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the license manager collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LicenseManagerCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := LicenseManagerCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) WithTimeout(timeout time.Duration) *LicenseManagerCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) WithContext(ctx context.Context) *LicenseManagerCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) WithHTTPClient(client *http.Client) *LicenseManagerCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDefaultQueryParameter adds the defaultVar to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) WithDefaultQueryParameter(defaultVar *bool) *LicenseManagerCollectionGetParams {
	o.SetDefaultQueryParameter(defaultVar)
	return o
}

// SetDefaultQueryParameter adds the default to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) SetDefaultQueryParameter(defaultVar *bool) {
	o.DefaultQueryParameter = defaultVar
}

// WithFieldsQueryParameter adds the fields to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) WithFieldsQueryParameter(fields []string) *LicenseManagerCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *LicenseManagerCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *LicenseManagerCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *LicenseManagerCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *LicenseManagerCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithURIHostQueryParameter adds the uRIHost to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) WithURIHostQueryParameter(uRIHost *string) *LicenseManagerCollectionGetParams {
	o.SetURIHostQueryParameter(uRIHost)
	return o
}

// SetURIHostQueryParameter adds the uriHost to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) SetURIHostQueryParameter(uRIHost *string) {
	o.URIHostQueryParameter = uRIHost
}

// WithUUIDQueryParameter adds the uuid to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) WithUUIDQueryParameter(uuid *string) *LicenseManagerCollectionGetParams {
	o.SetUUIDQueryParameter(uuid)
	return o
}

// SetUUIDQueryParameter adds the uuid to the license manager collection get params
func (o *LicenseManagerCollectionGetParams) SetUUIDQueryParameter(uuid *string) {
	o.UUIDQueryParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *LicenseManagerCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.DefaultQueryParameter != nil {

		// query param default
		var qrDefault bool

		if o.DefaultQueryParameter != nil {
			qrDefault = *o.DefaultQueryParameter
		}
		qDefault := swag.FormatBool(qrDefault)
		if qDefault != "" {

			if err := r.SetQueryParam("default", qDefault); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.URIHostQueryParameter != nil {

		// query param uri.host
		var qrURIHost string

		if o.URIHostQueryParameter != nil {
			qrURIHost = *o.URIHostQueryParameter
		}
		qURIHost := qrURIHost
		if qURIHost != "" {

			if err := r.SetQueryParam("uri.host", qURIHost); err != nil {
				return err
			}
		}
	}

	if o.UUIDQueryParameter != nil {

		// query param uuid
		var qrUUID string

		if o.UUIDQueryParameter != nil {
			qrUUID = *o.UUIDQueryParameter
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamLicenseManagerCollectionGet binds the parameter fields
func (o *LicenseManagerCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamLicenseManagerCollectionGet binds the parameter order_by
func (o *LicenseManagerCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
