// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewMediatorCollectionGetParams creates a new MediatorCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewMediatorCollectionGetParams() *MediatorCollectionGetParams {
	return &MediatorCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewMediatorCollectionGetParamsWithTimeout creates a new MediatorCollectionGetParams object
// with the ability to set a timeout on a request.
func NewMediatorCollectionGetParamsWithTimeout(timeout time.Duration) *MediatorCollectionGetParams {
	return &MediatorCollectionGetParams{
		timeout: timeout,
	}
}

// NewMediatorCollectionGetParamsWithContext creates a new MediatorCollectionGetParams object
// with the ability to set a context for a request.
func NewMediatorCollectionGetParamsWithContext(ctx context.Context) *MediatorCollectionGetParams {
	return &MediatorCollectionGetParams{
		Context: ctx,
	}
}

// NewMediatorCollectionGetParamsWithHTTPClient creates a new MediatorCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewMediatorCollectionGetParamsWithHTTPClient(client *http.Client) *MediatorCollectionGetParams {
	return &MediatorCollectionGetParams{
		HTTPClient: client,
	}
}

/*
MediatorCollectionGetParams contains all the parameters to send to the API endpoint

	for the mediator collection get operation.

	Typically these are written to a http.Request.
*/
type MediatorCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* IPAddress.

	   Filter by ip_address
	*/
	IPAddressQueryParameter *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* PeerClusterName.

	   Filter by peer_cluster.name
	*/
	PeerClusterNameQueryParameter *string

	/* PeerClusterUUID.

	   Filter by peer_cluster.uuid
	*/
	PeerClusterUUIDQueryParameter *string

	/* PeerMediatorConnectivity.

	   Filter by peer_mediator_connectivity
	*/
	PeerMediatorConnectivityQueryParameter *string

	/* Port.

	   Filter by port
	*/
	PortQueryParameter *int64

	/* Reachable.

	   Filter by reachable
	*/
	ReachableQueryParameter *bool

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* UUID.

	   Filter by uuid
	*/
	UUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the mediator collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MediatorCollectionGetParams) WithDefaults() *MediatorCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the mediator collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MediatorCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := MediatorCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the mediator collection get params
func (o *MediatorCollectionGetParams) WithTimeout(timeout time.Duration) *MediatorCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the mediator collection get params
func (o *MediatorCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the mediator collection get params
func (o *MediatorCollectionGetParams) WithContext(ctx context.Context) *MediatorCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the mediator collection get params
func (o *MediatorCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the mediator collection get params
func (o *MediatorCollectionGetParams) WithHTTPClient(client *http.Client) *MediatorCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the mediator collection get params
func (o *MediatorCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the mediator collection get params
func (o *MediatorCollectionGetParams) WithFieldsQueryParameter(fields []string) *MediatorCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the mediator collection get params
func (o *MediatorCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIPAddressQueryParameter adds the iPAddress to the mediator collection get params
func (o *MediatorCollectionGetParams) WithIPAddressQueryParameter(iPAddress *string) *MediatorCollectionGetParams {
	o.SetIPAddressQueryParameter(iPAddress)
	return o
}

// SetIPAddressQueryParameter adds the ipAddress to the mediator collection get params
func (o *MediatorCollectionGetParams) SetIPAddressQueryParameter(iPAddress *string) {
	o.IPAddressQueryParameter = iPAddress
}

// WithMaxRecordsQueryParameter adds the maxRecords to the mediator collection get params
func (o *MediatorCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *MediatorCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the mediator collection get params
func (o *MediatorCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the mediator collection get params
func (o *MediatorCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *MediatorCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the mediator collection get params
func (o *MediatorCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithPeerClusterNameQueryParameter adds the peerClusterName to the mediator collection get params
func (o *MediatorCollectionGetParams) WithPeerClusterNameQueryParameter(peerClusterName *string) *MediatorCollectionGetParams {
	o.SetPeerClusterNameQueryParameter(peerClusterName)
	return o
}

// SetPeerClusterNameQueryParameter adds the peerClusterName to the mediator collection get params
func (o *MediatorCollectionGetParams) SetPeerClusterNameQueryParameter(peerClusterName *string) {
	o.PeerClusterNameQueryParameter = peerClusterName
}

// WithPeerClusterUUIDQueryParameter adds the peerClusterUUID to the mediator collection get params
func (o *MediatorCollectionGetParams) WithPeerClusterUUIDQueryParameter(peerClusterUUID *string) *MediatorCollectionGetParams {
	o.SetPeerClusterUUIDQueryParameter(peerClusterUUID)
	return o
}

// SetPeerClusterUUIDQueryParameter adds the peerClusterUuid to the mediator collection get params
func (o *MediatorCollectionGetParams) SetPeerClusterUUIDQueryParameter(peerClusterUUID *string) {
	o.PeerClusterUUIDQueryParameter = peerClusterUUID
}

// WithPeerMediatorConnectivityQueryParameter adds the peerMediatorConnectivity to the mediator collection get params
func (o *MediatorCollectionGetParams) WithPeerMediatorConnectivityQueryParameter(peerMediatorConnectivity *string) *MediatorCollectionGetParams {
	o.SetPeerMediatorConnectivityQueryParameter(peerMediatorConnectivity)
	return o
}

// SetPeerMediatorConnectivityQueryParameter adds the peerMediatorConnectivity to the mediator collection get params
func (o *MediatorCollectionGetParams) SetPeerMediatorConnectivityQueryParameter(peerMediatorConnectivity *string) {
	o.PeerMediatorConnectivityQueryParameter = peerMediatorConnectivity
}

// WithPortQueryParameter adds the port to the mediator collection get params
func (o *MediatorCollectionGetParams) WithPortQueryParameter(port *int64) *MediatorCollectionGetParams {
	o.SetPortQueryParameter(port)
	return o
}

// SetPortQueryParameter adds the port to the mediator collection get params
func (o *MediatorCollectionGetParams) SetPortQueryParameter(port *int64) {
	o.PortQueryParameter = port
}

// WithReachableQueryParameter adds the reachable to the mediator collection get params
func (o *MediatorCollectionGetParams) WithReachableQueryParameter(reachable *bool) *MediatorCollectionGetParams {
	o.SetReachableQueryParameter(reachable)
	return o
}

// SetReachableQueryParameter adds the reachable to the mediator collection get params
func (o *MediatorCollectionGetParams) SetReachableQueryParameter(reachable *bool) {
	o.ReachableQueryParameter = reachable
}

// WithReturnRecordsQueryParameter adds the returnRecords to the mediator collection get params
func (o *MediatorCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *MediatorCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the mediator collection get params
func (o *MediatorCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the mediator collection get params
func (o *MediatorCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *MediatorCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the mediator collection get params
func (o *MediatorCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithUUIDQueryParameter adds the uuid to the mediator collection get params
func (o *MediatorCollectionGetParams) WithUUIDQueryParameter(uuid *string) *MediatorCollectionGetParams {
	o.SetUUIDQueryParameter(uuid)
	return o
}

// SetUUIDQueryParameter adds the uuid to the mediator collection get params
func (o *MediatorCollectionGetParams) SetUUIDQueryParameter(uuid *string) {
	o.UUIDQueryParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *MediatorCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.IPAddressQueryParameter != nil {

		// query param ip_address
		var qrIPAddress string

		if o.IPAddressQueryParameter != nil {
			qrIPAddress = *o.IPAddressQueryParameter
		}
		qIPAddress := qrIPAddress
		if qIPAddress != "" {

			if err := r.SetQueryParam("ip_address", qIPAddress); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PeerClusterNameQueryParameter != nil {

		// query param peer_cluster.name
		var qrPeerClusterName string

		if o.PeerClusterNameQueryParameter != nil {
			qrPeerClusterName = *o.PeerClusterNameQueryParameter
		}
		qPeerClusterName := qrPeerClusterName
		if qPeerClusterName != "" {

			if err := r.SetQueryParam("peer_cluster.name", qPeerClusterName); err != nil {
				return err
			}
		}
	}

	if o.PeerClusterUUIDQueryParameter != nil {

		// query param peer_cluster.uuid
		var qrPeerClusterUUID string

		if o.PeerClusterUUIDQueryParameter != nil {
			qrPeerClusterUUID = *o.PeerClusterUUIDQueryParameter
		}
		qPeerClusterUUID := qrPeerClusterUUID
		if qPeerClusterUUID != "" {

			if err := r.SetQueryParam("peer_cluster.uuid", qPeerClusterUUID); err != nil {
				return err
			}
		}
	}

	if o.PeerMediatorConnectivityQueryParameter != nil {

		// query param peer_mediator_connectivity
		var qrPeerMediatorConnectivity string

		if o.PeerMediatorConnectivityQueryParameter != nil {
			qrPeerMediatorConnectivity = *o.PeerMediatorConnectivityQueryParameter
		}
		qPeerMediatorConnectivity := qrPeerMediatorConnectivity
		if qPeerMediatorConnectivity != "" {

			if err := r.SetQueryParam("peer_mediator_connectivity", qPeerMediatorConnectivity); err != nil {
				return err
			}
		}
	}

	if o.PortQueryParameter != nil {

		// query param port
		var qrPort int64

		if o.PortQueryParameter != nil {
			qrPort = *o.PortQueryParameter
		}
		qPort := swag.FormatInt64(qrPort)
		if qPort != "" {

			if err := r.SetQueryParam("port", qPort); err != nil {
				return err
			}
		}
	}

	if o.ReachableQueryParameter != nil {

		// query param reachable
		var qrReachable bool

		if o.ReachableQueryParameter != nil {
			qrReachable = *o.ReachableQueryParameter
		}
		qReachable := swag.FormatBool(qrReachable)
		if qReachable != "" {

			if err := r.SetQueryParam("reachable", qReachable); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.UUIDQueryParameter != nil {

		// query param uuid
		var qrUUID string

		if o.UUIDQueryParameter != nil {
			qrUUID = *o.UUIDQueryParameter
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamMediatorCollectionGet binds the parameter fields
func (o *MediatorCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamMediatorCollectionGet binds the parameter order_by
func (o *MediatorCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
