// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewMetroclusterDrGroupCollectionGetParams creates a new MetroclusterDrGroupCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewMetroclusterDrGroupCollectionGetParams() *MetroclusterDrGroupCollectionGetParams {
	return &MetroclusterDrGroupCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewMetroclusterDrGroupCollectionGetParamsWithTimeout creates a new MetroclusterDrGroupCollectionGetParams object
// with the ability to set a timeout on a request.
func NewMetroclusterDrGroupCollectionGetParamsWithTimeout(timeout time.Duration) *MetroclusterDrGroupCollectionGetParams {
	return &MetroclusterDrGroupCollectionGetParams{
		timeout: timeout,
	}
}

// NewMetroclusterDrGroupCollectionGetParamsWithContext creates a new MetroclusterDrGroupCollectionGetParams object
// with the ability to set a context for a request.
func NewMetroclusterDrGroupCollectionGetParamsWithContext(ctx context.Context) *MetroclusterDrGroupCollectionGetParams {
	return &MetroclusterDrGroupCollectionGetParams{
		Context: ctx,
	}
}

// NewMetroclusterDrGroupCollectionGetParamsWithHTTPClient creates a new MetroclusterDrGroupCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewMetroclusterDrGroupCollectionGetParamsWithHTTPClient(client *http.Client) *MetroclusterDrGroupCollectionGetParams {
	return &MetroclusterDrGroupCollectionGetParams{
		HTTPClient: client,
	}
}

/*
MetroclusterDrGroupCollectionGetParams contains all the parameters to send to the API endpoint

	for the metrocluster dr group collection get operation.

	Typically these are written to a http.Request.
*/
type MetroclusterDrGroupCollectionGetParams struct {

	/* DrPairsNodeName.

	   Filter by dr_pairs.node.name
	*/
	DrPairsNodeNameQueryParameter *string

	/* DrPairsNodeUUID.

	   Filter by dr_pairs.node.uuid
	*/
	DrPairsNodeUUIDQueryParameter *string

	/* DrPairsPartnerName.

	   Filter by dr_pairs.partner.name
	*/
	DrPairsPartnerNameQueryParameter *string

	/* DrPairsPartnerUUID.

	   Filter by dr_pairs.partner.uuid
	*/
	DrPairsPartnerUUIDQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* ID.

	   Filter by id
	*/
	IDQueryParameter *int64

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* PartnerClusterName.

	   Filter by partner_cluster.name
	*/
	PartnerClusterNameQueryParameter *string

	/* PartnerClusterUUID.

	   Filter by partner_cluster.uuid
	*/
	PartnerClusterUUIDQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the metrocluster dr group collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MetroclusterDrGroupCollectionGetParams) WithDefaults() *MetroclusterDrGroupCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the metrocluster dr group collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MetroclusterDrGroupCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := MetroclusterDrGroupCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) WithTimeout(timeout time.Duration) *MetroclusterDrGroupCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) WithContext(ctx context.Context) *MetroclusterDrGroupCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) WithHTTPClient(client *http.Client) *MetroclusterDrGroupCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDrPairsNodeNameQueryParameter adds the drPairsNodeName to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) WithDrPairsNodeNameQueryParameter(drPairsNodeName *string) *MetroclusterDrGroupCollectionGetParams {
	o.SetDrPairsNodeNameQueryParameter(drPairsNodeName)
	return o
}

// SetDrPairsNodeNameQueryParameter adds the drPairsNodeName to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) SetDrPairsNodeNameQueryParameter(drPairsNodeName *string) {
	o.DrPairsNodeNameQueryParameter = drPairsNodeName
}

// WithDrPairsNodeUUIDQueryParameter adds the drPairsNodeUUID to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) WithDrPairsNodeUUIDQueryParameter(drPairsNodeUUID *string) *MetroclusterDrGroupCollectionGetParams {
	o.SetDrPairsNodeUUIDQueryParameter(drPairsNodeUUID)
	return o
}

// SetDrPairsNodeUUIDQueryParameter adds the drPairsNodeUuid to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) SetDrPairsNodeUUIDQueryParameter(drPairsNodeUUID *string) {
	o.DrPairsNodeUUIDQueryParameter = drPairsNodeUUID
}

// WithDrPairsPartnerNameQueryParameter adds the drPairsPartnerName to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) WithDrPairsPartnerNameQueryParameter(drPairsPartnerName *string) *MetroclusterDrGroupCollectionGetParams {
	o.SetDrPairsPartnerNameQueryParameter(drPairsPartnerName)
	return o
}

// SetDrPairsPartnerNameQueryParameter adds the drPairsPartnerName to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) SetDrPairsPartnerNameQueryParameter(drPairsPartnerName *string) {
	o.DrPairsPartnerNameQueryParameter = drPairsPartnerName
}

// WithDrPairsPartnerUUIDQueryParameter adds the drPairsPartnerUUID to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) WithDrPairsPartnerUUIDQueryParameter(drPairsPartnerUUID *string) *MetroclusterDrGroupCollectionGetParams {
	o.SetDrPairsPartnerUUIDQueryParameter(drPairsPartnerUUID)
	return o
}

// SetDrPairsPartnerUUIDQueryParameter adds the drPairsPartnerUuid to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) SetDrPairsPartnerUUIDQueryParameter(drPairsPartnerUUID *string) {
	o.DrPairsPartnerUUIDQueryParameter = drPairsPartnerUUID
}

// WithFieldsQueryParameter adds the fields to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) WithFieldsQueryParameter(fields []string) *MetroclusterDrGroupCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIDQueryParameter adds the id to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) WithIDQueryParameter(id *int64) *MetroclusterDrGroupCollectionGetParams {
	o.SetIDQueryParameter(id)
	return o
}

// SetIDQueryParameter adds the id to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) SetIDQueryParameter(id *int64) {
	o.IDQueryParameter = id
}

// WithMaxRecordsQueryParameter adds the maxRecords to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *MetroclusterDrGroupCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *MetroclusterDrGroupCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithPartnerClusterNameQueryParameter adds the partnerClusterName to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) WithPartnerClusterNameQueryParameter(partnerClusterName *string) *MetroclusterDrGroupCollectionGetParams {
	o.SetPartnerClusterNameQueryParameter(partnerClusterName)
	return o
}

// SetPartnerClusterNameQueryParameter adds the partnerClusterName to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) SetPartnerClusterNameQueryParameter(partnerClusterName *string) {
	o.PartnerClusterNameQueryParameter = partnerClusterName
}

// WithPartnerClusterUUIDQueryParameter adds the partnerClusterUUID to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) WithPartnerClusterUUIDQueryParameter(partnerClusterUUID *string) *MetroclusterDrGroupCollectionGetParams {
	o.SetPartnerClusterUUIDQueryParameter(partnerClusterUUID)
	return o
}

// SetPartnerClusterUUIDQueryParameter adds the partnerClusterUuid to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) SetPartnerClusterUUIDQueryParameter(partnerClusterUUID *string) {
	o.PartnerClusterUUIDQueryParameter = partnerClusterUUID
}

// WithReturnRecordsQueryParameter adds the returnRecords to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *MetroclusterDrGroupCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *MetroclusterDrGroupCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the metrocluster dr group collection get params
func (o *MetroclusterDrGroupCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WriteToRequest writes these params to a swagger request
func (o *MetroclusterDrGroupCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.DrPairsNodeNameQueryParameter != nil {

		// query param dr_pairs.node.name
		var qrDrPairsNodeName string

		if o.DrPairsNodeNameQueryParameter != nil {
			qrDrPairsNodeName = *o.DrPairsNodeNameQueryParameter
		}
		qDrPairsNodeName := qrDrPairsNodeName
		if qDrPairsNodeName != "" {

			if err := r.SetQueryParam("dr_pairs.node.name", qDrPairsNodeName); err != nil {
				return err
			}
		}
	}

	if o.DrPairsNodeUUIDQueryParameter != nil {

		// query param dr_pairs.node.uuid
		var qrDrPairsNodeUUID string

		if o.DrPairsNodeUUIDQueryParameter != nil {
			qrDrPairsNodeUUID = *o.DrPairsNodeUUIDQueryParameter
		}
		qDrPairsNodeUUID := qrDrPairsNodeUUID
		if qDrPairsNodeUUID != "" {

			if err := r.SetQueryParam("dr_pairs.node.uuid", qDrPairsNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.DrPairsPartnerNameQueryParameter != nil {

		// query param dr_pairs.partner.name
		var qrDrPairsPartnerName string

		if o.DrPairsPartnerNameQueryParameter != nil {
			qrDrPairsPartnerName = *o.DrPairsPartnerNameQueryParameter
		}
		qDrPairsPartnerName := qrDrPairsPartnerName
		if qDrPairsPartnerName != "" {

			if err := r.SetQueryParam("dr_pairs.partner.name", qDrPairsPartnerName); err != nil {
				return err
			}
		}
	}

	if o.DrPairsPartnerUUIDQueryParameter != nil {

		// query param dr_pairs.partner.uuid
		var qrDrPairsPartnerUUID string

		if o.DrPairsPartnerUUIDQueryParameter != nil {
			qrDrPairsPartnerUUID = *o.DrPairsPartnerUUIDQueryParameter
		}
		qDrPairsPartnerUUID := qrDrPairsPartnerUUID
		if qDrPairsPartnerUUID != "" {

			if err := r.SetQueryParam("dr_pairs.partner.uuid", qDrPairsPartnerUUID); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.IDQueryParameter != nil {

		// query param id
		var qrID int64

		if o.IDQueryParameter != nil {
			qrID = *o.IDQueryParameter
		}
		qID := swag.FormatInt64(qrID)
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PartnerClusterNameQueryParameter != nil {

		// query param partner_cluster.name
		var qrPartnerClusterName string

		if o.PartnerClusterNameQueryParameter != nil {
			qrPartnerClusterName = *o.PartnerClusterNameQueryParameter
		}
		qPartnerClusterName := qrPartnerClusterName
		if qPartnerClusterName != "" {

			if err := r.SetQueryParam("partner_cluster.name", qPartnerClusterName); err != nil {
				return err
			}
		}
	}

	if o.PartnerClusterUUIDQueryParameter != nil {

		// query param partner_cluster.uuid
		var qrPartnerClusterUUID string

		if o.PartnerClusterUUIDQueryParameter != nil {
			qrPartnerClusterUUID = *o.PartnerClusterUUIDQueryParameter
		}
		qPartnerClusterUUID := qrPartnerClusterUUID
		if qPartnerClusterUUID != "" {

			if err := r.SetQueryParam("partner_cluster.uuid", qPartnerClusterUUID); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamMetroclusterDrGroupCollectionGet binds the parameter fields
func (o *MetroclusterDrGroupCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamMetroclusterDrGroupCollectionGet binds the parameter order_by
func (o *MetroclusterDrGroupCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
