// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// MetroclusterInterconnectModifyReader is a Reader for the MetroclusterInterconnectModify structure.
type MetroclusterInterconnectModifyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *MetroclusterInterconnectModifyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewMetroclusterInterconnectModifyAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewMetroclusterInterconnectModifyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewMetroclusterInterconnectModifyAccepted creates a MetroclusterInterconnectModifyAccepted with default headers values
func NewMetroclusterInterconnectModifyAccepted() *MetroclusterInterconnectModifyAccepted {
	return &MetroclusterInterconnectModifyAccepted{}
}

/*
MetroclusterInterconnectModifyAccepted describes a response with status code 202, with default header values.

Accepted
*/
type MetroclusterInterconnectModifyAccepted struct {
	Payload *models.JobLinkResponse
}

// IsSuccess returns true when this metrocluster interconnect modify accepted response has a 2xx status code
func (o *MetroclusterInterconnectModifyAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this metrocluster interconnect modify accepted response has a 3xx status code
func (o *MetroclusterInterconnectModifyAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this metrocluster interconnect modify accepted response has a 4xx status code
func (o *MetroclusterInterconnectModifyAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this metrocluster interconnect modify accepted response has a 5xx status code
func (o *MetroclusterInterconnectModifyAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this metrocluster interconnect modify accepted response a status code equal to that given
func (o *MetroclusterInterconnectModifyAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *MetroclusterInterconnectModifyAccepted) Error() string {
	return fmt.Sprintf("[PATCH /cluster/metrocluster/interconnects/{node.uuid}/{partner_type}/{adapter}][%d] metroclusterInterconnectModifyAccepted  %+v", 202, o.Payload)
}

func (o *MetroclusterInterconnectModifyAccepted) String() string {
	return fmt.Sprintf("[PATCH /cluster/metrocluster/interconnects/{node.uuid}/{partner_type}/{adapter}][%d] metroclusterInterconnectModifyAccepted  %+v", 202, o.Payload)
}

func (o *MetroclusterInterconnectModifyAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *MetroclusterInterconnectModifyAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewMetroclusterInterconnectModifyDefault creates a MetroclusterInterconnectModifyDefault with default headers values
func NewMetroclusterInterconnectModifyDefault(code int) *MetroclusterInterconnectModifyDefault {
	return &MetroclusterInterconnectModifyDefault{
		_statusCode: code,
	}
}

/*
	MetroclusterInterconnectModifyDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

| Error Code | Description |
| ---------- | ----------- |
| 2425734 | An internal error has occurred. Wait a few minutes, and try the operation again. For further assistance, contact technical support. |
*/
type MetroclusterInterconnectModifyDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the metrocluster interconnect modify default response
func (o *MetroclusterInterconnectModifyDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this metrocluster interconnect modify default response has a 2xx status code
func (o *MetroclusterInterconnectModifyDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this metrocluster interconnect modify default response has a 3xx status code
func (o *MetroclusterInterconnectModifyDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this metrocluster interconnect modify default response has a 4xx status code
func (o *MetroclusterInterconnectModifyDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this metrocluster interconnect modify default response has a 5xx status code
func (o *MetroclusterInterconnectModifyDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this metrocluster interconnect modify default response a status code equal to that given
func (o *MetroclusterInterconnectModifyDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *MetroclusterInterconnectModifyDefault) Error() string {
	return fmt.Sprintf("[PATCH /cluster/metrocluster/interconnects/{node.uuid}/{partner_type}/{adapter}][%d] metrocluster_interconnect_modify default  %+v", o._statusCode, o.Payload)
}

func (o *MetroclusterInterconnectModifyDefault) String() string {
	return fmt.Sprintf("[PATCH /cluster/metrocluster/interconnects/{node.uuid}/{partner_type}/{adapter}][%d] metrocluster_interconnect_modify default  %+v", o._statusCode, o.Payload)
}

func (o *MetroclusterInterconnectModifyDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *MetroclusterInterconnectModifyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
