// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewMetroclusterOperationCollectionGetParams creates a new MetroclusterOperationCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewMetroclusterOperationCollectionGetParams() *MetroclusterOperationCollectionGetParams {
	return &MetroclusterOperationCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewMetroclusterOperationCollectionGetParamsWithTimeout creates a new MetroclusterOperationCollectionGetParams object
// with the ability to set a timeout on a request.
func NewMetroclusterOperationCollectionGetParamsWithTimeout(timeout time.Duration) *MetroclusterOperationCollectionGetParams {
	return &MetroclusterOperationCollectionGetParams{
		timeout: timeout,
	}
}

// NewMetroclusterOperationCollectionGetParamsWithContext creates a new MetroclusterOperationCollectionGetParams object
// with the ability to set a context for a request.
func NewMetroclusterOperationCollectionGetParamsWithContext(ctx context.Context) *MetroclusterOperationCollectionGetParams {
	return &MetroclusterOperationCollectionGetParams{
		Context: ctx,
	}
}

// NewMetroclusterOperationCollectionGetParamsWithHTTPClient creates a new MetroclusterOperationCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewMetroclusterOperationCollectionGetParamsWithHTTPClient(client *http.Client) *MetroclusterOperationCollectionGetParams {
	return &MetroclusterOperationCollectionGetParams{
		HTTPClient: client,
	}
}

/*
MetroclusterOperationCollectionGetParams contains all the parameters to send to the API endpoint

	for the metrocluster operation collection get operation.

	Typically these are written to a http.Request.
*/
type MetroclusterOperationCollectionGetParams struct {

	/* AdditionalInfo.

	   Filter by additional_info
	*/
	AdditionalInfoQueryParameter *string

	/* CommandLine.

	   Filter by command_line
	*/
	CommandLineQueryParameter *string

	/* EndTime.

	   Filter by end_time
	*/
	EndTimeQueryParameter *string

	/* Errors.

	   Filter by errors
	*/
	ErrorsQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* NodeName.

	   Filter by node.name
	*/
	NodeNameQueryParameter *string

	/* NodeUUID.

	   Filter by node.uuid
	*/
	NodeUUIDQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* StartTime.

	   Filter by start_time
	*/
	StartTimeQueryParameter *string

	/* State.

	   Filter by state
	*/
	StateQueryParameter *string

	/* Type.

	   Filter by type
	*/
	TypeQueryParameter *string

	/* UUID.

	   Filter by uuid
	*/
	UUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the metrocluster operation collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MetroclusterOperationCollectionGetParams) WithDefaults() *MetroclusterOperationCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the metrocluster operation collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MetroclusterOperationCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := MetroclusterOperationCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithTimeout(timeout time.Duration) *MetroclusterOperationCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithContext(ctx context.Context) *MetroclusterOperationCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithHTTPClient(client *http.Client) *MetroclusterOperationCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAdditionalInfoQueryParameter adds the additionalInfo to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithAdditionalInfoQueryParameter(additionalInfo *string) *MetroclusterOperationCollectionGetParams {
	o.SetAdditionalInfoQueryParameter(additionalInfo)
	return o
}

// SetAdditionalInfoQueryParameter adds the additionalInfo to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetAdditionalInfoQueryParameter(additionalInfo *string) {
	o.AdditionalInfoQueryParameter = additionalInfo
}

// WithCommandLineQueryParameter adds the commandLine to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithCommandLineQueryParameter(commandLine *string) *MetroclusterOperationCollectionGetParams {
	o.SetCommandLineQueryParameter(commandLine)
	return o
}

// SetCommandLineQueryParameter adds the commandLine to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetCommandLineQueryParameter(commandLine *string) {
	o.CommandLineQueryParameter = commandLine
}

// WithEndTimeQueryParameter adds the endTime to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithEndTimeQueryParameter(endTime *string) *MetroclusterOperationCollectionGetParams {
	o.SetEndTimeQueryParameter(endTime)
	return o
}

// SetEndTimeQueryParameter adds the endTime to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetEndTimeQueryParameter(endTime *string) {
	o.EndTimeQueryParameter = endTime
}

// WithErrorsQueryParameter adds the errors to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithErrorsQueryParameter(errors *string) *MetroclusterOperationCollectionGetParams {
	o.SetErrorsQueryParameter(errors)
	return o
}

// SetErrorsQueryParameter adds the errors to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetErrorsQueryParameter(errors *string) {
	o.ErrorsQueryParameter = errors
}

// WithFieldsQueryParameter adds the fields to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithFieldsQueryParameter(fields []string) *MetroclusterOperationCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *MetroclusterOperationCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNodeNameQueryParameter adds the nodeName to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithNodeNameQueryParameter(nodeName *string) *MetroclusterOperationCollectionGetParams {
	o.SetNodeNameQueryParameter(nodeName)
	return o
}

// SetNodeNameQueryParameter adds the nodeName to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetNodeNameQueryParameter(nodeName *string) {
	o.NodeNameQueryParameter = nodeName
}

// WithNodeUUIDQueryParameter adds the nodeUUID to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithNodeUUIDQueryParameter(nodeUUID *string) *MetroclusterOperationCollectionGetParams {
	o.SetNodeUUIDQueryParameter(nodeUUID)
	return o
}

// SetNodeUUIDQueryParameter adds the nodeUuid to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetNodeUUIDQueryParameter(nodeUUID *string) {
	o.NodeUUIDQueryParameter = nodeUUID
}

// WithOrderByQueryParameter adds the orderBy to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *MetroclusterOperationCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *MetroclusterOperationCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *MetroclusterOperationCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithStartTimeQueryParameter adds the startTime to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithStartTimeQueryParameter(startTime *string) *MetroclusterOperationCollectionGetParams {
	o.SetStartTimeQueryParameter(startTime)
	return o
}

// SetStartTimeQueryParameter adds the startTime to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetStartTimeQueryParameter(startTime *string) {
	o.StartTimeQueryParameter = startTime
}

// WithStateQueryParameter adds the state to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithStateQueryParameter(state *string) *MetroclusterOperationCollectionGetParams {
	o.SetStateQueryParameter(state)
	return o
}

// SetStateQueryParameter adds the state to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetStateQueryParameter(state *string) {
	o.StateQueryParameter = state
}

// WithTypeQueryParameter adds the typeVar to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithTypeQueryParameter(typeVar *string) *MetroclusterOperationCollectionGetParams {
	o.SetTypeQueryParameter(typeVar)
	return o
}

// SetTypeQueryParameter adds the type to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetTypeQueryParameter(typeVar *string) {
	o.TypeQueryParameter = typeVar
}

// WithUUIDQueryParameter adds the uuid to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) WithUUIDQueryParameter(uuid *string) *MetroclusterOperationCollectionGetParams {
	o.SetUUIDQueryParameter(uuid)
	return o
}

// SetUUIDQueryParameter adds the uuid to the metrocluster operation collection get params
func (o *MetroclusterOperationCollectionGetParams) SetUUIDQueryParameter(uuid *string) {
	o.UUIDQueryParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *MetroclusterOperationCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AdditionalInfoQueryParameter != nil {

		// query param additional_info
		var qrAdditionalInfo string

		if o.AdditionalInfoQueryParameter != nil {
			qrAdditionalInfo = *o.AdditionalInfoQueryParameter
		}
		qAdditionalInfo := qrAdditionalInfo
		if qAdditionalInfo != "" {

			if err := r.SetQueryParam("additional_info", qAdditionalInfo); err != nil {
				return err
			}
		}
	}

	if o.CommandLineQueryParameter != nil {

		// query param command_line
		var qrCommandLine string

		if o.CommandLineQueryParameter != nil {
			qrCommandLine = *o.CommandLineQueryParameter
		}
		qCommandLine := qrCommandLine
		if qCommandLine != "" {

			if err := r.SetQueryParam("command_line", qCommandLine); err != nil {
				return err
			}
		}
	}

	if o.EndTimeQueryParameter != nil {

		// query param end_time
		var qrEndTime string

		if o.EndTimeQueryParameter != nil {
			qrEndTime = *o.EndTimeQueryParameter
		}
		qEndTime := qrEndTime
		if qEndTime != "" {

			if err := r.SetQueryParam("end_time", qEndTime); err != nil {
				return err
			}
		}
	}

	if o.ErrorsQueryParameter != nil {

		// query param errors
		var qrErrors string

		if o.ErrorsQueryParameter != nil {
			qrErrors = *o.ErrorsQueryParameter
		}
		qErrors := qrErrors
		if qErrors != "" {

			if err := r.SetQueryParam("errors", qErrors); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NodeNameQueryParameter != nil {

		// query param node.name
		var qrNodeName string

		if o.NodeNameQueryParameter != nil {
			qrNodeName = *o.NodeNameQueryParameter
		}
		qNodeName := qrNodeName
		if qNodeName != "" {

			if err := r.SetQueryParam("node.name", qNodeName); err != nil {
				return err
			}
		}
	}

	if o.NodeUUIDQueryParameter != nil {

		// query param node.uuid
		var qrNodeUUID string

		if o.NodeUUIDQueryParameter != nil {
			qrNodeUUID = *o.NodeUUIDQueryParameter
		}
		qNodeUUID := qrNodeUUID
		if qNodeUUID != "" {

			if err := r.SetQueryParam("node.uuid", qNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.StartTimeQueryParameter != nil {

		// query param start_time
		var qrStartTime string

		if o.StartTimeQueryParameter != nil {
			qrStartTime = *o.StartTimeQueryParameter
		}
		qStartTime := qrStartTime
		if qStartTime != "" {

			if err := r.SetQueryParam("start_time", qStartTime); err != nil {
				return err
			}
		}
	}

	if o.StateQueryParameter != nil {

		// query param state
		var qrState string

		if o.StateQueryParameter != nil {
			qrState = *o.StateQueryParameter
		}
		qState := qrState
		if qState != "" {

			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}
	}

	if o.TypeQueryParameter != nil {

		// query param type
		var qrType string

		if o.TypeQueryParameter != nil {
			qrType = *o.TypeQueryParameter
		}
		qType := qrType
		if qType != "" {

			if err := r.SetQueryParam("type", qType); err != nil {
				return err
			}
		}
	}

	if o.UUIDQueryParameter != nil {

		// query param uuid
		var qrUUID string

		if o.UUIDQueryParameter != nil {
			qrUUID = *o.UUIDQueryParameter
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamMetroclusterOperationCollectionGet binds the parameter fields
func (o *MetroclusterOperationCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamMetroclusterOperationCollectionGet binds the parameter order_by
func (o *MetroclusterOperationCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
