// Code generated by go-swagger; DO NOT EDIT.

package cluster

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewSoftwarePackagesCollectionGetParams creates a new SoftwarePackagesCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSoftwarePackagesCollectionGetParams() *SoftwarePackagesCollectionGetParams {
	return &SoftwarePackagesCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSoftwarePackagesCollectionGetParamsWithTimeout creates a new SoftwarePackagesCollectionGetParams object
// with the ability to set a timeout on a request.
func NewSoftwarePackagesCollectionGetParamsWithTimeout(timeout time.Duration) *SoftwarePackagesCollectionGetParams {
	return &SoftwarePackagesCollectionGetParams{
		timeout: timeout,
	}
}

// NewSoftwarePackagesCollectionGetParamsWithContext creates a new SoftwarePackagesCollectionGetParams object
// with the ability to set a context for a request.
func NewSoftwarePackagesCollectionGetParamsWithContext(ctx context.Context) *SoftwarePackagesCollectionGetParams {
	return &SoftwarePackagesCollectionGetParams{
		Context: ctx,
	}
}

// NewSoftwarePackagesCollectionGetParamsWithHTTPClient creates a new SoftwarePackagesCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewSoftwarePackagesCollectionGetParamsWithHTTPClient(client *http.Client) *SoftwarePackagesCollectionGetParams {
	return &SoftwarePackagesCollectionGetParams{
		HTTPClient: client,
	}
}

/*
SoftwarePackagesCollectionGetParams contains all the parameters to send to the API endpoint

	for the software packages collection get operation.

	Typically these are written to a http.Request.
*/
type SoftwarePackagesCollectionGetParams struct {

	/* CreateTime.

	   Filter by create_time
	*/
	CreateTimeQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* Version.

	   Filter by version
	*/
	VersionQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the software packages collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SoftwarePackagesCollectionGetParams) WithDefaults() *SoftwarePackagesCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the software packages collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SoftwarePackagesCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := SoftwarePackagesCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) WithTimeout(timeout time.Duration) *SoftwarePackagesCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) WithContext(ctx context.Context) *SoftwarePackagesCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) WithHTTPClient(client *http.Client) *SoftwarePackagesCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCreateTimeQueryParameter adds the createTime to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) WithCreateTimeQueryParameter(createTime *string) *SoftwarePackagesCollectionGetParams {
	o.SetCreateTimeQueryParameter(createTime)
	return o
}

// SetCreateTimeQueryParameter adds the createTime to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) SetCreateTimeQueryParameter(createTime *string) {
	o.CreateTimeQueryParameter = createTime
}

// WithFieldsQueryParameter adds the fields to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) WithFieldsQueryParameter(fields []string) *SoftwarePackagesCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *SoftwarePackagesCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *SoftwarePackagesCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *SoftwarePackagesCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *SoftwarePackagesCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithVersionQueryParameter adds the version to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) WithVersionQueryParameter(version *string) *SoftwarePackagesCollectionGetParams {
	o.SetVersionQueryParameter(version)
	return o
}

// SetVersionQueryParameter adds the version to the software packages collection get params
func (o *SoftwarePackagesCollectionGetParams) SetVersionQueryParameter(version *string) {
	o.VersionQueryParameter = version
}

// WriteToRequest writes these params to a swagger request
func (o *SoftwarePackagesCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CreateTimeQueryParameter != nil {

		// query param create_time
		var qrCreateTime string

		if o.CreateTimeQueryParameter != nil {
			qrCreateTime = *o.CreateTimeQueryParameter
		}
		qCreateTime := qrCreateTime
		if qCreateTime != "" {

			if err := r.SetQueryParam("create_time", qCreateTime); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.VersionQueryParameter != nil {

		// query param version
		var qrVersion string

		if o.VersionQueryParameter != nil {
			qrVersion = *o.VersionQueryParameter
		}
		qVersion := qrVersion
		if qVersion != "" {

			if err := r.SetQueryParam("version", qVersion); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamSoftwarePackagesCollectionGet binds the parameter fields
func (o *SoftwarePackagesCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamSoftwarePackagesCollectionGet binds the parameter order_by
func (o *SoftwarePackagesCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
