// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewCifsConnectionCollectionGetParams creates a new CifsConnectionCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCifsConnectionCollectionGetParams() *CifsConnectionCollectionGetParams {
	return &CifsConnectionCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCifsConnectionCollectionGetParamsWithTimeout creates a new CifsConnectionCollectionGetParams object
// with the ability to set a timeout on a request.
func NewCifsConnectionCollectionGetParamsWithTimeout(timeout time.Duration) *CifsConnectionCollectionGetParams {
	return &CifsConnectionCollectionGetParams{
		timeout: timeout,
	}
}

// NewCifsConnectionCollectionGetParamsWithContext creates a new CifsConnectionCollectionGetParams object
// with the ability to set a context for a request.
func NewCifsConnectionCollectionGetParamsWithContext(ctx context.Context) *CifsConnectionCollectionGetParams {
	return &CifsConnectionCollectionGetParams{
		Context: ctx,
	}
}

// NewCifsConnectionCollectionGetParamsWithHTTPClient creates a new CifsConnectionCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewCifsConnectionCollectionGetParamsWithHTTPClient(client *http.Client) *CifsConnectionCollectionGetParams {
	return &CifsConnectionCollectionGetParams{
		HTTPClient: client,
	}
}

/*
CifsConnectionCollectionGetParams contains all the parameters to send to the API endpoint

	for the cifs connection collection get operation.

	Typically these are written to a http.Request.
*/
type CifsConnectionCollectionGetParams struct {

	/* ClientIP.

	   Filter by client_ip
	*/
	ClientIPQueryParameter *string

	/* ClientPort.

	   Filter by client_port
	*/
	ClientPortQueryParameter *int64

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* Identifier.

	   Filter by identifier
	*/
	IdentifierQueryParameter *int64

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* NetworkContextID.

	   Filter by network_context_id
	*/
	NetworkContextIDQueryParameter *int64

	/* NodeName.

	   Filter by node.name
	*/
	NodeNameQueryParameter *string

	/* NodeUUID.

	   Filter by node.uuid
	*/
	NodeUUIDQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* ServerIP.

	   Filter by server_ip
	*/
	ServerIPQueryParameter *string

	/* SessionsIdentifier.

	   Filter by sessions.identifier
	*/
	SessionsIDentifierQueryParameter *int64

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the cifs connection collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CifsConnectionCollectionGetParams) WithDefaults() *CifsConnectionCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the cifs connection collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CifsConnectionCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := CifsConnectionCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithTimeout(timeout time.Duration) *CifsConnectionCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithContext(ctx context.Context) *CifsConnectionCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithHTTPClient(client *http.Client) *CifsConnectionCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithClientIPQueryParameter adds the clientIP to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithClientIPQueryParameter(clientIP *string) *CifsConnectionCollectionGetParams {
	o.SetClientIPQueryParameter(clientIP)
	return o
}

// SetClientIPQueryParameter adds the clientIp to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetClientIPQueryParameter(clientIP *string) {
	o.ClientIPQueryParameter = clientIP
}

// WithClientPortQueryParameter adds the clientPort to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithClientPortQueryParameter(clientPort *int64) *CifsConnectionCollectionGetParams {
	o.SetClientPortQueryParameter(clientPort)
	return o
}

// SetClientPortQueryParameter adds the clientPort to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetClientPortQueryParameter(clientPort *int64) {
	o.ClientPortQueryParameter = clientPort
}

// WithFieldsQueryParameter adds the fields to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithFieldsQueryParameter(fields []string) *CifsConnectionCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIdentifierQueryParameter adds the identifier to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithIdentifierQueryParameter(identifier *int64) *CifsConnectionCollectionGetParams {
	o.SetIdentifierQueryParameter(identifier)
	return o
}

// SetIdentifierQueryParameter adds the identifier to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetIdentifierQueryParameter(identifier *int64) {
	o.IdentifierQueryParameter = identifier
}

// WithMaxRecordsQueryParameter adds the maxRecords to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *CifsConnectionCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNetworkContextIDQueryParameter adds the networkContextID to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithNetworkContextIDQueryParameter(networkContextID *int64) *CifsConnectionCollectionGetParams {
	o.SetNetworkContextIDQueryParameter(networkContextID)
	return o
}

// SetNetworkContextIDQueryParameter adds the networkContextId to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetNetworkContextIDQueryParameter(networkContextID *int64) {
	o.NetworkContextIDQueryParameter = networkContextID
}

// WithNodeNameQueryParameter adds the nodeName to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithNodeNameQueryParameter(nodeName *string) *CifsConnectionCollectionGetParams {
	o.SetNodeNameQueryParameter(nodeName)
	return o
}

// SetNodeNameQueryParameter adds the nodeName to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetNodeNameQueryParameter(nodeName *string) {
	o.NodeNameQueryParameter = nodeName
}

// WithNodeUUIDQueryParameter adds the nodeUUID to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithNodeUUIDQueryParameter(nodeUUID *string) *CifsConnectionCollectionGetParams {
	o.SetNodeUUIDQueryParameter(nodeUUID)
	return o
}

// SetNodeUUIDQueryParameter adds the nodeUuid to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetNodeUUIDQueryParameter(nodeUUID *string) {
	o.NodeUUIDQueryParameter = nodeUUID
}

// WithOrderByQueryParameter adds the orderBy to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *CifsConnectionCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *CifsConnectionCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *CifsConnectionCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithServerIPQueryParameter adds the serverIP to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithServerIPQueryParameter(serverIP *string) *CifsConnectionCollectionGetParams {
	o.SetServerIPQueryParameter(serverIP)
	return o
}

// SetServerIPQueryParameter adds the serverIp to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetServerIPQueryParameter(serverIP *string) {
	o.ServerIPQueryParameter = serverIP
}

// WithSessionsIDentifierQueryParameter adds the sessionsIdentifier to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithSessionsIDentifierQueryParameter(sessionsIdentifier *int64) *CifsConnectionCollectionGetParams {
	o.SetSessionsIDentifierQueryParameter(sessionsIdentifier)
	return o
}

// SetSessionsIDentifierQueryParameter adds the sessionsIdentifier to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetSessionsIDentifierQueryParameter(sessionsIdentifier *int64) {
	o.SessionsIDentifierQueryParameter = sessionsIdentifier
}

// WithSVMNameQueryParameter adds the svmName to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *CifsConnectionCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *CifsConnectionCollectionGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the cifs connection collection get params
func (o *CifsConnectionCollectionGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *CifsConnectionCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ClientIPQueryParameter != nil {

		// query param client_ip
		var qrClientIP string

		if o.ClientIPQueryParameter != nil {
			qrClientIP = *o.ClientIPQueryParameter
		}
		qClientIP := qrClientIP
		if qClientIP != "" {

			if err := r.SetQueryParam("client_ip", qClientIP); err != nil {
				return err
			}
		}
	}

	if o.ClientPortQueryParameter != nil {

		// query param client_port
		var qrClientPort int64

		if o.ClientPortQueryParameter != nil {
			qrClientPort = *o.ClientPortQueryParameter
		}
		qClientPort := swag.FormatInt64(qrClientPort)
		if qClientPort != "" {

			if err := r.SetQueryParam("client_port", qClientPort); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.IdentifierQueryParameter != nil {

		// query param identifier
		var qrIdentifier int64

		if o.IdentifierQueryParameter != nil {
			qrIdentifier = *o.IdentifierQueryParameter
		}
		qIdentifier := swag.FormatInt64(qrIdentifier)
		if qIdentifier != "" {

			if err := r.SetQueryParam("identifier", qIdentifier); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NetworkContextIDQueryParameter != nil {

		// query param network_context_id
		var qrNetworkContextID int64

		if o.NetworkContextIDQueryParameter != nil {
			qrNetworkContextID = *o.NetworkContextIDQueryParameter
		}
		qNetworkContextID := swag.FormatInt64(qrNetworkContextID)
		if qNetworkContextID != "" {

			if err := r.SetQueryParam("network_context_id", qNetworkContextID); err != nil {
				return err
			}
		}
	}

	if o.NodeNameQueryParameter != nil {

		// query param node.name
		var qrNodeName string

		if o.NodeNameQueryParameter != nil {
			qrNodeName = *o.NodeNameQueryParameter
		}
		qNodeName := qrNodeName
		if qNodeName != "" {

			if err := r.SetQueryParam("node.name", qNodeName); err != nil {
				return err
			}
		}
	}

	if o.NodeUUIDQueryParameter != nil {

		// query param node.uuid
		var qrNodeUUID string

		if o.NodeUUIDQueryParameter != nil {
			qrNodeUUID = *o.NodeUUIDQueryParameter
		}
		qNodeUUID := qrNodeUUID
		if qNodeUUID != "" {

			if err := r.SetQueryParam("node.uuid", qNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.ServerIPQueryParameter != nil {

		// query param server_ip
		var qrServerIP string

		if o.ServerIPQueryParameter != nil {
			qrServerIP = *o.ServerIPQueryParameter
		}
		qServerIP := qrServerIP
		if qServerIP != "" {

			if err := r.SetQueryParam("server_ip", qServerIP); err != nil {
				return err
			}
		}
	}

	if o.SessionsIDentifierQueryParameter != nil {

		// query param sessions.identifier
		var qrSessionsIdentifier int64

		if o.SessionsIDentifierQueryParameter != nil {
			qrSessionsIdentifier = *o.SessionsIDentifierQueryParameter
		}
		qSessionsIdentifier := swag.FormatInt64(qrSessionsIdentifier)
		if qSessionsIdentifier != "" {

			if err := r.SetQueryParam("sessions.identifier", qSessionsIdentifier); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamCifsConnectionCollectionGet binds the parameter fields
func (o *CifsConnectionCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamCifsConnectionCollectionGet binds the parameter order_by
func (o *CifsConnectionCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
