// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewCifsShareACLCreateParams creates a new CifsShareACLCreateParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCifsShareACLCreateParams() *CifsShareACLCreateParams {
	return &CifsShareACLCreateParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCifsShareACLCreateParamsWithTimeout creates a new CifsShareACLCreateParams object
// with the ability to set a timeout on a request.
func NewCifsShareACLCreateParamsWithTimeout(timeout time.Duration) *CifsShareACLCreateParams {
	return &CifsShareACLCreateParams{
		timeout: timeout,
	}
}

// NewCifsShareACLCreateParamsWithContext creates a new CifsShareACLCreateParams object
// with the ability to set a context for a request.
func NewCifsShareACLCreateParamsWithContext(ctx context.Context) *CifsShareACLCreateParams {
	return &CifsShareACLCreateParams{
		Context: ctx,
	}
}

// NewCifsShareACLCreateParamsWithHTTPClient creates a new CifsShareACLCreateParams object
// with the ability to set a custom HTTPClient for a request.
func NewCifsShareACLCreateParamsWithHTTPClient(client *http.Client) *CifsShareACLCreateParams {
	return &CifsShareACLCreateParams{
		HTTPClient: client,
	}
}

/*
CifsShareACLCreateParams contains all the parameters to send to the API endpoint

	for the cifs share acl create operation.

	Typically these are written to a http.Request.
*/
type CifsShareACLCreateParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.CifsShareACL

	/* ReturnRecords.

	   The default is false.  If set to true, the records are returned.
	*/
	ReturnRecordsQueryParameter *bool

	/* Share.

	   CIFS Share Name
	*/
	SharePathParameter string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the cifs share acl create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CifsShareACLCreateParams) WithDefaults() *CifsShareACLCreateParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the cifs share acl create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CifsShareACLCreateParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(false)
	)

	val := CifsShareACLCreateParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the cifs share acl create params
func (o *CifsShareACLCreateParams) WithTimeout(timeout time.Duration) *CifsShareACLCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the cifs share acl create params
func (o *CifsShareACLCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the cifs share acl create params
func (o *CifsShareACLCreateParams) WithContext(ctx context.Context) *CifsShareACLCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the cifs share acl create params
func (o *CifsShareACLCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the cifs share acl create params
func (o *CifsShareACLCreateParams) WithHTTPClient(client *http.Client) *CifsShareACLCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the cifs share acl create params
func (o *CifsShareACLCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the cifs share acl create params
func (o *CifsShareACLCreateParams) WithInfo(info *models.CifsShareACL) *CifsShareACLCreateParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the cifs share acl create params
func (o *CifsShareACLCreateParams) SetInfo(info *models.CifsShareACL) {
	o.Info = info
}

// WithReturnRecordsQueryParameter adds the returnRecords to the cifs share acl create params
func (o *CifsShareACLCreateParams) WithReturnRecordsQueryParameter(returnRecords *bool) *CifsShareACLCreateParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the cifs share acl create params
func (o *CifsShareACLCreateParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithSharePathParameter adds the share to the cifs share acl create params
func (o *CifsShareACLCreateParams) WithSharePathParameter(share string) *CifsShareACLCreateParams {
	o.SetSharePathParameter(share)
	return o
}

// SetSharePathParameter adds the share to the cifs share acl create params
func (o *CifsShareACLCreateParams) SetSharePathParameter(share string) {
	o.SharePathParameter = share
}

// WithSVMUUIDPathParameter adds the svmUUID to the cifs share acl create params
func (o *CifsShareACLCreateParams) WithSVMUUIDPathParameter(svmUUID string) *CifsShareACLCreateParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the cifs share acl create params
func (o *CifsShareACLCreateParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *CifsShareACLCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	// path param share
	if err := r.SetPathParam("share", o.SharePathParameter); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
