// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewCifsShareModifyParams creates a new CifsShareModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCifsShareModifyParams() *CifsShareModifyParams {
	return &CifsShareModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCifsShareModifyParamsWithTimeout creates a new CifsShareModifyParams object
// with the ability to set a timeout on a request.
func NewCifsShareModifyParamsWithTimeout(timeout time.Duration) *CifsShareModifyParams {
	return &CifsShareModifyParams{
		timeout: timeout,
	}
}

// NewCifsShareModifyParamsWithContext creates a new CifsShareModifyParams object
// with the ability to set a context for a request.
func NewCifsShareModifyParamsWithContext(ctx context.Context) *CifsShareModifyParams {
	return &CifsShareModifyParams{
		Context: ctx,
	}
}

// NewCifsShareModifyParamsWithHTTPClient creates a new CifsShareModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewCifsShareModifyParamsWithHTTPClient(client *http.Client) *CifsShareModifyParams {
	return &CifsShareModifyParams{
		HTTPClient: client,
	}
}

/*
CifsShareModifyParams contains all the parameters to send to the API endpoint

	for the cifs share modify operation.

	Typically these are written to a http.Request.
*/
type CifsShareModifyParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.CifsShare

	/* Name.

	   Share Name
	*/
	NamePathParameter string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the cifs share modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CifsShareModifyParams) WithDefaults() *CifsShareModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the cifs share modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CifsShareModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the cifs share modify params
func (o *CifsShareModifyParams) WithTimeout(timeout time.Duration) *CifsShareModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the cifs share modify params
func (o *CifsShareModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the cifs share modify params
func (o *CifsShareModifyParams) WithContext(ctx context.Context) *CifsShareModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the cifs share modify params
func (o *CifsShareModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the cifs share modify params
func (o *CifsShareModifyParams) WithHTTPClient(client *http.Client) *CifsShareModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the cifs share modify params
func (o *CifsShareModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the cifs share modify params
func (o *CifsShareModifyParams) WithInfo(info *models.CifsShare) *CifsShareModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the cifs share modify params
func (o *CifsShareModifyParams) SetInfo(info *models.CifsShare) {
	o.Info = info
}

// WithNamePathParameter adds the name to the cifs share modify params
func (o *CifsShareModifyParams) WithNamePathParameter(name string) *CifsShareModifyParams {
	o.SetNamePathParameter(name)
	return o
}

// SetNamePathParameter adds the name to the cifs share modify params
func (o *CifsShareModifyParams) SetNamePathParameter(name string) {
	o.NamePathParameter = name
}

// WithSVMUUIDPathParameter adds the svmUUID to the cifs share modify params
func (o *CifsShareModifyParams) WithSVMUUIDPathParameter(svmUUID string) *CifsShareModifyParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the cifs share modify params
func (o *CifsShareModifyParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *CifsShareModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param name
	if err := r.SetPathParam("name", o.NamePathParameter); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
