// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewCifsSymlinkMappingCreateParams creates a new CifsSymlinkMappingCreateParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCifsSymlinkMappingCreateParams() *CifsSymlinkMappingCreateParams {
	return &CifsSymlinkMappingCreateParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCifsSymlinkMappingCreateParamsWithTimeout creates a new CifsSymlinkMappingCreateParams object
// with the ability to set a timeout on a request.
func NewCifsSymlinkMappingCreateParamsWithTimeout(timeout time.Duration) *CifsSymlinkMappingCreateParams {
	return &CifsSymlinkMappingCreateParams{
		timeout: timeout,
	}
}

// NewCifsSymlinkMappingCreateParamsWithContext creates a new CifsSymlinkMappingCreateParams object
// with the ability to set a context for a request.
func NewCifsSymlinkMappingCreateParamsWithContext(ctx context.Context) *CifsSymlinkMappingCreateParams {
	return &CifsSymlinkMappingCreateParams{
		Context: ctx,
	}
}

// NewCifsSymlinkMappingCreateParamsWithHTTPClient creates a new CifsSymlinkMappingCreateParams object
// with the ability to set a custom HTTPClient for a request.
func NewCifsSymlinkMappingCreateParamsWithHTTPClient(client *http.Client) *CifsSymlinkMappingCreateParams {
	return &CifsSymlinkMappingCreateParams{
		HTTPClient: client,
	}
}

/*
CifsSymlinkMappingCreateParams contains all the parameters to send to the API endpoint

	for the cifs symlink mapping create operation.

	Typically these are written to a http.Request.
*/
type CifsSymlinkMappingCreateParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.CifsSymlinkMapping

	/* ReturnRecords.

	   The default is false.  If set to true, the records are returned.
	*/
	ReturnRecordsQueryParameter *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the cifs symlink mapping create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CifsSymlinkMappingCreateParams) WithDefaults() *CifsSymlinkMappingCreateParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the cifs symlink mapping create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CifsSymlinkMappingCreateParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(false)
	)

	val := CifsSymlinkMappingCreateParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the cifs symlink mapping create params
func (o *CifsSymlinkMappingCreateParams) WithTimeout(timeout time.Duration) *CifsSymlinkMappingCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the cifs symlink mapping create params
func (o *CifsSymlinkMappingCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the cifs symlink mapping create params
func (o *CifsSymlinkMappingCreateParams) WithContext(ctx context.Context) *CifsSymlinkMappingCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the cifs symlink mapping create params
func (o *CifsSymlinkMappingCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the cifs symlink mapping create params
func (o *CifsSymlinkMappingCreateParams) WithHTTPClient(client *http.Client) *CifsSymlinkMappingCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the cifs symlink mapping create params
func (o *CifsSymlinkMappingCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the cifs symlink mapping create params
func (o *CifsSymlinkMappingCreateParams) WithInfo(info *models.CifsSymlinkMapping) *CifsSymlinkMappingCreateParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the cifs symlink mapping create params
func (o *CifsSymlinkMappingCreateParams) SetInfo(info *models.CifsSymlinkMapping) {
	o.Info = info
}

// WithReturnRecordsQueryParameter adds the returnRecords to the cifs symlink mapping create params
func (o *CifsSymlinkMappingCreateParams) WithReturnRecordsQueryParameter(returnRecords *bool) *CifsSymlinkMappingCreateParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the cifs symlink mapping create params
func (o *CifsSymlinkMappingCreateParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WriteToRequest writes these params to a swagger request
func (o *CifsSymlinkMappingCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
