// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewCifsSymlinkMappingModifyParams creates a new CifsSymlinkMappingModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCifsSymlinkMappingModifyParams() *CifsSymlinkMappingModifyParams {
	return &CifsSymlinkMappingModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCifsSymlinkMappingModifyParamsWithTimeout creates a new CifsSymlinkMappingModifyParams object
// with the ability to set a timeout on a request.
func NewCifsSymlinkMappingModifyParamsWithTimeout(timeout time.Duration) *CifsSymlinkMappingModifyParams {
	return &CifsSymlinkMappingModifyParams{
		timeout: timeout,
	}
}

// NewCifsSymlinkMappingModifyParamsWithContext creates a new CifsSymlinkMappingModifyParams object
// with the ability to set a context for a request.
func NewCifsSymlinkMappingModifyParamsWithContext(ctx context.Context) *CifsSymlinkMappingModifyParams {
	return &CifsSymlinkMappingModifyParams{
		Context: ctx,
	}
}

// NewCifsSymlinkMappingModifyParamsWithHTTPClient creates a new CifsSymlinkMappingModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewCifsSymlinkMappingModifyParamsWithHTTPClient(client *http.Client) *CifsSymlinkMappingModifyParams {
	return &CifsSymlinkMappingModifyParams{
		HTTPClient: client,
	}
}

/*
CifsSymlinkMappingModifyParams contains all the parameters to send to the API endpoint

	for the cifs symlink mapping modify operation.

	Typically these are written to a http.Request.
*/
type CifsSymlinkMappingModifyParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.CifsSymlinkMapping

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	/* UnixPath.

	   UNIX symbolic link path
	*/
	UnixPathPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the cifs symlink mapping modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CifsSymlinkMappingModifyParams) WithDefaults() *CifsSymlinkMappingModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the cifs symlink mapping modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CifsSymlinkMappingModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the cifs symlink mapping modify params
func (o *CifsSymlinkMappingModifyParams) WithTimeout(timeout time.Duration) *CifsSymlinkMappingModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the cifs symlink mapping modify params
func (o *CifsSymlinkMappingModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the cifs symlink mapping modify params
func (o *CifsSymlinkMappingModifyParams) WithContext(ctx context.Context) *CifsSymlinkMappingModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the cifs symlink mapping modify params
func (o *CifsSymlinkMappingModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the cifs symlink mapping modify params
func (o *CifsSymlinkMappingModifyParams) WithHTTPClient(client *http.Client) *CifsSymlinkMappingModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the cifs symlink mapping modify params
func (o *CifsSymlinkMappingModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the cifs symlink mapping modify params
func (o *CifsSymlinkMappingModifyParams) WithInfo(info *models.CifsSymlinkMapping) *CifsSymlinkMappingModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the cifs symlink mapping modify params
func (o *CifsSymlinkMappingModifyParams) SetInfo(info *models.CifsSymlinkMapping) {
	o.Info = info
}

// WithSVMUUIDPathParameter adds the svmUUID to the cifs symlink mapping modify params
func (o *CifsSymlinkMappingModifyParams) WithSVMUUIDPathParameter(svmUUID string) *CifsSymlinkMappingModifyParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the cifs symlink mapping modify params
func (o *CifsSymlinkMappingModifyParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WithUnixPathPathParameter adds the unixPath to the cifs symlink mapping modify params
func (o *CifsSymlinkMappingModifyParams) WithUnixPathPathParameter(unixPath string) *CifsSymlinkMappingModifyParams {
	o.SetUnixPathPathParameter(unixPath)
	return o
}

// SetUnixPathPathParameter adds the unixPath to the cifs symlink mapping modify params
func (o *CifsSymlinkMappingModifyParams) SetUnixPathPathParameter(unixPath string) {
	o.UnixPathPathParameter = unixPath
}

// WriteToRequest writes these params to a swagger request
func (o *CifsSymlinkMappingModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	// path param unix_path
	if err := r.SetPathParam("unix_path", o.UnixPathPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
