// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewFileDirectorySecurityACLModifyParams creates a new FileDirectorySecurityACLModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewFileDirectorySecurityACLModifyParams() *FileDirectorySecurityACLModifyParams {
	return &FileDirectorySecurityACLModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewFileDirectorySecurityACLModifyParamsWithTimeout creates a new FileDirectorySecurityACLModifyParams object
// with the ability to set a timeout on a request.
func NewFileDirectorySecurityACLModifyParamsWithTimeout(timeout time.Duration) *FileDirectorySecurityACLModifyParams {
	return &FileDirectorySecurityACLModifyParams{
		timeout: timeout,
	}
}

// NewFileDirectorySecurityACLModifyParamsWithContext creates a new FileDirectorySecurityACLModifyParams object
// with the ability to set a context for a request.
func NewFileDirectorySecurityACLModifyParamsWithContext(ctx context.Context) *FileDirectorySecurityACLModifyParams {
	return &FileDirectorySecurityACLModifyParams{
		Context: ctx,
	}
}

// NewFileDirectorySecurityACLModifyParamsWithHTTPClient creates a new FileDirectorySecurityACLModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewFileDirectorySecurityACLModifyParamsWithHTTPClient(client *http.Client) *FileDirectorySecurityACLModifyParams {
	return &FileDirectorySecurityACLModifyParams{
		HTTPClient: client,
	}
}

/*
FileDirectorySecurityACLModifyParams contains all the parameters to send to the API endpoint

	for the file directory security acl modify operation.

	Typically these are written to a http.Request.
*/
type FileDirectorySecurityACLModifyParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.FileDirectorySecurityACL

	/* Path.

	   path
	*/
	PathPathParameter string

	/* ReturnRecords.

	   The default is false.  If set to true, the records are returned.
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning. When doing a POST, PATCH, or DELETE operation on a single record, the default is 0 seconds.  This means that if an asynchronous operation is started, the server immediately returns HTTP code 202 (Accepted) along with a link to the job.  If a non-zero value is specified for POST, PATCH, or DELETE operations, ONTAP waits that length of time to see if the job completes so it can return something other than 202.
	*/
	ReturnTimeoutQueryParameter *int64

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	/* User.

	   User Name
	*/
	UserPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the file directory security acl modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FileDirectorySecurityACLModifyParams) WithDefaults() *FileDirectorySecurityACLModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the file directory security acl modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FileDirectorySecurityACLModifyParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(false)

		returnTimeoutQueryParameterDefault = int64(0)
	)

	val := FileDirectorySecurityACLModifyParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) WithTimeout(timeout time.Duration) *FileDirectorySecurityACLModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) WithContext(ctx context.Context) *FileDirectorySecurityACLModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) WithHTTPClient(client *http.Client) *FileDirectorySecurityACLModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) WithInfo(info *models.FileDirectorySecurityACL) *FileDirectorySecurityACLModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) SetInfo(info *models.FileDirectorySecurityACL) {
	o.Info = info
}

// WithPathPathParameter adds the path to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) WithPathPathParameter(path string) *FileDirectorySecurityACLModifyParams {
	o.SetPathPathParameter(path)
	return o
}

// SetPathPathParameter adds the path to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) SetPathPathParameter(path string) {
	o.PathPathParameter = path
}

// WithReturnRecordsQueryParameter adds the returnRecords to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) WithReturnRecordsQueryParameter(returnRecords *bool) *FileDirectorySecurityACLModifyParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *FileDirectorySecurityACLModifyParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSVMUUIDPathParameter adds the svmUUID to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) WithSVMUUIDPathParameter(svmUUID string) *FileDirectorySecurityACLModifyParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WithUserPathParameter adds the user to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) WithUserPathParameter(user string) *FileDirectorySecurityACLModifyParams {
	o.SetUserPathParameter(user)
	return o
}

// SetUserPathParameter adds the user to the file directory security acl modify params
func (o *FileDirectorySecurityACLModifyParams) SetUserPathParameter(user string) {
	o.UserPathParameter = user
}

// WriteToRequest writes these params to a swagger request
func (o *FileDirectorySecurityACLModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param path
	if err := r.SetPathParam("path", o.PathPathParameter); err != nil {
		return err
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	// path param user
	if err := r.SetPathParam("user", o.UserPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
