// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewFpolicyConnectionModifyParams creates a new FpolicyConnectionModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewFpolicyConnectionModifyParams() *FpolicyConnectionModifyParams {
	return &FpolicyConnectionModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewFpolicyConnectionModifyParamsWithTimeout creates a new FpolicyConnectionModifyParams object
// with the ability to set a timeout on a request.
func NewFpolicyConnectionModifyParamsWithTimeout(timeout time.Duration) *FpolicyConnectionModifyParams {
	return &FpolicyConnectionModifyParams{
		timeout: timeout,
	}
}

// NewFpolicyConnectionModifyParamsWithContext creates a new FpolicyConnectionModifyParams object
// with the ability to set a context for a request.
func NewFpolicyConnectionModifyParamsWithContext(ctx context.Context) *FpolicyConnectionModifyParams {
	return &FpolicyConnectionModifyParams{
		Context: ctx,
	}
}

// NewFpolicyConnectionModifyParamsWithHTTPClient creates a new FpolicyConnectionModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewFpolicyConnectionModifyParamsWithHTTPClient(client *http.Client) *FpolicyConnectionModifyParams {
	return &FpolicyConnectionModifyParams{
		HTTPClient: client,
	}
}

/*
FpolicyConnectionModifyParams contains all the parameters to send to the API endpoint

	for the fpolicy connection modify operation.

	Typically these are written to a http.Request.
*/
type FpolicyConnectionModifyParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.FpolicyConnection

	/* NodeUUID.

	   Node UUID.
	*/
	NodeUUIDPathParameter string

	/* PolicyName.

	   Policy name
	*/
	PolicyNamePathParameter string

	/* Server.

	   FPolicy Server IP address
	*/
	ServerPathParameter string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SvmUUID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the fpolicy connection modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FpolicyConnectionModifyParams) WithDefaults() *FpolicyConnectionModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the fpolicy connection modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FpolicyConnectionModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) WithTimeout(timeout time.Duration) *FpolicyConnectionModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) WithContext(ctx context.Context) *FpolicyConnectionModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) WithHTTPClient(client *http.Client) *FpolicyConnectionModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) WithInfo(info *models.FpolicyConnection) *FpolicyConnectionModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) SetInfo(info *models.FpolicyConnection) {
	o.Info = info
}

// WithNodeUUIDPathParameter adds the nodeUUID to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) WithNodeUUIDPathParameter(nodeUUID string) *FpolicyConnectionModifyParams {
	o.SetNodeUUIDPathParameter(nodeUUID)
	return o
}

// SetNodeUUIDPathParameter adds the nodeUuid to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) SetNodeUUIDPathParameter(nodeUUID string) {
	o.NodeUUIDPathParameter = nodeUUID
}

// WithPolicyNamePathParameter adds the policyName to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) WithPolicyNamePathParameter(policyName string) *FpolicyConnectionModifyParams {
	o.SetPolicyNamePathParameter(policyName)
	return o
}

// SetPolicyNamePathParameter adds the policyName to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) SetPolicyNamePathParameter(policyName string) {
	o.PolicyNamePathParameter = policyName
}

// WithServerPathParameter adds the server to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) WithServerPathParameter(server string) *FpolicyConnectionModifyParams {
	o.SetServerPathParameter(server)
	return o
}

// SetServerPathParameter adds the server to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) SetServerPathParameter(server string) {
	o.ServerPathParameter = server
}

// WithSvmUUID adds the svmUUID to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) WithSvmUUID(svmUUID string) *FpolicyConnectionModifyParams {
	o.SetSvmUUID(svmUUID)
	return o
}

// SetSvmUUID adds the svmUuid to the fpolicy connection modify params
func (o *FpolicyConnectionModifyParams) SetSvmUUID(svmUUID string) {
	o.SvmUUID = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *FpolicyConnectionModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param node.uuid
	if err := r.SetPathParam("node.uuid", o.NodeUUIDPathParameter); err != nil {
		return err
	}

	// path param policy.name
	if err := r.SetPathParam("policy.name", o.PolicyNamePathParameter); err != nil {
		return err
	}

	// path param server
	if err := r.SetPathParam("server", o.ServerPathParameter); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SvmUUID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
