// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewLocalCifsGroupDeleteParams creates a new LocalCifsGroupDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLocalCifsGroupDeleteParams() *LocalCifsGroupDeleteParams {
	return &LocalCifsGroupDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLocalCifsGroupDeleteParamsWithTimeout creates a new LocalCifsGroupDeleteParams object
// with the ability to set a timeout on a request.
func NewLocalCifsGroupDeleteParamsWithTimeout(timeout time.Duration) *LocalCifsGroupDeleteParams {
	return &LocalCifsGroupDeleteParams{
		timeout: timeout,
	}
}

// NewLocalCifsGroupDeleteParamsWithContext creates a new LocalCifsGroupDeleteParams object
// with the ability to set a context for a request.
func NewLocalCifsGroupDeleteParamsWithContext(ctx context.Context) *LocalCifsGroupDeleteParams {
	return &LocalCifsGroupDeleteParams{
		Context: ctx,
	}
}

// NewLocalCifsGroupDeleteParamsWithHTTPClient creates a new LocalCifsGroupDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewLocalCifsGroupDeleteParamsWithHTTPClient(client *http.Client) *LocalCifsGroupDeleteParams {
	return &LocalCifsGroupDeleteParams{
		HTTPClient: client,
	}
}

/*
LocalCifsGroupDeleteParams contains all the parameters to send to the API endpoint

	for the local cifs group delete operation.

	Typically these are written to a http.Request.
*/
type LocalCifsGroupDeleteParams struct {

	/* Sid.

	   Local group SID
	*/
	SIDPathParameter string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the local cifs group delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LocalCifsGroupDeleteParams) WithDefaults() *LocalCifsGroupDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the local cifs group delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LocalCifsGroupDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the local cifs group delete params
func (o *LocalCifsGroupDeleteParams) WithTimeout(timeout time.Duration) *LocalCifsGroupDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the local cifs group delete params
func (o *LocalCifsGroupDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the local cifs group delete params
func (o *LocalCifsGroupDeleteParams) WithContext(ctx context.Context) *LocalCifsGroupDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the local cifs group delete params
func (o *LocalCifsGroupDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the local cifs group delete params
func (o *LocalCifsGroupDeleteParams) WithHTTPClient(client *http.Client) *LocalCifsGroupDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the local cifs group delete params
func (o *LocalCifsGroupDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithSIDPathParameter adds the sid to the local cifs group delete params
func (o *LocalCifsGroupDeleteParams) WithSIDPathParameter(sid string) *LocalCifsGroupDeleteParams {
	o.SetSIDPathParameter(sid)
	return o
}

// SetSIDPathParameter adds the sid to the local cifs group delete params
func (o *LocalCifsGroupDeleteParams) SetSIDPathParameter(sid string) {
	o.SIDPathParameter = sid
}

// WithSVMUUIDPathParameter adds the svmUUID to the local cifs group delete params
func (o *LocalCifsGroupDeleteParams) WithSVMUUIDPathParameter(svmUUID string) *LocalCifsGroupDeleteParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the local cifs group delete params
func (o *LocalCifsGroupDeleteParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *LocalCifsGroupDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param sid
	if err := r.SetPathParam("sid", o.SIDPathParameter); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
