// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewLocalCifsUserCollectionGetParams creates a new LocalCifsUserCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLocalCifsUserCollectionGetParams() *LocalCifsUserCollectionGetParams {
	return &LocalCifsUserCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLocalCifsUserCollectionGetParamsWithTimeout creates a new LocalCifsUserCollectionGetParams object
// with the ability to set a timeout on a request.
func NewLocalCifsUserCollectionGetParamsWithTimeout(timeout time.Duration) *LocalCifsUserCollectionGetParams {
	return &LocalCifsUserCollectionGetParams{
		timeout: timeout,
	}
}

// NewLocalCifsUserCollectionGetParamsWithContext creates a new LocalCifsUserCollectionGetParams object
// with the ability to set a context for a request.
func NewLocalCifsUserCollectionGetParamsWithContext(ctx context.Context) *LocalCifsUserCollectionGetParams {
	return &LocalCifsUserCollectionGetParams{
		Context: ctx,
	}
}

// NewLocalCifsUserCollectionGetParamsWithHTTPClient creates a new LocalCifsUserCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewLocalCifsUserCollectionGetParamsWithHTTPClient(client *http.Client) *LocalCifsUserCollectionGetParams {
	return &LocalCifsUserCollectionGetParams{
		HTTPClient: client,
	}
}

/*
LocalCifsUserCollectionGetParams contains all the parameters to send to the API endpoint

	for the local cifs user collection get operation.

	Typically these are written to a http.Request.
*/
type LocalCifsUserCollectionGetParams struct {

	/* AccountDisabled.

	   Filter by account_disabled
	*/
	AccountDisabledQueryParameter *bool

	/* Description.

	   Filter by description
	*/
	DescriptionQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* FullName.

	   Filter by full_name
	*/
	FullNameQueryParameter *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* MembershipName.

	   Filter by membership.name
	*/
	MembershIPNameQueryParameter *string

	/* MembershipSid.

	   Filter by membership.sid
	*/
	MembershIPSIDQueryParameter *string

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* Sid.

	   Filter by sid
	*/
	SIDQueryParameter *string

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the local cifs user collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LocalCifsUserCollectionGetParams) WithDefaults() *LocalCifsUserCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the local cifs user collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LocalCifsUserCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := LocalCifsUserCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithTimeout(timeout time.Duration) *LocalCifsUserCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithContext(ctx context.Context) *LocalCifsUserCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithHTTPClient(client *http.Client) *LocalCifsUserCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountDisabledQueryParameter adds the accountDisabled to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithAccountDisabledQueryParameter(accountDisabled *bool) *LocalCifsUserCollectionGetParams {
	o.SetAccountDisabledQueryParameter(accountDisabled)
	return o
}

// SetAccountDisabledQueryParameter adds the accountDisabled to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetAccountDisabledQueryParameter(accountDisabled *bool) {
	o.AccountDisabledQueryParameter = accountDisabled
}

// WithDescriptionQueryParameter adds the description to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithDescriptionQueryParameter(description *string) *LocalCifsUserCollectionGetParams {
	o.SetDescriptionQueryParameter(description)
	return o
}

// SetDescriptionQueryParameter adds the description to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetDescriptionQueryParameter(description *string) {
	o.DescriptionQueryParameter = description
}

// WithFieldsQueryParameter adds the fields to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithFieldsQueryParameter(fields []string) *LocalCifsUserCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithFullNameQueryParameter adds the fullName to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithFullNameQueryParameter(fullName *string) *LocalCifsUserCollectionGetParams {
	o.SetFullNameQueryParameter(fullName)
	return o
}

// SetFullNameQueryParameter adds the fullName to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetFullNameQueryParameter(fullName *string) {
	o.FullNameQueryParameter = fullName
}

// WithMaxRecordsQueryParameter adds the maxRecords to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *LocalCifsUserCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithMembershIPNameQueryParameter adds the membershipName to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithMembershIPNameQueryParameter(membershipName *string) *LocalCifsUserCollectionGetParams {
	o.SetMembershIPNameQueryParameter(membershipName)
	return o
}

// SetMembershIPNameQueryParameter adds the membershipName to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetMembershIPNameQueryParameter(membershipName *string) {
	o.MembershIPNameQueryParameter = membershipName
}

// WithMembershIPSIDQueryParameter adds the membershipSid to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithMembershIPSIDQueryParameter(membershipSid *string) *LocalCifsUserCollectionGetParams {
	o.SetMembershIPSIDQueryParameter(membershipSid)
	return o
}

// SetMembershIPSIDQueryParameter adds the membershipSid to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetMembershIPSIDQueryParameter(membershipSid *string) {
	o.MembershIPSIDQueryParameter = membershipSid
}

// WithNameQueryParameter adds the name to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithNameQueryParameter(name *string) *LocalCifsUserCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *LocalCifsUserCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *LocalCifsUserCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *LocalCifsUserCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSIDQueryParameter adds the sid to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithSIDQueryParameter(sid *string) *LocalCifsUserCollectionGetParams {
	o.SetSIDQueryParameter(sid)
	return o
}

// SetSIDQueryParameter adds the sid to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetSIDQueryParameter(sid *string) {
	o.SIDQueryParameter = sid
}

// WithSVMNameQueryParameter adds the svmName to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *LocalCifsUserCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *LocalCifsUserCollectionGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the local cifs user collection get params
func (o *LocalCifsUserCollectionGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *LocalCifsUserCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountDisabledQueryParameter != nil {

		// query param account_disabled
		var qrAccountDisabled bool

		if o.AccountDisabledQueryParameter != nil {
			qrAccountDisabled = *o.AccountDisabledQueryParameter
		}
		qAccountDisabled := swag.FormatBool(qrAccountDisabled)
		if qAccountDisabled != "" {

			if err := r.SetQueryParam("account_disabled", qAccountDisabled); err != nil {
				return err
			}
		}
	}

	if o.DescriptionQueryParameter != nil {

		// query param description
		var qrDescription string

		if o.DescriptionQueryParameter != nil {
			qrDescription = *o.DescriptionQueryParameter
		}
		qDescription := qrDescription
		if qDescription != "" {

			if err := r.SetQueryParam("description", qDescription); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.FullNameQueryParameter != nil {

		// query param full_name
		var qrFullName string

		if o.FullNameQueryParameter != nil {
			qrFullName = *o.FullNameQueryParameter
		}
		qFullName := qrFullName
		if qFullName != "" {

			if err := r.SetQueryParam("full_name", qFullName); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.MembershIPNameQueryParameter != nil {

		// query param membership.name
		var qrMembershipName string

		if o.MembershIPNameQueryParameter != nil {
			qrMembershipName = *o.MembershIPNameQueryParameter
		}
		qMembershipName := qrMembershipName
		if qMembershipName != "" {

			if err := r.SetQueryParam("membership.name", qMembershipName); err != nil {
				return err
			}
		}
	}

	if o.MembershIPSIDQueryParameter != nil {

		// query param membership.sid
		var qrMembershipSid string

		if o.MembershIPSIDQueryParameter != nil {
			qrMembershipSid = *o.MembershIPSIDQueryParameter
		}
		qMembershipSid := qrMembershipSid
		if qMembershipSid != "" {

			if err := r.SetQueryParam("membership.sid", qMembershipSid); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SIDQueryParameter != nil {

		// query param sid
		var qrSid string

		if o.SIDQueryParameter != nil {
			qrSid = *o.SIDQueryParameter
		}
		qSid := qrSid
		if qSid != "" {

			if err := r.SetQueryParam("sid", qSid); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamLocalCifsUserCollectionGet binds the parameter fields
func (o *LocalCifsUserCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamLocalCifsUserCollectionGet binds the parameter order_by
func (o *LocalCifsUserCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
