// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewLocalCifsUserModifyParams creates a new LocalCifsUserModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLocalCifsUserModifyParams() *LocalCifsUserModifyParams {
	return &LocalCifsUserModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLocalCifsUserModifyParamsWithTimeout creates a new LocalCifsUserModifyParams object
// with the ability to set a timeout on a request.
func NewLocalCifsUserModifyParamsWithTimeout(timeout time.Duration) *LocalCifsUserModifyParams {
	return &LocalCifsUserModifyParams{
		timeout: timeout,
	}
}

// NewLocalCifsUserModifyParamsWithContext creates a new LocalCifsUserModifyParams object
// with the ability to set a context for a request.
func NewLocalCifsUserModifyParamsWithContext(ctx context.Context) *LocalCifsUserModifyParams {
	return &LocalCifsUserModifyParams{
		Context: ctx,
	}
}

// NewLocalCifsUserModifyParamsWithHTTPClient creates a new LocalCifsUserModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewLocalCifsUserModifyParamsWithHTTPClient(client *http.Client) *LocalCifsUserModifyParams {
	return &LocalCifsUserModifyParams{
		HTTPClient: client,
	}
}

/*
LocalCifsUserModifyParams contains all the parameters to send to the API endpoint

	for the local cifs user modify operation.

	Typically these are written to a http.Request.
*/
type LocalCifsUserModifyParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.LocalCifsUser

	/* Sid.

	   Local user SID
	*/
	SIDPathParameter string

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the local cifs user modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LocalCifsUserModifyParams) WithDefaults() *LocalCifsUserModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the local cifs user modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LocalCifsUserModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the local cifs user modify params
func (o *LocalCifsUserModifyParams) WithTimeout(timeout time.Duration) *LocalCifsUserModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the local cifs user modify params
func (o *LocalCifsUserModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the local cifs user modify params
func (o *LocalCifsUserModifyParams) WithContext(ctx context.Context) *LocalCifsUserModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the local cifs user modify params
func (o *LocalCifsUserModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the local cifs user modify params
func (o *LocalCifsUserModifyParams) WithHTTPClient(client *http.Client) *LocalCifsUserModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the local cifs user modify params
func (o *LocalCifsUserModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the local cifs user modify params
func (o *LocalCifsUserModifyParams) WithInfo(info *models.LocalCifsUser) *LocalCifsUserModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the local cifs user modify params
func (o *LocalCifsUserModifyParams) SetInfo(info *models.LocalCifsUser) {
	o.Info = info
}

// WithSIDPathParameter adds the sid to the local cifs user modify params
func (o *LocalCifsUserModifyParams) WithSIDPathParameter(sid string) *LocalCifsUserModifyParams {
	o.SetSIDPathParameter(sid)
	return o
}

// SetSIDPathParameter adds the sid to the local cifs user modify params
func (o *LocalCifsUserModifyParams) SetSIDPathParameter(sid string) {
	o.SIDPathParameter = sid
}

// WithSVMUUIDPathParameter adds the svmUUID to the local cifs user modify params
func (o *LocalCifsUserModifyParams) WithSVMUUIDPathParameter(svmUUID string) *LocalCifsUserModifyParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the local cifs user modify params
func (o *LocalCifsUserModifyParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *LocalCifsUserModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param sid
	if err := r.SetPathParam("sid", o.SIDPathParameter); err != nil {
		return err
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
