// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewNfsGetParams creates a new NfsGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNfsGetParams() *NfsGetParams {
	return &NfsGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNfsGetParamsWithTimeout creates a new NfsGetParams object
// with the ability to set a timeout on a request.
func NewNfsGetParamsWithTimeout(timeout time.Duration) *NfsGetParams {
	return &NfsGetParams{
		timeout: timeout,
	}
}

// NewNfsGetParamsWithContext creates a new NfsGetParams object
// with the ability to set a context for a request.
func NewNfsGetParamsWithContext(ctx context.Context) *NfsGetParams {
	return &NfsGetParams{
		Context: ctx,
	}
}

// NewNfsGetParamsWithHTTPClient creates a new NfsGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewNfsGetParamsWithHTTPClient(client *http.Client) *NfsGetParams {
	return &NfsGetParams{
		HTTPClient: client,
	}
}

/*
NfsGetParams contains all the parameters to send to the API endpoint

	for the nfs get operation.

	Typically these are written to a http.Request.
*/
type NfsGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	// SvmUUID.
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the nfs get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NfsGetParams) WithDefaults() *NfsGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the nfs get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NfsGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the nfs get params
func (o *NfsGetParams) WithTimeout(timeout time.Duration) *NfsGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the nfs get params
func (o *NfsGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the nfs get params
func (o *NfsGetParams) WithContext(ctx context.Context) *NfsGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the nfs get params
func (o *NfsGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the nfs get params
func (o *NfsGetParams) WithHTTPClient(client *http.Client) *NfsGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the nfs get params
func (o *NfsGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the nfs get params
func (o *NfsGetParams) WithFieldsQueryParameter(fields []string) *NfsGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the nfs get params
func (o *NfsGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithSVMUUIDPathParameter adds the svmUUID to the nfs get params
func (o *NfsGetParams) WithSVMUUIDPathParameter(svmUUID string) *NfsGetParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the nfs get params
func (o *NfsGetParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *NfsGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamNfsGet binds the parameter fields
func (o *NfsGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
