// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewShadowcopyCollectionGetParams creates a new ShadowcopyCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewShadowcopyCollectionGetParams() *ShadowcopyCollectionGetParams {
	return &ShadowcopyCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewShadowcopyCollectionGetParamsWithTimeout creates a new ShadowcopyCollectionGetParams object
// with the ability to set a timeout on a request.
func NewShadowcopyCollectionGetParamsWithTimeout(timeout time.Duration) *ShadowcopyCollectionGetParams {
	return &ShadowcopyCollectionGetParams{
		timeout: timeout,
	}
}

// NewShadowcopyCollectionGetParamsWithContext creates a new ShadowcopyCollectionGetParams object
// with the ability to set a context for a request.
func NewShadowcopyCollectionGetParamsWithContext(ctx context.Context) *ShadowcopyCollectionGetParams {
	return &ShadowcopyCollectionGetParams{
		Context: ctx,
	}
}

// NewShadowcopyCollectionGetParamsWithHTTPClient creates a new ShadowcopyCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewShadowcopyCollectionGetParamsWithHTTPClient(client *http.Client) *ShadowcopyCollectionGetParams {
	return &ShadowcopyCollectionGetParams{
		HTTPClient: client,
	}
}

/*
ShadowcopyCollectionGetParams contains all the parameters to send to the API endpoint

	for the shadowcopy collection get operation.

	Typically these are written to a http.Request.
*/
type ShadowcopyCollectionGetParams struct {

	/* ClientUUID.

	   Filter by client_uuid
	*/
	ClientUUIDQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* Files.

	   Filter by files
	*/
	FilesQueryParameter *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* ShadowcopySetUUID.

	   Filter by shadowcopy_set.uuid
	*/
	ShadowcopySetUUIDQueryParameter *string

	/* ShareName.

	   Filter by share.name
	*/
	ShareNameQueryParameter *string

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	/* UUID.

	   Filter by uuid
	*/
	UUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the shadowcopy collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ShadowcopyCollectionGetParams) WithDefaults() *ShadowcopyCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the shadowcopy collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ShadowcopyCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := ShadowcopyCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) WithTimeout(timeout time.Duration) *ShadowcopyCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) WithContext(ctx context.Context) *ShadowcopyCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) WithHTTPClient(client *http.Client) *ShadowcopyCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithClientUUIDQueryParameter adds the clientUUID to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) WithClientUUIDQueryParameter(clientUUID *string) *ShadowcopyCollectionGetParams {
	o.SetClientUUIDQueryParameter(clientUUID)
	return o
}

// SetClientUUIDQueryParameter adds the clientUuid to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) SetClientUUIDQueryParameter(clientUUID *string) {
	o.ClientUUIDQueryParameter = clientUUID
}

// WithFieldsQueryParameter adds the fields to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) WithFieldsQueryParameter(fields []string) *ShadowcopyCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithFilesQueryParameter adds the files to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) WithFilesQueryParameter(files *string) *ShadowcopyCollectionGetParams {
	o.SetFilesQueryParameter(files)
	return o
}

// SetFilesQueryParameter adds the files to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) SetFilesQueryParameter(files *string) {
	o.FilesQueryParameter = files
}

// WithMaxRecordsQueryParameter adds the maxRecords to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *ShadowcopyCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *ShadowcopyCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *ShadowcopyCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *ShadowcopyCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithShadowcopySetUUIDQueryParameter adds the shadowcopySetUUID to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) WithShadowcopySetUUIDQueryParameter(shadowcopySetUUID *string) *ShadowcopyCollectionGetParams {
	o.SetShadowcopySetUUIDQueryParameter(shadowcopySetUUID)
	return o
}

// SetShadowcopySetUUIDQueryParameter adds the shadowcopySetUuid to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) SetShadowcopySetUUIDQueryParameter(shadowcopySetUUID *string) {
	o.ShadowcopySetUUIDQueryParameter = shadowcopySetUUID
}

// WithShareNameQueryParameter adds the shareName to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) WithShareNameQueryParameter(shareName *string) *ShadowcopyCollectionGetParams {
	o.SetShareNameQueryParameter(shareName)
	return o
}

// SetShareNameQueryParameter adds the shareName to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) SetShareNameQueryParameter(shareName *string) {
	o.ShareNameQueryParameter = shareName
}

// WithSVMNameQueryParameter adds the svmName to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *ShadowcopyCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *ShadowcopyCollectionGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WithUUIDQueryParameter adds the uuid to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) WithUUIDQueryParameter(uuid *string) *ShadowcopyCollectionGetParams {
	o.SetUUIDQueryParameter(uuid)
	return o
}

// SetUUIDQueryParameter adds the uuid to the shadowcopy collection get params
func (o *ShadowcopyCollectionGetParams) SetUUIDQueryParameter(uuid *string) {
	o.UUIDQueryParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *ShadowcopyCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ClientUUIDQueryParameter != nil {

		// query param client_uuid
		var qrClientUUID string

		if o.ClientUUIDQueryParameter != nil {
			qrClientUUID = *o.ClientUUIDQueryParameter
		}
		qClientUUID := qrClientUUID
		if qClientUUID != "" {

			if err := r.SetQueryParam("client_uuid", qClientUUID); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.FilesQueryParameter != nil {

		// query param files
		var qrFiles string

		if o.FilesQueryParameter != nil {
			qrFiles = *o.FilesQueryParameter
		}
		qFiles := qrFiles
		if qFiles != "" {

			if err := r.SetQueryParam("files", qFiles); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.ShadowcopySetUUIDQueryParameter != nil {

		// query param shadowcopy_set.uuid
		var qrShadowcopySetUUID string

		if o.ShadowcopySetUUIDQueryParameter != nil {
			qrShadowcopySetUUID = *o.ShadowcopySetUUIDQueryParameter
		}
		qShadowcopySetUUID := qrShadowcopySetUUID
		if qShadowcopySetUUID != "" {

			if err := r.SetQueryParam("shadowcopy_set.uuid", qShadowcopySetUUID); err != nil {
				return err
			}
		}
	}

	if o.ShareNameQueryParameter != nil {

		// query param share.name
		var qrShareName string

		if o.ShareNameQueryParameter != nil {
			qrShareName = *o.ShareNameQueryParameter
		}
		qShareName := qrShareName
		if qShareName != "" {

			if err := r.SetQueryParam("share.name", qShareName); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if o.UUIDQueryParameter != nil {

		// query param uuid
		var qrUUID string

		if o.UUIDQueryParameter != nil {
			qrUUID = *o.UUIDQueryParameter
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamShadowcopyCollectionGet binds the parameter fields
func (o *ShadowcopyCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamShadowcopyCollectionGet binds the parameter order_by
func (o *ShadowcopyCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
