// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewUserGroupPrivilegesCollectionGetParams creates a new UserGroupPrivilegesCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUserGroupPrivilegesCollectionGetParams() *UserGroupPrivilegesCollectionGetParams {
	return &UserGroupPrivilegesCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUserGroupPrivilegesCollectionGetParamsWithTimeout creates a new UserGroupPrivilegesCollectionGetParams object
// with the ability to set a timeout on a request.
func NewUserGroupPrivilegesCollectionGetParamsWithTimeout(timeout time.Duration) *UserGroupPrivilegesCollectionGetParams {
	return &UserGroupPrivilegesCollectionGetParams{
		timeout: timeout,
	}
}

// NewUserGroupPrivilegesCollectionGetParamsWithContext creates a new UserGroupPrivilegesCollectionGetParams object
// with the ability to set a context for a request.
func NewUserGroupPrivilegesCollectionGetParamsWithContext(ctx context.Context) *UserGroupPrivilegesCollectionGetParams {
	return &UserGroupPrivilegesCollectionGetParams{
		Context: ctx,
	}
}

// NewUserGroupPrivilegesCollectionGetParamsWithHTTPClient creates a new UserGroupPrivilegesCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewUserGroupPrivilegesCollectionGetParamsWithHTTPClient(client *http.Client) *UserGroupPrivilegesCollectionGetParams {
	return &UserGroupPrivilegesCollectionGetParams{
		HTTPClient: client,
	}
}

/*
UserGroupPrivilegesCollectionGetParams contains all the parameters to send to the API endpoint

	for the user group privileges collection get operation.

	Typically these are written to a http.Request.
*/
type UserGroupPrivilegesCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* Privileges.

	   Filter by privileges
	*/
	PrivilegesQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the user group privileges collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserGroupPrivilegesCollectionGetParams) WithDefaults() *UserGroupPrivilegesCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the user group privileges collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UserGroupPrivilegesCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := UserGroupPrivilegesCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) WithTimeout(timeout time.Duration) *UserGroupPrivilegesCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) WithContext(ctx context.Context) *UserGroupPrivilegesCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) WithHTTPClient(client *http.Client) *UserGroupPrivilegesCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) WithFieldsQueryParameter(fields []string) *UserGroupPrivilegesCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *UserGroupPrivilegesCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) WithNameQueryParameter(name *string) *UserGroupPrivilegesCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *UserGroupPrivilegesCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithPrivilegesQueryParameter adds the privileges to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) WithPrivilegesQueryParameter(privileges *string) *UserGroupPrivilegesCollectionGetParams {
	o.SetPrivilegesQueryParameter(privileges)
	return o
}

// SetPrivilegesQueryParameter adds the privileges to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) SetPrivilegesQueryParameter(privileges *string) {
	o.PrivilegesQueryParameter = privileges
}

// WithReturnRecordsQueryParameter adds the returnRecords to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *UserGroupPrivilegesCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *UserGroupPrivilegesCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSVMNameQueryParameter adds the svmName to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *UserGroupPrivilegesCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *UserGroupPrivilegesCollectionGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the user group privileges collection get params
func (o *UserGroupPrivilegesCollectionGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *UserGroupPrivilegesCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PrivilegesQueryParameter != nil {

		// query param privileges
		var qrPrivileges string

		if o.PrivilegesQueryParameter != nil {
			qrPrivileges = *o.PrivilegesQueryParameter
		}
		qPrivileges := qrPrivileges
		if qPrivileges != "" {

			if err := r.SetQueryParam("privileges", qPrivileges); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamUserGroupPrivilegesCollectionGet binds the parameter fields
func (o *UserGroupPrivilegesCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamUserGroupPrivilegesCollectionGet binds the parameter order_by
func (o *UserGroupPrivilegesCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
