// Code generated by go-swagger; DO NOT EDIT.

package n_a_s

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewVscanServerStatusGetParams creates a new VscanServerStatusGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewVscanServerStatusGetParams() *VscanServerStatusGetParams {
	return &VscanServerStatusGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewVscanServerStatusGetParamsWithTimeout creates a new VscanServerStatusGetParams object
// with the ability to set a timeout on a request.
func NewVscanServerStatusGetParamsWithTimeout(timeout time.Duration) *VscanServerStatusGetParams {
	return &VscanServerStatusGetParams{
		timeout: timeout,
	}
}

// NewVscanServerStatusGetParamsWithContext creates a new VscanServerStatusGetParams object
// with the ability to set a context for a request.
func NewVscanServerStatusGetParamsWithContext(ctx context.Context) *VscanServerStatusGetParams {
	return &VscanServerStatusGetParams{
		Context: ctx,
	}
}

// NewVscanServerStatusGetParamsWithHTTPClient creates a new VscanServerStatusGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewVscanServerStatusGetParamsWithHTTPClient(client *http.Client) *VscanServerStatusGetParams {
	return &VscanServerStatusGetParams{
		HTTPClient: client,
	}
}

/*
VscanServerStatusGetParams contains all the parameters to send to the API endpoint

	for the vscan server status get operation.

	Typically these are written to a http.Request.
*/
type VscanServerStatusGetParams struct {

	/* DisconnectedReason.

	   Filter by disconnected_reason
	*/
	DisconnectedReasonQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* InterfaceIPAddress.

	   Filter by interface.ip.address
	*/
	InterfaceIPAddressQueryParameter *string

	/* InterfaceName.

	   Filter by interface.name
	*/
	InterfaceNameQueryParameter *string

	/* InterfaceUUID.

	   Filter by interface.uuid
	*/
	InterfaceUUIDQueryParameter *string

	/* IP.

	   Filter by ip
	*/
	IPQueryParameter *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* NodeName.

	   Filter by node.name
	*/
	NodeNameQueryParameter *string

	/* NodeUUID.

	   Filter by node.uuid
	*/
	NodeUUIDQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* State.

	   Filter by state
	*/
	StateQueryParameter *string

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	/* Type.

	   Filter by type
	*/
	TypeQueryParameter *string

	/* UpdateTime.

	   Filter by update_time
	*/
	UpdateTimeQueryParameter *string

	/* Vendor.

	   Filter by vendor
	*/
	VendorQueryParameter *string

	/* Version.

	   Filter by version
	*/
	VersionQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the vscan server status get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VscanServerStatusGetParams) WithDefaults() *VscanServerStatusGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the vscan server status get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VscanServerStatusGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := VscanServerStatusGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the vscan server status get params
func (o *VscanServerStatusGetParams) WithTimeout(timeout time.Duration) *VscanServerStatusGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the vscan server status get params
func (o *VscanServerStatusGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the vscan server status get params
func (o *VscanServerStatusGetParams) WithContext(ctx context.Context) *VscanServerStatusGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the vscan server status get params
func (o *VscanServerStatusGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the vscan server status get params
func (o *VscanServerStatusGetParams) WithHTTPClient(client *http.Client) *VscanServerStatusGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the vscan server status get params
func (o *VscanServerStatusGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDisconnectedReasonQueryParameter adds the disconnectedReason to the vscan server status get params
func (o *VscanServerStatusGetParams) WithDisconnectedReasonQueryParameter(disconnectedReason *string) *VscanServerStatusGetParams {
	o.SetDisconnectedReasonQueryParameter(disconnectedReason)
	return o
}

// SetDisconnectedReasonQueryParameter adds the disconnectedReason to the vscan server status get params
func (o *VscanServerStatusGetParams) SetDisconnectedReasonQueryParameter(disconnectedReason *string) {
	o.DisconnectedReasonQueryParameter = disconnectedReason
}

// WithFieldsQueryParameter adds the fields to the vscan server status get params
func (o *VscanServerStatusGetParams) WithFieldsQueryParameter(fields []string) *VscanServerStatusGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the vscan server status get params
func (o *VscanServerStatusGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithInterfaceIPAddressQueryParameter adds the interfaceIPAddress to the vscan server status get params
func (o *VscanServerStatusGetParams) WithInterfaceIPAddressQueryParameter(interfaceIPAddress *string) *VscanServerStatusGetParams {
	o.SetInterfaceIPAddressQueryParameter(interfaceIPAddress)
	return o
}

// SetInterfaceIPAddressQueryParameter adds the interfaceIpAddress to the vscan server status get params
func (o *VscanServerStatusGetParams) SetInterfaceIPAddressQueryParameter(interfaceIPAddress *string) {
	o.InterfaceIPAddressQueryParameter = interfaceIPAddress
}

// WithInterfaceNameQueryParameter adds the interfaceName to the vscan server status get params
func (o *VscanServerStatusGetParams) WithInterfaceNameQueryParameter(interfaceName *string) *VscanServerStatusGetParams {
	o.SetInterfaceNameQueryParameter(interfaceName)
	return o
}

// SetInterfaceNameQueryParameter adds the interfaceName to the vscan server status get params
func (o *VscanServerStatusGetParams) SetInterfaceNameQueryParameter(interfaceName *string) {
	o.InterfaceNameQueryParameter = interfaceName
}

// WithInterfaceUUIDQueryParameter adds the interfaceUUID to the vscan server status get params
func (o *VscanServerStatusGetParams) WithInterfaceUUIDQueryParameter(interfaceUUID *string) *VscanServerStatusGetParams {
	o.SetInterfaceUUIDQueryParameter(interfaceUUID)
	return o
}

// SetInterfaceUUIDQueryParameter adds the interfaceUuid to the vscan server status get params
func (o *VscanServerStatusGetParams) SetInterfaceUUIDQueryParameter(interfaceUUID *string) {
	o.InterfaceUUIDQueryParameter = interfaceUUID
}

// WithIPQueryParameter adds the ip to the vscan server status get params
func (o *VscanServerStatusGetParams) WithIPQueryParameter(ip *string) *VscanServerStatusGetParams {
	o.SetIPQueryParameter(ip)
	return o
}

// SetIPQueryParameter adds the ip to the vscan server status get params
func (o *VscanServerStatusGetParams) SetIPQueryParameter(ip *string) {
	o.IPQueryParameter = ip
}

// WithMaxRecordsQueryParameter adds the maxRecords to the vscan server status get params
func (o *VscanServerStatusGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *VscanServerStatusGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the vscan server status get params
func (o *VscanServerStatusGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNodeNameQueryParameter adds the nodeName to the vscan server status get params
func (o *VscanServerStatusGetParams) WithNodeNameQueryParameter(nodeName *string) *VscanServerStatusGetParams {
	o.SetNodeNameQueryParameter(nodeName)
	return o
}

// SetNodeNameQueryParameter adds the nodeName to the vscan server status get params
func (o *VscanServerStatusGetParams) SetNodeNameQueryParameter(nodeName *string) {
	o.NodeNameQueryParameter = nodeName
}

// WithNodeUUIDQueryParameter adds the nodeUUID to the vscan server status get params
func (o *VscanServerStatusGetParams) WithNodeUUIDQueryParameter(nodeUUID *string) *VscanServerStatusGetParams {
	o.SetNodeUUIDQueryParameter(nodeUUID)
	return o
}

// SetNodeUUIDQueryParameter adds the nodeUuid to the vscan server status get params
func (o *VscanServerStatusGetParams) SetNodeUUIDQueryParameter(nodeUUID *string) {
	o.NodeUUIDQueryParameter = nodeUUID
}

// WithOrderByQueryParameter adds the orderBy to the vscan server status get params
func (o *VscanServerStatusGetParams) WithOrderByQueryParameter(orderBy []string) *VscanServerStatusGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the vscan server status get params
func (o *VscanServerStatusGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the vscan server status get params
func (o *VscanServerStatusGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *VscanServerStatusGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the vscan server status get params
func (o *VscanServerStatusGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the vscan server status get params
func (o *VscanServerStatusGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *VscanServerStatusGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the vscan server status get params
func (o *VscanServerStatusGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithStateQueryParameter adds the state to the vscan server status get params
func (o *VscanServerStatusGetParams) WithStateQueryParameter(state *string) *VscanServerStatusGetParams {
	o.SetStateQueryParameter(state)
	return o
}

// SetStateQueryParameter adds the state to the vscan server status get params
func (o *VscanServerStatusGetParams) SetStateQueryParameter(state *string) {
	o.StateQueryParameter = state
}

// WithSVMNameQueryParameter adds the svmName to the vscan server status get params
func (o *VscanServerStatusGetParams) WithSVMNameQueryParameter(svmName *string) *VscanServerStatusGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the vscan server status get params
func (o *VscanServerStatusGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the vscan server status get params
func (o *VscanServerStatusGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *VscanServerStatusGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the vscan server status get params
func (o *VscanServerStatusGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WithTypeQueryParameter adds the typeVar to the vscan server status get params
func (o *VscanServerStatusGetParams) WithTypeQueryParameter(typeVar *string) *VscanServerStatusGetParams {
	o.SetTypeQueryParameter(typeVar)
	return o
}

// SetTypeQueryParameter adds the type to the vscan server status get params
func (o *VscanServerStatusGetParams) SetTypeQueryParameter(typeVar *string) {
	o.TypeQueryParameter = typeVar
}

// WithUpdateTimeQueryParameter adds the updateTime to the vscan server status get params
func (o *VscanServerStatusGetParams) WithUpdateTimeQueryParameter(updateTime *string) *VscanServerStatusGetParams {
	o.SetUpdateTimeQueryParameter(updateTime)
	return o
}

// SetUpdateTimeQueryParameter adds the updateTime to the vscan server status get params
func (o *VscanServerStatusGetParams) SetUpdateTimeQueryParameter(updateTime *string) {
	o.UpdateTimeQueryParameter = updateTime
}

// WithVendorQueryParameter adds the vendor to the vscan server status get params
func (o *VscanServerStatusGetParams) WithVendorQueryParameter(vendor *string) *VscanServerStatusGetParams {
	o.SetVendorQueryParameter(vendor)
	return o
}

// SetVendorQueryParameter adds the vendor to the vscan server status get params
func (o *VscanServerStatusGetParams) SetVendorQueryParameter(vendor *string) {
	o.VendorQueryParameter = vendor
}

// WithVersionQueryParameter adds the version to the vscan server status get params
func (o *VscanServerStatusGetParams) WithVersionQueryParameter(version *string) *VscanServerStatusGetParams {
	o.SetVersionQueryParameter(version)
	return o
}

// SetVersionQueryParameter adds the version to the vscan server status get params
func (o *VscanServerStatusGetParams) SetVersionQueryParameter(version *string) {
	o.VersionQueryParameter = version
}

// WriteToRequest writes these params to a swagger request
func (o *VscanServerStatusGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.DisconnectedReasonQueryParameter != nil {

		// query param disconnected_reason
		var qrDisconnectedReason string

		if o.DisconnectedReasonQueryParameter != nil {
			qrDisconnectedReason = *o.DisconnectedReasonQueryParameter
		}
		qDisconnectedReason := qrDisconnectedReason
		if qDisconnectedReason != "" {

			if err := r.SetQueryParam("disconnected_reason", qDisconnectedReason); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.InterfaceIPAddressQueryParameter != nil {

		// query param interface.ip.address
		var qrInterfaceIPAddress string

		if o.InterfaceIPAddressQueryParameter != nil {
			qrInterfaceIPAddress = *o.InterfaceIPAddressQueryParameter
		}
		qInterfaceIPAddress := qrInterfaceIPAddress
		if qInterfaceIPAddress != "" {

			if err := r.SetQueryParam("interface.ip.address", qInterfaceIPAddress); err != nil {
				return err
			}
		}
	}

	if o.InterfaceNameQueryParameter != nil {

		// query param interface.name
		var qrInterfaceName string

		if o.InterfaceNameQueryParameter != nil {
			qrInterfaceName = *o.InterfaceNameQueryParameter
		}
		qInterfaceName := qrInterfaceName
		if qInterfaceName != "" {

			if err := r.SetQueryParam("interface.name", qInterfaceName); err != nil {
				return err
			}
		}
	}

	if o.InterfaceUUIDQueryParameter != nil {

		// query param interface.uuid
		var qrInterfaceUUID string

		if o.InterfaceUUIDQueryParameter != nil {
			qrInterfaceUUID = *o.InterfaceUUIDQueryParameter
		}
		qInterfaceUUID := qrInterfaceUUID
		if qInterfaceUUID != "" {

			if err := r.SetQueryParam("interface.uuid", qInterfaceUUID); err != nil {
				return err
			}
		}
	}

	if o.IPQueryParameter != nil {

		// query param ip
		var qrIP string

		if o.IPQueryParameter != nil {
			qrIP = *o.IPQueryParameter
		}
		qIP := qrIP
		if qIP != "" {

			if err := r.SetQueryParam("ip", qIP); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NodeNameQueryParameter != nil {

		// query param node.name
		var qrNodeName string

		if o.NodeNameQueryParameter != nil {
			qrNodeName = *o.NodeNameQueryParameter
		}
		qNodeName := qrNodeName
		if qNodeName != "" {

			if err := r.SetQueryParam("node.name", qNodeName); err != nil {
				return err
			}
		}
	}

	if o.NodeUUIDQueryParameter != nil {

		// query param node.uuid
		var qrNodeUUID string

		if o.NodeUUIDQueryParameter != nil {
			qrNodeUUID = *o.NodeUUIDQueryParameter
		}
		qNodeUUID := qrNodeUUID
		if qNodeUUID != "" {

			if err := r.SetQueryParam("node.uuid", qNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.StateQueryParameter != nil {

		// query param state
		var qrState string

		if o.StateQueryParameter != nil {
			qrState = *o.StateQueryParameter
		}
		qState := qrState
		if qState != "" {

			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if o.TypeQueryParameter != nil {

		// query param type
		var qrType string

		if o.TypeQueryParameter != nil {
			qrType = *o.TypeQueryParameter
		}
		qType := qrType
		if qType != "" {

			if err := r.SetQueryParam("type", qType); err != nil {
				return err
			}
		}
	}

	if o.UpdateTimeQueryParameter != nil {

		// query param update_time
		var qrUpdateTime string

		if o.UpdateTimeQueryParameter != nil {
			qrUpdateTime = *o.UpdateTimeQueryParameter
		}
		qUpdateTime := qrUpdateTime
		if qUpdateTime != "" {

			if err := r.SetQueryParam("update_time", qUpdateTime); err != nil {
				return err
			}
		}
	}

	if o.VendorQueryParameter != nil {

		// query param vendor
		var qrVendor string

		if o.VendorQueryParameter != nil {
			qrVendor = *o.VendorQueryParameter
		}
		qVendor := qrVendor
		if qVendor != "" {

			if err := r.SetQueryParam("vendor", qVendor); err != nil {
				return err
			}
		}
	}

	if o.VersionQueryParameter != nil {

		// query param version
		var qrVersion string

		if o.VersionQueryParameter != nil {
			qrVersion = *o.VersionQueryParameter
		}
		qVersion := qrVersion
		if qVersion != "" {

			if err := r.SetQueryParam("version", qVersion); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamVscanServerStatusGet binds the parameter fields
func (o *VscanServerStatusGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamVscanServerStatusGet binds the parameter order_by
func (o *VscanServerStatusGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
