// Code generated by go-swagger; DO NOT EDIT.

package n_v_me

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewNvmeSubsystemControllerGetParams creates a new NvmeSubsystemControllerGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNvmeSubsystemControllerGetParams() *NvmeSubsystemControllerGetParams {
	return &NvmeSubsystemControllerGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNvmeSubsystemControllerGetParamsWithTimeout creates a new NvmeSubsystemControllerGetParams object
// with the ability to set a timeout on a request.
func NewNvmeSubsystemControllerGetParamsWithTimeout(timeout time.Duration) *NvmeSubsystemControllerGetParams {
	return &NvmeSubsystemControllerGetParams{
		timeout: timeout,
	}
}

// NewNvmeSubsystemControllerGetParamsWithContext creates a new NvmeSubsystemControllerGetParams object
// with the ability to set a context for a request.
func NewNvmeSubsystemControllerGetParamsWithContext(ctx context.Context) *NvmeSubsystemControllerGetParams {
	return &NvmeSubsystemControllerGetParams{
		Context: ctx,
	}
}

// NewNvmeSubsystemControllerGetParamsWithHTTPClient creates a new NvmeSubsystemControllerGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewNvmeSubsystemControllerGetParamsWithHTTPClient(client *http.Client) *NvmeSubsystemControllerGetParams {
	return &NvmeSubsystemControllerGetParams{
		HTTPClient: client,
	}
}

/*
NvmeSubsystemControllerGetParams contains all the parameters to send to the API endpoint

	for the nvme subsystem controller get operation.

	Typically these are written to a http.Request.
*/
type NvmeSubsystemControllerGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* ID.

	   The unique identifier of the NVMe subsystem controller.

	*/
	IDPathParameter string

	/* SubsystemUUID.

	   The unique identifier of the NVMe subsystem.

	*/
	SubsystemUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the nvme subsystem controller get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeSubsystemControllerGetParams) WithDefaults() *NvmeSubsystemControllerGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the nvme subsystem controller get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeSubsystemControllerGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the nvme subsystem controller get params
func (o *NvmeSubsystemControllerGetParams) WithTimeout(timeout time.Duration) *NvmeSubsystemControllerGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the nvme subsystem controller get params
func (o *NvmeSubsystemControllerGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the nvme subsystem controller get params
func (o *NvmeSubsystemControllerGetParams) WithContext(ctx context.Context) *NvmeSubsystemControllerGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the nvme subsystem controller get params
func (o *NvmeSubsystemControllerGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the nvme subsystem controller get params
func (o *NvmeSubsystemControllerGetParams) WithHTTPClient(client *http.Client) *NvmeSubsystemControllerGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the nvme subsystem controller get params
func (o *NvmeSubsystemControllerGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the nvme subsystem controller get params
func (o *NvmeSubsystemControllerGetParams) WithFieldsQueryParameter(fields []string) *NvmeSubsystemControllerGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the nvme subsystem controller get params
func (o *NvmeSubsystemControllerGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIDPathParameter adds the id to the nvme subsystem controller get params
func (o *NvmeSubsystemControllerGetParams) WithIDPathParameter(id string) *NvmeSubsystemControllerGetParams {
	o.SetIDPathParameter(id)
	return o
}

// SetIDPathParameter adds the id to the nvme subsystem controller get params
func (o *NvmeSubsystemControllerGetParams) SetIDPathParameter(id string) {
	o.IDPathParameter = id
}

// WithSubsystemUUIDPathParameter adds the subsystemUUID to the nvme subsystem controller get params
func (o *NvmeSubsystemControllerGetParams) WithSubsystemUUIDPathParameter(subsystemUUID string) *NvmeSubsystemControllerGetParams {
	o.SetSubsystemUUIDPathParameter(subsystemUUID)
	return o
}

// SetSubsystemUUIDPathParameter adds the subsystemUuid to the nvme subsystem controller get params
func (o *NvmeSubsystemControllerGetParams) SetSubsystemUUIDPathParameter(subsystemUUID string) {
	o.SubsystemUUIDPathParameter = subsystemUUID
}

// WriteToRequest writes these params to a swagger request
func (o *NvmeSubsystemControllerGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", o.IDPathParameter); err != nil {
		return err
	}

	// path param subsystem.uuid
	if err := r.SetPathParam("subsystem.uuid", o.SubsystemUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamNvmeSubsystemControllerGet binds the parameter fields
func (o *NvmeSubsystemControllerGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
