// Code generated by go-swagger; DO NOT EDIT.

package n_v_me

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewNvmeSubsystemDeleteParams creates a new NvmeSubsystemDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNvmeSubsystemDeleteParams() *NvmeSubsystemDeleteParams {
	return &NvmeSubsystemDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNvmeSubsystemDeleteParamsWithTimeout creates a new NvmeSubsystemDeleteParams object
// with the ability to set a timeout on a request.
func NewNvmeSubsystemDeleteParamsWithTimeout(timeout time.Duration) *NvmeSubsystemDeleteParams {
	return &NvmeSubsystemDeleteParams{
		timeout: timeout,
	}
}

// NewNvmeSubsystemDeleteParamsWithContext creates a new NvmeSubsystemDeleteParams object
// with the ability to set a context for a request.
func NewNvmeSubsystemDeleteParamsWithContext(ctx context.Context) *NvmeSubsystemDeleteParams {
	return &NvmeSubsystemDeleteParams{
		Context: ctx,
	}
}

// NewNvmeSubsystemDeleteParamsWithHTTPClient creates a new NvmeSubsystemDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewNvmeSubsystemDeleteParamsWithHTTPClient(client *http.Client) *NvmeSubsystemDeleteParams {
	return &NvmeSubsystemDeleteParams{
		HTTPClient: client,
	}
}

/*
NvmeSubsystemDeleteParams contains all the parameters to send to the API endpoint

	for the nvme subsystem delete operation.

	Typically these are written to a http.Request.
*/
type NvmeSubsystemDeleteParams struct {

	/* AllowDeleteWhileMapped.

	   Allows for the deletion of a mapped NVMe subsystem.

	*/
	AllowDeleteWhileMappedQueryParameter *bool

	/* AllowDeleteWithHosts.

	   Allows for the deletion of an NVMe subsystem with NVMe hosts.

	*/
	AllowDeleteWithHostsQueryParameter *bool

	/* UUID.

	   The unique identifier of the NVMe subsystem.

	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the nvme subsystem delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeSubsystemDeleteParams) WithDefaults() *NvmeSubsystemDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the nvme subsystem delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NvmeSubsystemDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the nvme subsystem delete params
func (o *NvmeSubsystemDeleteParams) WithTimeout(timeout time.Duration) *NvmeSubsystemDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the nvme subsystem delete params
func (o *NvmeSubsystemDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the nvme subsystem delete params
func (o *NvmeSubsystemDeleteParams) WithContext(ctx context.Context) *NvmeSubsystemDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the nvme subsystem delete params
func (o *NvmeSubsystemDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the nvme subsystem delete params
func (o *NvmeSubsystemDeleteParams) WithHTTPClient(client *http.Client) *NvmeSubsystemDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the nvme subsystem delete params
func (o *NvmeSubsystemDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAllowDeleteWhileMappedQueryParameter adds the allowDeleteWhileMapped to the nvme subsystem delete params
func (o *NvmeSubsystemDeleteParams) WithAllowDeleteWhileMappedQueryParameter(allowDeleteWhileMapped *bool) *NvmeSubsystemDeleteParams {
	o.SetAllowDeleteWhileMappedQueryParameter(allowDeleteWhileMapped)
	return o
}

// SetAllowDeleteWhileMappedQueryParameter adds the allowDeleteWhileMapped to the nvme subsystem delete params
func (o *NvmeSubsystemDeleteParams) SetAllowDeleteWhileMappedQueryParameter(allowDeleteWhileMapped *bool) {
	o.AllowDeleteWhileMappedQueryParameter = allowDeleteWhileMapped
}

// WithAllowDeleteWithHostsQueryParameter adds the allowDeleteWithHosts to the nvme subsystem delete params
func (o *NvmeSubsystemDeleteParams) WithAllowDeleteWithHostsQueryParameter(allowDeleteWithHosts *bool) *NvmeSubsystemDeleteParams {
	o.SetAllowDeleteWithHostsQueryParameter(allowDeleteWithHosts)
	return o
}

// SetAllowDeleteWithHostsQueryParameter adds the allowDeleteWithHosts to the nvme subsystem delete params
func (o *NvmeSubsystemDeleteParams) SetAllowDeleteWithHostsQueryParameter(allowDeleteWithHosts *bool) {
	o.AllowDeleteWithHostsQueryParameter = allowDeleteWithHosts
}

// WithUUIDPathParameter adds the uuid to the nvme subsystem delete params
func (o *NvmeSubsystemDeleteParams) WithUUIDPathParameter(uuid string) *NvmeSubsystemDeleteParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the nvme subsystem delete params
func (o *NvmeSubsystemDeleteParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *NvmeSubsystemDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AllowDeleteWhileMappedQueryParameter != nil {

		// query param allow_delete_while_mapped
		var qrAllowDeleteWhileMapped bool

		if o.AllowDeleteWhileMappedQueryParameter != nil {
			qrAllowDeleteWhileMapped = *o.AllowDeleteWhileMappedQueryParameter
		}
		qAllowDeleteWhileMapped := swag.FormatBool(qrAllowDeleteWhileMapped)
		if qAllowDeleteWhileMapped != "" {

			if err := r.SetQueryParam("allow_delete_while_mapped", qAllowDeleteWhileMapped); err != nil {
				return err
			}
		}
	}

	if o.AllowDeleteWithHostsQueryParameter != nil {

		// query param allow_delete_with_hosts
		var qrAllowDeleteWithHosts bool

		if o.AllowDeleteWithHostsQueryParameter != nil {
			qrAllowDeleteWithHosts = *o.AllowDeleteWithHostsQueryParameter
		}
		qAllowDeleteWithHosts := swag.FormatBool(qrAllowDeleteWithHosts)
		if qAllowDeleteWithHosts != "" {

			if err := r.SetQueryParam("allow_delete_with_hosts", qAllowDeleteWithHosts); err != nil {
				return err
			}
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
