// Code generated by go-swagger; DO NOT EDIT.

package n_v_me

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NvmeSubsystemHostCreateReader is a Reader for the NvmeSubsystemHostCreate structure.
type NvmeSubsystemHostCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *NvmeSubsystemHostCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewNvmeSubsystemHostCreateCreated()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewNvmeSubsystemHostCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewNvmeSubsystemHostCreateCreated creates a NvmeSubsystemHostCreateCreated with default headers values
func NewNvmeSubsystemHostCreateCreated() *NvmeSubsystemHostCreateCreated {
	return &NvmeSubsystemHostCreateCreated{}
}

/*
NvmeSubsystemHostCreateCreated describes a response with status code 201, with default header values.

Created
*/
type NvmeSubsystemHostCreateCreated struct {
	Payload *models.NvmeSubsystemHostResponse
}

// IsSuccess returns true when this nvme subsystem host create created response has a 2xx status code
func (o *NvmeSubsystemHostCreateCreated) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this nvme subsystem host create created response has a 3xx status code
func (o *NvmeSubsystemHostCreateCreated) IsRedirect() bool {
	return false
}

// IsClientError returns true when this nvme subsystem host create created response has a 4xx status code
func (o *NvmeSubsystemHostCreateCreated) IsClientError() bool {
	return false
}

// IsServerError returns true when this nvme subsystem host create created response has a 5xx status code
func (o *NvmeSubsystemHostCreateCreated) IsServerError() bool {
	return false
}

// IsCode returns true when this nvme subsystem host create created response a status code equal to that given
func (o *NvmeSubsystemHostCreateCreated) IsCode(code int) bool {
	return code == 201
}

func (o *NvmeSubsystemHostCreateCreated) Error() string {
	return fmt.Sprintf("[POST /protocols/nvme/subsystems/{subsystem.uuid}/hosts][%d] nvmeSubsystemHostCreateCreated  %+v", 201, o.Payload)
}

func (o *NvmeSubsystemHostCreateCreated) String() string {
	return fmt.Sprintf("[POST /protocols/nvme/subsystems/{subsystem.uuid}/hosts][%d] nvmeSubsystemHostCreateCreated  %+v", 201, o.Payload)
}

func (o *NvmeSubsystemHostCreateCreated) GetPayload() *models.NvmeSubsystemHostResponse {
	return o.Payload
}

func (o *NvmeSubsystemHostCreateCreated) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.NvmeSubsystemHostResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewNvmeSubsystemHostCreateDefault creates a NvmeSubsystemHostCreateDefault with default headers values
func NewNvmeSubsystemHostCreateDefault(code int) *NvmeSubsystemHostCreateDefault {
	return &NvmeSubsystemHostCreateDefault{
		_statusCode: code,
	}
}

/*
	NvmeSubsystemHostCreateDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

| Error Code | Description |
| ---------- | ----------- |
| 72089705 | The NVMe subsystem host already exists for the NVMe subsystem. |
| 72089771 | The NQN is invalid. A non-empty qualifier is required after the prefix. An example of a valid NQN is _nqn.1992-01.com.example:string_. |
| 72089772 | The NQN is invalid. Add the prefix _'nqn'_. An example of a valid NQN is _nqn.1992-01.com.example:string_. |
| 72089773 | The NQN is invalid. The date field must be formatted _yyyy-mm_. An example of a valid NQN is _nqn.1992-01.com.example:string_. |
| 72090001 | The NVMe subsystem does not exist. |
| 72090002 | The POST request of hosts to an NVMe subsystem can only contain an 'nqn' property or 'records' property, but not both. |
| 72090003 | The elements in the records array for a POST of hosts to an NVMe subsystem must contain only the nqn property. |
*/
type NvmeSubsystemHostCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the nvme subsystem host create default response
func (o *NvmeSubsystemHostCreateDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this nvme subsystem host create default response has a 2xx status code
func (o *NvmeSubsystemHostCreateDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this nvme subsystem host create default response has a 3xx status code
func (o *NvmeSubsystemHostCreateDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this nvme subsystem host create default response has a 4xx status code
func (o *NvmeSubsystemHostCreateDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this nvme subsystem host create default response has a 5xx status code
func (o *NvmeSubsystemHostCreateDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this nvme subsystem host create default response a status code equal to that given
func (o *NvmeSubsystemHostCreateDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *NvmeSubsystemHostCreateDefault) Error() string {
	return fmt.Sprintf("[POST /protocols/nvme/subsystems/{subsystem.uuid}/hosts][%d] nvme_subsystem_host_create default  %+v", o._statusCode, o.Payload)
}

func (o *NvmeSubsystemHostCreateDefault) String() string {
	return fmt.Sprintf("[POST /protocols/nvme/subsystems/{subsystem.uuid}/hosts][%d] nvme_subsystem_host_create default  %+v", o._statusCode, o.Payload)
}

func (o *NvmeSubsystemHostCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *NvmeSubsystemHostCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
