// Code generated by go-swagger; DO NOT EDIT.

package name_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGlobalCacheSettingGetParams creates a new GlobalCacheSettingGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGlobalCacheSettingGetParams() *GlobalCacheSettingGetParams {
	return &GlobalCacheSettingGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGlobalCacheSettingGetParamsWithTimeout creates a new GlobalCacheSettingGetParams object
// with the ability to set a timeout on a request.
func NewGlobalCacheSettingGetParamsWithTimeout(timeout time.Duration) *GlobalCacheSettingGetParams {
	return &GlobalCacheSettingGetParams{
		timeout: timeout,
	}
}

// NewGlobalCacheSettingGetParamsWithContext creates a new GlobalCacheSettingGetParams object
// with the ability to set a context for a request.
func NewGlobalCacheSettingGetParamsWithContext(ctx context.Context) *GlobalCacheSettingGetParams {
	return &GlobalCacheSettingGetParams{
		Context: ctx,
	}
}

// NewGlobalCacheSettingGetParamsWithHTTPClient creates a new GlobalCacheSettingGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewGlobalCacheSettingGetParamsWithHTTPClient(client *http.Client) *GlobalCacheSettingGetParams {
	return &GlobalCacheSettingGetParams{
		HTTPClient: client,
	}
}

/*
GlobalCacheSettingGetParams contains all the parameters to send to the API endpoint

	for the global cache setting get operation.

	Typically these are written to a http.Request.
*/
type GlobalCacheSettingGetParams struct {

	/* EvictionTimeInterval.

	   Filter by eviction_time_interval
	*/
	EvictionTimeIntervalQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* RemoteFetchEnabled.

	   Filter by remote_fetch_enabled
	*/
	RemoteFetchEnabledQueryParameter *bool

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the global cache setting get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GlobalCacheSettingGetParams) WithDefaults() *GlobalCacheSettingGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the global cache setting get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GlobalCacheSettingGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := GlobalCacheSettingGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the global cache setting get params
func (o *GlobalCacheSettingGetParams) WithTimeout(timeout time.Duration) *GlobalCacheSettingGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the global cache setting get params
func (o *GlobalCacheSettingGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the global cache setting get params
func (o *GlobalCacheSettingGetParams) WithContext(ctx context.Context) *GlobalCacheSettingGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the global cache setting get params
func (o *GlobalCacheSettingGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the global cache setting get params
func (o *GlobalCacheSettingGetParams) WithHTTPClient(client *http.Client) *GlobalCacheSettingGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the global cache setting get params
func (o *GlobalCacheSettingGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithEvictionTimeIntervalQueryParameter adds the evictionTimeInterval to the global cache setting get params
func (o *GlobalCacheSettingGetParams) WithEvictionTimeIntervalQueryParameter(evictionTimeInterval *string) *GlobalCacheSettingGetParams {
	o.SetEvictionTimeIntervalQueryParameter(evictionTimeInterval)
	return o
}

// SetEvictionTimeIntervalQueryParameter adds the evictionTimeInterval to the global cache setting get params
func (o *GlobalCacheSettingGetParams) SetEvictionTimeIntervalQueryParameter(evictionTimeInterval *string) {
	o.EvictionTimeIntervalQueryParameter = evictionTimeInterval
}

// WithFieldsQueryParameter adds the fields to the global cache setting get params
func (o *GlobalCacheSettingGetParams) WithFieldsQueryParameter(fields []string) *GlobalCacheSettingGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the global cache setting get params
func (o *GlobalCacheSettingGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the global cache setting get params
func (o *GlobalCacheSettingGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *GlobalCacheSettingGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the global cache setting get params
func (o *GlobalCacheSettingGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the global cache setting get params
func (o *GlobalCacheSettingGetParams) WithOrderByQueryParameter(orderBy []string) *GlobalCacheSettingGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the global cache setting get params
func (o *GlobalCacheSettingGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithRemoteFetchEnabledQueryParameter adds the remoteFetchEnabled to the global cache setting get params
func (o *GlobalCacheSettingGetParams) WithRemoteFetchEnabledQueryParameter(remoteFetchEnabled *bool) *GlobalCacheSettingGetParams {
	o.SetRemoteFetchEnabledQueryParameter(remoteFetchEnabled)
	return o
}

// SetRemoteFetchEnabledQueryParameter adds the remoteFetchEnabled to the global cache setting get params
func (o *GlobalCacheSettingGetParams) SetRemoteFetchEnabledQueryParameter(remoteFetchEnabled *bool) {
	o.RemoteFetchEnabledQueryParameter = remoteFetchEnabled
}

// WithReturnRecordsQueryParameter adds the returnRecords to the global cache setting get params
func (o *GlobalCacheSettingGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *GlobalCacheSettingGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the global cache setting get params
func (o *GlobalCacheSettingGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the global cache setting get params
func (o *GlobalCacheSettingGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *GlobalCacheSettingGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the global cache setting get params
func (o *GlobalCacheSettingGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WriteToRequest writes these params to a swagger request
func (o *GlobalCacheSettingGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.EvictionTimeIntervalQueryParameter != nil {

		// query param eviction_time_interval
		var qrEvictionTimeInterval string

		if o.EvictionTimeIntervalQueryParameter != nil {
			qrEvictionTimeInterval = *o.EvictionTimeIntervalQueryParameter
		}
		qEvictionTimeInterval := qrEvictionTimeInterval
		if qEvictionTimeInterval != "" {

			if err := r.SetQueryParam("eviction_time_interval", qEvictionTimeInterval); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.RemoteFetchEnabledQueryParameter != nil {

		// query param remote_fetch_enabled
		var qrRemoteFetchEnabled bool

		if o.RemoteFetchEnabledQueryParameter != nil {
			qrRemoteFetchEnabled = *o.RemoteFetchEnabledQueryParameter
		}
		qRemoteFetchEnabled := swag.FormatBool(qrRemoteFetchEnabled)
		if qRemoteFetchEnabled != "" {

			if err := r.SetQueryParam("remote_fetch_enabled", qRemoteFetchEnabled); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamGlobalCacheSettingGet binds the parameter fields
func (o *GlobalCacheSettingGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamGlobalCacheSettingGet binds the parameter order_by
func (o *GlobalCacheSettingGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
