// Code generated by go-swagger; DO NOT EDIT.

package name_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewLdapSchemaCollectionGetParams creates a new LdapSchemaCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLdapSchemaCollectionGetParams() *LdapSchemaCollectionGetParams {
	return &LdapSchemaCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLdapSchemaCollectionGetParamsWithTimeout creates a new LdapSchemaCollectionGetParams object
// with the ability to set a timeout on a request.
func NewLdapSchemaCollectionGetParamsWithTimeout(timeout time.Duration) *LdapSchemaCollectionGetParams {
	return &LdapSchemaCollectionGetParams{
		timeout: timeout,
	}
}

// NewLdapSchemaCollectionGetParamsWithContext creates a new LdapSchemaCollectionGetParams object
// with the ability to set a context for a request.
func NewLdapSchemaCollectionGetParamsWithContext(ctx context.Context) *LdapSchemaCollectionGetParams {
	return &LdapSchemaCollectionGetParams{
		Context: ctx,
	}
}

// NewLdapSchemaCollectionGetParamsWithHTTPClient creates a new LdapSchemaCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewLdapSchemaCollectionGetParamsWithHTTPClient(client *http.Client) *LdapSchemaCollectionGetParams {
	return &LdapSchemaCollectionGetParams{
		HTTPClient: client,
	}
}

/*
LdapSchemaCollectionGetParams contains all the parameters to send to the API endpoint

	for the ldap schema collection get operation.

	Typically these are written to a http.Request.
*/
type LdapSchemaCollectionGetParams struct {

	/* Comment.

	   Filter by comment
	*/
	CommentQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* GlobalSchema.

	   Filter by global_schema
	*/
	GlobalSchemaQueryParameter *bool

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* NameMappingAccountUnix.

	   Filter by name_mapping.account.unix
	*/
	NameMappingAccountUnixQueryParameter *string

	/* NameMappingAccountWindows.

	   Filter by name_mapping.account.windows
	*/
	NameMappingAccountWindowsQueryParameter *string

	/* NameMappingWindowsToUnixAttribute.

	   Filter by name_mapping.windows_to_unix.attribute
	*/
	NameMappingWindowsToUnixAttributeQueryParameter *string

	/* NameMappingWindowsToUnixNoDomainPrefix.

	   Filter by name_mapping.windows_to_unix.no_domain_prefix
	*/
	NameMappingWindowsToUnixNoDomainPrefixQueryParameter *bool

	/* NameMappingWindowsToUnixObjectClass.

	   Filter by name_mapping.windows_to_unix.object_class
	*/
	NameMappingWindowsToUnixObjectClassQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* OwnerName.

	   Filter by owner.name
	*/
	OwnerNameQueryParameter *string

	/* OwnerUUID.

	   Filter by owner.uuid
	*/
	OwnerUUIDQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* Rfc2307AttributeGecos.

	   Filter by rfc2307.attribute.gecos
	*/
	Rfc2307AttributeGecosQueryParameter *string

	/* Rfc2307AttributeGidNumber.

	   Filter by rfc2307.attribute.gid_number
	*/
	Rfc2307AttributeGIDNumberQueryParameter *string

	/* Rfc2307AttributeHomeDirectory.

	   Filter by rfc2307.attribute.home_directory
	*/
	Rfc2307AttributeHomeDirectoryQueryParameter *string

	/* Rfc2307AttributeLoginShell.

	   Filter by rfc2307.attribute.login_shell
	*/
	Rfc2307AttributeLoginShellQueryParameter *string

	/* Rfc2307AttributeUID.

	   Filter by rfc2307.attribute.uid
	*/
	Rfc2307AttributeUIDQueryParameter *string

	/* Rfc2307AttributeUIDNumber.

	   Filter by rfc2307.attribute.uid_number
	*/
	Rfc2307AttributeUIDNumberQueryParameter *string

	/* Rfc2307AttributeUserPassword.

	   Filter by rfc2307.attribute.user_password
	*/
	Rfc2307AttributeUserPasswordQueryParameter *string

	/* Rfc2307CnGroup.

	   Filter by rfc2307.cn.group
	*/
	Rfc2307CnGroupQueryParameter *string

	/* Rfc2307CnNetgroup.

	   Filter by rfc2307.cn.netgroup
	*/
	Rfc2307CnNetgroupQueryParameter *string

	/* Rfc2307MemberNisNetgroup.

	   Filter by rfc2307.member.nis_netgroup
	*/
	Rfc2307MemberNisNetgroupQueryParameter *string

	/* Rfc2307MemberUID.

	   Filter by rfc2307.member.uid
	*/
	Rfc2307MemberUIDQueryParameter *string

	/* Rfc2307NisMapentry.

	   Filter by rfc2307.nis.mapentry
	*/
	Rfc2307NisMapentryQueryParameter *string

	/* Rfc2307NisMapname.

	   Filter by rfc2307.nis.mapname
	*/
	Rfc2307NisMapnameQueryParameter *string

	/* Rfc2307NisNetgroup.

	   Filter by rfc2307.nis.netgroup
	*/
	Rfc2307NisNetgroupQueryParameter *string

	/* Rfc2307NisNetgroupTriple.

	   Filter by rfc2307.nis.netgroup_triple
	*/
	Rfc2307NisNetgroupTripleQueryParameter *string

	/* Rfc2307NisObject.

	   Filter by rfc2307.nis.object
	*/
	Rfc2307NisObjectQueryParameter *string

	/* Rfc2307PosixAccount.

	   Filter by rfc2307.posix.account
	*/
	Rfc2307PosixAccountQueryParameter *string

	/* Rfc2307PosixGroup.

	   Filter by rfc2307.posix.group
	*/
	Rfc2307PosixGroupQueryParameter *string

	/* Rfc2307bisEnabled.

	   Filter by rfc2307bis.enabled
	*/
	Rfc2307bisEnabledQueryParameter *bool

	/* Rfc2307bisGroupOfUniqueNames.

	   Filter by rfc2307bis.group_of_unique_names
	*/
	Rfc2307bisGroupOfUniqueNamesQueryParameter *string

	/* Rfc2307bisMaximumGroups.

	   Filter by rfc2307bis.maximum_groups
	*/
	Rfc2307bisMaximumGroupsQueryParameter *int64

	/* Rfc2307bisUniqueMember.

	   Filter by rfc2307bis.unique_member
	*/
	Rfc2307bisUniqueMemberQueryParameter *string

	/* Scope.

	   Filter by scope
	*/
	ScopeQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ldap schema collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LdapSchemaCollectionGetParams) WithDefaults() *LdapSchemaCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ldap schema collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LdapSchemaCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := LdapSchemaCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithTimeout(timeout time.Duration) *LdapSchemaCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithContext(ctx context.Context) *LdapSchemaCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithHTTPClient(client *http.Client) *LdapSchemaCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCommentQueryParameter adds the comment to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithCommentQueryParameter(comment *string) *LdapSchemaCollectionGetParams {
	o.SetCommentQueryParameter(comment)
	return o
}

// SetCommentQueryParameter adds the comment to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetCommentQueryParameter(comment *string) {
	o.CommentQueryParameter = comment
}

// WithFieldsQueryParameter adds the fields to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithFieldsQueryParameter(fields []string) *LdapSchemaCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithGlobalSchemaQueryParameter adds the globalSchema to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithGlobalSchemaQueryParameter(globalSchema *bool) *LdapSchemaCollectionGetParams {
	o.SetGlobalSchemaQueryParameter(globalSchema)
	return o
}

// SetGlobalSchemaQueryParameter adds the globalSchema to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetGlobalSchemaQueryParameter(globalSchema *bool) {
	o.GlobalSchemaQueryParameter = globalSchema
}

// WithMaxRecordsQueryParameter adds the maxRecords to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *LdapSchemaCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithNameQueryParameter(name *string) *LdapSchemaCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithNameMappingAccountUnixQueryParameter adds the nameMappingAccountUnix to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithNameMappingAccountUnixQueryParameter(nameMappingAccountUnix *string) *LdapSchemaCollectionGetParams {
	o.SetNameMappingAccountUnixQueryParameter(nameMappingAccountUnix)
	return o
}

// SetNameMappingAccountUnixQueryParameter adds the nameMappingAccountUnix to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetNameMappingAccountUnixQueryParameter(nameMappingAccountUnix *string) {
	o.NameMappingAccountUnixQueryParameter = nameMappingAccountUnix
}

// WithNameMappingAccountWindowsQueryParameter adds the nameMappingAccountWindows to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithNameMappingAccountWindowsQueryParameter(nameMappingAccountWindows *string) *LdapSchemaCollectionGetParams {
	o.SetNameMappingAccountWindowsQueryParameter(nameMappingAccountWindows)
	return o
}

// SetNameMappingAccountWindowsQueryParameter adds the nameMappingAccountWindows to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetNameMappingAccountWindowsQueryParameter(nameMappingAccountWindows *string) {
	o.NameMappingAccountWindowsQueryParameter = nameMappingAccountWindows
}

// WithNameMappingWindowsToUnixAttributeQueryParameter adds the nameMappingWindowsToUnixAttribute to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithNameMappingWindowsToUnixAttributeQueryParameter(nameMappingWindowsToUnixAttribute *string) *LdapSchemaCollectionGetParams {
	o.SetNameMappingWindowsToUnixAttributeQueryParameter(nameMappingWindowsToUnixAttribute)
	return o
}

// SetNameMappingWindowsToUnixAttributeQueryParameter adds the nameMappingWindowsToUnixAttribute to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetNameMappingWindowsToUnixAttributeQueryParameter(nameMappingWindowsToUnixAttribute *string) {
	o.NameMappingWindowsToUnixAttributeQueryParameter = nameMappingWindowsToUnixAttribute
}

// WithNameMappingWindowsToUnixNoDomainPrefixQueryParameter adds the nameMappingWindowsToUnixNoDomainPrefix to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithNameMappingWindowsToUnixNoDomainPrefixQueryParameter(nameMappingWindowsToUnixNoDomainPrefix *bool) *LdapSchemaCollectionGetParams {
	o.SetNameMappingWindowsToUnixNoDomainPrefixQueryParameter(nameMappingWindowsToUnixNoDomainPrefix)
	return o
}

// SetNameMappingWindowsToUnixNoDomainPrefixQueryParameter adds the nameMappingWindowsToUnixNoDomainPrefix to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetNameMappingWindowsToUnixNoDomainPrefixQueryParameter(nameMappingWindowsToUnixNoDomainPrefix *bool) {
	o.NameMappingWindowsToUnixNoDomainPrefixQueryParameter = nameMappingWindowsToUnixNoDomainPrefix
}

// WithNameMappingWindowsToUnixObjectClassQueryParameter adds the nameMappingWindowsToUnixObjectClass to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithNameMappingWindowsToUnixObjectClassQueryParameter(nameMappingWindowsToUnixObjectClass *string) *LdapSchemaCollectionGetParams {
	o.SetNameMappingWindowsToUnixObjectClassQueryParameter(nameMappingWindowsToUnixObjectClass)
	return o
}

// SetNameMappingWindowsToUnixObjectClassQueryParameter adds the nameMappingWindowsToUnixObjectClass to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetNameMappingWindowsToUnixObjectClassQueryParameter(nameMappingWindowsToUnixObjectClass *string) {
	o.NameMappingWindowsToUnixObjectClassQueryParameter = nameMappingWindowsToUnixObjectClass
}

// WithOrderByQueryParameter adds the orderBy to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *LdapSchemaCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithOwnerNameQueryParameter adds the ownerName to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithOwnerNameQueryParameter(ownerName *string) *LdapSchemaCollectionGetParams {
	o.SetOwnerNameQueryParameter(ownerName)
	return o
}

// SetOwnerNameQueryParameter adds the ownerName to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetOwnerNameQueryParameter(ownerName *string) {
	o.OwnerNameQueryParameter = ownerName
}

// WithOwnerUUIDQueryParameter adds the ownerUUID to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithOwnerUUIDQueryParameter(ownerUUID *string) *LdapSchemaCollectionGetParams {
	o.SetOwnerUUIDQueryParameter(ownerUUID)
	return o
}

// SetOwnerUUIDQueryParameter adds the ownerUuid to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetOwnerUUIDQueryParameter(ownerUUID *string) {
	o.OwnerUUIDQueryParameter = ownerUUID
}

// WithReturnRecordsQueryParameter adds the returnRecords to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *LdapSchemaCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *LdapSchemaCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithRfc2307AttributeGecosQueryParameter adds the rfc2307AttributeGecos to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307AttributeGecosQueryParameter(rfc2307AttributeGecos *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307AttributeGecosQueryParameter(rfc2307AttributeGecos)
	return o
}

// SetRfc2307AttributeGecosQueryParameter adds the rfc2307AttributeGecos to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307AttributeGecosQueryParameter(rfc2307AttributeGecos *string) {
	o.Rfc2307AttributeGecosQueryParameter = rfc2307AttributeGecos
}

// WithRfc2307AttributeGIDNumberQueryParameter adds the rfc2307AttributeGidNumber to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307AttributeGIDNumberQueryParameter(rfc2307AttributeGidNumber *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307AttributeGIDNumberQueryParameter(rfc2307AttributeGidNumber)
	return o
}

// SetRfc2307AttributeGIDNumberQueryParameter adds the rfc2307AttributeGidNumber to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307AttributeGIDNumberQueryParameter(rfc2307AttributeGidNumber *string) {
	o.Rfc2307AttributeGIDNumberQueryParameter = rfc2307AttributeGidNumber
}

// WithRfc2307AttributeHomeDirectoryQueryParameter adds the rfc2307AttributeHomeDirectory to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307AttributeHomeDirectoryQueryParameter(rfc2307AttributeHomeDirectory *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307AttributeHomeDirectoryQueryParameter(rfc2307AttributeHomeDirectory)
	return o
}

// SetRfc2307AttributeHomeDirectoryQueryParameter adds the rfc2307AttributeHomeDirectory to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307AttributeHomeDirectoryQueryParameter(rfc2307AttributeHomeDirectory *string) {
	o.Rfc2307AttributeHomeDirectoryQueryParameter = rfc2307AttributeHomeDirectory
}

// WithRfc2307AttributeLoginShellQueryParameter adds the rfc2307AttributeLoginShell to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307AttributeLoginShellQueryParameter(rfc2307AttributeLoginShell *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307AttributeLoginShellQueryParameter(rfc2307AttributeLoginShell)
	return o
}

// SetRfc2307AttributeLoginShellQueryParameter adds the rfc2307AttributeLoginShell to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307AttributeLoginShellQueryParameter(rfc2307AttributeLoginShell *string) {
	o.Rfc2307AttributeLoginShellQueryParameter = rfc2307AttributeLoginShell
}

// WithRfc2307AttributeUIDQueryParameter adds the rfc2307AttributeUID to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307AttributeUIDQueryParameter(rfc2307AttributeUID *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307AttributeUIDQueryParameter(rfc2307AttributeUID)
	return o
}

// SetRfc2307AttributeUIDQueryParameter adds the rfc2307AttributeUid to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307AttributeUIDQueryParameter(rfc2307AttributeUID *string) {
	o.Rfc2307AttributeUIDQueryParameter = rfc2307AttributeUID
}

// WithRfc2307AttributeUIDNumberQueryParameter adds the rfc2307AttributeUIDNumber to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307AttributeUIDNumberQueryParameter(rfc2307AttributeUIDNumber *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307AttributeUIDNumberQueryParameter(rfc2307AttributeUIDNumber)
	return o
}

// SetRfc2307AttributeUIDNumberQueryParameter adds the rfc2307AttributeUidNumber to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307AttributeUIDNumberQueryParameter(rfc2307AttributeUIDNumber *string) {
	o.Rfc2307AttributeUIDNumberQueryParameter = rfc2307AttributeUIDNumber
}

// WithRfc2307AttributeUserPasswordQueryParameter adds the rfc2307AttributeUserPassword to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307AttributeUserPasswordQueryParameter(rfc2307AttributeUserPassword *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307AttributeUserPasswordQueryParameter(rfc2307AttributeUserPassword)
	return o
}

// SetRfc2307AttributeUserPasswordQueryParameter adds the rfc2307AttributeUserPassword to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307AttributeUserPasswordQueryParameter(rfc2307AttributeUserPassword *string) {
	o.Rfc2307AttributeUserPasswordQueryParameter = rfc2307AttributeUserPassword
}

// WithRfc2307CnGroupQueryParameter adds the rfc2307CnGroup to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307CnGroupQueryParameter(rfc2307CnGroup *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307CnGroupQueryParameter(rfc2307CnGroup)
	return o
}

// SetRfc2307CnGroupQueryParameter adds the rfc2307CnGroup to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307CnGroupQueryParameter(rfc2307CnGroup *string) {
	o.Rfc2307CnGroupQueryParameter = rfc2307CnGroup
}

// WithRfc2307CnNetgroupQueryParameter adds the rfc2307CnNetgroup to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307CnNetgroupQueryParameter(rfc2307CnNetgroup *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307CnNetgroupQueryParameter(rfc2307CnNetgroup)
	return o
}

// SetRfc2307CnNetgroupQueryParameter adds the rfc2307CnNetgroup to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307CnNetgroupQueryParameter(rfc2307CnNetgroup *string) {
	o.Rfc2307CnNetgroupQueryParameter = rfc2307CnNetgroup
}

// WithRfc2307MemberNisNetgroupQueryParameter adds the rfc2307MemberNisNetgroup to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307MemberNisNetgroupQueryParameter(rfc2307MemberNisNetgroup *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307MemberNisNetgroupQueryParameter(rfc2307MemberNisNetgroup)
	return o
}

// SetRfc2307MemberNisNetgroupQueryParameter adds the rfc2307MemberNisNetgroup to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307MemberNisNetgroupQueryParameter(rfc2307MemberNisNetgroup *string) {
	o.Rfc2307MemberNisNetgroupQueryParameter = rfc2307MemberNisNetgroup
}

// WithRfc2307MemberUIDQueryParameter adds the rfc2307MemberUID to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307MemberUIDQueryParameter(rfc2307MemberUID *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307MemberUIDQueryParameter(rfc2307MemberUID)
	return o
}

// SetRfc2307MemberUIDQueryParameter adds the rfc2307MemberUid to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307MemberUIDQueryParameter(rfc2307MemberUID *string) {
	o.Rfc2307MemberUIDQueryParameter = rfc2307MemberUID
}

// WithRfc2307NisMapentryQueryParameter adds the rfc2307NisMapentry to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307NisMapentryQueryParameter(rfc2307NisMapentry *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307NisMapentryQueryParameter(rfc2307NisMapentry)
	return o
}

// SetRfc2307NisMapentryQueryParameter adds the rfc2307NisMapentry to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307NisMapentryQueryParameter(rfc2307NisMapentry *string) {
	o.Rfc2307NisMapentryQueryParameter = rfc2307NisMapentry
}

// WithRfc2307NisMapnameQueryParameter adds the rfc2307NisMapname to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307NisMapnameQueryParameter(rfc2307NisMapname *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307NisMapnameQueryParameter(rfc2307NisMapname)
	return o
}

// SetRfc2307NisMapnameQueryParameter adds the rfc2307NisMapname to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307NisMapnameQueryParameter(rfc2307NisMapname *string) {
	o.Rfc2307NisMapnameQueryParameter = rfc2307NisMapname
}

// WithRfc2307NisNetgroupQueryParameter adds the rfc2307NisNetgroup to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307NisNetgroupQueryParameter(rfc2307NisNetgroup *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307NisNetgroupQueryParameter(rfc2307NisNetgroup)
	return o
}

// SetRfc2307NisNetgroupQueryParameter adds the rfc2307NisNetgroup to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307NisNetgroupQueryParameter(rfc2307NisNetgroup *string) {
	o.Rfc2307NisNetgroupQueryParameter = rfc2307NisNetgroup
}

// WithRfc2307NisNetgroupTripleQueryParameter adds the rfc2307NisNetgroupTriple to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307NisNetgroupTripleQueryParameter(rfc2307NisNetgroupTriple *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307NisNetgroupTripleQueryParameter(rfc2307NisNetgroupTriple)
	return o
}

// SetRfc2307NisNetgroupTripleQueryParameter adds the rfc2307NisNetgroupTriple to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307NisNetgroupTripleQueryParameter(rfc2307NisNetgroupTriple *string) {
	o.Rfc2307NisNetgroupTripleQueryParameter = rfc2307NisNetgroupTriple
}

// WithRfc2307NisObjectQueryParameter adds the rfc2307NisObject to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307NisObjectQueryParameter(rfc2307NisObject *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307NisObjectQueryParameter(rfc2307NisObject)
	return o
}

// SetRfc2307NisObjectQueryParameter adds the rfc2307NisObject to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307NisObjectQueryParameter(rfc2307NisObject *string) {
	o.Rfc2307NisObjectQueryParameter = rfc2307NisObject
}

// WithRfc2307PosixAccountQueryParameter adds the rfc2307PosixAccount to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307PosixAccountQueryParameter(rfc2307PosixAccount *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307PosixAccountQueryParameter(rfc2307PosixAccount)
	return o
}

// SetRfc2307PosixAccountQueryParameter adds the rfc2307PosixAccount to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307PosixAccountQueryParameter(rfc2307PosixAccount *string) {
	o.Rfc2307PosixAccountQueryParameter = rfc2307PosixAccount
}

// WithRfc2307PosixGroupQueryParameter adds the rfc2307PosixGroup to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307PosixGroupQueryParameter(rfc2307PosixGroup *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307PosixGroupQueryParameter(rfc2307PosixGroup)
	return o
}

// SetRfc2307PosixGroupQueryParameter adds the rfc2307PosixGroup to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307PosixGroupQueryParameter(rfc2307PosixGroup *string) {
	o.Rfc2307PosixGroupQueryParameter = rfc2307PosixGroup
}

// WithRfc2307bisEnabledQueryParameter adds the rfc2307bisEnabled to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307bisEnabledQueryParameter(rfc2307bisEnabled *bool) *LdapSchemaCollectionGetParams {
	o.SetRfc2307bisEnabledQueryParameter(rfc2307bisEnabled)
	return o
}

// SetRfc2307bisEnabledQueryParameter adds the rfc2307bisEnabled to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307bisEnabledQueryParameter(rfc2307bisEnabled *bool) {
	o.Rfc2307bisEnabledQueryParameter = rfc2307bisEnabled
}

// WithRfc2307bisGroupOfUniqueNamesQueryParameter adds the rfc2307bisGroupOfUniqueNames to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307bisGroupOfUniqueNamesQueryParameter(rfc2307bisGroupOfUniqueNames *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307bisGroupOfUniqueNamesQueryParameter(rfc2307bisGroupOfUniqueNames)
	return o
}

// SetRfc2307bisGroupOfUniqueNamesQueryParameter adds the rfc2307bisGroupOfUniqueNames to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307bisGroupOfUniqueNamesQueryParameter(rfc2307bisGroupOfUniqueNames *string) {
	o.Rfc2307bisGroupOfUniqueNamesQueryParameter = rfc2307bisGroupOfUniqueNames
}

// WithRfc2307bisMaximumGroupsQueryParameter adds the rfc2307bisMaximumGroups to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307bisMaximumGroupsQueryParameter(rfc2307bisMaximumGroups *int64) *LdapSchemaCollectionGetParams {
	o.SetRfc2307bisMaximumGroupsQueryParameter(rfc2307bisMaximumGroups)
	return o
}

// SetRfc2307bisMaximumGroupsQueryParameter adds the rfc2307bisMaximumGroups to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307bisMaximumGroupsQueryParameter(rfc2307bisMaximumGroups *int64) {
	o.Rfc2307bisMaximumGroupsQueryParameter = rfc2307bisMaximumGroups
}

// WithRfc2307bisUniqueMemberQueryParameter adds the rfc2307bisUniqueMember to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithRfc2307bisUniqueMemberQueryParameter(rfc2307bisUniqueMember *string) *LdapSchemaCollectionGetParams {
	o.SetRfc2307bisUniqueMemberQueryParameter(rfc2307bisUniqueMember)
	return o
}

// SetRfc2307bisUniqueMemberQueryParameter adds the rfc2307bisUniqueMember to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetRfc2307bisUniqueMemberQueryParameter(rfc2307bisUniqueMember *string) {
	o.Rfc2307bisUniqueMemberQueryParameter = rfc2307bisUniqueMember
}

// WithScopeQueryParameter adds the scope to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) WithScopeQueryParameter(scope *string) *LdapSchemaCollectionGetParams {
	o.SetScopeQueryParameter(scope)
	return o
}

// SetScopeQueryParameter adds the scope to the ldap schema collection get params
func (o *LdapSchemaCollectionGetParams) SetScopeQueryParameter(scope *string) {
	o.ScopeQueryParameter = scope
}

// WriteToRequest writes these params to a swagger request
func (o *LdapSchemaCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CommentQueryParameter != nil {

		// query param comment
		var qrComment string

		if o.CommentQueryParameter != nil {
			qrComment = *o.CommentQueryParameter
		}
		qComment := qrComment
		if qComment != "" {

			if err := r.SetQueryParam("comment", qComment); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.GlobalSchemaQueryParameter != nil {

		// query param global_schema
		var qrGlobalSchema bool

		if o.GlobalSchemaQueryParameter != nil {
			qrGlobalSchema = *o.GlobalSchemaQueryParameter
		}
		qGlobalSchema := swag.FormatBool(qrGlobalSchema)
		if qGlobalSchema != "" {

			if err := r.SetQueryParam("global_schema", qGlobalSchema); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.NameMappingAccountUnixQueryParameter != nil {

		// query param name_mapping.account.unix
		var qrNameMappingAccountUnix string

		if o.NameMappingAccountUnixQueryParameter != nil {
			qrNameMappingAccountUnix = *o.NameMappingAccountUnixQueryParameter
		}
		qNameMappingAccountUnix := qrNameMappingAccountUnix
		if qNameMappingAccountUnix != "" {

			if err := r.SetQueryParam("name_mapping.account.unix", qNameMappingAccountUnix); err != nil {
				return err
			}
		}
	}

	if o.NameMappingAccountWindowsQueryParameter != nil {

		// query param name_mapping.account.windows
		var qrNameMappingAccountWindows string

		if o.NameMappingAccountWindowsQueryParameter != nil {
			qrNameMappingAccountWindows = *o.NameMappingAccountWindowsQueryParameter
		}
		qNameMappingAccountWindows := qrNameMappingAccountWindows
		if qNameMappingAccountWindows != "" {

			if err := r.SetQueryParam("name_mapping.account.windows", qNameMappingAccountWindows); err != nil {
				return err
			}
		}
	}

	if o.NameMappingWindowsToUnixAttributeQueryParameter != nil {

		// query param name_mapping.windows_to_unix.attribute
		var qrNameMappingWindowsToUnixAttribute string

		if o.NameMappingWindowsToUnixAttributeQueryParameter != nil {
			qrNameMappingWindowsToUnixAttribute = *o.NameMappingWindowsToUnixAttributeQueryParameter
		}
		qNameMappingWindowsToUnixAttribute := qrNameMappingWindowsToUnixAttribute
		if qNameMappingWindowsToUnixAttribute != "" {

			if err := r.SetQueryParam("name_mapping.windows_to_unix.attribute", qNameMappingWindowsToUnixAttribute); err != nil {
				return err
			}
		}
	}

	if o.NameMappingWindowsToUnixNoDomainPrefixQueryParameter != nil {

		// query param name_mapping.windows_to_unix.no_domain_prefix
		var qrNameMappingWindowsToUnixNoDomainPrefix bool

		if o.NameMappingWindowsToUnixNoDomainPrefixQueryParameter != nil {
			qrNameMappingWindowsToUnixNoDomainPrefix = *o.NameMappingWindowsToUnixNoDomainPrefixQueryParameter
		}
		qNameMappingWindowsToUnixNoDomainPrefix := swag.FormatBool(qrNameMappingWindowsToUnixNoDomainPrefix)
		if qNameMappingWindowsToUnixNoDomainPrefix != "" {

			if err := r.SetQueryParam("name_mapping.windows_to_unix.no_domain_prefix", qNameMappingWindowsToUnixNoDomainPrefix); err != nil {
				return err
			}
		}
	}

	if o.NameMappingWindowsToUnixObjectClassQueryParameter != nil {

		// query param name_mapping.windows_to_unix.object_class
		var qrNameMappingWindowsToUnixObjectClass string

		if o.NameMappingWindowsToUnixObjectClassQueryParameter != nil {
			qrNameMappingWindowsToUnixObjectClass = *o.NameMappingWindowsToUnixObjectClassQueryParameter
		}
		qNameMappingWindowsToUnixObjectClass := qrNameMappingWindowsToUnixObjectClass
		if qNameMappingWindowsToUnixObjectClass != "" {

			if err := r.SetQueryParam("name_mapping.windows_to_unix.object_class", qNameMappingWindowsToUnixObjectClass); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.OwnerNameQueryParameter != nil {

		// query param owner.name
		var qrOwnerName string

		if o.OwnerNameQueryParameter != nil {
			qrOwnerName = *o.OwnerNameQueryParameter
		}
		qOwnerName := qrOwnerName
		if qOwnerName != "" {

			if err := r.SetQueryParam("owner.name", qOwnerName); err != nil {
				return err
			}
		}
	}

	if o.OwnerUUIDQueryParameter != nil {

		// query param owner.uuid
		var qrOwnerUUID string

		if o.OwnerUUIDQueryParameter != nil {
			qrOwnerUUID = *o.OwnerUUIDQueryParameter
		}
		qOwnerUUID := qrOwnerUUID
		if qOwnerUUID != "" {

			if err := r.SetQueryParam("owner.uuid", qOwnerUUID); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307AttributeGecosQueryParameter != nil {

		// query param rfc2307.attribute.gecos
		var qrRfc2307AttributeGecos string

		if o.Rfc2307AttributeGecosQueryParameter != nil {
			qrRfc2307AttributeGecos = *o.Rfc2307AttributeGecosQueryParameter
		}
		qRfc2307AttributeGecos := qrRfc2307AttributeGecos
		if qRfc2307AttributeGecos != "" {

			if err := r.SetQueryParam("rfc2307.attribute.gecos", qRfc2307AttributeGecos); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307AttributeGIDNumberQueryParameter != nil {

		// query param rfc2307.attribute.gid_number
		var qrRfc2307AttributeGidNumber string

		if o.Rfc2307AttributeGIDNumberQueryParameter != nil {
			qrRfc2307AttributeGidNumber = *o.Rfc2307AttributeGIDNumberQueryParameter
		}
		qRfc2307AttributeGidNumber := qrRfc2307AttributeGidNumber
		if qRfc2307AttributeGidNumber != "" {

			if err := r.SetQueryParam("rfc2307.attribute.gid_number", qRfc2307AttributeGidNumber); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307AttributeHomeDirectoryQueryParameter != nil {

		// query param rfc2307.attribute.home_directory
		var qrRfc2307AttributeHomeDirectory string

		if o.Rfc2307AttributeHomeDirectoryQueryParameter != nil {
			qrRfc2307AttributeHomeDirectory = *o.Rfc2307AttributeHomeDirectoryQueryParameter
		}
		qRfc2307AttributeHomeDirectory := qrRfc2307AttributeHomeDirectory
		if qRfc2307AttributeHomeDirectory != "" {

			if err := r.SetQueryParam("rfc2307.attribute.home_directory", qRfc2307AttributeHomeDirectory); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307AttributeLoginShellQueryParameter != nil {

		// query param rfc2307.attribute.login_shell
		var qrRfc2307AttributeLoginShell string

		if o.Rfc2307AttributeLoginShellQueryParameter != nil {
			qrRfc2307AttributeLoginShell = *o.Rfc2307AttributeLoginShellQueryParameter
		}
		qRfc2307AttributeLoginShell := qrRfc2307AttributeLoginShell
		if qRfc2307AttributeLoginShell != "" {

			if err := r.SetQueryParam("rfc2307.attribute.login_shell", qRfc2307AttributeLoginShell); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307AttributeUIDQueryParameter != nil {

		// query param rfc2307.attribute.uid
		var qrRfc2307AttributeUID string

		if o.Rfc2307AttributeUIDQueryParameter != nil {
			qrRfc2307AttributeUID = *o.Rfc2307AttributeUIDQueryParameter
		}
		qRfc2307AttributeUID := qrRfc2307AttributeUID
		if qRfc2307AttributeUID != "" {

			if err := r.SetQueryParam("rfc2307.attribute.uid", qRfc2307AttributeUID); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307AttributeUIDNumberQueryParameter != nil {

		// query param rfc2307.attribute.uid_number
		var qrRfc2307AttributeUIDNumber string

		if o.Rfc2307AttributeUIDNumberQueryParameter != nil {
			qrRfc2307AttributeUIDNumber = *o.Rfc2307AttributeUIDNumberQueryParameter
		}
		qRfc2307AttributeUIDNumber := qrRfc2307AttributeUIDNumber
		if qRfc2307AttributeUIDNumber != "" {

			if err := r.SetQueryParam("rfc2307.attribute.uid_number", qRfc2307AttributeUIDNumber); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307AttributeUserPasswordQueryParameter != nil {

		// query param rfc2307.attribute.user_password
		var qrRfc2307AttributeUserPassword string

		if o.Rfc2307AttributeUserPasswordQueryParameter != nil {
			qrRfc2307AttributeUserPassword = *o.Rfc2307AttributeUserPasswordQueryParameter
		}
		qRfc2307AttributeUserPassword := qrRfc2307AttributeUserPassword
		if qRfc2307AttributeUserPassword != "" {

			if err := r.SetQueryParam("rfc2307.attribute.user_password", qRfc2307AttributeUserPassword); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307CnGroupQueryParameter != nil {

		// query param rfc2307.cn.group
		var qrRfc2307CnGroup string

		if o.Rfc2307CnGroupQueryParameter != nil {
			qrRfc2307CnGroup = *o.Rfc2307CnGroupQueryParameter
		}
		qRfc2307CnGroup := qrRfc2307CnGroup
		if qRfc2307CnGroup != "" {

			if err := r.SetQueryParam("rfc2307.cn.group", qRfc2307CnGroup); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307CnNetgroupQueryParameter != nil {

		// query param rfc2307.cn.netgroup
		var qrRfc2307CnNetgroup string

		if o.Rfc2307CnNetgroupQueryParameter != nil {
			qrRfc2307CnNetgroup = *o.Rfc2307CnNetgroupQueryParameter
		}
		qRfc2307CnNetgroup := qrRfc2307CnNetgroup
		if qRfc2307CnNetgroup != "" {

			if err := r.SetQueryParam("rfc2307.cn.netgroup", qRfc2307CnNetgroup); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307MemberNisNetgroupQueryParameter != nil {

		// query param rfc2307.member.nis_netgroup
		var qrRfc2307MemberNisNetgroup string

		if o.Rfc2307MemberNisNetgroupQueryParameter != nil {
			qrRfc2307MemberNisNetgroup = *o.Rfc2307MemberNisNetgroupQueryParameter
		}
		qRfc2307MemberNisNetgroup := qrRfc2307MemberNisNetgroup
		if qRfc2307MemberNisNetgroup != "" {

			if err := r.SetQueryParam("rfc2307.member.nis_netgroup", qRfc2307MemberNisNetgroup); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307MemberUIDQueryParameter != nil {

		// query param rfc2307.member.uid
		var qrRfc2307MemberUID string

		if o.Rfc2307MemberUIDQueryParameter != nil {
			qrRfc2307MemberUID = *o.Rfc2307MemberUIDQueryParameter
		}
		qRfc2307MemberUID := qrRfc2307MemberUID
		if qRfc2307MemberUID != "" {

			if err := r.SetQueryParam("rfc2307.member.uid", qRfc2307MemberUID); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307NisMapentryQueryParameter != nil {

		// query param rfc2307.nis.mapentry
		var qrRfc2307NisMapentry string

		if o.Rfc2307NisMapentryQueryParameter != nil {
			qrRfc2307NisMapentry = *o.Rfc2307NisMapentryQueryParameter
		}
		qRfc2307NisMapentry := qrRfc2307NisMapentry
		if qRfc2307NisMapentry != "" {

			if err := r.SetQueryParam("rfc2307.nis.mapentry", qRfc2307NisMapentry); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307NisMapnameQueryParameter != nil {

		// query param rfc2307.nis.mapname
		var qrRfc2307NisMapname string

		if o.Rfc2307NisMapnameQueryParameter != nil {
			qrRfc2307NisMapname = *o.Rfc2307NisMapnameQueryParameter
		}
		qRfc2307NisMapname := qrRfc2307NisMapname
		if qRfc2307NisMapname != "" {

			if err := r.SetQueryParam("rfc2307.nis.mapname", qRfc2307NisMapname); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307NisNetgroupQueryParameter != nil {

		// query param rfc2307.nis.netgroup
		var qrRfc2307NisNetgroup string

		if o.Rfc2307NisNetgroupQueryParameter != nil {
			qrRfc2307NisNetgroup = *o.Rfc2307NisNetgroupQueryParameter
		}
		qRfc2307NisNetgroup := qrRfc2307NisNetgroup
		if qRfc2307NisNetgroup != "" {

			if err := r.SetQueryParam("rfc2307.nis.netgroup", qRfc2307NisNetgroup); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307NisNetgroupTripleQueryParameter != nil {

		// query param rfc2307.nis.netgroup_triple
		var qrRfc2307NisNetgroupTriple string

		if o.Rfc2307NisNetgroupTripleQueryParameter != nil {
			qrRfc2307NisNetgroupTriple = *o.Rfc2307NisNetgroupTripleQueryParameter
		}
		qRfc2307NisNetgroupTriple := qrRfc2307NisNetgroupTriple
		if qRfc2307NisNetgroupTriple != "" {

			if err := r.SetQueryParam("rfc2307.nis.netgroup_triple", qRfc2307NisNetgroupTriple); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307NisObjectQueryParameter != nil {

		// query param rfc2307.nis.object
		var qrRfc2307NisObject string

		if o.Rfc2307NisObjectQueryParameter != nil {
			qrRfc2307NisObject = *o.Rfc2307NisObjectQueryParameter
		}
		qRfc2307NisObject := qrRfc2307NisObject
		if qRfc2307NisObject != "" {

			if err := r.SetQueryParam("rfc2307.nis.object", qRfc2307NisObject); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307PosixAccountQueryParameter != nil {

		// query param rfc2307.posix.account
		var qrRfc2307PosixAccount string

		if o.Rfc2307PosixAccountQueryParameter != nil {
			qrRfc2307PosixAccount = *o.Rfc2307PosixAccountQueryParameter
		}
		qRfc2307PosixAccount := qrRfc2307PosixAccount
		if qRfc2307PosixAccount != "" {

			if err := r.SetQueryParam("rfc2307.posix.account", qRfc2307PosixAccount); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307PosixGroupQueryParameter != nil {

		// query param rfc2307.posix.group
		var qrRfc2307PosixGroup string

		if o.Rfc2307PosixGroupQueryParameter != nil {
			qrRfc2307PosixGroup = *o.Rfc2307PosixGroupQueryParameter
		}
		qRfc2307PosixGroup := qrRfc2307PosixGroup
		if qRfc2307PosixGroup != "" {

			if err := r.SetQueryParam("rfc2307.posix.group", qRfc2307PosixGroup); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307bisEnabledQueryParameter != nil {

		// query param rfc2307bis.enabled
		var qrRfc2307bisEnabled bool

		if o.Rfc2307bisEnabledQueryParameter != nil {
			qrRfc2307bisEnabled = *o.Rfc2307bisEnabledQueryParameter
		}
		qRfc2307bisEnabled := swag.FormatBool(qrRfc2307bisEnabled)
		if qRfc2307bisEnabled != "" {

			if err := r.SetQueryParam("rfc2307bis.enabled", qRfc2307bisEnabled); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307bisGroupOfUniqueNamesQueryParameter != nil {

		// query param rfc2307bis.group_of_unique_names
		var qrRfc2307bisGroupOfUniqueNames string

		if o.Rfc2307bisGroupOfUniqueNamesQueryParameter != nil {
			qrRfc2307bisGroupOfUniqueNames = *o.Rfc2307bisGroupOfUniqueNamesQueryParameter
		}
		qRfc2307bisGroupOfUniqueNames := qrRfc2307bisGroupOfUniqueNames
		if qRfc2307bisGroupOfUniqueNames != "" {

			if err := r.SetQueryParam("rfc2307bis.group_of_unique_names", qRfc2307bisGroupOfUniqueNames); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307bisMaximumGroupsQueryParameter != nil {

		// query param rfc2307bis.maximum_groups
		var qrRfc2307bisMaximumGroups int64

		if o.Rfc2307bisMaximumGroupsQueryParameter != nil {
			qrRfc2307bisMaximumGroups = *o.Rfc2307bisMaximumGroupsQueryParameter
		}
		qRfc2307bisMaximumGroups := swag.FormatInt64(qrRfc2307bisMaximumGroups)
		if qRfc2307bisMaximumGroups != "" {

			if err := r.SetQueryParam("rfc2307bis.maximum_groups", qRfc2307bisMaximumGroups); err != nil {
				return err
			}
		}
	}

	if o.Rfc2307bisUniqueMemberQueryParameter != nil {

		// query param rfc2307bis.unique_member
		var qrRfc2307bisUniqueMember string

		if o.Rfc2307bisUniqueMemberQueryParameter != nil {
			qrRfc2307bisUniqueMember = *o.Rfc2307bisUniqueMemberQueryParameter
		}
		qRfc2307bisUniqueMember := qrRfc2307bisUniqueMember
		if qRfc2307bisUniqueMember != "" {

			if err := r.SetQueryParam("rfc2307bis.unique_member", qRfc2307bisUniqueMember); err != nil {
				return err
			}
		}
	}

	if o.ScopeQueryParameter != nil {

		// query param scope
		var qrScope string

		if o.ScopeQueryParameter != nil {
			qrScope = *o.ScopeQueryParameter
		}
		qScope := qrScope
		if qScope != "" {

			if err := r.SetQueryParam("scope", qScope); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamLdapSchemaCollectionGet binds the parameter fields
func (o *LdapSchemaCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamLdapSchemaCollectionGet binds the parameter order_by
func (o *LdapSchemaCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
