// Code generated by go-swagger; DO NOT EDIT.

package name_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewNameMappingCollectionGetParams creates a new NameMappingCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNameMappingCollectionGetParams() *NameMappingCollectionGetParams {
	return &NameMappingCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNameMappingCollectionGetParamsWithTimeout creates a new NameMappingCollectionGetParams object
// with the ability to set a timeout on a request.
func NewNameMappingCollectionGetParamsWithTimeout(timeout time.Duration) *NameMappingCollectionGetParams {
	return &NameMappingCollectionGetParams{
		timeout: timeout,
	}
}

// NewNameMappingCollectionGetParamsWithContext creates a new NameMappingCollectionGetParams object
// with the ability to set a context for a request.
func NewNameMappingCollectionGetParamsWithContext(ctx context.Context) *NameMappingCollectionGetParams {
	return &NameMappingCollectionGetParams{
		Context: ctx,
	}
}

// NewNameMappingCollectionGetParamsWithHTTPClient creates a new NameMappingCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewNameMappingCollectionGetParamsWithHTTPClient(client *http.Client) *NameMappingCollectionGetParams {
	return &NameMappingCollectionGetParams{
		HTTPClient: client,
	}
}

/*
NameMappingCollectionGetParams contains all the parameters to send to the API endpoint

	for the name mapping collection get operation.

	Typically these are written to a http.Request.
*/
type NameMappingCollectionGetParams struct {

	/* ClientMatch.

	   Filter by client_match
	*/
	ClientMatchQueryParameter *string

	/* Direction.

	   Filter by direction
	*/
	DirectionQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* Index.

	   Filter by index
	*/
	IndexQueryParameter *int64

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* Pattern.

	   Filter by pattern
	*/
	PatternQueryParameter *string

	/* Replacement.

	   Filter by replacement
	*/
	ReplacementQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the name mapping collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NameMappingCollectionGetParams) WithDefaults() *NameMappingCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the name mapping collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NameMappingCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := NameMappingCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the name mapping collection get params
func (o *NameMappingCollectionGetParams) WithTimeout(timeout time.Duration) *NameMappingCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the name mapping collection get params
func (o *NameMappingCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the name mapping collection get params
func (o *NameMappingCollectionGetParams) WithContext(ctx context.Context) *NameMappingCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the name mapping collection get params
func (o *NameMappingCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the name mapping collection get params
func (o *NameMappingCollectionGetParams) WithHTTPClient(client *http.Client) *NameMappingCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the name mapping collection get params
func (o *NameMappingCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithClientMatchQueryParameter adds the clientMatch to the name mapping collection get params
func (o *NameMappingCollectionGetParams) WithClientMatchQueryParameter(clientMatch *string) *NameMappingCollectionGetParams {
	o.SetClientMatchQueryParameter(clientMatch)
	return o
}

// SetClientMatchQueryParameter adds the clientMatch to the name mapping collection get params
func (o *NameMappingCollectionGetParams) SetClientMatchQueryParameter(clientMatch *string) {
	o.ClientMatchQueryParameter = clientMatch
}

// WithDirectionQueryParameter adds the direction to the name mapping collection get params
func (o *NameMappingCollectionGetParams) WithDirectionQueryParameter(direction *string) *NameMappingCollectionGetParams {
	o.SetDirectionQueryParameter(direction)
	return o
}

// SetDirectionQueryParameter adds the direction to the name mapping collection get params
func (o *NameMappingCollectionGetParams) SetDirectionQueryParameter(direction *string) {
	o.DirectionQueryParameter = direction
}

// WithFieldsQueryParameter adds the fields to the name mapping collection get params
func (o *NameMappingCollectionGetParams) WithFieldsQueryParameter(fields []string) *NameMappingCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the name mapping collection get params
func (o *NameMappingCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIndexQueryParameter adds the index to the name mapping collection get params
func (o *NameMappingCollectionGetParams) WithIndexQueryParameter(index *int64) *NameMappingCollectionGetParams {
	o.SetIndexQueryParameter(index)
	return o
}

// SetIndexQueryParameter adds the index to the name mapping collection get params
func (o *NameMappingCollectionGetParams) SetIndexQueryParameter(index *int64) {
	o.IndexQueryParameter = index
}

// WithMaxRecordsQueryParameter adds the maxRecords to the name mapping collection get params
func (o *NameMappingCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *NameMappingCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the name mapping collection get params
func (o *NameMappingCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the name mapping collection get params
func (o *NameMappingCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *NameMappingCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the name mapping collection get params
func (o *NameMappingCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithPatternQueryParameter adds the pattern to the name mapping collection get params
func (o *NameMappingCollectionGetParams) WithPatternQueryParameter(pattern *string) *NameMappingCollectionGetParams {
	o.SetPatternQueryParameter(pattern)
	return o
}

// SetPatternQueryParameter adds the pattern to the name mapping collection get params
func (o *NameMappingCollectionGetParams) SetPatternQueryParameter(pattern *string) {
	o.PatternQueryParameter = pattern
}

// WithReplacementQueryParameter adds the replacement to the name mapping collection get params
func (o *NameMappingCollectionGetParams) WithReplacementQueryParameter(replacement *string) *NameMappingCollectionGetParams {
	o.SetReplacementQueryParameter(replacement)
	return o
}

// SetReplacementQueryParameter adds the replacement to the name mapping collection get params
func (o *NameMappingCollectionGetParams) SetReplacementQueryParameter(replacement *string) {
	o.ReplacementQueryParameter = replacement
}

// WithReturnRecordsQueryParameter adds the returnRecords to the name mapping collection get params
func (o *NameMappingCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *NameMappingCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the name mapping collection get params
func (o *NameMappingCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the name mapping collection get params
func (o *NameMappingCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *NameMappingCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the name mapping collection get params
func (o *NameMappingCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSVMNameQueryParameter adds the svmName to the name mapping collection get params
func (o *NameMappingCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *NameMappingCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the name mapping collection get params
func (o *NameMappingCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the name mapping collection get params
func (o *NameMappingCollectionGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *NameMappingCollectionGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the name mapping collection get params
func (o *NameMappingCollectionGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *NameMappingCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ClientMatchQueryParameter != nil {

		// query param client_match
		var qrClientMatch string

		if o.ClientMatchQueryParameter != nil {
			qrClientMatch = *o.ClientMatchQueryParameter
		}
		qClientMatch := qrClientMatch
		if qClientMatch != "" {

			if err := r.SetQueryParam("client_match", qClientMatch); err != nil {
				return err
			}
		}
	}

	if o.DirectionQueryParameter != nil {

		// query param direction
		var qrDirection string

		if o.DirectionQueryParameter != nil {
			qrDirection = *o.DirectionQueryParameter
		}
		qDirection := qrDirection
		if qDirection != "" {

			if err := r.SetQueryParam("direction", qDirection); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.IndexQueryParameter != nil {

		// query param index
		var qrIndex int64

		if o.IndexQueryParameter != nil {
			qrIndex = *o.IndexQueryParameter
		}
		qIndex := swag.FormatInt64(qrIndex)
		if qIndex != "" {

			if err := r.SetQueryParam("index", qIndex); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PatternQueryParameter != nil {

		// query param pattern
		var qrPattern string

		if o.PatternQueryParameter != nil {
			qrPattern = *o.PatternQueryParameter
		}
		qPattern := qrPattern
		if qPattern != "" {

			if err := r.SetQueryParam("pattern", qPattern); err != nil {
				return err
			}
		}
	}

	if o.ReplacementQueryParameter != nil {

		// query param replacement
		var qrReplacement string

		if o.ReplacementQueryParameter != nil {
			qrReplacement = *o.ReplacementQueryParameter
		}
		qReplacement := qrReplacement
		if qReplacement != "" {

			if err := r.SetQueryParam("replacement", qReplacement); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamNameMappingCollectionGet binds the parameter fields
func (o *NameMappingCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamNameMappingCollectionGet binds the parameter order_by
func (o *NameMappingCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
