// Code generated by go-swagger; DO NOT EDIT.

package name_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewNetgroupsSettingsGetParams creates a new NetgroupsSettingsGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNetgroupsSettingsGetParams() *NetgroupsSettingsGetParams {
	return &NetgroupsSettingsGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNetgroupsSettingsGetParamsWithTimeout creates a new NetgroupsSettingsGetParams object
// with the ability to set a timeout on a request.
func NewNetgroupsSettingsGetParamsWithTimeout(timeout time.Duration) *NetgroupsSettingsGetParams {
	return &NetgroupsSettingsGetParams{
		timeout: timeout,
	}
}

// NewNetgroupsSettingsGetParamsWithContext creates a new NetgroupsSettingsGetParams object
// with the ability to set a context for a request.
func NewNetgroupsSettingsGetParamsWithContext(ctx context.Context) *NetgroupsSettingsGetParams {
	return &NetgroupsSettingsGetParams{
		Context: ctx,
	}
}

// NewNetgroupsSettingsGetParamsWithHTTPClient creates a new NetgroupsSettingsGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewNetgroupsSettingsGetParamsWithHTTPClient(client *http.Client) *NetgroupsSettingsGetParams {
	return &NetgroupsSettingsGetParams{
		HTTPClient: client,
	}
}

/*
NetgroupsSettingsGetParams contains all the parameters to send to the API endpoint

	for the netgroups settings get operation.

	Typically these are written to a http.Request.
*/
type NetgroupsSettingsGetParams struct {

	/* Enabled.

	   Filter by enabled
	*/
	EnabledQueryParameter *bool

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* NegativeCacheEnabledByhost.

	   Filter by negative_cache_enabled_byhost
	*/
	NegativeCacheEnabledByhostQueryParameter *bool

	/* NegativeTTLByhost.

	   Filter by negative_ttl_byhost
	*/
	NegativeTTLByhostQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   SVM UUID.
	*/
	SVMUUIDPathParameter string

	/* TTLByhost.

	   Filter by ttl_byhost
	*/
	TTLByhostQueryParameter *string

	/* TTLForMembers.

	   Filter by ttl_for_members
	*/
	TTLForMembersQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the netgroups settings get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetgroupsSettingsGetParams) WithDefaults() *NetgroupsSettingsGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the netgroups settings get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetgroupsSettingsGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := NetgroupsSettingsGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) WithTimeout(timeout time.Duration) *NetgroupsSettingsGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) WithContext(ctx context.Context) *NetgroupsSettingsGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) WithHTTPClient(client *http.Client) *NetgroupsSettingsGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithEnabledQueryParameter adds the enabled to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) WithEnabledQueryParameter(enabled *bool) *NetgroupsSettingsGetParams {
	o.SetEnabledQueryParameter(enabled)
	return o
}

// SetEnabledQueryParameter adds the enabled to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) SetEnabledQueryParameter(enabled *bool) {
	o.EnabledQueryParameter = enabled
}

// WithFieldsQueryParameter adds the fields to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) WithFieldsQueryParameter(fields []string) *NetgroupsSettingsGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *NetgroupsSettingsGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNegativeCacheEnabledByhostQueryParameter adds the negativeCacheEnabledByhost to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) WithNegativeCacheEnabledByhostQueryParameter(negativeCacheEnabledByhost *bool) *NetgroupsSettingsGetParams {
	o.SetNegativeCacheEnabledByhostQueryParameter(negativeCacheEnabledByhost)
	return o
}

// SetNegativeCacheEnabledByhostQueryParameter adds the negativeCacheEnabledByhost to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) SetNegativeCacheEnabledByhostQueryParameter(negativeCacheEnabledByhost *bool) {
	o.NegativeCacheEnabledByhostQueryParameter = negativeCacheEnabledByhost
}

// WithNegativeTTLByhostQueryParameter adds the negativeTTLByhost to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) WithNegativeTTLByhostQueryParameter(negativeTTLByhost *string) *NetgroupsSettingsGetParams {
	o.SetNegativeTTLByhostQueryParameter(negativeTTLByhost)
	return o
}

// SetNegativeTTLByhostQueryParameter adds the negativeTtlByhost to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) SetNegativeTTLByhostQueryParameter(negativeTTLByhost *string) {
	o.NegativeTTLByhostQueryParameter = negativeTTLByhost
}

// WithOrderByQueryParameter adds the orderBy to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) WithOrderByQueryParameter(orderBy []string) *NetgroupsSettingsGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *NetgroupsSettingsGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *NetgroupsSettingsGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSVMNameQueryParameter adds the svmName to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) WithSVMNameQueryParameter(svmName *string) *NetgroupsSettingsGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDPathParameter adds the svmUUID to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) WithSVMUUIDPathParameter(svmUUID string) *NetgroupsSettingsGetParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WithTTLByhostQueryParameter adds the tTLByhost to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) WithTTLByhostQueryParameter(tTLByhost *string) *NetgroupsSettingsGetParams {
	o.SetTTLByhostQueryParameter(tTLByhost)
	return o
}

// SetTTLByhostQueryParameter adds the ttlByhost to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) SetTTLByhostQueryParameter(tTLByhost *string) {
	o.TTLByhostQueryParameter = tTLByhost
}

// WithTTLForMembersQueryParameter adds the tTLForMembers to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) WithTTLForMembersQueryParameter(tTLForMembers *string) *NetgroupsSettingsGetParams {
	o.SetTTLForMembersQueryParameter(tTLForMembers)
	return o
}

// SetTTLForMembersQueryParameter adds the ttlForMembers to the netgroups settings get params
func (o *NetgroupsSettingsGetParams) SetTTLForMembersQueryParameter(tTLForMembers *string) {
	o.TTLForMembersQueryParameter = tTLForMembers
}

// WriteToRequest writes these params to a swagger request
func (o *NetgroupsSettingsGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.EnabledQueryParameter != nil {

		// query param enabled
		var qrEnabled bool

		if o.EnabledQueryParameter != nil {
			qrEnabled = *o.EnabledQueryParameter
		}
		qEnabled := swag.FormatBool(qrEnabled)
		if qEnabled != "" {

			if err := r.SetQueryParam("enabled", qEnabled); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NegativeCacheEnabledByhostQueryParameter != nil {

		// query param negative_cache_enabled_byhost
		var qrNegativeCacheEnabledByhost bool

		if o.NegativeCacheEnabledByhostQueryParameter != nil {
			qrNegativeCacheEnabledByhost = *o.NegativeCacheEnabledByhostQueryParameter
		}
		qNegativeCacheEnabledByhost := swag.FormatBool(qrNegativeCacheEnabledByhost)
		if qNegativeCacheEnabledByhost != "" {

			if err := r.SetQueryParam("negative_cache_enabled_byhost", qNegativeCacheEnabledByhost); err != nil {
				return err
			}
		}
	}

	if o.NegativeTTLByhostQueryParameter != nil {

		// query param negative_ttl_byhost
		var qrNegativeTTLByhost string

		if o.NegativeTTLByhostQueryParameter != nil {
			qrNegativeTTLByhost = *o.NegativeTTLByhostQueryParameter
		}
		qNegativeTTLByhost := qrNegativeTTLByhost
		if qNegativeTTLByhost != "" {

			if err := r.SetQueryParam("negative_ttl_byhost", qNegativeTTLByhost); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if o.TTLByhostQueryParameter != nil {

		// query param ttl_byhost
		var qrTTLByhost string

		if o.TTLByhostQueryParameter != nil {
			qrTTLByhost = *o.TTLByhostQueryParameter
		}
		qTTLByhost := qrTTLByhost
		if qTTLByhost != "" {

			if err := r.SetQueryParam("ttl_byhost", qTTLByhost); err != nil {
				return err
			}
		}
	}

	if o.TTLForMembersQueryParameter != nil {

		// query param ttl_for_members
		var qrTTLForMembers string

		if o.TTLForMembersQueryParameter != nil {
			qrTTLForMembers = *o.TTLForMembersQueryParameter
		}
		qTTLForMembers := qrTTLForMembers
		if qTTLForMembers != "" {

			if err := r.SetQueryParam("ttl_for_members", qTTLForMembers); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamNetgroupsSettingsGet binds the parameter fields
func (o *NetgroupsSettingsGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamNetgroupsSettingsGet binds the parameter order_by
func (o *NetgroupsSettingsGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
