// Code generated by go-swagger; DO NOT EDIT.

package name_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewUnixUserCollectionGetParams creates a new UnixUserCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUnixUserCollectionGetParams() *UnixUserCollectionGetParams {
	return &UnixUserCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUnixUserCollectionGetParamsWithTimeout creates a new UnixUserCollectionGetParams object
// with the ability to set a timeout on a request.
func NewUnixUserCollectionGetParamsWithTimeout(timeout time.Duration) *UnixUserCollectionGetParams {
	return &UnixUserCollectionGetParams{
		timeout: timeout,
	}
}

// NewUnixUserCollectionGetParamsWithContext creates a new UnixUserCollectionGetParams object
// with the ability to set a context for a request.
func NewUnixUserCollectionGetParamsWithContext(ctx context.Context) *UnixUserCollectionGetParams {
	return &UnixUserCollectionGetParams{
		Context: ctx,
	}
}

// NewUnixUserCollectionGetParamsWithHTTPClient creates a new UnixUserCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewUnixUserCollectionGetParamsWithHTTPClient(client *http.Client) *UnixUserCollectionGetParams {
	return &UnixUserCollectionGetParams{
		HTTPClient: client,
	}
}

/*
UnixUserCollectionGetParams contains all the parameters to send to the API endpoint

	for the unix user collection get operation.

	Typically these are written to a http.Request.
*/
type UnixUserCollectionGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* FullName.

	   Filter by full_name
	*/
	FullNameQueryParameter *string

	/* ID.

	   Filter by id
	*/
	IDQueryParameter *int64

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* PrimaryGid.

	   Filter by primary_gid
	*/
	PrimaryGIDQueryParameter *int64

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the unix user collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UnixUserCollectionGetParams) WithDefaults() *UnixUserCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the unix user collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UnixUserCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := UnixUserCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the unix user collection get params
func (o *UnixUserCollectionGetParams) WithTimeout(timeout time.Duration) *UnixUserCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the unix user collection get params
func (o *UnixUserCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the unix user collection get params
func (o *UnixUserCollectionGetParams) WithContext(ctx context.Context) *UnixUserCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the unix user collection get params
func (o *UnixUserCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the unix user collection get params
func (o *UnixUserCollectionGetParams) WithHTTPClient(client *http.Client) *UnixUserCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the unix user collection get params
func (o *UnixUserCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the unix user collection get params
func (o *UnixUserCollectionGetParams) WithFieldsQueryParameter(fields []string) *UnixUserCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the unix user collection get params
func (o *UnixUserCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithFullNameQueryParameter adds the fullName to the unix user collection get params
func (o *UnixUserCollectionGetParams) WithFullNameQueryParameter(fullName *string) *UnixUserCollectionGetParams {
	o.SetFullNameQueryParameter(fullName)
	return o
}

// SetFullNameQueryParameter adds the fullName to the unix user collection get params
func (o *UnixUserCollectionGetParams) SetFullNameQueryParameter(fullName *string) {
	o.FullNameQueryParameter = fullName
}

// WithIDQueryParameter adds the id to the unix user collection get params
func (o *UnixUserCollectionGetParams) WithIDQueryParameter(id *int64) *UnixUserCollectionGetParams {
	o.SetIDQueryParameter(id)
	return o
}

// SetIDQueryParameter adds the id to the unix user collection get params
func (o *UnixUserCollectionGetParams) SetIDQueryParameter(id *int64) {
	o.IDQueryParameter = id
}

// WithMaxRecordsQueryParameter adds the maxRecords to the unix user collection get params
func (o *UnixUserCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *UnixUserCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the unix user collection get params
func (o *UnixUserCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the unix user collection get params
func (o *UnixUserCollectionGetParams) WithNameQueryParameter(name *string) *UnixUserCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the unix user collection get params
func (o *UnixUserCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the unix user collection get params
func (o *UnixUserCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *UnixUserCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the unix user collection get params
func (o *UnixUserCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithPrimaryGIDQueryParameter adds the primaryGid to the unix user collection get params
func (o *UnixUserCollectionGetParams) WithPrimaryGIDQueryParameter(primaryGid *int64) *UnixUserCollectionGetParams {
	o.SetPrimaryGIDQueryParameter(primaryGid)
	return o
}

// SetPrimaryGIDQueryParameter adds the primaryGid to the unix user collection get params
func (o *UnixUserCollectionGetParams) SetPrimaryGIDQueryParameter(primaryGid *int64) {
	o.PrimaryGIDQueryParameter = primaryGid
}

// WithReturnRecordsQueryParameter adds the returnRecords to the unix user collection get params
func (o *UnixUserCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *UnixUserCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the unix user collection get params
func (o *UnixUserCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the unix user collection get params
func (o *UnixUserCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *UnixUserCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the unix user collection get params
func (o *UnixUserCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSVMNameQueryParameter adds the svmName to the unix user collection get params
func (o *UnixUserCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *UnixUserCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the unix user collection get params
func (o *UnixUserCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the unix user collection get params
func (o *UnixUserCollectionGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *UnixUserCollectionGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the unix user collection get params
func (o *UnixUserCollectionGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *UnixUserCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.FullNameQueryParameter != nil {

		// query param full_name
		var qrFullName string

		if o.FullNameQueryParameter != nil {
			qrFullName = *o.FullNameQueryParameter
		}
		qFullName := qrFullName
		if qFullName != "" {

			if err := r.SetQueryParam("full_name", qFullName); err != nil {
				return err
			}
		}
	}

	if o.IDQueryParameter != nil {

		// query param id
		var qrID int64

		if o.IDQueryParameter != nil {
			qrID = *o.IDQueryParameter
		}
		qID := swag.FormatInt64(qrID)
		if qID != "" {

			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PrimaryGIDQueryParameter != nil {

		// query param primary_gid
		var qrPrimaryGid int64

		if o.PrimaryGIDQueryParameter != nil {
			qrPrimaryGid = *o.PrimaryGIDQueryParameter
		}
		qPrimaryGid := swag.FormatInt64(qrPrimaryGid)
		if qPrimaryGid != "" {

			if err := r.SetQueryParam("primary_gid", qPrimaryGid); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamUnixUserCollectionGet binds the parameter fields
func (o *UnixUserCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamUnixUserCollectionGet binds the parameter order_by
func (o *UnixUserCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
