// Code generated by go-swagger; DO NOT EDIT.

package ndmp

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewNdmpSvmCollectionGetParams creates a new NdmpSvmCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNdmpSvmCollectionGetParams() *NdmpSvmCollectionGetParams {
	return &NdmpSvmCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNdmpSvmCollectionGetParamsWithTimeout creates a new NdmpSvmCollectionGetParams object
// with the ability to set a timeout on a request.
func NewNdmpSvmCollectionGetParamsWithTimeout(timeout time.Duration) *NdmpSvmCollectionGetParams {
	return &NdmpSvmCollectionGetParams{
		timeout: timeout,
	}
}

// NewNdmpSvmCollectionGetParamsWithContext creates a new NdmpSvmCollectionGetParams object
// with the ability to set a context for a request.
func NewNdmpSvmCollectionGetParamsWithContext(ctx context.Context) *NdmpSvmCollectionGetParams {
	return &NdmpSvmCollectionGetParams{
		Context: ctx,
	}
}

// NewNdmpSvmCollectionGetParamsWithHTTPClient creates a new NdmpSvmCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewNdmpSvmCollectionGetParamsWithHTTPClient(client *http.Client) *NdmpSvmCollectionGetParams {
	return &NdmpSvmCollectionGetParams{
		HTTPClient: client,
	}
}

/*
NdmpSvmCollectionGetParams contains all the parameters to send to the API endpoint

	for the ndmp svm collection get operation.

	Typically these are written to a http.Request.
*/
type NdmpSvmCollectionGetParams struct {

	/* AuthenticationTypes.

	   Filter by authentication_types
	*/
	AuthenticationTypesQueryParameter *string

	/* Enabled.

	   Filter by enabled
	*/
	EnabledQueryParameter *bool

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ndmp svm collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NdmpSvmCollectionGetParams) WithDefaults() *NdmpSvmCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ndmp svm collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NdmpSvmCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := NdmpSvmCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) WithTimeout(timeout time.Duration) *NdmpSvmCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) WithContext(ctx context.Context) *NdmpSvmCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) WithHTTPClient(client *http.Client) *NdmpSvmCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAuthenticationTypesQueryParameter adds the authenticationTypes to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) WithAuthenticationTypesQueryParameter(authenticationTypes *string) *NdmpSvmCollectionGetParams {
	o.SetAuthenticationTypesQueryParameter(authenticationTypes)
	return o
}

// SetAuthenticationTypesQueryParameter adds the authenticationTypes to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) SetAuthenticationTypesQueryParameter(authenticationTypes *string) {
	o.AuthenticationTypesQueryParameter = authenticationTypes
}

// WithEnabledQueryParameter adds the enabled to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) WithEnabledQueryParameter(enabled *bool) *NdmpSvmCollectionGetParams {
	o.SetEnabledQueryParameter(enabled)
	return o
}

// SetEnabledQueryParameter adds the enabled to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) SetEnabledQueryParameter(enabled *bool) {
	o.EnabledQueryParameter = enabled
}

// WithFieldsQueryParameter adds the fields to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) WithFieldsQueryParameter(fields []string) *NdmpSvmCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *NdmpSvmCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *NdmpSvmCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *NdmpSvmCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *NdmpSvmCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSVMNameQueryParameter adds the svmName to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *NdmpSvmCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *NdmpSvmCollectionGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the ndmp svm collection get params
func (o *NdmpSvmCollectionGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *NdmpSvmCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AuthenticationTypesQueryParameter != nil {

		// query param authentication_types
		var qrAuthenticationTypes string

		if o.AuthenticationTypesQueryParameter != nil {
			qrAuthenticationTypes = *o.AuthenticationTypesQueryParameter
		}
		qAuthenticationTypes := qrAuthenticationTypes
		if qAuthenticationTypes != "" {

			if err := r.SetQueryParam("authentication_types", qAuthenticationTypes); err != nil {
				return err
			}
		}
	}

	if o.EnabledQueryParameter != nil {

		// query param enabled
		var qrEnabled bool

		if o.EnabledQueryParameter != nil {
			qrEnabled = *o.EnabledQueryParameter
		}
		qEnabled := swag.FormatBool(qrEnabled)
		if qEnabled != "" {

			if err := r.SetQueryParam("enabled", qEnabled); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamNdmpSvmCollectionGet binds the parameter fields
func (o *NdmpSvmCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamNdmpSvmCollectionGet binds the parameter order_by
func (o *NdmpSvmCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
