// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewFcInterfaceModifyParams creates a new FcInterfaceModifyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewFcInterfaceModifyParams() *FcInterfaceModifyParams {
	return &FcInterfaceModifyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewFcInterfaceModifyParamsWithTimeout creates a new FcInterfaceModifyParams object
// with the ability to set a timeout on a request.
func NewFcInterfaceModifyParamsWithTimeout(timeout time.Duration) *FcInterfaceModifyParams {
	return &FcInterfaceModifyParams{
		timeout: timeout,
	}
}

// NewFcInterfaceModifyParamsWithContext creates a new FcInterfaceModifyParams object
// with the ability to set a context for a request.
func NewFcInterfaceModifyParamsWithContext(ctx context.Context) *FcInterfaceModifyParams {
	return &FcInterfaceModifyParams{
		Context: ctx,
	}
}

// NewFcInterfaceModifyParamsWithHTTPClient creates a new FcInterfaceModifyParams object
// with the ability to set a custom HTTPClient for a request.
func NewFcInterfaceModifyParamsWithHTTPClient(client *http.Client) *FcInterfaceModifyParams {
	return &FcInterfaceModifyParams{
		HTTPClient: client,
	}
}

/*
FcInterfaceModifyParams contains all the parameters to send to the API endpoint

	for the fc interface modify operation.

	Typically these are written to a http.Request.
*/
type FcInterfaceModifyParams struct {

	/* Info.

	   The new property values for the FC interface.

	*/
	Info *models.FcInterface

	/* UUID.

	   The unique identifier for the FC interface.

	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the fc interface modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FcInterfaceModifyParams) WithDefaults() *FcInterfaceModifyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the fc interface modify params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FcInterfaceModifyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the fc interface modify params
func (o *FcInterfaceModifyParams) WithTimeout(timeout time.Duration) *FcInterfaceModifyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the fc interface modify params
func (o *FcInterfaceModifyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the fc interface modify params
func (o *FcInterfaceModifyParams) WithContext(ctx context.Context) *FcInterfaceModifyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the fc interface modify params
func (o *FcInterfaceModifyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the fc interface modify params
func (o *FcInterfaceModifyParams) WithHTTPClient(client *http.Client) *FcInterfaceModifyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the fc interface modify params
func (o *FcInterfaceModifyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the fc interface modify params
func (o *FcInterfaceModifyParams) WithInfo(info *models.FcInterface) *FcInterfaceModifyParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the fc interface modify params
func (o *FcInterfaceModifyParams) SetInfo(info *models.FcInterface) {
	o.Info = info
}

// WithUUIDPathParameter adds the uuid to the fc interface modify params
func (o *FcInterfaceModifyParams) WithUUIDPathParameter(uuid string) *FcInterfaceModifyParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the fc interface modify params
func (o *FcInterfaceModifyParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *FcInterfaceModifyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
