// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewFcSwitchCollectionGetParams creates a new FcSwitchCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewFcSwitchCollectionGetParams() *FcSwitchCollectionGetParams {
	return &FcSwitchCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewFcSwitchCollectionGetParamsWithTimeout creates a new FcSwitchCollectionGetParams object
// with the ability to set a timeout on a request.
func NewFcSwitchCollectionGetParamsWithTimeout(timeout time.Duration) *FcSwitchCollectionGetParams {
	return &FcSwitchCollectionGetParams{
		timeout: timeout,
	}
}

// NewFcSwitchCollectionGetParamsWithContext creates a new FcSwitchCollectionGetParams object
// with the ability to set a context for a request.
func NewFcSwitchCollectionGetParamsWithContext(ctx context.Context) *FcSwitchCollectionGetParams {
	return &FcSwitchCollectionGetParams{
		Context: ctx,
	}
}

// NewFcSwitchCollectionGetParamsWithHTTPClient creates a new FcSwitchCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewFcSwitchCollectionGetParamsWithHTTPClient(client *http.Client) *FcSwitchCollectionGetParams {
	return &FcSwitchCollectionGetParams{
		HTTPClient: client,
	}
}

/*
FcSwitchCollectionGetParams contains all the parameters to send to the API endpoint

	for the fc switch collection get operation.

	Typically these are written to a http.Request.
*/
type FcSwitchCollectionGetParams struct {

	/* CacheAge.

	   Filter by cache.age
	*/
	CacheAgeQueryParameter *string

	/* CacheIsCurrent.

	   Filter by cache.is_current
	*/
	CacheIsCurrentQueryParameter *bool

	/* CacheMaximumAge.

	   The maximum age of data in the Fibre Channel fabric cache before it should be refreshed from the fabric. The default is 15 minutes.

	   Format: iso8601
	   Default: "15 minutes"
	*/
	CacheMaximumAgeQueryParameter *string

	/* CacheUpdateTime.

	   Filter by cache.update_time
	*/
	CacheUpdateTimeQueryParameter *string

	/* DomainID.

	   Filter by domain_id
	*/
	DomainIDQueryParameter *int64

	/* FabricName.

	   The WWN of the primary switch of the Fibre Channel fabric.

	*/
	FabricNamePathParameter string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* PortsAttachedDevicePortID.

	   Filter by ports.attached_device.port_id
	*/
	PortsAttachedDevicePortIDQueryParameter *string

	/* PortsAttachedDeviceWwpn.

	   Filter by ports.attached_device.wwpn
	*/
	PortsAttachedDeviceWwpnQueryParameter *string

	/* PortsSlot.

	   Filter by ports.slot
	*/
	PortsSlotQueryParameter *string

	/* PortsState.

	   Filter by ports.state
	*/
	PortsStateQueryParameter *string

	/* PortsType.

	   Filter by ports.type
	*/
	PortsTypeQueryParameter *string

	/* PortsWwpn.

	   Filter by ports.wwpn
	*/
	PortsWwpnQueryParameter *string

	/* Release.

	   Filter by release
	*/
	ReleaseQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* Vendor.

	   Filter by vendor
	*/
	VendorQueryParameter *string

	/* Wwn.

	   Filter by wwn
	*/
	WwnQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the fc switch collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FcSwitchCollectionGetParams) WithDefaults() *FcSwitchCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the fc switch collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FcSwitchCollectionGetParams) SetDefaults() {
	var (
		cacheMaximumAgeQueryParameterDefault = string("15 minutes")

		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := FcSwitchCollectionGetParams{
		CacheMaximumAgeQueryParameter: &cacheMaximumAgeQueryParameterDefault,
		ReturnRecordsQueryParameter:   &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter:   &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithTimeout(timeout time.Duration) *FcSwitchCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithContext(ctx context.Context) *FcSwitchCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithHTTPClient(client *http.Client) *FcSwitchCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCacheAgeQueryParameter adds the cacheAge to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithCacheAgeQueryParameter(cacheAge *string) *FcSwitchCollectionGetParams {
	o.SetCacheAgeQueryParameter(cacheAge)
	return o
}

// SetCacheAgeQueryParameter adds the cacheAge to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetCacheAgeQueryParameter(cacheAge *string) {
	o.CacheAgeQueryParameter = cacheAge
}

// WithCacheIsCurrentQueryParameter adds the cacheIsCurrent to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithCacheIsCurrentQueryParameter(cacheIsCurrent *bool) *FcSwitchCollectionGetParams {
	o.SetCacheIsCurrentQueryParameter(cacheIsCurrent)
	return o
}

// SetCacheIsCurrentQueryParameter adds the cacheIsCurrent to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetCacheIsCurrentQueryParameter(cacheIsCurrent *bool) {
	o.CacheIsCurrentQueryParameter = cacheIsCurrent
}

// WithCacheMaximumAgeQueryParameter adds the cacheMaximumAge to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithCacheMaximumAgeQueryParameter(cacheMaximumAge *string) *FcSwitchCollectionGetParams {
	o.SetCacheMaximumAgeQueryParameter(cacheMaximumAge)
	return o
}

// SetCacheMaximumAgeQueryParameter adds the cacheMaximumAge to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetCacheMaximumAgeQueryParameter(cacheMaximumAge *string) {
	o.CacheMaximumAgeQueryParameter = cacheMaximumAge
}

// WithCacheUpdateTimeQueryParameter adds the cacheUpdateTime to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithCacheUpdateTimeQueryParameter(cacheUpdateTime *string) *FcSwitchCollectionGetParams {
	o.SetCacheUpdateTimeQueryParameter(cacheUpdateTime)
	return o
}

// SetCacheUpdateTimeQueryParameter adds the cacheUpdateTime to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetCacheUpdateTimeQueryParameter(cacheUpdateTime *string) {
	o.CacheUpdateTimeQueryParameter = cacheUpdateTime
}

// WithDomainIDQueryParameter adds the domainID to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithDomainIDQueryParameter(domainID *int64) *FcSwitchCollectionGetParams {
	o.SetDomainIDQueryParameter(domainID)
	return o
}

// SetDomainIDQueryParameter adds the domainId to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetDomainIDQueryParameter(domainID *int64) {
	o.DomainIDQueryParameter = domainID
}

// WithFabricNamePathParameter adds the fabricName to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithFabricNamePathParameter(fabricName string) *FcSwitchCollectionGetParams {
	o.SetFabricNamePathParameter(fabricName)
	return o
}

// SetFabricNamePathParameter adds the fabricName to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetFabricNamePathParameter(fabricName string) {
	o.FabricNamePathParameter = fabricName
}

// WithFieldsQueryParameter adds the fields to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithFieldsQueryParameter(fields []string) *FcSwitchCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *FcSwitchCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithNameQueryParameter(name *string) *FcSwitchCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *FcSwitchCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithPortsAttachedDevicePortIDQueryParameter adds the portsAttachedDevicePortID to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithPortsAttachedDevicePortIDQueryParameter(portsAttachedDevicePortID *string) *FcSwitchCollectionGetParams {
	o.SetPortsAttachedDevicePortIDQueryParameter(portsAttachedDevicePortID)
	return o
}

// SetPortsAttachedDevicePortIDQueryParameter adds the portsAttachedDevicePortId to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetPortsAttachedDevicePortIDQueryParameter(portsAttachedDevicePortID *string) {
	o.PortsAttachedDevicePortIDQueryParameter = portsAttachedDevicePortID
}

// WithPortsAttachedDeviceWwpnQueryParameter adds the portsAttachedDeviceWwpn to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithPortsAttachedDeviceWwpnQueryParameter(portsAttachedDeviceWwpn *string) *FcSwitchCollectionGetParams {
	o.SetPortsAttachedDeviceWwpnQueryParameter(portsAttachedDeviceWwpn)
	return o
}

// SetPortsAttachedDeviceWwpnQueryParameter adds the portsAttachedDeviceWwpn to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetPortsAttachedDeviceWwpnQueryParameter(portsAttachedDeviceWwpn *string) {
	o.PortsAttachedDeviceWwpnQueryParameter = portsAttachedDeviceWwpn
}

// WithPortsSlotQueryParameter adds the portsSlot to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithPortsSlotQueryParameter(portsSlot *string) *FcSwitchCollectionGetParams {
	o.SetPortsSlotQueryParameter(portsSlot)
	return o
}

// SetPortsSlotQueryParameter adds the portsSlot to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetPortsSlotQueryParameter(portsSlot *string) {
	o.PortsSlotQueryParameter = portsSlot
}

// WithPortsStateQueryParameter adds the portsState to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithPortsStateQueryParameter(portsState *string) *FcSwitchCollectionGetParams {
	o.SetPortsStateQueryParameter(portsState)
	return o
}

// SetPortsStateQueryParameter adds the portsState to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetPortsStateQueryParameter(portsState *string) {
	o.PortsStateQueryParameter = portsState
}

// WithPortsTypeQueryParameter adds the portsType to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithPortsTypeQueryParameter(portsType *string) *FcSwitchCollectionGetParams {
	o.SetPortsTypeQueryParameter(portsType)
	return o
}

// SetPortsTypeQueryParameter adds the portsType to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetPortsTypeQueryParameter(portsType *string) {
	o.PortsTypeQueryParameter = portsType
}

// WithPortsWwpnQueryParameter adds the portsWwpn to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithPortsWwpnQueryParameter(portsWwpn *string) *FcSwitchCollectionGetParams {
	o.SetPortsWwpnQueryParameter(portsWwpn)
	return o
}

// SetPortsWwpnQueryParameter adds the portsWwpn to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetPortsWwpnQueryParameter(portsWwpn *string) {
	o.PortsWwpnQueryParameter = portsWwpn
}

// WithReleaseQueryParameter adds the release to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithReleaseQueryParameter(release *string) *FcSwitchCollectionGetParams {
	o.SetReleaseQueryParameter(release)
	return o
}

// SetReleaseQueryParameter adds the release to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetReleaseQueryParameter(release *string) {
	o.ReleaseQueryParameter = release
}

// WithReturnRecordsQueryParameter adds the returnRecords to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *FcSwitchCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *FcSwitchCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithVendorQueryParameter adds the vendor to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithVendorQueryParameter(vendor *string) *FcSwitchCollectionGetParams {
	o.SetVendorQueryParameter(vendor)
	return o
}

// SetVendorQueryParameter adds the vendor to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetVendorQueryParameter(vendor *string) {
	o.VendorQueryParameter = vendor
}

// WithWwnQueryParameter adds the wwn to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) WithWwnQueryParameter(wwn *string) *FcSwitchCollectionGetParams {
	o.SetWwnQueryParameter(wwn)
	return o
}

// SetWwnQueryParameter adds the wwn to the fc switch collection get params
func (o *FcSwitchCollectionGetParams) SetWwnQueryParameter(wwn *string) {
	o.WwnQueryParameter = wwn
}

// WriteToRequest writes these params to a swagger request
func (o *FcSwitchCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CacheAgeQueryParameter != nil {

		// query param cache.age
		var qrCacheAge string

		if o.CacheAgeQueryParameter != nil {
			qrCacheAge = *o.CacheAgeQueryParameter
		}
		qCacheAge := qrCacheAge
		if qCacheAge != "" {

			if err := r.SetQueryParam("cache.age", qCacheAge); err != nil {
				return err
			}
		}
	}

	if o.CacheIsCurrentQueryParameter != nil {

		// query param cache.is_current
		var qrCacheIsCurrent bool

		if o.CacheIsCurrentQueryParameter != nil {
			qrCacheIsCurrent = *o.CacheIsCurrentQueryParameter
		}
		qCacheIsCurrent := swag.FormatBool(qrCacheIsCurrent)
		if qCacheIsCurrent != "" {

			if err := r.SetQueryParam("cache.is_current", qCacheIsCurrent); err != nil {
				return err
			}
		}
	}

	if o.CacheMaximumAgeQueryParameter != nil {

		// query param cache.maximum_age
		var qrCacheMaximumAge string

		if o.CacheMaximumAgeQueryParameter != nil {
			qrCacheMaximumAge = *o.CacheMaximumAgeQueryParameter
		}
		qCacheMaximumAge := qrCacheMaximumAge
		if qCacheMaximumAge != "" {

			if err := r.SetQueryParam("cache.maximum_age", qCacheMaximumAge); err != nil {
				return err
			}
		}
	}

	if o.CacheUpdateTimeQueryParameter != nil {

		// query param cache.update_time
		var qrCacheUpdateTime string

		if o.CacheUpdateTimeQueryParameter != nil {
			qrCacheUpdateTime = *o.CacheUpdateTimeQueryParameter
		}
		qCacheUpdateTime := qrCacheUpdateTime
		if qCacheUpdateTime != "" {

			if err := r.SetQueryParam("cache.update_time", qCacheUpdateTime); err != nil {
				return err
			}
		}
	}

	if o.DomainIDQueryParameter != nil {

		// query param domain_id
		var qrDomainID int64

		if o.DomainIDQueryParameter != nil {
			qrDomainID = *o.DomainIDQueryParameter
		}
		qDomainID := swag.FormatInt64(qrDomainID)
		if qDomainID != "" {

			if err := r.SetQueryParam("domain_id", qDomainID); err != nil {
				return err
			}
		}
	}

	// path param fabric.name
	if err := r.SetPathParam("fabric.name", o.FabricNamePathParameter); err != nil {
		return err
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PortsAttachedDevicePortIDQueryParameter != nil {

		// query param ports.attached_device.port_id
		var qrPortsAttachedDevicePortID string

		if o.PortsAttachedDevicePortIDQueryParameter != nil {
			qrPortsAttachedDevicePortID = *o.PortsAttachedDevicePortIDQueryParameter
		}
		qPortsAttachedDevicePortID := qrPortsAttachedDevicePortID
		if qPortsAttachedDevicePortID != "" {

			if err := r.SetQueryParam("ports.attached_device.port_id", qPortsAttachedDevicePortID); err != nil {
				return err
			}
		}
	}

	if o.PortsAttachedDeviceWwpnQueryParameter != nil {

		// query param ports.attached_device.wwpn
		var qrPortsAttachedDeviceWwpn string

		if o.PortsAttachedDeviceWwpnQueryParameter != nil {
			qrPortsAttachedDeviceWwpn = *o.PortsAttachedDeviceWwpnQueryParameter
		}
		qPortsAttachedDeviceWwpn := qrPortsAttachedDeviceWwpn
		if qPortsAttachedDeviceWwpn != "" {

			if err := r.SetQueryParam("ports.attached_device.wwpn", qPortsAttachedDeviceWwpn); err != nil {
				return err
			}
		}
	}

	if o.PortsSlotQueryParameter != nil {

		// query param ports.slot
		var qrPortsSlot string

		if o.PortsSlotQueryParameter != nil {
			qrPortsSlot = *o.PortsSlotQueryParameter
		}
		qPortsSlot := qrPortsSlot
		if qPortsSlot != "" {

			if err := r.SetQueryParam("ports.slot", qPortsSlot); err != nil {
				return err
			}
		}
	}

	if o.PortsStateQueryParameter != nil {

		// query param ports.state
		var qrPortsState string

		if o.PortsStateQueryParameter != nil {
			qrPortsState = *o.PortsStateQueryParameter
		}
		qPortsState := qrPortsState
		if qPortsState != "" {

			if err := r.SetQueryParam("ports.state", qPortsState); err != nil {
				return err
			}
		}
	}

	if o.PortsTypeQueryParameter != nil {

		// query param ports.type
		var qrPortsType string

		if o.PortsTypeQueryParameter != nil {
			qrPortsType = *o.PortsTypeQueryParameter
		}
		qPortsType := qrPortsType
		if qPortsType != "" {

			if err := r.SetQueryParam("ports.type", qPortsType); err != nil {
				return err
			}
		}
	}

	if o.PortsWwpnQueryParameter != nil {

		// query param ports.wwpn
		var qrPortsWwpn string

		if o.PortsWwpnQueryParameter != nil {
			qrPortsWwpn = *o.PortsWwpnQueryParameter
		}
		qPortsWwpn := qrPortsWwpn
		if qPortsWwpn != "" {

			if err := r.SetQueryParam("ports.wwpn", qPortsWwpn); err != nil {
				return err
			}
		}
	}

	if o.ReleaseQueryParameter != nil {

		// query param release
		var qrRelease string

		if o.ReleaseQueryParameter != nil {
			qrRelease = *o.ReleaseQueryParameter
		}
		qRelease := qrRelease
		if qRelease != "" {

			if err := r.SetQueryParam("release", qRelease); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.VendorQueryParameter != nil {

		// query param vendor
		var qrVendor string

		if o.VendorQueryParameter != nil {
			qrVendor = *o.VendorQueryParameter
		}
		qVendor := qrVendor
		if qVendor != "" {

			if err := r.SetQueryParam("vendor", qVendor); err != nil {
				return err
			}
		}
	}

	if o.WwnQueryParameter != nil {

		// query param wwn
		var qrWwn string

		if o.WwnQueryParameter != nil {
			qrWwn = *o.WwnQueryParameter
		}
		qWwn := qrWwn
		if qWwn != "" {

			if err := r.SetQueryParam("wwn", qWwn); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamFcSwitchCollectionGet binds the parameter fields
func (o *FcSwitchCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamFcSwitchCollectionGet binds the parameter order_by
func (o *FcSwitchCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
