// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewIPServicePolicyDeleteParams creates a new IPServicePolicyDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIPServicePolicyDeleteParams() *IPServicePolicyDeleteParams {
	return &IPServicePolicyDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIPServicePolicyDeleteParamsWithTimeout creates a new IPServicePolicyDeleteParams object
// with the ability to set a timeout on a request.
func NewIPServicePolicyDeleteParamsWithTimeout(timeout time.Duration) *IPServicePolicyDeleteParams {
	return &IPServicePolicyDeleteParams{
		timeout: timeout,
	}
}

// NewIPServicePolicyDeleteParamsWithContext creates a new IPServicePolicyDeleteParams object
// with the ability to set a context for a request.
func NewIPServicePolicyDeleteParamsWithContext(ctx context.Context) *IPServicePolicyDeleteParams {
	return &IPServicePolicyDeleteParams{
		Context: ctx,
	}
}

// NewIPServicePolicyDeleteParamsWithHTTPClient creates a new IPServicePolicyDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewIPServicePolicyDeleteParamsWithHTTPClient(client *http.Client) *IPServicePolicyDeleteParams {
	return &IPServicePolicyDeleteParams{
		HTTPClient: client,
	}
}

/*
IPServicePolicyDeleteParams contains all the parameters to send to the API endpoint

	for the ip service policy delete operation.

	Typically these are written to a http.Request.
*/
type IPServicePolicyDeleteParams struct {

	/* UUID.

	   UUID of the service policy
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ip service policy delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IPServicePolicyDeleteParams) WithDefaults() *IPServicePolicyDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ip service policy delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IPServicePolicyDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the ip service policy delete params
func (o *IPServicePolicyDeleteParams) WithTimeout(timeout time.Duration) *IPServicePolicyDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ip service policy delete params
func (o *IPServicePolicyDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ip service policy delete params
func (o *IPServicePolicyDeleteParams) WithContext(ctx context.Context) *IPServicePolicyDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ip service policy delete params
func (o *IPServicePolicyDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ip service policy delete params
func (o *IPServicePolicyDeleteParams) WithHTTPClient(client *http.Client) *IPServicePolicyDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ip service policy delete params
func (o *IPServicePolicyDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUUIDPathParameter adds the uuid to the ip service policy delete params
func (o *IPServicePolicyDeleteParams) WithUUIDPathParameter(uuid string) *IPServicePolicyDeleteParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the ip service policy delete params
func (o *IPServicePolicyDeleteParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *IPServicePolicyDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
