// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewIpspaceDeleteParams creates a new IpspaceDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIpspaceDeleteParams() *IpspaceDeleteParams {
	return &IpspaceDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIpspaceDeleteParamsWithTimeout creates a new IpspaceDeleteParams object
// with the ability to set a timeout on a request.
func NewIpspaceDeleteParamsWithTimeout(timeout time.Duration) *IpspaceDeleteParams {
	return &IpspaceDeleteParams{
		timeout: timeout,
	}
}

// NewIpspaceDeleteParamsWithContext creates a new IpspaceDeleteParams object
// with the ability to set a context for a request.
func NewIpspaceDeleteParamsWithContext(ctx context.Context) *IpspaceDeleteParams {
	return &IpspaceDeleteParams{
		Context: ctx,
	}
}

// NewIpspaceDeleteParamsWithHTTPClient creates a new IpspaceDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewIpspaceDeleteParamsWithHTTPClient(client *http.Client) *IpspaceDeleteParams {
	return &IpspaceDeleteParams{
		HTTPClient: client,
	}
}

/*
IpspaceDeleteParams contains all the parameters to send to the API endpoint

	for the ipspace delete operation.

	Typically these are written to a http.Request.
*/
type IpspaceDeleteParams struct {

	/* UUID.

	   IPspace UUID
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ipspace delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpspaceDeleteParams) WithDefaults() *IpspaceDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ipspace delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpspaceDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the ipspace delete params
func (o *IpspaceDeleteParams) WithTimeout(timeout time.Duration) *IpspaceDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ipspace delete params
func (o *IpspaceDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ipspace delete params
func (o *IpspaceDeleteParams) WithContext(ctx context.Context) *IpspaceDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ipspace delete params
func (o *IpspaceDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ipspace delete params
func (o *IpspaceDeleteParams) WithHTTPClient(client *http.Client) *IpspaceDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ipspace delete params
func (o *IpspaceDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUUIDPathParameter adds the uuid to the ipspace delete params
func (o *IpspaceDeleteParams) WithUUIDPathParameter(uuid string) *IpspaceDeleteParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the ipspace delete params
func (o *IpspaceDeleteParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *IpspaceDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
