// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewNetworkEthernetBroadcastDomainGetParams creates a new NetworkEthernetBroadcastDomainGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewNetworkEthernetBroadcastDomainGetParams() *NetworkEthernetBroadcastDomainGetParams {
	return &NetworkEthernetBroadcastDomainGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewNetworkEthernetBroadcastDomainGetParamsWithTimeout creates a new NetworkEthernetBroadcastDomainGetParams object
// with the ability to set a timeout on a request.
func NewNetworkEthernetBroadcastDomainGetParamsWithTimeout(timeout time.Duration) *NetworkEthernetBroadcastDomainGetParams {
	return &NetworkEthernetBroadcastDomainGetParams{
		timeout: timeout,
	}
}

// NewNetworkEthernetBroadcastDomainGetParamsWithContext creates a new NetworkEthernetBroadcastDomainGetParams object
// with the ability to set a context for a request.
func NewNetworkEthernetBroadcastDomainGetParamsWithContext(ctx context.Context) *NetworkEthernetBroadcastDomainGetParams {
	return &NetworkEthernetBroadcastDomainGetParams{
		Context: ctx,
	}
}

// NewNetworkEthernetBroadcastDomainGetParamsWithHTTPClient creates a new NetworkEthernetBroadcastDomainGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewNetworkEthernetBroadcastDomainGetParamsWithHTTPClient(client *http.Client) *NetworkEthernetBroadcastDomainGetParams {
	return &NetworkEthernetBroadcastDomainGetParams{
		HTTPClient: client,
	}
}

/*
NetworkEthernetBroadcastDomainGetParams contains all the parameters to send to the API endpoint

	for the network ethernet broadcast domain get operation.

	Typically these are written to a http.Request.
*/
type NetworkEthernetBroadcastDomainGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* UUID.

	   Broadcast domain UUID
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the network ethernet broadcast domain get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetworkEthernetBroadcastDomainGetParams) WithDefaults() *NetworkEthernetBroadcastDomainGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the network ethernet broadcast domain get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *NetworkEthernetBroadcastDomainGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the network ethernet broadcast domain get params
func (o *NetworkEthernetBroadcastDomainGetParams) WithTimeout(timeout time.Duration) *NetworkEthernetBroadcastDomainGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the network ethernet broadcast domain get params
func (o *NetworkEthernetBroadcastDomainGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the network ethernet broadcast domain get params
func (o *NetworkEthernetBroadcastDomainGetParams) WithContext(ctx context.Context) *NetworkEthernetBroadcastDomainGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the network ethernet broadcast domain get params
func (o *NetworkEthernetBroadcastDomainGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the network ethernet broadcast domain get params
func (o *NetworkEthernetBroadcastDomainGetParams) WithHTTPClient(client *http.Client) *NetworkEthernetBroadcastDomainGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the network ethernet broadcast domain get params
func (o *NetworkEthernetBroadcastDomainGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the network ethernet broadcast domain get params
func (o *NetworkEthernetBroadcastDomainGetParams) WithFieldsQueryParameter(fields []string) *NetworkEthernetBroadcastDomainGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the network ethernet broadcast domain get params
func (o *NetworkEthernetBroadcastDomainGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithUUIDPathParameter adds the uuid to the network ethernet broadcast domain get params
func (o *NetworkEthernetBroadcastDomainGetParams) WithUUIDPathParameter(uuid string) *NetworkEthernetBroadcastDomainGetParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the network ethernet broadcast domain get params
func (o *NetworkEthernetBroadcastDomainGetParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *NetworkEthernetBroadcastDomainGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamNetworkEthernetBroadcastDomainGet binds the parameter fields
func (o *NetworkEthernetBroadcastDomainGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
