// Code generated by go-swagger; DO NOT EDIT.

package networking

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// SwitchCreateReader is a Reader for the SwitchCreate structure.
type SwitchCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SwitchCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewSwitchCreateAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewSwitchCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewSwitchCreateAccepted creates a SwitchCreateAccepted with default headers values
func NewSwitchCreateAccepted() *SwitchCreateAccepted {
	return &SwitchCreateAccepted{}
}

/*
SwitchCreateAccepted describes a response with status code 202, with default header values.

Accepted
*/
type SwitchCreateAccepted struct {
	Payload *models.JobLinkResponse
}

// IsSuccess returns true when this switch create accepted response has a 2xx status code
func (o *SwitchCreateAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this switch create accepted response has a 3xx status code
func (o *SwitchCreateAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this switch create accepted response has a 4xx status code
func (o *SwitchCreateAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this switch create accepted response has a 5xx status code
func (o *SwitchCreateAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this switch create accepted response a status code equal to that given
func (o *SwitchCreateAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *SwitchCreateAccepted) Error() string {
	return fmt.Sprintf("[POST /network/ethernet/switches][%d] switchCreateAccepted  %+v", 202, o.Payload)
}

func (o *SwitchCreateAccepted) String() string {
	return fmt.Sprintf("[POST /network/ethernet/switches][%d] switchCreateAccepted  %+v", 202, o.Payload)
}

func (o *SwitchCreateAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *SwitchCreateAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSwitchCreateDefault creates a SwitchCreateDefault with default headers values
func NewSwitchCreateDefault(code int) *SwitchCreateDefault {
	return &SwitchCreateDefault{
		_statusCode: code,
	}
}

/*
	SwitchCreateDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

| Error Code | Description |
| ---------- | ----------- |
| 12517376 | Model number validation failed. Specify correct model number and try the command again. |
| 12517377 | IP address \"{address}\" is not reachable. Verify that the address is valid or check the network path. |
| 12517379 | SNMP validation request timed out. Verify that the \"snmp.user\" parameter is valid. |
| 12517381 | SNMP validation request timed out. Verify that the \"snmp.user\" parameter is valid (i.e., the SNMPv3 user exists in ONTAP and on the remote switch). If the \"snmp.user\" parameter is valid, verify that the SNMPv3 user's credentials are the same both in ONTAP as well as in the remote switch. If a custom engine-id was provided for the SNMPv3 user, ensure it is the same as that of the remote switch. |
| 12517383 | Switch type \"{network}\" is not valid for specified switch model \"{model}\". |
| 12517384 | SHM is already monitoring a switch with IP address \"{address}\". |
| 12517385 | Model \"{model}\" is unknown. Use \"OTHER\" if the switch model is not one of the following&#58; {models}. |
*/
type SwitchCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the switch create default response
func (o *SwitchCreateDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this switch create default response has a 2xx status code
func (o *SwitchCreateDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this switch create default response has a 3xx status code
func (o *SwitchCreateDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this switch create default response has a 4xx status code
func (o *SwitchCreateDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this switch create default response has a 5xx status code
func (o *SwitchCreateDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this switch create default response a status code equal to that given
func (o *SwitchCreateDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *SwitchCreateDefault) Error() string {
	return fmt.Sprintf("[POST /network/ethernet/switches][%d] switch_create default  %+v", o._statusCode, o.Payload)
}

func (o *SwitchCreateDefault) String() string {
	return fmt.Sprintf("[POST /network/ethernet/switches][%d] switch_create default  %+v", o._statusCode, o.Payload)
}

func (o *SwitchCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SwitchCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
