// Code generated by go-swagger; DO NOT EDIT.

package object_store

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// S3BucketSvmCreateReader is a Reader for the S3BucketSvmCreate structure.
type S3BucketSvmCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *S3BucketSvmCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewS3BucketSvmCreateAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewS3BucketSvmCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewS3BucketSvmCreateAccepted creates a S3BucketSvmCreateAccepted with default headers values
func NewS3BucketSvmCreateAccepted() *S3BucketSvmCreateAccepted {
	return &S3BucketSvmCreateAccepted{}
}

/*
S3BucketSvmCreateAccepted describes a response with status code 202, with default header values.

Accepted
*/
type S3BucketSvmCreateAccepted struct {
	Payload *models.JobLinkResponse
}

// IsSuccess returns true when this s3 bucket svm create accepted response has a 2xx status code
func (o *S3BucketSvmCreateAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this s3 bucket svm create accepted response has a 3xx status code
func (o *S3BucketSvmCreateAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this s3 bucket svm create accepted response has a 4xx status code
func (o *S3BucketSvmCreateAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this s3 bucket svm create accepted response has a 5xx status code
func (o *S3BucketSvmCreateAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this s3 bucket svm create accepted response a status code equal to that given
func (o *S3BucketSvmCreateAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *S3BucketSvmCreateAccepted) Error() string {
	return fmt.Sprintf("[POST /protocols/s3/services/{svm.uuid}/buckets][%d] s3BucketSvmCreateAccepted  %+v", 202, o.Payload)
}

func (o *S3BucketSvmCreateAccepted) String() string {
	return fmt.Sprintf("[POST /protocols/s3/services/{svm.uuid}/buckets][%d] s3BucketSvmCreateAccepted  %+v", 202, o.Payload)
}

func (o *S3BucketSvmCreateAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *S3BucketSvmCreateAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewS3BucketSvmCreateDefault creates a S3BucketSvmCreateDefault with default headers values
func NewS3BucketSvmCreateDefault(code int) *S3BucketSvmCreateDefault {
	return &S3BucketSvmCreateDefault{
		_statusCode: code,
	}
}

/*
	S3BucketSvmCreateDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

| Error code | Message |
| ---------- | ------- |
| 92405777   | "Failed to create bucket \\\"{bucket name}\\\" for SVM \\\"{svm.name}\\\". Reason: {Reason of failure}. ";
| 92405785   | "Bucket name \\\"{bucket name}\\\" contains invalid characters. Valid characters for a bucket name are 0-9, a-z, \\\".\\\", and \\\"-\\\". ";
| 92405786   | "Bucket name \\\"{bucket name}\\\" is not valid. Bucket names must have between 3 and 63 characters. ";
| 92405811   | "Failed to create bucket \\\"{bucket name}\\\" for SVM \\\"{svm.name}\\\". Wait a few minutes and try the operation again.";
| 92405812   | "Failed to create the object store volume. Reason: {Reason for failure}.";
| 92405819   | "Cannot provision an object store server volume for bucket \\\"{bucket name}\\\" in SVM \\\"{svm.name}\\\" on the following aggregates because they are SnapLock aggregates: {List of aggregates.name}.";
| 92405820   | "Failed to check whether the aggregate \\\"{aggregates.name}\\\" is a FabricPool. Reason: {Reason for failure}.";
| 92405821   | "Cannot provision an object store server volume for bucket \\\"{bucket name}\\\" in SVM \\\"{svm.name}\\\" on the following aggregates because they are FabricPool: {List of aggregates.name}.";
| 92405827   | "Internal Error. Unable to generate object store volume name.";
| 92405857   | "One or more aggregates must be specified if \\\"constituents_per_aggregate\\\" is specified.";
| 92405858   | "Failed to \\\"create\\\" the \\\"bucket\\\" because the operation is only supported on data SVMs.";
| 92405859   | "The specified \\\"aggregates.uuid\\\" \\\"{aggregates.uuid}\\\" does not exist.";
| 92405860   | "The specified \\\"aggregates.name\\\" \\\"{aggregates.name}\\\" and \\\"aggregates.uuid\\\" \\\"{aggregates.uuid}\\\" refer to different aggregates.";
| 92405861   | "The specified SVM UUID or bucket UUID does not exist.";
| 92405863   | "An error occurs when creating an access policy. The reason for failure is detailed in the error message.";
| 92405891   | "The resources specified in the access policy are not valid. Valid ways to specify a resource are \\\"*\\\", \\\"<bucket-name>\\\", \\\"<bucket-name>/.../...\\\". Valid characters for a resource are 0-9, A-Z, a-z, \\\"_\\\", \\\"+\\\", \\\",\\\", \\\";\\\", \\\":\\\", \\\";\\\", \\\"=\\\", \\\".\\\", \\\"&\\\", \\\"@\\\", \\\"?\\\", \\\"(\\\", \\\")\\\", \\\"'\\\", \\\"*\\\", \\\"!\\\", \\\"-\\\" and \\\"\\$\\\".";
| 92405894   | "Statements, principals and resources list can have a maximum of 10 entries.";
| 92405897   | "The principals specified in the access policy are not in the correct format. User name must be in between 1 and 64 characters. Valid characters for a user name are 0-9, A-Z, a-z, \\\"_\\\", \\\"+\\\", \\\"=\\\", \\\",\\\", \\\".\\\", \\\"@\\\", and \\\"-\\\". ";
| 92405898   | "The SID specified in the access policy is not valid. Valid characters for a SID are 0-9, A-Z and a-z.";
*/
type S3BucketSvmCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the s3 bucket svm create default response
func (o *S3BucketSvmCreateDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this s3 bucket svm create default response has a 2xx status code
func (o *S3BucketSvmCreateDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this s3 bucket svm create default response has a 3xx status code
func (o *S3BucketSvmCreateDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this s3 bucket svm create default response has a 4xx status code
func (o *S3BucketSvmCreateDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this s3 bucket svm create default response has a 5xx status code
func (o *S3BucketSvmCreateDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this s3 bucket svm create default response a status code equal to that given
func (o *S3BucketSvmCreateDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *S3BucketSvmCreateDefault) Error() string {
	return fmt.Sprintf("[POST /protocols/s3/services/{svm.uuid}/buckets][%d] s3_bucket_svm_create default  %+v", o._statusCode, o.Payload)
}

func (o *S3BucketSvmCreateDefault) String() string {
	return fmt.Sprintf("[POST /protocols/s3/services/{svm.uuid}/buckets][%d] s3_bucket_svm_create default  %+v", o._statusCode, o.Payload)
}

func (o *S3BucketSvmCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *S3BucketSvmCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
