// Code generated by go-swagger; DO NOT EDIT.

package object_store

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewS3PolicyCreateParams creates a new S3PolicyCreateParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewS3PolicyCreateParams() *S3PolicyCreateParams {
	return &S3PolicyCreateParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewS3PolicyCreateParamsWithTimeout creates a new S3PolicyCreateParams object
// with the ability to set a timeout on a request.
func NewS3PolicyCreateParamsWithTimeout(timeout time.Duration) *S3PolicyCreateParams {
	return &S3PolicyCreateParams{
		timeout: timeout,
	}
}

// NewS3PolicyCreateParamsWithContext creates a new S3PolicyCreateParams object
// with the ability to set a context for a request.
func NewS3PolicyCreateParamsWithContext(ctx context.Context) *S3PolicyCreateParams {
	return &S3PolicyCreateParams{
		Context: ctx,
	}
}

// NewS3PolicyCreateParamsWithHTTPClient creates a new S3PolicyCreateParams object
// with the ability to set a custom HTTPClient for a request.
func NewS3PolicyCreateParamsWithHTTPClient(client *http.Client) *S3PolicyCreateParams {
	return &S3PolicyCreateParams{
		HTTPClient: client,
	}
}

/*
S3PolicyCreateParams contains all the parameters to send to the API endpoint

	for the s3 policy create operation.

	Typically these are written to a http.Request.
*/
type S3PolicyCreateParams struct {

	/* Info.

	   Info specification
	*/
	Info *models.S3Policy

	/* ReturnRecords.

	   The default is false.  If set to true, the records are returned.
	*/
	ReturnRecordsQueryParameter *bool

	/* SvmUUID.

	   UUID of the SVM to which this object belongs.
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the s3 policy create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *S3PolicyCreateParams) WithDefaults() *S3PolicyCreateParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the s3 policy create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *S3PolicyCreateParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(false)
	)

	val := S3PolicyCreateParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the s3 policy create params
func (o *S3PolicyCreateParams) WithTimeout(timeout time.Duration) *S3PolicyCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the s3 policy create params
func (o *S3PolicyCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the s3 policy create params
func (o *S3PolicyCreateParams) WithContext(ctx context.Context) *S3PolicyCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the s3 policy create params
func (o *S3PolicyCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the s3 policy create params
func (o *S3PolicyCreateParams) WithHTTPClient(client *http.Client) *S3PolicyCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the s3 policy create params
func (o *S3PolicyCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the s3 policy create params
func (o *S3PolicyCreateParams) WithInfo(info *models.S3Policy) *S3PolicyCreateParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the s3 policy create params
func (o *S3PolicyCreateParams) SetInfo(info *models.S3Policy) {
	o.Info = info
}

// WithReturnRecordsQueryParameter adds the returnRecords to the s3 policy create params
func (o *S3PolicyCreateParams) WithReturnRecordsQueryParameter(returnRecords *bool) *S3PolicyCreateParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the s3 policy create params
func (o *S3PolicyCreateParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithSVMUUIDPathParameter adds the svmUUID to the s3 policy create params
func (o *S3PolicyCreateParams) WithSVMUUIDPathParameter(svmUUID string) *S3PolicyCreateParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the s3 policy create params
func (o *S3PolicyCreateParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *S3PolicyCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
