// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewFcpServiceGetParams creates a new FcpServiceGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewFcpServiceGetParams() *FcpServiceGetParams {
	return &FcpServiceGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewFcpServiceGetParamsWithTimeout creates a new FcpServiceGetParams object
// with the ability to set a timeout on a request.
func NewFcpServiceGetParamsWithTimeout(timeout time.Duration) *FcpServiceGetParams {
	return &FcpServiceGetParams{
		timeout: timeout,
	}
}

// NewFcpServiceGetParamsWithContext creates a new FcpServiceGetParams object
// with the ability to set a context for a request.
func NewFcpServiceGetParamsWithContext(ctx context.Context) *FcpServiceGetParams {
	return &FcpServiceGetParams{
		Context: ctx,
	}
}

// NewFcpServiceGetParamsWithHTTPClient creates a new FcpServiceGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewFcpServiceGetParamsWithHTTPClient(client *http.Client) *FcpServiceGetParams {
	return &FcpServiceGetParams{
		HTTPClient: client,
	}
}

/*
FcpServiceGetParams contains all the parameters to send to the API endpoint

	for the fcp service get operation.

	Typically these are written to a http.Request.
*/
type FcpServiceGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* SvmUUID.

	   The unique identifier of the SVM for which to retrieve the FC Protocol service.

	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the fcp service get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FcpServiceGetParams) WithDefaults() *FcpServiceGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the fcp service get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *FcpServiceGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the fcp service get params
func (o *FcpServiceGetParams) WithTimeout(timeout time.Duration) *FcpServiceGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the fcp service get params
func (o *FcpServiceGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the fcp service get params
func (o *FcpServiceGetParams) WithContext(ctx context.Context) *FcpServiceGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the fcp service get params
func (o *FcpServiceGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the fcp service get params
func (o *FcpServiceGetParams) WithHTTPClient(client *http.Client) *FcpServiceGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the fcp service get params
func (o *FcpServiceGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the fcp service get params
func (o *FcpServiceGetParams) WithFieldsQueryParameter(fields []string) *FcpServiceGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the fcp service get params
func (o *FcpServiceGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithSVMUUIDPathParameter adds the svmUUID to the fcp service get params
func (o *FcpServiceGetParams) WithSVMUUIDPathParameter(svmUUID string) *FcpServiceGetParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the fcp service get params
func (o *FcpServiceGetParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *FcpServiceGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamFcpServiceGet binds the parameter fields
func (o *FcpServiceGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
