// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIgroupCollectionGetParams creates a new IgroupCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIgroupCollectionGetParams() *IgroupCollectionGetParams {
	return &IgroupCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIgroupCollectionGetParamsWithTimeout creates a new IgroupCollectionGetParams object
// with the ability to set a timeout on a request.
func NewIgroupCollectionGetParamsWithTimeout(timeout time.Duration) *IgroupCollectionGetParams {
	return &IgroupCollectionGetParams{
		timeout: timeout,
	}
}

// NewIgroupCollectionGetParamsWithContext creates a new IgroupCollectionGetParams object
// with the ability to set a context for a request.
func NewIgroupCollectionGetParamsWithContext(ctx context.Context) *IgroupCollectionGetParams {
	return &IgroupCollectionGetParams{
		Context: ctx,
	}
}

// NewIgroupCollectionGetParamsWithHTTPClient creates a new IgroupCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewIgroupCollectionGetParamsWithHTTPClient(client *http.Client) *IgroupCollectionGetParams {
	return &IgroupCollectionGetParams{
		HTTPClient: client,
	}
}

/*
IgroupCollectionGetParams contains all the parameters to send to the API endpoint

	for the igroup collection get operation.

	Typically these are written to a http.Request.
*/
type IgroupCollectionGetParams struct {

	/* Comment.

	   Filter by comment
	*/
	CommentQueryParameter *string

	/* ConnectivityTrackingAlertsSummaryArgumentsCode.

	   Filter by connectivity_tracking.alerts.summary.arguments.code
	*/
	ConnectivityTrackingAlertsSummaryArgumentsCodeQueryParameter *string

	/* ConnectivityTrackingAlertsSummaryArgumentsMessage.

	   Filter by connectivity_tracking.alerts.summary.arguments.message
	*/
	ConnectivityTrackingAlertsSummaryArgumentsMessageQueryParameter *string

	/* ConnectivityTrackingAlertsSummaryCode.

	   Filter by connectivity_tracking.alerts.summary.code
	*/
	ConnectivityTrackingAlertsSummaryCodeQueryParameter *string

	/* ConnectivityTrackingAlertsSummaryMessage.

	   Filter by connectivity_tracking.alerts.summary.message
	*/
	ConnectivityTrackingAlertsSummaryMessageQueryParameter *string

	/* ConnectivityTrackingAlertsSummaryTarget.

	   Filter by connectivity_tracking.alerts.summary.target
	*/
	ConnectivityTrackingAlertsSummaryTargetQueryParameter *string

	/* ConnectivityTrackingConnectionState.

	   Filter by connectivity_tracking.connection_state
	*/
	ConnectivityTrackingConnectionStateQueryParameter *string

	/* ConnectivityTrackingRequiredNodesName.

	   Filter by connectivity_tracking.required_nodes.name
	*/
	ConnectivityTrackingRequiredNodesNameQueryParameter *string

	/* ConnectivityTrackingRequiredNodesUUID.

	   Filter by connectivity_tracking.required_nodes.uuid
	*/
	ConnectivityTrackingRequiredNodesUUIDQueryParameter *string

	/* DeleteOnUnmap.

	   Filter by delete_on_unmap
	*/
	DeleteOnUnmapQueryParameter *bool

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* IgroupsComment.

	   Filter by igroups.comment
	*/
	IgroupsCommentQueryParameter *string

	/* IgroupsName.

	   Filter by igroups.name
	*/
	IgroupsNameQueryParameter *string

	/* IgroupsUUID.

	   Filter by igroups.uuid
	*/
	IgroupsUUIDQueryParameter *string

	/* InitiatorsComment.

	   Filter by initiators.comment
	*/
	InitiatorsCommentQueryParameter *string

	/* InitiatorsConnectivityTrackingConnectionState.

	   Filter by initiators.connectivity_tracking.connection_state
	*/
	InitiatorsConnectivityTrackingConnectionStateQueryParameter *string

	/* InitiatorsIgroupName.

	   Filter by initiators.igroup.name
	*/
	InitiatorsIgroupNameQueryParameter *string

	/* InitiatorsIgroupUUID.

	   Filter by initiators.igroup.uuid
	*/
	InitiatorsIgroupUUIDQueryParameter *string

	/* InitiatorsName.

	   Filter by initiators.name
	*/
	InitiatorsNameQueryParameter *string

	/* LunMapsLogicalUnitNumber.

	   Filter by lun_maps.logical_unit_number
	*/
	LunMapsLogicalUnitNumberQueryParameter *int64

	/* LunMapsLunName.

	   Filter by lun_maps.lun.name
	*/
	LunMapsLunNameQueryParameter *string

	/* LunMapsLunNodeName.

	   Filter by lun_maps.lun.node.name
	*/
	LunMapsLunNodeNameQueryParameter *string

	/* LunMapsLunNodeUUID.

	   Filter by lun_maps.lun.node.uuid
	*/
	LunMapsLunNodeUUIDQueryParameter *string

	/* LunMapsLunUUID.

	   Filter by lun_maps.lun.uuid
	*/
	LunMapsLunUUIDQueryParameter *string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* OsType.

	   Filter by os_type
	*/
	OsTypeQueryParameter *string

	/* ParentIgroupsComment.

	   Filter by parent_igroups.comment
	*/
	ParentIgroupsCommentQueryParameter *string

	/* ParentIgroupsName.

	   Filter by parent_igroups.name
	*/
	ParentIgroupsNameQueryParameter *string

	/* ParentIgroupsUUID.

	   Filter by parent_igroups.uuid
	*/
	ParentIgroupsUUIDQueryParameter *string

	/* PortsetName.

	   Filter by portset.name
	*/
	PortsetNameQueryParameter *string

	/* PortsetUUID.

	   Filter by portset.uuid
	*/
	PortsetUUIDQueryParameter *string

	/* Protocol.

	   Filter by protocol
	*/
	ProtocolQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* SupportsIgroups.

	   Filter by supports_igroups
	*/
	SupportsIgroupsQueryParameter *bool

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	/* TargetFirmwareRevision.

	   Filter by target.firmware_revision
	*/
	TargetFirmwareRevisionQueryParameter *string

	/* TargetProductID.

	   Filter by target.product_id
	*/
	TargetProductIDQueryParameter *string

	/* TargetVendorID.

	   Filter by target.vendor_id
	*/
	TargetVendorIDQueryParameter *string

	/* UUID.

	   Filter by uuid
	*/
	UUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the igroup collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IgroupCollectionGetParams) WithDefaults() *IgroupCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the igroup collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IgroupCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := IgroupCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the igroup collection get params
func (o *IgroupCollectionGetParams) WithTimeout(timeout time.Duration) *IgroupCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the igroup collection get params
func (o *IgroupCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the igroup collection get params
func (o *IgroupCollectionGetParams) WithContext(ctx context.Context) *IgroupCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the igroup collection get params
func (o *IgroupCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the igroup collection get params
func (o *IgroupCollectionGetParams) WithHTTPClient(client *http.Client) *IgroupCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the igroup collection get params
func (o *IgroupCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCommentQueryParameter adds the comment to the igroup collection get params
func (o *IgroupCollectionGetParams) WithCommentQueryParameter(comment *string) *IgroupCollectionGetParams {
	o.SetCommentQueryParameter(comment)
	return o
}

// SetCommentQueryParameter adds the comment to the igroup collection get params
func (o *IgroupCollectionGetParams) SetCommentQueryParameter(comment *string) {
	o.CommentQueryParameter = comment
}

// WithConnectivityTrackingAlertsSummaryArgumentsCodeQueryParameter adds the connectivityTrackingAlertsSummaryArgumentsCode to the igroup collection get params
func (o *IgroupCollectionGetParams) WithConnectivityTrackingAlertsSummaryArgumentsCodeQueryParameter(connectivityTrackingAlertsSummaryArgumentsCode *string) *IgroupCollectionGetParams {
	o.SetConnectivityTrackingAlertsSummaryArgumentsCodeQueryParameter(connectivityTrackingAlertsSummaryArgumentsCode)
	return o
}

// SetConnectivityTrackingAlertsSummaryArgumentsCodeQueryParameter adds the connectivityTrackingAlertsSummaryArgumentsCode to the igroup collection get params
func (o *IgroupCollectionGetParams) SetConnectivityTrackingAlertsSummaryArgumentsCodeQueryParameter(connectivityTrackingAlertsSummaryArgumentsCode *string) {
	o.ConnectivityTrackingAlertsSummaryArgumentsCodeQueryParameter = connectivityTrackingAlertsSummaryArgumentsCode
}

// WithConnectivityTrackingAlertsSummaryArgumentsMessageQueryParameter adds the connectivityTrackingAlertsSummaryArgumentsMessage to the igroup collection get params
func (o *IgroupCollectionGetParams) WithConnectivityTrackingAlertsSummaryArgumentsMessageQueryParameter(connectivityTrackingAlertsSummaryArgumentsMessage *string) *IgroupCollectionGetParams {
	o.SetConnectivityTrackingAlertsSummaryArgumentsMessageQueryParameter(connectivityTrackingAlertsSummaryArgumentsMessage)
	return o
}

// SetConnectivityTrackingAlertsSummaryArgumentsMessageQueryParameter adds the connectivityTrackingAlertsSummaryArgumentsMessage to the igroup collection get params
func (o *IgroupCollectionGetParams) SetConnectivityTrackingAlertsSummaryArgumentsMessageQueryParameter(connectivityTrackingAlertsSummaryArgumentsMessage *string) {
	o.ConnectivityTrackingAlertsSummaryArgumentsMessageQueryParameter = connectivityTrackingAlertsSummaryArgumentsMessage
}

// WithConnectivityTrackingAlertsSummaryCodeQueryParameter adds the connectivityTrackingAlertsSummaryCode to the igroup collection get params
func (o *IgroupCollectionGetParams) WithConnectivityTrackingAlertsSummaryCodeQueryParameter(connectivityTrackingAlertsSummaryCode *string) *IgroupCollectionGetParams {
	o.SetConnectivityTrackingAlertsSummaryCodeQueryParameter(connectivityTrackingAlertsSummaryCode)
	return o
}

// SetConnectivityTrackingAlertsSummaryCodeQueryParameter adds the connectivityTrackingAlertsSummaryCode to the igroup collection get params
func (o *IgroupCollectionGetParams) SetConnectivityTrackingAlertsSummaryCodeQueryParameter(connectivityTrackingAlertsSummaryCode *string) {
	o.ConnectivityTrackingAlertsSummaryCodeQueryParameter = connectivityTrackingAlertsSummaryCode
}

// WithConnectivityTrackingAlertsSummaryMessageQueryParameter adds the connectivityTrackingAlertsSummaryMessage to the igroup collection get params
func (o *IgroupCollectionGetParams) WithConnectivityTrackingAlertsSummaryMessageQueryParameter(connectivityTrackingAlertsSummaryMessage *string) *IgroupCollectionGetParams {
	o.SetConnectivityTrackingAlertsSummaryMessageQueryParameter(connectivityTrackingAlertsSummaryMessage)
	return o
}

// SetConnectivityTrackingAlertsSummaryMessageQueryParameter adds the connectivityTrackingAlertsSummaryMessage to the igroup collection get params
func (o *IgroupCollectionGetParams) SetConnectivityTrackingAlertsSummaryMessageQueryParameter(connectivityTrackingAlertsSummaryMessage *string) {
	o.ConnectivityTrackingAlertsSummaryMessageQueryParameter = connectivityTrackingAlertsSummaryMessage
}

// WithConnectivityTrackingAlertsSummaryTargetQueryParameter adds the connectivityTrackingAlertsSummaryTarget to the igroup collection get params
func (o *IgroupCollectionGetParams) WithConnectivityTrackingAlertsSummaryTargetQueryParameter(connectivityTrackingAlertsSummaryTarget *string) *IgroupCollectionGetParams {
	o.SetConnectivityTrackingAlertsSummaryTargetQueryParameter(connectivityTrackingAlertsSummaryTarget)
	return o
}

// SetConnectivityTrackingAlertsSummaryTargetQueryParameter adds the connectivityTrackingAlertsSummaryTarget to the igroup collection get params
func (o *IgroupCollectionGetParams) SetConnectivityTrackingAlertsSummaryTargetQueryParameter(connectivityTrackingAlertsSummaryTarget *string) {
	o.ConnectivityTrackingAlertsSummaryTargetQueryParameter = connectivityTrackingAlertsSummaryTarget
}

// WithConnectivityTrackingConnectionStateQueryParameter adds the connectivityTrackingConnectionState to the igroup collection get params
func (o *IgroupCollectionGetParams) WithConnectivityTrackingConnectionStateQueryParameter(connectivityTrackingConnectionState *string) *IgroupCollectionGetParams {
	o.SetConnectivityTrackingConnectionStateQueryParameter(connectivityTrackingConnectionState)
	return o
}

// SetConnectivityTrackingConnectionStateQueryParameter adds the connectivityTrackingConnectionState to the igroup collection get params
func (o *IgroupCollectionGetParams) SetConnectivityTrackingConnectionStateQueryParameter(connectivityTrackingConnectionState *string) {
	o.ConnectivityTrackingConnectionStateQueryParameter = connectivityTrackingConnectionState
}

// WithConnectivityTrackingRequiredNodesNameQueryParameter adds the connectivityTrackingRequiredNodesName to the igroup collection get params
func (o *IgroupCollectionGetParams) WithConnectivityTrackingRequiredNodesNameQueryParameter(connectivityTrackingRequiredNodesName *string) *IgroupCollectionGetParams {
	o.SetConnectivityTrackingRequiredNodesNameQueryParameter(connectivityTrackingRequiredNodesName)
	return o
}

// SetConnectivityTrackingRequiredNodesNameQueryParameter adds the connectivityTrackingRequiredNodesName to the igroup collection get params
func (o *IgroupCollectionGetParams) SetConnectivityTrackingRequiredNodesNameQueryParameter(connectivityTrackingRequiredNodesName *string) {
	o.ConnectivityTrackingRequiredNodesNameQueryParameter = connectivityTrackingRequiredNodesName
}

// WithConnectivityTrackingRequiredNodesUUIDQueryParameter adds the connectivityTrackingRequiredNodesUUID to the igroup collection get params
func (o *IgroupCollectionGetParams) WithConnectivityTrackingRequiredNodesUUIDQueryParameter(connectivityTrackingRequiredNodesUUID *string) *IgroupCollectionGetParams {
	o.SetConnectivityTrackingRequiredNodesUUIDQueryParameter(connectivityTrackingRequiredNodesUUID)
	return o
}

// SetConnectivityTrackingRequiredNodesUUIDQueryParameter adds the connectivityTrackingRequiredNodesUuid to the igroup collection get params
func (o *IgroupCollectionGetParams) SetConnectivityTrackingRequiredNodesUUIDQueryParameter(connectivityTrackingRequiredNodesUUID *string) {
	o.ConnectivityTrackingRequiredNodesUUIDQueryParameter = connectivityTrackingRequiredNodesUUID
}

// WithDeleteOnUnmapQueryParameter adds the deleteOnUnmap to the igroup collection get params
func (o *IgroupCollectionGetParams) WithDeleteOnUnmapQueryParameter(deleteOnUnmap *bool) *IgroupCollectionGetParams {
	o.SetDeleteOnUnmapQueryParameter(deleteOnUnmap)
	return o
}

// SetDeleteOnUnmapQueryParameter adds the deleteOnUnmap to the igroup collection get params
func (o *IgroupCollectionGetParams) SetDeleteOnUnmapQueryParameter(deleteOnUnmap *bool) {
	o.DeleteOnUnmapQueryParameter = deleteOnUnmap
}

// WithFieldsQueryParameter adds the fields to the igroup collection get params
func (o *IgroupCollectionGetParams) WithFieldsQueryParameter(fields []string) *IgroupCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the igroup collection get params
func (o *IgroupCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIgroupsCommentQueryParameter adds the igroupsComment to the igroup collection get params
func (o *IgroupCollectionGetParams) WithIgroupsCommentQueryParameter(igroupsComment *string) *IgroupCollectionGetParams {
	o.SetIgroupsCommentQueryParameter(igroupsComment)
	return o
}

// SetIgroupsCommentQueryParameter adds the igroupsComment to the igroup collection get params
func (o *IgroupCollectionGetParams) SetIgroupsCommentQueryParameter(igroupsComment *string) {
	o.IgroupsCommentQueryParameter = igroupsComment
}

// WithIgroupsNameQueryParameter adds the igroupsName to the igroup collection get params
func (o *IgroupCollectionGetParams) WithIgroupsNameQueryParameter(igroupsName *string) *IgroupCollectionGetParams {
	o.SetIgroupsNameQueryParameter(igroupsName)
	return o
}

// SetIgroupsNameQueryParameter adds the igroupsName to the igroup collection get params
func (o *IgroupCollectionGetParams) SetIgroupsNameQueryParameter(igroupsName *string) {
	o.IgroupsNameQueryParameter = igroupsName
}

// WithIgroupsUUIDQueryParameter adds the igroupsUUID to the igroup collection get params
func (o *IgroupCollectionGetParams) WithIgroupsUUIDQueryParameter(igroupsUUID *string) *IgroupCollectionGetParams {
	o.SetIgroupsUUIDQueryParameter(igroupsUUID)
	return o
}

// SetIgroupsUUIDQueryParameter adds the igroupsUuid to the igroup collection get params
func (o *IgroupCollectionGetParams) SetIgroupsUUIDQueryParameter(igroupsUUID *string) {
	o.IgroupsUUIDQueryParameter = igroupsUUID
}

// WithInitiatorsCommentQueryParameter adds the initiatorsComment to the igroup collection get params
func (o *IgroupCollectionGetParams) WithInitiatorsCommentQueryParameter(initiatorsComment *string) *IgroupCollectionGetParams {
	o.SetInitiatorsCommentQueryParameter(initiatorsComment)
	return o
}

// SetInitiatorsCommentQueryParameter adds the initiatorsComment to the igroup collection get params
func (o *IgroupCollectionGetParams) SetInitiatorsCommentQueryParameter(initiatorsComment *string) {
	o.InitiatorsCommentQueryParameter = initiatorsComment
}

// WithInitiatorsConnectivityTrackingConnectionStateQueryParameter adds the initiatorsConnectivityTrackingConnectionState to the igroup collection get params
func (o *IgroupCollectionGetParams) WithInitiatorsConnectivityTrackingConnectionStateQueryParameter(initiatorsConnectivityTrackingConnectionState *string) *IgroupCollectionGetParams {
	o.SetInitiatorsConnectivityTrackingConnectionStateQueryParameter(initiatorsConnectivityTrackingConnectionState)
	return o
}

// SetInitiatorsConnectivityTrackingConnectionStateQueryParameter adds the initiatorsConnectivityTrackingConnectionState to the igroup collection get params
func (o *IgroupCollectionGetParams) SetInitiatorsConnectivityTrackingConnectionStateQueryParameter(initiatorsConnectivityTrackingConnectionState *string) {
	o.InitiatorsConnectivityTrackingConnectionStateQueryParameter = initiatorsConnectivityTrackingConnectionState
}

// WithInitiatorsIgroupNameQueryParameter adds the initiatorsIgroupName to the igroup collection get params
func (o *IgroupCollectionGetParams) WithInitiatorsIgroupNameQueryParameter(initiatorsIgroupName *string) *IgroupCollectionGetParams {
	o.SetInitiatorsIgroupNameQueryParameter(initiatorsIgroupName)
	return o
}

// SetInitiatorsIgroupNameQueryParameter adds the initiatorsIgroupName to the igroup collection get params
func (o *IgroupCollectionGetParams) SetInitiatorsIgroupNameQueryParameter(initiatorsIgroupName *string) {
	o.InitiatorsIgroupNameQueryParameter = initiatorsIgroupName
}

// WithInitiatorsIgroupUUIDQueryParameter adds the initiatorsIgroupUUID to the igroup collection get params
func (o *IgroupCollectionGetParams) WithInitiatorsIgroupUUIDQueryParameter(initiatorsIgroupUUID *string) *IgroupCollectionGetParams {
	o.SetInitiatorsIgroupUUIDQueryParameter(initiatorsIgroupUUID)
	return o
}

// SetInitiatorsIgroupUUIDQueryParameter adds the initiatorsIgroupUuid to the igroup collection get params
func (o *IgroupCollectionGetParams) SetInitiatorsIgroupUUIDQueryParameter(initiatorsIgroupUUID *string) {
	o.InitiatorsIgroupUUIDQueryParameter = initiatorsIgroupUUID
}

// WithInitiatorsNameQueryParameter adds the initiatorsName to the igroup collection get params
func (o *IgroupCollectionGetParams) WithInitiatorsNameQueryParameter(initiatorsName *string) *IgroupCollectionGetParams {
	o.SetInitiatorsNameQueryParameter(initiatorsName)
	return o
}

// SetInitiatorsNameQueryParameter adds the initiatorsName to the igroup collection get params
func (o *IgroupCollectionGetParams) SetInitiatorsNameQueryParameter(initiatorsName *string) {
	o.InitiatorsNameQueryParameter = initiatorsName
}

// WithLunMapsLogicalUnitNumberQueryParameter adds the lunMapsLogicalUnitNumber to the igroup collection get params
func (o *IgroupCollectionGetParams) WithLunMapsLogicalUnitNumberQueryParameter(lunMapsLogicalUnitNumber *int64) *IgroupCollectionGetParams {
	o.SetLunMapsLogicalUnitNumberQueryParameter(lunMapsLogicalUnitNumber)
	return o
}

// SetLunMapsLogicalUnitNumberQueryParameter adds the lunMapsLogicalUnitNumber to the igroup collection get params
func (o *IgroupCollectionGetParams) SetLunMapsLogicalUnitNumberQueryParameter(lunMapsLogicalUnitNumber *int64) {
	o.LunMapsLogicalUnitNumberQueryParameter = lunMapsLogicalUnitNumber
}

// WithLunMapsLunNameQueryParameter adds the lunMapsLunName to the igroup collection get params
func (o *IgroupCollectionGetParams) WithLunMapsLunNameQueryParameter(lunMapsLunName *string) *IgroupCollectionGetParams {
	o.SetLunMapsLunNameQueryParameter(lunMapsLunName)
	return o
}

// SetLunMapsLunNameQueryParameter adds the lunMapsLunName to the igroup collection get params
func (o *IgroupCollectionGetParams) SetLunMapsLunNameQueryParameter(lunMapsLunName *string) {
	o.LunMapsLunNameQueryParameter = lunMapsLunName
}

// WithLunMapsLunNodeNameQueryParameter adds the lunMapsLunNodeName to the igroup collection get params
func (o *IgroupCollectionGetParams) WithLunMapsLunNodeNameQueryParameter(lunMapsLunNodeName *string) *IgroupCollectionGetParams {
	o.SetLunMapsLunNodeNameQueryParameter(lunMapsLunNodeName)
	return o
}

// SetLunMapsLunNodeNameQueryParameter adds the lunMapsLunNodeName to the igroup collection get params
func (o *IgroupCollectionGetParams) SetLunMapsLunNodeNameQueryParameter(lunMapsLunNodeName *string) {
	o.LunMapsLunNodeNameQueryParameter = lunMapsLunNodeName
}

// WithLunMapsLunNodeUUIDQueryParameter adds the lunMapsLunNodeUUID to the igroup collection get params
func (o *IgroupCollectionGetParams) WithLunMapsLunNodeUUIDQueryParameter(lunMapsLunNodeUUID *string) *IgroupCollectionGetParams {
	o.SetLunMapsLunNodeUUIDQueryParameter(lunMapsLunNodeUUID)
	return o
}

// SetLunMapsLunNodeUUIDQueryParameter adds the lunMapsLunNodeUuid to the igroup collection get params
func (o *IgroupCollectionGetParams) SetLunMapsLunNodeUUIDQueryParameter(lunMapsLunNodeUUID *string) {
	o.LunMapsLunNodeUUIDQueryParameter = lunMapsLunNodeUUID
}

// WithLunMapsLunUUIDQueryParameter adds the lunMapsLunUUID to the igroup collection get params
func (o *IgroupCollectionGetParams) WithLunMapsLunUUIDQueryParameter(lunMapsLunUUID *string) *IgroupCollectionGetParams {
	o.SetLunMapsLunUUIDQueryParameter(lunMapsLunUUID)
	return o
}

// SetLunMapsLunUUIDQueryParameter adds the lunMapsLunUuid to the igroup collection get params
func (o *IgroupCollectionGetParams) SetLunMapsLunUUIDQueryParameter(lunMapsLunUUID *string) {
	o.LunMapsLunUUIDQueryParameter = lunMapsLunUUID
}

// WithMaxRecordsQueryParameter adds the maxRecords to the igroup collection get params
func (o *IgroupCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *IgroupCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the igroup collection get params
func (o *IgroupCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the igroup collection get params
func (o *IgroupCollectionGetParams) WithNameQueryParameter(name *string) *IgroupCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the igroup collection get params
func (o *IgroupCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the igroup collection get params
func (o *IgroupCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *IgroupCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the igroup collection get params
func (o *IgroupCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithOsTypeQueryParameter adds the osType to the igroup collection get params
func (o *IgroupCollectionGetParams) WithOsTypeQueryParameter(osType *string) *IgroupCollectionGetParams {
	o.SetOsTypeQueryParameter(osType)
	return o
}

// SetOsTypeQueryParameter adds the osType to the igroup collection get params
func (o *IgroupCollectionGetParams) SetOsTypeQueryParameter(osType *string) {
	o.OsTypeQueryParameter = osType
}

// WithParentIgroupsCommentQueryParameter adds the parentIgroupsComment to the igroup collection get params
func (o *IgroupCollectionGetParams) WithParentIgroupsCommentQueryParameter(parentIgroupsComment *string) *IgroupCollectionGetParams {
	o.SetParentIgroupsCommentQueryParameter(parentIgroupsComment)
	return o
}

// SetParentIgroupsCommentQueryParameter adds the parentIgroupsComment to the igroup collection get params
func (o *IgroupCollectionGetParams) SetParentIgroupsCommentQueryParameter(parentIgroupsComment *string) {
	o.ParentIgroupsCommentQueryParameter = parentIgroupsComment
}

// WithParentIgroupsNameQueryParameter adds the parentIgroupsName to the igroup collection get params
func (o *IgroupCollectionGetParams) WithParentIgroupsNameQueryParameter(parentIgroupsName *string) *IgroupCollectionGetParams {
	o.SetParentIgroupsNameQueryParameter(parentIgroupsName)
	return o
}

// SetParentIgroupsNameQueryParameter adds the parentIgroupsName to the igroup collection get params
func (o *IgroupCollectionGetParams) SetParentIgroupsNameQueryParameter(parentIgroupsName *string) {
	o.ParentIgroupsNameQueryParameter = parentIgroupsName
}

// WithParentIgroupsUUIDQueryParameter adds the parentIgroupsUUID to the igroup collection get params
func (o *IgroupCollectionGetParams) WithParentIgroupsUUIDQueryParameter(parentIgroupsUUID *string) *IgroupCollectionGetParams {
	o.SetParentIgroupsUUIDQueryParameter(parentIgroupsUUID)
	return o
}

// SetParentIgroupsUUIDQueryParameter adds the parentIgroupsUuid to the igroup collection get params
func (o *IgroupCollectionGetParams) SetParentIgroupsUUIDQueryParameter(parentIgroupsUUID *string) {
	o.ParentIgroupsUUIDQueryParameter = parentIgroupsUUID
}

// WithPortsetNameQueryParameter adds the portsetName to the igroup collection get params
func (o *IgroupCollectionGetParams) WithPortsetNameQueryParameter(portsetName *string) *IgroupCollectionGetParams {
	o.SetPortsetNameQueryParameter(portsetName)
	return o
}

// SetPortsetNameQueryParameter adds the portsetName to the igroup collection get params
func (o *IgroupCollectionGetParams) SetPortsetNameQueryParameter(portsetName *string) {
	o.PortsetNameQueryParameter = portsetName
}

// WithPortsetUUIDQueryParameter adds the portsetUUID to the igroup collection get params
func (o *IgroupCollectionGetParams) WithPortsetUUIDQueryParameter(portsetUUID *string) *IgroupCollectionGetParams {
	o.SetPortsetUUIDQueryParameter(portsetUUID)
	return o
}

// SetPortsetUUIDQueryParameter adds the portsetUuid to the igroup collection get params
func (o *IgroupCollectionGetParams) SetPortsetUUIDQueryParameter(portsetUUID *string) {
	o.PortsetUUIDQueryParameter = portsetUUID
}

// WithProtocolQueryParameter adds the protocol to the igroup collection get params
func (o *IgroupCollectionGetParams) WithProtocolQueryParameter(protocol *string) *IgroupCollectionGetParams {
	o.SetProtocolQueryParameter(protocol)
	return o
}

// SetProtocolQueryParameter adds the protocol to the igroup collection get params
func (o *IgroupCollectionGetParams) SetProtocolQueryParameter(protocol *string) {
	o.ProtocolQueryParameter = protocol
}

// WithReturnRecordsQueryParameter adds the returnRecords to the igroup collection get params
func (o *IgroupCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *IgroupCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the igroup collection get params
func (o *IgroupCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the igroup collection get params
func (o *IgroupCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *IgroupCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the igroup collection get params
func (o *IgroupCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSupportsIgroupsQueryParameter adds the supportsIgroups to the igroup collection get params
func (o *IgroupCollectionGetParams) WithSupportsIgroupsQueryParameter(supportsIgroups *bool) *IgroupCollectionGetParams {
	o.SetSupportsIgroupsQueryParameter(supportsIgroups)
	return o
}

// SetSupportsIgroupsQueryParameter adds the supportsIgroups to the igroup collection get params
func (o *IgroupCollectionGetParams) SetSupportsIgroupsQueryParameter(supportsIgroups *bool) {
	o.SupportsIgroupsQueryParameter = supportsIgroups
}

// WithSVMNameQueryParameter adds the svmName to the igroup collection get params
func (o *IgroupCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *IgroupCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the igroup collection get params
func (o *IgroupCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the igroup collection get params
func (o *IgroupCollectionGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *IgroupCollectionGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the igroup collection get params
func (o *IgroupCollectionGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WithTargetFirmwareRevisionQueryParameter adds the targetFirmwareRevision to the igroup collection get params
func (o *IgroupCollectionGetParams) WithTargetFirmwareRevisionQueryParameter(targetFirmwareRevision *string) *IgroupCollectionGetParams {
	o.SetTargetFirmwareRevisionQueryParameter(targetFirmwareRevision)
	return o
}

// SetTargetFirmwareRevisionQueryParameter adds the targetFirmwareRevision to the igroup collection get params
func (o *IgroupCollectionGetParams) SetTargetFirmwareRevisionQueryParameter(targetFirmwareRevision *string) {
	o.TargetFirmwareRevisionQueryParameter = targetFirmwareRevision
}

// WithTargetProductIDQueryParameter adds the targetProductID to the igroup collection get params
func (o *IgroupCollectionGetParams) WithTargetProductIDQueryParameter(targetProductID *string) *IgroupCollectionGetParams {
	o.SetTargetProductIDQueryParameter(targetProductID)
	return o
}

// SetTargetProductIDQueryParameter adds the targetProductId to the igroup collection get params
func (o *IgroupCollectionGetParams) SetTargetProductIDQueryParameter(targetProductID *string) {
	o.TargetProductIDQueryParameter = targetProductID
}

// WithTargetVendorIDQueryParameter adds the targetVendorID to the igroup collection get params
func (o *IgroupCollectionGetParams) WithTargetVendorIDQueryParameter(targetVendorID *string) *IgroupCollectionGetParams {
	o.SetTargetVendorIDQueryParameter(targetVendorID)
	return o
}

// SetTargetVendorIDQueryParameter adds the targetVendorId to the igroup collection get params
func (o *IgroupCollectionGetParams) SetTargetVendorIDQueryParameter(targetVendorID *string) {
	o.TargetVendorIDQueryParameter = targetVendorID
}

// WithUUIDQueryParameter adds the uuid to the igroup collection get params
func (o *IgroupCollectionGetParams) WithUUIDQueryParameter(uuid *string) *IgroupCollectionGetParams {
	o.SetUUIDQueryParameter(uuid)
	return o
}

// SetUUIDQueryParameter adds the uuid to the igroup collection get params
func (o *IgroupCollectionGetParams) SetUUIDQueryParameter(uuid *string) {
	o.UUIDQueryParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *IgroupCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CommentQueryParameter != nil {

		// query param comment
		var qrComment string

		if o.CommentQueryParameter != nil {
			qrComment = *o.CommentQueryParameter
		}
		qComment := qrComment
		if qComment != "" {

			if err := r.SetQueryParam("comment", qComment); err != nil {
				return err
			}
		}
	}

	if o.ConnectivityTrackingAlertsSummaryArgumentsCodeQueryParameter != nil {

		// query param connectivity_tracking.alerts.summary.arguments.code
		var qrConnectivityTrackingAlertsSummaryArgumentsCode string

		if o.ConnectivityTrackingAlertsSummaryArgumentsCodeQueryParameter != nil {
			qrConnectivityTrackingAlertsSummaryArgumentsCode = *o.ConnectivityTrackingAlertsSummaryArgumentsCodeQueryParameter
		}
		qConnectivityTrackingAlertsSummaryArgumentsCode := qrConnectivityTrackingAlertsSummaryArgumentsCode
		if qConnectivityTrackingAlertsSummaryArgumentsCode != "" {

			if err := r.SetQueryParam("connectivity_tracking.alerts.summary.arguments.code", qConnectivityTrackingAlertsSummaryArgumentsCode); err != nil {
				return err
			}
		}
	}

	if o.ConnectivityTrackingAlertsSummaryArgumentsMessageQueryParameter != nil {

		// query param connectivity_tracking.alerts.summary.arguments.message
		var qrConnectivityTrackingAlertsSummaryArgumentsMessage string

		if o.ConnectivityTrackingAlertsSummaryArgumentsMessageQueryParameter != nil {
			qrConnectivityTrackingAlertsSummaryArgumentsMessage = *o.ConnectivityTrackingAlertsSummaryArgumentsMessageQueryParameter
		}
		qConnectivityTrackingAlertsSummaryArgumentsMessage := qrConnectivityTrackingAlertsSummaryArgumentsMessage
		if qConnectivityTrackingAlertsSummaryArgumentsMessage != "" {

			if err := r.SetQueryParam("connectivity_tracking.alerts.summary.arguments.message", qConnectivityTrackingAlertsSummaryArgumentsMessage); err != nil {
				return err
			}
		}
	}

	if o.ConnectivityTrackingAlertsSummaryCodeQueryParameter != nil {

		// query param connectivity_tracking.alerts.summary.code
		var qrConnectivityTrackingAlertsSummaryCode string

		if o.ConnectivityTrackingAlertsSummaryCodeQueryParameter != nil {
			qrConnectivityTrackingAlertsSummaryCode = *o.ConnectivityTrackingAlertsSummaryCodeQueryParameter
		}
		qConnectivityTrackingAlertsSummaryCode := qrConnectivityTrackingAlertsSummaryCode
		if qConnectivityTrackingAlertsSummaryCode != "" {

			if err := r.SetQueryParam("connectivity_tracking.alerts.summary.code", qConnectivityTrackingAlertsSummaryCode); err != nil {
				return err
			}
		}
	}

	if o.ConnectivityTrackingAlertsSummaryMessageQueryParameter != nil {

		// query param connectivity_tracking.alerts.summary.message
		var qrConnectivityTrackingAlertsSummaryMessage string

		if o.ConnectivityTrackingAlertsSummaryMessageQueryParameter != nil {
			qrConnectivityTrackingAlertsSummaryMessage = *o.ConnectivityTrackingAlertsSummaryMessageQueryParameter
		}
		qConnectivityTrackingAlertsSummaryMessage := qrConnectivityTrackingAlertsSummaryMessage
		if qConnectivityTrackingAlertsSummaryMessage != "" {

			if err := r.SetQueryParam("connectivity_tracking.alerts.summary.message", qConnectivityTrackingAlertsSummaryMessage); err != nil {
				return err
			}
		}
	}

	if o.ConnectivityTrackingAlertsSummaryTargetQueryParameter != nil {

		// query param connectivity_tracking.alerts.summary.target
		var qrConnectivityTrackingAlertsSummaryTarget string

		if o.ConnectivityTrackingAlertsSummaryTargetQueryParameter != nil {
			qrConnectivityTrackingAlertsSummaryTarget = *o.ConnectivityTrackingAlertsSummaryTargetQueryParameter
		}
		qConnectivityTrackingAlertsSummaryTarget := qrConnectivityTrackingAlertsSummaryTarget
		if qConnectivityTrackingAlertsSummaryTarget != "" {

			if err := r.SetQueryParam("connectivity_tracking.alerts.summary.target", qConnectivityTrackingAlertsSummaryTarget); err != nil {
				return err
			}
		}
	}

	if o.ConnectivityTrackingConnectionStateQueryParameter != nil {

		// query param connectivity_tracking.connection_state
		var qrConnectivityTrackingConnectionState string

		if o.ConnectivityTrackingConnectionStateQueryParameter != nil {
			qrConnectivityTrackingConnectionState = *o.ConnectivityTrackingConnectionStateQueryParameter
		}
		qConnectivityTrackingConnectionState := qrConnectivityTrackingConnectionState
		if qConnectivityTrackingConnectionState != "" {

			if err := r.SetQueryParam("connectivity_tracking.connection_state", qConnectivityTrackingConnectionState); err != nil {
				return err
			}
		}
	}

	if o.ConnectivityTrackingRequiredNodesNameQueryParameter != nil {

		// query param connectivity_tracking.required_nodes.name
		var qrConnectivityTrackingRequiredNodesName string

		if o.ConnectivityTrackingRequiredNodesNameQueryParameter != nil {
			qrConnectivityTrackingRequiredNodesName = *o.ConnectivityTrackingRequiredNodesNameQueryParameter
		}
		qConnectivityTrackingRequiredNodesName := qrConnectivityTrackingRequiredNodesName
		if qConnectivityTrackingRequiredNodesName != "" {

			if err := r.SetQueryParam("connectivity_tracking.required_nodes.name", qConnectivityTrackingRequiredNodesName); err != nil {
				return err
			}
		}
	}

	if o.ConnectivityTrackingRequiredNodesUUIDQueryParameter != nil {

		// query param connectivity_tracking.required_nodes.uuid
		var qrConnectivityTrackingRequiredNodesUUID string

		if o.ConnectivityTrackingRequiredNodesUUIDQueryParameter != nil {
			qrConnectivityTrackingRequiredNodesUUID = *o.ConnectivityTrackingRequiredNodesUUIDQueryParameter
		}
		qConnectivityTrackingRequiredNodesUUID := qrConnectivityTrackingRequiredNodesUUID
		if qConnectivityTrackingRequiredNodesUUID != "" {

			if err := r.SetQueryParam("connectivity_tracking.required_nodes.uuid", qConnectivityTrackingRequiredNodesUUID); err != nil {
				return err
			}
		}
	}

	if o.DeleteOnUnmapQueryParameter != nil {

		// query param delete_on_unmap
		var qrDeleteOnUnmap bool

		if o.DeleteOnUnmapQueryParameter != nil {
			qrDeleteOnUnmap = *o.DeleteOnUnmapQueryParameter
		}
		qDeleteOnUnmap := swag.FormatBool(qrDeleteOnUnmap)
		if qDeleteOnUnmap != "" {

			if err := r.SetQueryParam("delete_on_unmap", qDeleteOnUnmap); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.IgroupsCommentQueryParameter != nil {

		// query param igroups.comment
		var qrIgroupsComment string

		if o.IgroupsCommentQueryParameter != nil {
			qrIgroupsComment = *o.IgroupsCommentQueryParameter
		}
		qIgroupsComment := qrIgroupsComment
		if qIgroupsComment != "" {

			if err := r.SetQueryParam("igroups.comment", qIgroupsComment); err != nil {
				return err
			}
		}
	}

	if o.IgroupsNameQueryParameter != nil {

		// query param igroups.name
		var qrIgroupsName string

		if o.IgroupsNameQueryParameter != nil {
			qrIgroupsName = *o.IgroupsNameQueryParameter
		}
		qIgroupsName := qrIgroupsName
		if qIgroupsName != "" {

			if err := r.SetQueryParam("igroups.name", qIgroupsName); err != nil {
				return err
			}
		}
	}

	if o.IgroupsUUIDQueryParameter != nil {

		// query param igroups.uuid
		var qrIgroupsUUID string

		if o.IgroupsUUIDQueryParameter != nil {
			qrIgroupsUUID = *o.IgroupsUUIDQueryParameter
		}
		qIgroupsUUID := qrIgroupsUUID
		if qIgroupsUUID != "" {

			if err := r.SetQueryParam("igroups.uuid", qIgroupsUUID); err != nil {
				return err
			}
		}
	}

	if o.InitiatorsCommentQueryParameter != nil {

		// query param initiators.comment
		var qrInitiatorsComment string

		if o.InitiatorsCommentQueryParameter != nil {
			qrInitiatorsComment = *o.InitiatorsCommentQueryParameter
		}
		qInitiatorsComment := qrInitiatorsComment
		if qInitiatorsComment != "" {

			if err := r.SetQueryParam("initiators.comment", qInitiatorsComment); err != nil {
				return err
			}
		}
	}

	if o.InitiatorsConnectivityTrackingConnectionStateQueryParameter != nil {

		// query param initiators.connectivity_tracking.connection_state
		var qrInitiatorsConnectivityTrackingConnectionState string

		if o.InitiatorsConnectivityTrackingConnectionStateQueryParameter != nil {
			qrInitiatorsConnectivityTrackingConnectionState = *o.InitiatorsConnectivityTrackingConnectionStateQueryParameter
		}
		qInitiatorsConnectivityTrackingConnectionState := qrInitiatorsConnectivityTrackingConnectionState
		if qInitiatorsConnectivityTrackingConnectionState != "" {

			if err := r.SetQueryParam("initiators.connectivity_tracking.connection_state", qInitiatorsConnectivityTrackingConnectionState); err != nil {
				return err
			}
		}
	}

	if o.InitiatorsIgroupNameQueryParameter != nil {

		// query param initiators.igroup.name
		var qrInitiatorsIgroupName string

		if o.InitiatorsIgroupNameQueryParameter != nil {
			qrInitiatorsIgroupName = *o.InitiatorsIgroupNameQueryParameter
		}
		qInitiatorsIgroupName := qrInitiatorsIgroupName
		if qInitiatorsIgroupName != "" {

			if err := r.SetQueryParam("initiators.igroup.name", qInitiatorsIgroupName); err != nil {
				return err
			}
		}
	}

	if o.InitiatorsIgroupUUIDQueryParameter != nil {

		// query param initiators.igroup.uuid
		var qrInitiatorsIgroupUUID string

		if o.InitiatorsIgroupUUIDQueryParameter != nil {
			qrInitiatorsIgroupUUID = *o.InitiatorsIgroupUUIDQueryParameter
		}
		qInitiatorsIgroupUUID := qrInitiatorsIgroupUUID
		if qInitiatorsIgroupUUID != "" {

			if err := r.SetQueryParam("initiators.igroup.uuid", qInitiatorsIgroupUUID); err != nil {
				return err
			}
		}
	}

	if o.InitiatorsNameQueryParameter != nil {

		// query param initiators.name
		var qrInitiatorsName string

		if o.InitiatorsNameQueryParameter != nil {
			qrInitiatorsName = *o.InitiatorsNameQueryParameter
		}
		qInitiatorsName := qrInitiatorsName
		if qInitiatorsName != "" {

			if err := r.SetQueryParam("initiators.name", qInitiatorsName); err != nil {
				return err
			}
		}
	}

	if o.LunMapsLogicalUnitNumberQueryParameter != nil {

		// query param lun_maps.logical_unit_number
		var qrLunMapsLogicalUnitNumber int64

		if o.LunMapsLogicalUnitNumberQueryParameter != nil {
			qrLunMapsLogicalUnitNumber = *o.LunMapsLogicalUnitNumberQueryParameter
		}
		qLunMapsLogicalUnitNumber := swag.FormatInt64(qrLunMapsLogicalUnitNumber)
		if qLunMapsLogicalUnitNumber != "" {

			if err := r.SetQueryParam("lun_maps.logical_unit_number", qLunMapsLogicalUnitNumber); err != nil {
				return err
			}
		}
	}

	if o.LunMapsLunNameQueryParameter != nil {

		// query param lun_maps.lun.name
		var qrLunMapsLunName string

		if o.LunMapsLunNameQueryParameter != nil {
			qrLunMapsLunName = *o.LunMapsLunNameQueryParameter
		}
		qLunMapsLunName := qrLunMapsLunName
		if qLunMapsLunName != "" {

			if err := r.SetQueryParam("lun_maps.lun.name", qLunMapsLunName); err != nil {
				return err
			}
		}
	}

	if o.LunMapsLunNodeNameQueryParameter != nil {

		// query param lun_maps.lun.node.name
		var qrLunMapsLunNodeName string

		if o.LunMapsLunNodeNameQueryParameter != nil {
			qrLunMapsLunNodeName = *o.LunMapsLunNodeNameQueryParameter
		}
		qLunMapsLunNodeName := qrLunMapsLunNodeName
		if qLunMapsLunNodeName != "" {

			if err := r.SetQueryParam("lun_maps.lun.node.name", qLunMapsLunNodeName); err != nil {
				return err
			}
		}
	}

	if o.LunMapsLunNodeUUIDQueryParameter != nil {

		// query param lun_maps.lun.node.uuid
		var qrLunMapsLunNodeUUID string

		if o.LunMapsLunNodeUUIDQueryParameter != nil {
			qrLunMapsLunNodeUUID = *o.LunMapsLunNodeUUIDQueryParameter
		}
		qLunMapsLunNodeUUID := qrLunMapsLunNodeUUID
		if qLunMapsLunNodeUUID != "" {

			if err := r.SetQueryParam("lun_maps.lun.node.uuid", qLunMapsLunNodeUUID); err != nil {
				return err
			}
		}
	}

	if o.LunMapsLunUUIDQueryParameter != nil {

		// query param lun_maps.lun.uuid
		var qrLunMapsLunUUID string

		if o.LunMapsLunUUIDQueryParameter != nil {
			qrLunMapsLunUUID = *o.LunMapsLunUUIDQueryParameter
		}
		qLunMapsLunUUID := qrLunMapsLunUUID
		if qLunMapsLunUUID != "" {

			if err := r.SetQueryParam("lun_maps.lun.uuid", qLunMapsLunUUID); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.OsTypeQueryParameter != nil {

		// query param os_type
		var qrOsType string

		if o.OsTypeQueryParameter != nil {
			qrOsType = *o.OsTypeQueryParameter
		}
		qOsType := qrOsType
		if qOsType != "" {

			if err := r.SetQueryParam("os_type", qOsType); err != nil {
				return err
			}
		}
	}

	if o.ParentIgroupsCommentQueryParameter != nil {

		// query param parent_igroups.comment
		var qrParentIgroupsComment string

		if o.ParentIgroupsCommentQueryParameter != nil {
			qrParentIgroupsComment = *o.ParentIgroupsCommentQueryParameter
		}
		qParentIgroupsComment := qrParentIgroupsComment
		if qParentIgroupsComment != "" {

			if err := r.SetQueryParam("parent_igroups.comment", qParentIgroupsComment); err != nil {
				return err
			}
		}
	}

	if o.ParentIgroupsNameQueryParameter != nil {

		// query param parent_igroups.name
		var qrParentIgroupsName string

		if o.ParentIgroupsNameQueryParameter != nil {
			qrParentIgroupsName = *o.ParentIgroupsNameQueryParameter
		}
		qParentIgroupsName := qrParentIgroupsName
		if qParentIgroupsName != "" {

			if err := r.SetQueryParam("parent_igroups.name", qParentIgroupsName); err != nil {
				return err
			}
		}
	}

	if o.ParentIgroupsUUIDQueryParameter != nil {

		// query param parent_igroups.uuid
		var qrParentIgroupsUUID string

		if o.ParentIgroupsUUIDQueryParameter != nil {
			qrParentIgroupsUUID = *o.ParentIgroupsUUIDQueryParameter
		}
		qParentIgroupsUUID := qrParentIgroupsUUID
		if qParentIgroupsUUID != "" {

			if err := r.SetQueryParam("parent_igroups.uuid", qParentIgroupsUUID); err != nil {
				return err
			}
		}
	}

	if o.PortsetNameQueryParameter != nil {

		// query param portset.name
		var qrPortsetName string

		if o.PortsetNameQueryParameter != nil {
			qrPortsetName = *o.PortsetNameQueryParameter
		}
		qPortsetName := qrPortsetName
		if qPortsetName != "" {

			if err := r.SetQueryParam("portset.name", qPortsetName); err != nil {
				return err
			}
		}
	}

	if o.PortsetUUIDQueryParameter != nil {

		// query param portset.uuid
		var qrPortsetUUID string

		if o.PortsetUUIDQueryParameter != nil {
			qrPortsetUUID = *o.PortsetUUIDQueryParameter
		}
		qPortsetUUID := qrPortsetUUID
		if qPortsetUUID != "" {

			if err := r.SetQueryParam("portset.uuid", qPortsetUUID); err != nil {
				return err
			}
		}
	}

	if o.ProtocolQueryParameter != nil {

		// query param protocol
		var qrProtocol string

		if o.ProtocolQueryParameter != nil {
			qrProtocol = *o.ProtocolQueryParameter
		}
		qProtocol := qrProtocol
		if qProtocol != "" {

			if err := r.SetQueryParam("protocol", qProtocol); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SupportsIgroupsQueryParameter != nil {

		// query param supports_igroups
		var qrSupportsIgroups bool

		if o.SupportsIgroupsQueryParameter != nil {
			qrSupportsIgroups = *o.SupportsIgroupsQueryParameter
		}
		qSupportsIgroups := swag.FormatBool(qrSupportsIgroups)
		if qSupportsIgroups != "" {

			if err := r.SetQueryParam("supports_igroups", qSupportsIgroups); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if o.TargetFirmwareRevisionQueryParameter != nil {

		// query param target.firmware_revision
		var qrTargetFirmwareRevision string

		if o.TargetFirmwareRevisionQueryParameter != nil {
			qrTargetFirmwareRevision = *o.TargetFirmwareRevisionQueryParameter
		}
		qTargetFirmwareRevision := qrTargetFirmwareRevision
		if qTargetFirmwareRevision != "" {

			if err := r.SetQueryParam("target.firmware_revision", qTargetFirmwareRevision); err != nil {
				return err
			}
		}
	}

	if o.TargetProductIDQueryParameter != nil {

		// query param target.product_id
		var qrTargetProductID string

		if o.TargetProductIDQueryParameter != nil {
			qrTargetProductID = *o.TargetProductIDQueryParameter
		}
		qTargetProductID := qrTargetProductID
		if qTargetProductID != "" {

			if err := r.SetQueryParam("target.product_id", qTargetProductID); err != nil {
				return err
			}
		}
	}

	if o.TargetVendorIDQueryParameter != nil {

		// query param target.vendor_id
		var qrTargetVendorID string

		if o.TargetVendorIDQueryParameter != nil {
			qrTargetVendorID = *o.TargetVendorIDQueryParameter
		}
		qTargetVendorID := qrTargetVendorID
		if qTargetVendorID != "" {

			if err := r.SetQueryParam("target.vendor_id", qTargetVendorID); err != nil {
				return err
			}
		}
	}

	if o.UUIDQueryParameter != nil {

		// query param uuid
		var qrUUID string

		if o.UUIDQueryParameter != nil {
			qrUUID = *o.UUIDQueryParameter
		}
		qUUID := qrUUID
		if qUUID != "" {

			if err := r.SetQueryParam("uuid", qUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamIgroupCollectionGet binds the parameter fields
func (o *IgroupCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamIgroupCollectionGet binds the parameter order_by
func (o *IgroupCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
