// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIgroupInitiatorGetParams creates a new IgroupInitiatorGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIgroupInitiatorGetParams() *IgroupInitiatorGetParams {
	return &IgroupInitiatorGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIgroupInitiatorGetParamsWithTimeout creates a new IgroupInitiatorGetParams object
// with the ability to set a timeout on a request.
func NewIgroupInitiatorGetParamsWithTimeout(timeout time.Duration) *IgroupInitiatorGetParams {
	return &IgroupInitiatorGetParams{
		timeout: timeout,
	}
}

// NewIgroupInitiatorGetParamsWithContext creates a new IgroupInitiatorGetParams object
// with the ability to set a context for a request.
func NewIgroupInitiatorGetParamsWithContext(ctx context.Context) *IgroupInitiatorGetParams {
	return &IgroupInitiatorGetParams{
		Context: ctx,
	}
}

// NewIgroupInitiatorGetParamsWithHTTPClient creates a new IgroupInitiatorGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewIgroupInitiatorGetParamsWithHTTPClient(client *http.Client) *IgroupInitiatorGetParams {
	return &IgroupInitiatorGetParams{
		HTTPClient: client,
	}
}

/*
IgroupInitiatorGetParams contains all the parameters to send to the API endpoint

	for the igroup initiator get operation.

	Typically these are written to a http.Request.
*/
type IgroupInitiatorGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* IgroupUUID.

	   The unique identifier of the initiator group.

	*/
	IgroupUUIDPathParameter string

	/* Name.

	   Initiator name

	*/
	NamePathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the igroup initiator get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IgroupInitiatorGetParams) WithDefaults() *IgroupInitiatorGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the igroup initiator get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IgroupInitiatorGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the igroup initiator get params
func (o *IgroupInitiatorGetParams) WithTimeout(timeout time.Duration) *IgroupInitiatorGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the igroup initiator get params
func (o *IgroupInitiatorGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the igroup initiator get params
func (o *IgroupInitiatorGetParams) WithContext(ctx context.Context) *IgroupInitiatorGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the igroup initiator get params
func (o *IgroupInitiatorGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the igroup initiator get params
func (o *IgroupInitiatorGetParams) WithHTTPClient(client *http.Client) *IgroupInitiatorGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the igroup initiator get params
func (o *IgroupInitiatorGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the igroup initiator get params
func (o *IgroupInitiatorGetParams) WithFieldsQueryParameter(fields []string) *IgroupInitiatorGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the igroup initiator get params
func (o *IgroupInitiatorGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIgroupUUIDPathParameter adds the igroupUUID to the igroup initiator get params
func (o *IgroupInitiatorGetParams) WithIgroupUUIDPathParameter(igroupUUID string) *IgroupInitiatorGetParams {
	o.SetIgroupUUIDPathParameter(igroupUUID)
	return o
}

// SetIgroupUUIDPathParameter adds the igroupUuid to the igroup initiator get params
func (o *IgroupInitiatorGetParams) SetIgroupUUIDPathParameter(igroupUUID string) {
	o.IgroupUUIDPathParameter = igroupUUID
}

// WithNamePathParameter adds the name to the igroup initiator get params
func (o *IgroupInitiatorGetParams) WithNamePathParameter(name string) *IgroupInitiatorGetParams {
	o.SetNamePathParameter(name)
	return o
}

// SetNamePathParameter adds the name to the igroup initiator get params
func (o *IgroupInitiatorGetParams) SetNamePathParameter(name string) {
	o.NamePathParameter = name
}

// WriteToRequest writes these params to a swagger request
func (o *IgroupInitiatorGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param igroup.uuid
	if err := r.SetPathParam("igroup.uuid", o.IgroupUUIDPathParameter); err != nil {
		return err
	}

	// path param name
	if err := r.SetPathParam("name", o.NamePathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamIgroupInitiatorGet binds the parameter fields
func (o *IgroupInitiatorGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
