// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewLunAttributeCreateParams creates a new LunAttributeCreateParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLunAttributeCreateParams() *LunAttributeCreateParams {
	return &LunAttributeCreateParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLunAttributeCreateParamsWithTimeout creates a new LunAttributeCreateParams object
// with the ability to set a timeout on a request.
func NewLunAttributeCreateParamsWithTimeout(timeout time.Duration) *LunAttributeCreateParams {
	return &LunAttributeCreateParams{
		timeout: timeout,
	}
}

// NewLunAttributeCreateParamsWithContext creates a new LunAttributeCreateParams object
// with the ability to set a context for a request.
func NewLunAttributeCreateParamsWithContext(ctx context.Context) *LunAttributeCreateParams {
	return &LunAttributeCreateParams{
		Context: ctx,
	}
}

// NewLunAttributeCreateParamsWithHTTPClient creates a new LunAttributeCreateParams object
// with the ability to set a custom HTTPClient for a request.
func NewLunAttributeCreateParamsWithHTTPClient(client *http.Client) *LunAttributeCreateParams {
	return &LunAttributeCreateParams{
		HTTPClient: client,
	}
}

/*
LunAttributeCreateParams contains all the parameters to send to the API endpoint

	for the lun attribute create operation.

	Typically these are written to a http.Request.
*/
type LunAttributeCreateParams struct {

	/* Info.

	   The attribute name and value to add to the LUN.

	*/
	Info *models.LunAttribute

	/* LunUUID.

	   The unique identifier of the LUN.

	*/
	LunUUIDPathParameter string

	/* ReturnRecords.

	   The default is false.  If set to true, the records are returned.
	*/
	ReturnRecordsQueryParameter *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the lun attribute create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LunAttributeCreateParams) WithDefaults() *LunAttributeCreateParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the lun attribute create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LunAttributeCreateParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(false)
	)

	val := LunAttributeCreateParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the lun attribute create params
func (o *LunAttributeCreateParams) WithTimeout(timeout time.Duration) *LunAttributeCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the lun attribute create params
func (o *LunAttributeCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the lun attribute create params
func (o *LunAttributeCreateParams) WithContext(ctx context.Context) *LunAttributeCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the lun attribute create params
func (o *LunAttributeCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the lun attribute create params
func (o *LunAttributeCreateParams) WithHTTPClient(client *http.Client) *LunAttributeCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the lun attribute create params
func (o *LunAttributeCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the lun attribute create params
func (o *LunAttributeCreateParams) WithInfo(info *models.LunAttribute) *LunAttributeCreateParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the lun attribute create params
func (o *LunAttributeCreateParams) SetInfo(info *models.LunAttribute) {
	o.Info = info
}

// WithLunUUIDPathParameter adds the lunUUID to the lun attribute create params
func (o *LunAttributeCreateParams) WithLunUUIDPathParameter(lunUUID string) *LunAttributeCreateParams {
	o.SetLunUUIDPathParameter(lunUUID)
	return o
}

// SetLunUUIDPathParameter adds the lunUuid to the lun attribute create params
func (o *LunAttributeCreateParams) SetLunUUIDPathParameter(lunUUID string) {
	o.LunUUIDPathParameter = lunUUID
}

// WithReturnRecordsQueryParameter adds the returnRecords to the lun attribute create params
func (o *LunAttributeCreateParams) WithReturnRecordsQueryParameter(returnRecords *bool) *LunAttributeCreateParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the lun attribute create params
func (o *LunAttributeCreateParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WriteToRequest writes these params to a swagger request
func (o *LunAttributeCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	// path param lun.uuid
	if err := r.SetPathParam("lun.uuid", o.LunUUIDPathParameter); err != nil {
		return err
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
