// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// NewLunCreateParams creates a new LunCreateParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLunCreateParams() *LunCreateParams {
	return &LunCreateParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLunCreateParamsWithTimeout creates a new LunCreateParams object
// with the ability to set a timeout on a request.
func NewLunCreateParamsWithTimeout(timeout time.Duration) *LunCreateParams {
	return &LunCreateParams{
		timeout: timeout,
	}
}

// NewLunCreateParamsWithContext creates a new LunCreateParams object
// with the ability to set a context for a request.
func NewLunCreateParamsWithContext(ctx context.Context) *LunCreateParams {
	return &LunCreateParams{
		Context: ctx,
	}
}

// NewLunCreateParamsWithHTTPClient creates a new LunCreateParams object
// with the ability to set a custom HTTPClient for a request.
func NewLunCreateParamsWithHTTPClient(client *http.Client) *LunCreateParams {
	return &LunCreateParams{
		HTTPClient: client,
	}
}

/*
LunCreateParams contains all the parameters to send to the API endpoint

	for the lun create operation.

	Typically these are written to a http.Request.
*/
type LunCreateParams struct {

	/* Info.

	   The property values for the new LUN.

	*/
	Info *models.Lun

	/* ReturnRecords.

	   The default is false.  If set to true, the records are returned.
	*/
	ReturnRecordsQueryParameter *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the lun create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LunCreateParams) WithDefaults() *LunCreateParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the lun create params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LunCreateParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(false)
	)

	val := LunCreateParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the lun create params
func (o *LunCreateParams) WithTimeout(timeout time.Duration) *LunCreateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the lun create params
func (o *LunCreateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the lun create params
func (o *LunCreateParams) WithContext(ctx context.Context) *LunCreateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the lun create params
func (o *LunCreateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the lun create params
func (o *LunCreateParams) WithHTTPClient(client *http.Client) *LunCreateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the lun create params
func (o *LunCreateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithInfo adds the info to the lun create params
func (o *LunCreateParams) WithInfo(info *models.Lun) *LunCreateParams {
	o.SetInfo(info)
	return o
}

// SetInfo adds the info to the lun create params
func (o *LunCreateParams) SetInfo(info *models.Lun) {
	o.Info = info
}

// WithReturnRecordsQueryParameter adds the returnRecords to the lun create params
func (o *LunCreateParams) WithReturnRecordsQueryParameter(returnRecords *bool) *LunCreateParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the lun create params
func (o *LunCreateParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WriteToRequest writes these params to a swagger request
func (o *LunCreateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Info != nil {
		if err := r.SetBodyParam(o.Info); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
