// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewLunGetParams creates a new LunGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewLunGetParams() *LunGetParams {
	return &LunGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewLunGetParamsWithTimeout creates a new LunGetParams object
// with the ability to set a timeout on a request.
func NewLunGetParamsWithTimeout(timeout time.Duration) *LunGetParams {
	return &LunGetParams{
		timeout: timeout,
	}
}

// NewLunGetParamsWithContext creates a new LunGetParams object
// with the ability to set a context for a request.
func NewLunGetParamsWithContext(ctx context.Context) *LunGetParams {
	return &LunGetParams{
		Context: ctx,
	}
}

// NewLunGetParamsWithHTTPClient creates a new LunGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewLunGetParamsWithHTTPClient(client *http.Client) *LunGetParams {
	return &LunGetParams{
		HTTPClient: client,
	}
}

/*
LunGetParams contains all the parameters to send to the API endpoint

	for the lun get operation.

	Typically these are written to a http.Request.
*/
type LunGetParams struct {

	/* DataOffset.

	     The offset, in bytes, at which to begin reading LUN data.<br/>
	LUN data read requests are distinguished by the header entry `Accept: multipart/form-data`. When this header entry is provided, query parameters `data.offset` and `data.size` are required and used to specify the portion of the LUN's data to read; no other query parameters are allowed. Reads are limited to one megabyte (1MB) per request. Data is returned as `multipart/form-data` content with exactly one form entry containing the data. The form entry has content type `application/octet-stream`.


	     Format: int64
	*/
	DataOffsetQueryParameter *int64

	/* DataSize.

	     The size, in bytes, of LUN data to read.<br/>
	LUN data read requests are distinguished by the header entry `Accept: multipart/form-data`. When this header entry is provided, query parameters `data.offset` and `data.size` are required and used to specify the portion of the LUN's data to read; no other query parameters are allowed. Reads are limited to one megabyte (1MB) per request. Data is returned as `multipart/form-data` content with exactly one form entry containing the data. The form entry has content type `application/octet-stream`.


	     Format: int64
	*/
	DataSizeQueryParameter *int64

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* UUID.

	   The unique identifier of the LUN to retrieve.

	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the lun get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LunGetParams) WithDefaults() *LunGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the lun get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *LunGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the lun get params
func (o *LunGetParams) WithTimeout(timeout time.Duration) *LunGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the lun get params
func (o *LunGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the lun get params
func (o *LunGetParams) WithContext(ctx context.Context) *LunGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the lun get params
func (o *LunGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the lun get params
func (o *LunGetParams) WithHTTPClient(client *http.Client) *LunGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the lun get params
func (o *LunGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDataOffsetQueryParameter adds the dataOffset to the lun get params
func (o *LunGetParams) WithDataOffsetQueryParameter(dataOffset *int64) *LunGetParams {
	o.SetDataOffsetQueryParameter(dataOffset)
	return o
}

// SetDataOffsetQueryParameter adds the dataOffset to the lun get params
func (o *LunGetParams) SetDataOffsetQueryParameter(dataOffset *int64) {
	o.DataOffsetQueryParameter = dataOffset
}

// WithDataSizeQueryParameter adds the dataSize to the lun get params
func (o *LunGetParams) WithDataSizeQueryParameter(dataSize *int64) *LunGetParams {
	o.SetDataSizeQueryParameter(dataSize)
	return o
}

// SetDataSizeQueryParameter adds the dataSize to the lun get params
func (o *LunGetParams) SetDataSizeQueryParameter(dataSize *int64) {
	o.DataSizeQueryParameter = dataSize
}

// WithFieldsQueryParameter adds the fields to the lun get params
func (o *LunGetParams) WithFieldsQueryParameter(fields []string) *LunGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the lun get params
func (o *LunGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithUUIDPathParameter adds the uuid to the lun get params
func (o *LunGetParams) WithUUIDPathParameter(uuid string) *LunGetParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the lun get params
func (o *LunGetParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *LunGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.DataOffsetQueryParameter != nil {

		// query param data.offset
		var qrDataOffset int64

		if o.DataOffsetQueryParameter != nil {
			qrDataOffset = *o.DataOffsetQueryParameter
		}
		qDataOffset := swag.FormatInt64(qrDataOffset)
		if qDataOffset != "" {

			if err := r.SetQueryParam("data.offset", qDataOffset); err != nil {
				return err
			}
		}
	}

	if o.DataSizeQueryParameter != nil {

		// query param data.size
		var qrDataSize int64

		if o.DataSizeQueryParameter != nil {
			qrDataSize = *o.DataSizeQueryParameter
		}
		qDataSize := swag.FormatInt64(qrDataSize)
		if qDataSize != "" {

			if err := r.SetQueryParam("data.size", qDataSize); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamLunGet binds the parameter fields
func (o *LunGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
