// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewVvolBindingGetParams creates a new VvolBindingGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewVvolBindingGetParams() *VvolBindingGetParams {
	return &VvolBindingGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewVvolBindingGetParamsWithTimeout creates a new VvolBindingGetParams object
// with the ability to set a timeout on a request.
func NewVvolBindingGetParamsWithTimeout(timeout time.Duration) *VvolBindingGetParams {
	return &VvolBindingGetParams{
		timeout: timeout,
	}
}

// NewVvolBindingGetParamsWithContext creates a new VvolBindingGetParams object
// with the ability to set a context for a request.
func NewVvolBindingGetParamsWithContext(ctx context.Context) *VvolBindingGetParams {
	return &VvolBindingGetParams{
		Context: ctx,
	}
}

// NewVvolBindingGetParamsWithHTTPClient creates a new VvolBindingGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewVvolBindingGetParamsWithHTTPClient(client *http.Client) *VvolBindingGetParams {
	return &VvolBindingGetParams{
		HTTPClient: client,
	}
}

/*
VvolBindingGetParams contains all the parameters to send to the API endpoint

	for the vvol binding get operation.

	Typically these are written to a http.Request.
*/
type VvolBindingGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* ProtocolEndpointUUID.

	   The unique identifier of the class `protocol_endpoint` LUN.

	*/
	ProtocolEndpointUUIDPathParameter string

	/* VvolUUID.

	   The unique identifier of the class `vvol` LUN.

	*/
	VvolUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the vvol binding get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VvolBindingGetParams) WithDefaults() *VvolBindingGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the vvol binding get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VvolBindingGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the vvol binding get params
func (o *VvolBindingGetParams) WithTimeout(timeout time.Duration) *VvolBindingGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the vvol binding get params
func (o *VvolBindingGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the vvol binding get params
func (o *VvolBindingGetParams) WithContext(ctx context.Context) *VvolBindingGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the vvol binding get params
func (o *VvolBindingGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the vvol binding get params
func (o *VvolBindingGetParams) WithHTTPClient(client *http.Client) *VvolBindingGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the vvol binding get params
func (o *VvolBindingGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the vvol binding get params
func (o *VvolBindingGetParams) WithFieldsQueryParameter(fields []string) *VvolBindingGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the vvol binding get params
func (o *VvolBindingGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithProtocolEndpointUUIDPathParameter adds the protocolEndpointUUID to the vvol binding get params
func (o *VvolBindingGetParams) WithProtocolEndpointUUIDPathParameter(protocolEndpointUUID string) *VvolBindingGetParams {
	o.SetProtocolEndpointUUIDPathParameter(protocolEndpointUUID)
	return o
}

// SetProtocolEndpointUUIDPathParameter adds the protocolEndpointUuid to the vvol binding get params
func (o *VvolBindingGetParams) SetProtocolEndpointUUIDPathParameter(protocolEndpointUUID string) {
	o.ProtocolEndpointUUIDPathParameter = protocolEndpointUUID
}

// WithVvolUUIDPathParameter adds the vvolUUID to the vvol binding get params
func (o *VvolBindingGetParams) WithVvolUUIDPathParameter(vvolUUID string) *VvolBindingGetParams {
	o.SetVvolUUIDPathParameter(vvolUUID)
	return o
}

// SetVvolUUIDPathParameter adds the vvolUuid to the vvol binding get params
func (o *VvolBindingGetParams) SetVvolUUIDPathParameter(vvolUUID string) {
	o.VvolUUIDPathParameter = vvolUUID
}

// WriteToRequest writes these params to a swagger request
func (o *VvolBindingGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param protocol_endpoint.uuid
	if err := r.SetPathParam("protocol_endpoint.uuid", o.ProtocolEndpointUUIDPathParameter); err != nil {
		return err
	}

	// path param vvol.uuid
	if err := r.SetPathParam("vvol.uuid", o.VvolUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamVvolBindingGet binds the parameter fields
func (o *VvolBindingGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
