// Code generated by go-swagger; DO NOT EDIT.

package s_a_n

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewWwpnAliasCollectionGetParams creates a new WwpnAliasCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewWwpnAliasCollectionGetParams() *WwpnAliasCollectionGetParams {
	return &WwpnAliasCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewWwpnAliasCollectionGetParamsWithTimeout creates a new WwpnAliasCollectionGetParams object
// with the ability to set a timeout on a request.
func NewWwpnAliasCollectionGetParamsWithTimeout(timeout time.Duration) *WwpnAliasCollectionGetParams {
	return &WwpnAliasCollectionGetParams{
		timeout: timeout,
	}
}

// NewWwpnAliasCollectionGetParamsWithContext creates a new WwpnAliasCollectionGetParams object
// with the ability to set a context for a request.
func NewWwpnAliasCollectionGetParamsWithContext(ctx context.Context) *WwpnAliasCollectionGetParams {
	return &WwpnAliasCollectionGetParams{
		Context: ctx,
	}
}

// NewWwpnAliasCollectionGetParamsWithHTTPClient creates a new WwpnAliasCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewWwpnAliasCollectionGetParamsWithHTTPClient(client *http.Client) *WwpnAliasCollectionGetParams {
	return &WwpnAliasCollectionGetParams{
		HTTPClient: client,
	}
}

/*
WwpnAliasCollectionGetParams contains all the parameters to send to the API endpoint

	for the wwpn alias collection get operation.

	Typically these are written to a http.Request.
*/
type WwpnAliasCollectionGetParams struct {

	/* Alias.

	   Filter by alias
	*/
	AliasQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	/* Wwpn.

	   Filter by wwpn
	*/
	WwpnQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the wwpn alias collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WwpnAliasCollectionGetParams) WithDefaults() *WwpnAliasCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the wwpn alias collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *WwpnAliasCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := WwpnAliasCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) WithTimeout(timeout time.Duration) *WwpnAliasCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) WithContext(ctx context.Context) *WwpnAliasCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) WithHTTPClient(client *http.Client) *WwpnAliasCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAliasQueryParameter adds the alias to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) WithAliasQueryParameter(alias *string) *WwpnAliasCollectionGetParams {
	o.SetAliasQueryParameter(alias)
	return o
}

// SetAliasQueryParameter adds the alias to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) SetAliasQueryParameter(alias *string) {
	o.AliasQueryParameter = alias
}

// WithFieldsQueryParameter adds the fields to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) WithFieldsQueryParameter(fields []string) *WwpnAliasCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *WwpnAliasCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *WwpnAliasCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *WwpnAliasCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *WwpnAliasCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithSVMNameQueryParameter adds the svmName to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *WwpnAliasCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *WwpnAliasCollectionGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WithWwpnQueryParameter adds the wwpn to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) WithWwpnQueryParameter(wwpn *string) *WwpnAliasCollectionGetParams {
	o.SetWwpnQueryParameter(wwpn)
	return o
}

// SetWwpnQueryParameter adds the wwpn to the wwpn alias collection get params
func (o *WwpnAliasCollectionGetParams) SetWwpnQueryParameter(wwpn *string) {
	o.WwpnQueryParameter = wwpn
}

// WriteToRequest writes these params to a swagger request
func (o *WwpnAliasCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AliasQueryParameter != nil {

		// query param alias
		var qrAlias string

		if o.AliasQueryParameter != nil {
			qrAlias = *o.AliasQueryParameter
		}
		qAlias := qrAlias
		if qAlias != "" {

			if err := r.SetQueryParam("alias", qAlias); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if o.WwpnQueryParameter != nil {

		// query param wwpn
		var qrWwpn string

		if o.WwpnQueryParameter != nil {
			qrWwpn = *o.WwpnQueryParameter
		}
		qWwpn := qrWwpn
		if qWwpn != "" {

			if err := r.SetQueryParam("wwpn", qWwpn); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamWwpnAliasCollectionGet binds the parameter fields
func (o *WwpnAliasCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamWwpnAliasCollectionGet binds the parameter order_by
func (o *WwpnAliasCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
