// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewAuditLogForwardingGetParams creates a new AuditLogForwardingGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAuditLogForwardingGetParams() *AuditLogForwardingGetParams {
	return &AuditLogForwardingGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAuditLogForwardingGetParamsWithTimeout creates a new AuditLogForwardingGetParams object
// with the ability to set a timeout on a request.
func NewAuditLogForwardingGetParamsWithTimeout(timeout time.Duration) *AuditLogForwardingGetParams {
	return &AuditLogForwardingGetParams{
		timeout: timeout,
	}
}

// NewAuditLogForwardingGetParamsWithContext creates a new AuditLogForwardingGetParams object
// with the ability to set a context for a request.
func NewAuditLogForwardingGetParamsWithContext(ctx context.Context) *AuditLogForwardingGetParams {
	return &AuditLogForwardingGetParams{
		Context: ctx,
	}
}

// NewAuditLogForwardingGetParamsWithHTTPClient creates a new AuditLogForwardingGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewAuditLogForwardingGetParamsWithHTTPClient(client *http.Client) *AuditLogForwardingGetParams {
	return &AuditLogForwardingGetParams{
		HTTPClient: client,
	}
}

/*
AuditLogForwardingGetParams contains all the parameters to send to the API endpoint

	for the audit log forwarding get operation.

	Typically these are written to a http.Request.
*/
type AuditLogForwardingGetParams struct {

	/* Address.

	   Filter by address
	*/
	AddressQueryParameter *string

	/* Facility.

	   Filter by facility
	*/
	FacilityQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* Port.

	   Filter by port
	*/
	PortQueryParameter *int64

	/* Protocol.

	   Filter by protocol
	*/
	ProtocolQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* VerifyServer.

	   Filter by verify_server
	*/
	VerifyServerQueryParameter *bool

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the audit log forwarding get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AuditLogForwardingGetParams) WithDefaults() *AuditLogForwardingGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the audit log forwarding get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AuditLogForwardingGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := AuditLogForwardingGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) WithTimeout(timeout time.Duration) *AuditLogForwardingGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) WithContext(ctx context.Context) *AuditLogForwardingGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) WithHTTPClient(client *http.Client) *AuditLogForwardingGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAddressQueryParameter adds the address to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) WithAddressQueryParameter(address *string) *AuditLogForwardingGetParams {
	o.SetAddressQueryParameter(address)
	return o
}

// SetAddressQueryParameter adds the address to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) SetAddressQueryParameter(address *string) {
	o.AddressQueryParameter = address
}

// WithFacilityQueryParameter adds the facility to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) WithFacilityQueryParameter(facility *string) *AuditLogForwardingGetParams {
	o.SetFacilityQueryParameter(facility)
	return o
}

// SetFacilityQueryParameter adds the facility to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) SetFacilityQueryParameter(facility *string) {
	o.FacilityQueryParameter = facility
}

// WithFieldsQueryParameter adds the fields to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) WithFieldsQueryParameter(fields []string) *AuditLogForwardingGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *AuditLogForwardingGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) WithOrderByQueryParameter(orderBy []string) *AuditLogForwardingGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithPortQueryParameter adds the port to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) WithPortQueryParameter(port *int64) *AuditLogForwardingGetParams {
	o.SetPortQueryParameter(port)
	return o
}

// SetPortQueryParameter adds the port to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) SetPortQueryParameter(port *int64) {
	o.PortQueryParameter = port
}

// WithProtocolQueryParameter adds the protocol to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) WithProtocolQueryParameter(protocol *string) *AuditLogForwardingGetParams {
	o.SetProtocolQueryParameter(protocol)
	return o
}

// SetProtocolQueryParameter adds the protocol to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) SetProtocolQueryParameter(protocol *string) {
	o.ProtocolQueryParameter = protocol
}

// WithReturnRecordsQueryParameter adds the returnRecords to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *AuditLogForwardingGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *AuditLogForwardingGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithVerifyServerQueryParameter adds the verifyServer to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) WithVerifyServerQueryParameter(verifyServer *bool) *AuditLogForwardingGetParams {
	o.SetVerifyServerQueryParameter(verifyServer)
	return o
}

// SetVerifyServerQueryParameter adds the verifyServer to the audit log forwarding get params
func (o *AuditLogForwardingGetParams) SetVerifyServerQueryParameter(verifyServer *bool) {
	o.VerifyServerQueryParameter = verifyServer
}

// WriteToRequest writes these params to a swagger request
func (o *AuditLogForwardingGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AddressQueryParameter != nil {

		// query param address
		var qrAddress string

		if o.AddressQueryParameter != nil {
			qrAddress = *o.AddressQueryParameter
		}
		qAddress := qrAddress
		if qAddress != "" {

			if err := r.SetQueryParam("address", qAddress); err != nil {
				return err
			}
		}
	}

	if o.FacilityQueryParameter != nil {

		// query param facility
		var qrFacility string

		if o.FacilityQueryParameter != nil {
			qrFacility = *o.FacilityQueryParameter
		}
		qFacility := qrFacility
		if qFacility != "" {

			if err := r.SetQueryParam("facility", qFacility); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.PortQueryParameter != nil {

		// query param port
		var qrPort int64

		if o.PortQueryParameter != nil {
			qrPort = *o.PortQueryParameter
		}
		qPort := swag.FormatInt64(qrPort)
		if qPort != "" {

			if err := r.SetQueryParam("port", qPort); err != nil {
				return err
			}
		}
	}

	if o.ProtocolQueryParameter != nil {

		// query param protocol
		var qrProtocol string

		if o.ProtocolQueryParameter != nil {
			qrProtocol = *o.ProtocolQueryParameter
		}
		qProtocol := qrProtocol
		if qProtocol != "" {

			if err := r.SetQueryParam("protocol", qProtocol); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.VerifyServerQueryParameter != nil {

		// query param verify_server
		var qrVerifyServer bool

		if o.VerifyServerQueryParameter != nil {
			qrVerifyServer = *o.VerifyServerQueryParameter
		}
		qVerifyServer := swag.FormatBool(qrVerifyServer)
		if qVerifyServer != "" {

			if err := r.SetQueryParam("verify_server", qVerifyServer); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamAuditLogForwardingGet binds the parameter fields
func (o *AuditLogForwardingGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamAuditLogForwardingGet binds the parameter order_by
func (o *AuditLogForwardingGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
