// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewIpsecCaCertificateCollectionGetParams creates a new IpsecCaCertificateCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIpsecCaCertificateCollectionGetParams() *IpsecCaCertificateCollectionGetParams {
	return &IpsecCaCertificateCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIpsecCaCertificateCollectionGetParamsWithTimeout creates a new IpsecCaCertificateCollectionGetParams object
// with the ability to set a timeout on a request.
func NewIpsecCaCertificateCollectionGetParamsWithTimeout(timeout time.Duration) *IpsecCaCertificateCollectionGetParams {
	return &IpsecCaCertificateCollectionGetParams{
		timeout: timeout,
	}
}

// NewIpsecCaCertificateCollectionGetParamsWithContext creates a new IpsecCaCertificateCollectionGetParams object
// with the ability to set a context for a request.
func NewIpsecCaCertificateCollectionGetParamsWithContext(ctx context.Context) *IpsecCaCertificateCollectionGetParams {
	return &IpsecCaCertificateCollectionGetParams{
		Context: ctx,
	}
}

// NewIpsecCaCertificateCollectionGetParamsWithHTTPClient creates a new IpsecCaCertificateCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewIpsecCaCertificateCollectionGetParamsWithHTTPClient(client *http.Client) *IpsecCaCertificateCollectionGetParams {
	return &IpsecCaCertificateCollectionGetParams{
		HTTPClient: client,
	}
}

/*
IpsecCaCertificateCollectionGetParams contains all the parameters to send to the API endpoint

	for the ipsec ca certificate collection get operation.

	Typically these are written to a http.Request.
*/
type IpsecCaCertificateCollectionGetParams struct {

	/* CertificateUUID.

	   Filter by certificate.uuid
	*/
	CertificateUUIDQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* Scope.

	   Filter by scope
	*/
	ScopeQueryParameter *string

	/* SvmName.

	   Filter by svm.name
	*/
	SVMNameQueryParameter *string

	/* SvmUUID.

	   Filter by svm.uuid
	*/
	SVMUUIDQueryParameter *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ipsec ca certificate collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpsecCaCertificateCollectionGetParams) WithDefaults() *IpsecCaCertificateCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ipsec ca certificate collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpsecCaCertificateCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := IpsecCaCertificateCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) WithTimeout(timeout time.Duration) *IpsecCaCertificateCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) WithContext(ctx context.Context) *IpsecCaCertificateCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) WithHTTPClient(client *http.Client) *IpsecCaCertificateCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCertificateUUIDQueryParameter adds the certificateUUID to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) WithCertificateUUIDQueryParameter(certificateUUID *string) *IpsecCaCertificateCollectionGetParams {
	o.SetCertificateUUIDQueryParameter(certificateUUID)
	return o
}

// SetCertificateUUIDQueryParameter adds the certificateUuid to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) SetCertificateUUIDQueryParameter(certificateUUID *string) {
	o.CertificateUUIDQueryParameter = certificateUUID
}

// WithFieldsQueryParameter adds the fields to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) WithFieldsQueryParameter(fields []string) *IpsecCaCertificateCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *IpsecCaCertificateCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *IpsecCaCertificateCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *IpsecCaCertificateCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *IpsecCaCertificateCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithScopeQueryParameter adds the scope to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) WithScopeQueryParameter(scope *string) *IpsecCaCertificateCollectionGetParams {
	o.SetScopeQueryParameter(scope)
	return o
}

// SetScopeQueryParameter adds the scope to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) SetScopeQueryParameter(scope *string) {
	o.ScopeQueryParameter = scope
}

// WithSVMNameQueryParameter adds the svmName to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) WithSVMNameQueryParameter(svmName *string) *IpsecCaCertificateCollectionGetParams {
	o.SetSVMNameQueryParameter(svmName)
	return o
}

// SetSVMNameQueryParameter adds the svmName to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) SetSVMNameQueryParameter(svmName *string) {
	o.SVMNameQueryParameter = svmName
}

// WithSVMUUIDQueryParameter adds the svmUUID to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) WithSVMUUIDQueryParameter(svmUUID *string) *IpsecCaCertificateCollectionGetParams {
	o.SetSVMUUIDQueryParameter(svmUUID)
	return o
}

// SetSVMUUIDQueryParameter adds the svmUuid to the ipsec ca certificate collection get params
func (o *IpsecCaCertificateCollectionGetParams) SetSVMUUIDQueryParameter(svmUUID *string) {
	o.SVMUUIDQueryParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *IpsecCaCertificateCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CertificateUUIDQueryParameter != nil {

		// query param certificate.uuid
		var qrCertificateUUID string

		if o.CertificateUUIDQueryParameter != nil {
			qrCertificateUUID = *o.CertificateUUIDQueryParameter
		}
		qCertificateUUID := qrCertificateUUID
		if qCertificateUUID != "" {

			if err := r.SetQueryParam("certificate.uuid", qCertificateUUID); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.ScopeQueryParameter != nil {

		// query param scope
		var qrScope string

		if o.ScopeQueryParameter != nil {
			qrScope = *o.ScopeQueryParameter
		}
		qScope := qrScope
		if qScope != "" {

			if err := r.SetQueryParam("scope", qScope); err != nil {
				return err
			}
		}
	}

	if o.SVMNameQueryParameter != nil {

		// query param svm.name
		var qrSvmName string

		if o.SVMNameQueryParameter != nil {
			qrSvmName = *o.SVMNameQueryParameter
		}
		qSvmName := qrSvmName
		if qSvmName != "" {

			if err := r.SetQueryParam("svm.name", qSvmName); err != nil {
				return err
			}
		}
	}

	if o.SVMUUIDQueryParameter != nil {

		// query param svm.uuid
		var qrSvmUUID string

		if o.SVMUUIDQueryParameter != nil {
			qrSvmUUID = *o.SVMUUIDQueryParameter
		}
		qSvmUUID := qrSvmUUID
		if qSvmUUID != "" {

			if err := r.SetQueryParam("svm.uuid", qSvmUUID); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamIpsecCaCertificateCollectionGet binds the parameter fields
func (o *IpsecCaCertificateCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamIpsecCaCertificateCollectionGet binds the parameter order_by
func (o *IpsecCaCertificateCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
