// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewIpsecCaCertificateDeleteParams creates a new IpsecCaCertificateDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIpsecCaCertificateDeleteParams() *IpsecCaCertificateDeleteParams {
	return &IpsecCaCertificateDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIpsecCaCertificateDeleteParamsWithTimeout creates a new IpsecCaCertificateDeleteParams object
// with the ability to set a timeout on a request.
func NewIpsecCaCertificateDeleteParamsWithTimeout(timeout time.Duration) *IpsecCaCertificateDeleteParams {
	return &IpsecCaCertificateDeleteParams{
		timeout: timeout,
	}
}

// NewIpsecCaCertificateDeleteParamsWithContext creates a new IpsecCaCertificateDeleteParams object
// with the ability to set a context for a request.
func NewIpsecCaCertificateDeleteParamsWithContext(ctx context.Context) *IpsecCaCertificateDeleteParams {
	return &IpsecCaCertificateDeleteParams{
		Context: ctx,
	}
}

// NewIpsecCaCertificateDeleteParamsWithHTTPClient creates a new IpsecCaCertificateDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewIpsecCaCertificateDeleteParamsWithHTTPClient(client *http.Client) *IpsecCaCertificateDeleteParams {
	return &IpsecCaCertificateDeleteParams{
		HTTPClient: client,
	}
}

/*
IpsecCaCertificateDeleteParams contains all the parameters to send to the API endpoint

	for the ipsec ca certificate delete operation.

	Typically these are written to a http.Request.
*/
type IpsecCaCertificateDeleteParams struct {

	/* CertificateUUID.

	   UUID of the CA certificate to be deleted from IPsec.
	*/
	CertificateUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ipsec ca certificate delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpsecCaCertificateDeleteParams) WithDefaults() *IpsecCaCertificateDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ipsec ca certificate delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpsecCaCertificateDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the ipsec ca certificate delete params
func (o *IpsecCaCertificateDeleteParams) WithTimeout(timeout time.Duration) *IpsecCaCertificateDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ipsec ca certificate delete params
func (o *IpsecCaCertificateDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ipsec ca certificate delete params
func (o *IpsecCaCertificateDeleteParams) WithContext(ctx context.Context) *IpsecCaCertificateDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ipsec ca certificate delete params
func (o *IpsecCaCertificateDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ipsec ca certificate delete params
func (o *IpsecCaCertificateDeleteParams) WithHTTPClient(client *http.Client) *IpsecCaCertificateDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ipsec ca certificate delete params
func (o *IpsecCaCertificateDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCertificateUUIDPathParameter adds the certificateUUID to the ipsec ca certificate delete params
func (o *IpsecCaCertificateDeleteParams) WithCertificateUUIDPathParameter(certificateUUID string) *IpsecCaCertificateDeleteParams {
	o.SetCertificateUUIDPathParameter(certificateUUID)
	return o
}

// SetCertificateUUIDPathParameter adds the certificateUuid to the ipsec ca certificate delete params
func (o *IpsecCaCertificateDeleteParams) SetCertificateUUIDPathParameter(certificateUUID string) {
	o.CertificateUUIDPathParameter = certificateUUID
}

// WriteToRequest writes these params to a swagger request
func (o *IpsecCaCertificateDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param certificate.uuid
	if err := r.SetPathParam("certificate.uuid", o.CertificateUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
