// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewIpsecPolicyDeleteParams creates a new IpsecPolicyDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewIpsecPolicyDeleteParams() *IpsecPolicyDeleteParams {
	return &IpsecPolicyDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewIpsecPolicyDeleteParamsWithTimeout creates a new IpsecPolicyDeleteParams object
// with the ability to set a timeout on a request.
func NewIpsecPolicyDeleteParamsWithTimeout(timeout time.Duration) *IpsecPolicyDeleteParams {
	return &IpsecPolicyDeleteParams{
		timeout: timeout,
	}
}

// NewIpsecPolicyDeleteParamsWithContext creates a new IpsecPolicyDeleteParams object
// with the ability to set a context for a request.
func NewIpsecPolicyDeleteParamsWithContext(ctx context.Context) *IpsecPolicyDeleteParams {
	return &IpsecPolicyDeleteParams{
		Context: ctx,
	}
}

// NewIpsecPolicyDeleteParamsWithHTTPClient creates a new IpsecPolicyDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewIpsecPolicyDeleteParamsWithHTTPClient(client *http.Client) *IpsecPolicyDeleteParams {
	return &IpsecPolicyDeleteParams{
		HTTPClient: client,
	}
}

/*
IpsecPolicyDeleteParams contains all the parameters to send to the API endpoint

	for the ipsec policy delete operation.

	Typically these are written to a http.Request.
*/
type IpsecPolicyDeleteParams struct {

	/* UUID.

	   IPsec policy UUID
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the ipsec policy delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpsecPolicyDeleteParams) WithDefaults() *IpsecPolicyDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the ipsec policy delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *IpsecPolicyDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the ipsec policy delete params
func (o *IpsecPolicyDeleteParams) WithTimeout(timeout time.Duration) *IpsecPolicyDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ipsec policy delete params
func (o *IpsecPolicyDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ipsec policy delete params
func (o *IpsecPolicyDeleteParams) WithContext(ctx context.Context) *IpsecPolicyDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ipsec policy delete params
func (o *IpsecPolicyDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ipsec policy delete params
func (o *IpsecPolicyDeleteParams) WithHTTPClient(client *http.Client) *IpsecPolicyDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ipsec policy delete params
func (o *IpsecPolicyDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUUIDPathParameter adds the uuid to the ipsec policy delete params
func (o *IpsecPolicyDeleteParams) WithUUIDPathParameter(uuid string) *IpsecPolicyDeleteParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the ipsec policy delete params
func (o *IpsecPolicyDeleteParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *IpsecPolicyDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
