// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewMultiAdminVerifyApprovalGroupCollectionGetParams creates a new MultiAdminVerifyApprovalGroupCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewMultiAdminVerifyApprovalGroupCollectionGetParams() *MultiAdminVerifyApprovalGroupCollectionGetParams {
	return &MultiAdminVerifyApprovalGroupCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewMultiAdminVerifyApprovalGroupCollectionGetParamsWithTimeout creates a new MultiAdminVerifyApprovalGroupCollectionGetParams object
// with the ability to set a timeout on a request.
func NewMultiAdminVerifyApprovalGroupCollectionGetParamsWithTimeout(timeout time.Duration) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	return &MultiAdminVerifyApprovalGroupCollectionGetParams{
		timeout: timeout,
	}
}

// NewMultiAdminVerifyApprovalGroupCollectionGetParamsWithContext creates a new MultiAdminVerifyApprovalGroupCollectionGetParams object
// with the ability to set a context for a request.
func NewMultiAdminVerifyApprovalGroupCollectionGetParamsWithContext(ctx context.Context) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	return &MultiAdminVerifyApprovalGroupCollectionGetParams{
		Context: ctx,
	}
}

// NewMultiAdminVerifyApprovalGroupCollectionGetParamsWithHTTPClient creates a new MultiAdminVerifyApprovalGroupCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewMultiAdminVerifyApprovalGroupCollectionGetParamsWithHTTPClient(client *http.Client) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	return &MultiAdminVerifyApprovalGroupCollectionGetParams{
		HTTPClient: client,
	}
}

/*
MultiAdminVerifyApprovalGroupCollectionGetParams contains all the parameters to send to the API endpoint

	for the multi admin verify approval group collection get operation.

	Typically these are written to a http.Request.
*/
type MultiAdminVerifyApprovalGroupCollectionGetParams struct {

	/* Approvers.

	   Filter by approvers
	*/
	ApproversQueryParameter *string

	/* Email.

	   Filter by email
	*/
	EmailQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* Name.

	   Filter by name
	*/
	NameQueryParameter *string

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* OwnerName.

	   Filter by owner.name
	*/
	OwnerNameQueryParameter *string

	/* OwnerUUID.

	   Filter by owner.uuid
	*/
	OwnerUUIDQueryParameter *string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the multi admin verify approval group collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) WithDefaults() *MultiAdminVerifyApprovalGroupCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the multi admin verify approval group collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := MultiAdminVerifyApprovalGroupCollectionGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) WithTimeout(timeout time.Duration) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) WithContext(ctx context.Context) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) WithHTTPClient(client *http.Client) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithApproversQueryParameter adds the approvers to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) WithApproversQueryParameter(approvers *string) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	o.SetApproversQueryParameter(approvers)
	return o
}

// SetApproversQueryParameter adds the approvers to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) SetApproversQueryParameter(approvers *string) {
	o.ApproversQueryParameter = approvers
}

// WithEmailQueryParameter adds the email to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) WithEmailQueryParameter(email *string) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	o.SetEmailQueryParameter(email)
	return o
}

// SetEmailQueryParameter adds the email to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) SetEmailQueryParameter(email *string) {
	o.EmailQueryParameter = email
}

// WithFieldsQueryParameter adds the fields to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) WithFieldsQueryParameter(fields []string) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithMaxRecordsQueryParameter adds the maxRecords to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithNameQueryParameter adds the name to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) WithNameQueryParameter(name *string) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	o.SetNameQueryParameter(name)
	return o
}

// SetNameQueryParameter adds the name to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) SetNameQueryParameter(name *string) {
	o.NameQueryParameter = name
}

// WithOrderByQueryParameter adds the orderBy to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithOwnerNameQueryParameter adds the ownerName to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) WithOwnerNameQueryParameter(ownerName *string) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	o.SetOwnerNameQueryParameter(ownerName)
	return o
}

// SetOwnerNameQueryParameter adds the ownerName to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) SetOwnerNameQueryParameter(ownerName *string) {
	o.OwnerNameQueryParameter = ownerName
}

// WithOwnerUUIDQueryParameter adds the ownerUUID to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) WithOwnerUUIDQueryParameter(ownerUUID *string) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	o.SetOwnerUUIDQueryParameter(ownerUUID)
	return o
}

// SetOwnerUUIDQueryParameter adds the ownerUuid to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) SetOwnerUUIDQueryParameter(ownerUUID *string) {
	o.OwnerUUIDQueryParameter = ownerUUID
}

// WithReturnRecordsQueryParameter adds the returnRecords to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *MultiAdminVerifyApprovalGroupCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the multi admin verify approval group collection get params
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WriteToRequest writes these params to a swagger request
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ApproversQueryParameter != nil {

		// query param approvers
		var qrApprovers string

		if o.ApproversQueryParameter != nil {
			qrApprovers = *o.ApproversQueryParameter
		}
		qApprovers := qrApprovers
		if qApprovers != "" {

			if err := r.SetQueryParam("approvers", qApprovers); err != nil {
				return err
			}
		}
	}

	if o.EmailQueryParameter != nil {

		// query param email
		var qrEmail string

		if o.EmailQueryParameter != nil {
			qrEmail = *o.EmailQueryParameter
		}
		qEmail := qrEmail
		if qEmail != "" {

			if err := r.SetQueryParam("email", qEmail); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.NameQueryParameter != nil {

		// query param name
		var qrName string

		if o.NameQueryParameter != nil {
			qrName = *o.NameQueryParameter
		}
		qName := qrName
		if qName != "" {

			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.OwnerNameQueryParameter != nil {

		// query param owner.name
		var qrOwnerName string

		if o.OwnerNameQueryParameter != nil {
			qrOwnerName = *o.OwnerNameQueryParameter
		}
		qOwnerName := qrOwnerName
		if qOwnerName != "" {

			if err := r.SetQueryParam("owner.name", qOwnerName); err != nil {
				return err
			}
		}
	}

	if o.OwnerUUIDQueryParameter != nil {

		// query param owner.uuid
		var qrOwnerUUID string

		if o.OwnerUUIDQueryParameter != nil {
			qrOwnerUUID = *o.OwnerUUIDQueryParameter
		}
		qOwnerUUID := qrOwnerUUID
		if qOwnerUUID != "" {

			if err := r.SetQueryParam("owner.uuid", qOwnerUUID); err != nil {
				return err
			}
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamMultiAdminVerifyApprovalGroupCollectionGet binds the parameter fields
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamMultiAdminVerifyApprovalGroupCollectionGet binds the parameter order_by
func (o *MultiAdminVerifyApprovalGroupCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
