// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewMultiAdminVerifyRuleGetParams creates a new MultiAdminVerifyRuleGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewMultiAdminVerifyRuleGetParams() *MultiAdminVerifyRuleGetParams {
	return &MultiAdminVerifyRuleGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewMultiAdminVerifyRuleGetParamsWithTimeout creates a new MultiAdminVerifyRuleGetParams object
// with the ability to set a timeout on a request.
func NewMultiAdminVerifyRuleGetParamsWithTimeout(timeout time.Duration) *MultiAdminVerifyRuleGetParams {
	return &MultiAdminVerifyRuleGetParams{
		timeout: timeout,
	}
}

// NewMultiAdminVerifyRuleGetParamsWithContext creates a new MultiAdminVerifyRuleGetParams object
// with the ability to set a context for a request.
func NewMultiAdminVerifyRuleGetParamsWithContext(ctx context.Context) *MultiAdminVerifyRuleGetParams {
	return &MultiAdminVerifyRuleGetParams{
		Context: ctx,
	}
}

// NewMultiAdminVerifyRuleGetParamsWithHTTPClient creates a new MultiAdminVerifyRuleGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewMultiAdminVerifyRuleGetParamsWithHTTPClient(client *http.Client) *MultiAdminVerifyRuleGetParams {
	return &MultiAdminVerifyRuleGetParams{
		HTTPClient: client,
	}
}

/*
MultiAdminVerifyRuleGetParams contains all the parameters to send to the API endpoint

	for the multi admin verify rule get operation.

	Typically these are written to a http.Request.
*/
type MultiAdminVerifyRuleGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	// Operation.
	OperationPathParameter string

	// OwnerUUID.
	OwnerUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the multi admin verify rule get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MultiAdminVerifyRuleGetParams) WithDefaults() *MultiAdminVerifyRuleGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the multi admin verify rule get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *MultiAdminVerifyRuleGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the multi admin verify rule get params
func (o *MultiAdminVerifyRuleGetParams) WithTimeout(timeout time.Duration) *MultiAdminVerifyRuleGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the multi admin verify rule get params
func (o *MultiAdminVerifyRuleGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the multi admin verify rule get params
func (o *MultiAdminVerifyRuleGetParams) WithContext(ctx context.Context) *MultiAdminVerifyRuleGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the multi admin verify rule get params
func (o *MultiAdminVerifyRuleGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the multi admin verify rule get params
func (o *MultiAdminVerifyRuleGetParams) WithHTTPClient(client *http.Client) *MultiAdminVerifyRuleGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the multi admin verify rule get params
func (o *MultiAdminVerifyRuleGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the multi admin verify rule get params
func (o *MultiAdminVerifyRuleGetParams) WithFieldsQueryParameter(fields []string) *MultiAdminVerifyRuleGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the multi admin verify rule get params
func (o *MultiAdminVerifyRuleGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithOperationPathParameter adds the operation to the multi admin verify rule get params
func (o *MultiAdminVerifyRuleGetParams) WithOperationPathParameter(operation string) *MultiAdminVerifyRuleGetParams {
	o.SetOperationPathParameter(operation)
	return o
}

// SetOperationPathParameter adds the operation to the multi admin verify rule get params
func (o *MultiAdminVerifyRuleGetParams) SetOperationPathParameter(operation string) {
	o.OperationPathParameter = operation
}

// WithOwnerUUIDPathParameter adds the ownerUUID to the multi admin verify rule get params
func (o *MultiAdminVerifyRuleGetParams) WithOwnerUUIDPathParameter(ownerUUID string) *MultiAdminVerifyRuleGetParams {
	o.SetOwnerUUIDPathParameter(ownerUUID)
	return o
}

// SetOwnerUUIDPathParameter adds the ownerUuid to the multi admin verify rule get params
func (o *MultiAdminVerifyRuleGetParams) SetOwnerUUIDPathParameter(ownerUUID string) {
	o.OwnerUUIDPathParameter = ownerUUID
}

// WriteToRequest writes these params to a swagger request
func (o *MultiAdminVerifyRuleGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param operation
	if err := r.SetPathParam("operation", o.OperationPathParameter); err != nil {
		return err
	}

	// path param owner.uuid
	if err := r.SetPathParam("owner.uuid", o.OwnerUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamMultiAdminVerifyRuleGet binds the parameter fields
func (o *MultiAdminVerifyRuleGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
