// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewPublickeyGetParams creates a new PublickeyGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPublickeyGetParams() *PublickeyGetParams {
	return &PublickeyGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPublickeyGetParamsWithTimeout creates a new PublickeyGetParams object
// with the ability to set a timeout on a request.
func NewPublickeyGetParamsWithTimeout(timeout time.Duration) *PublickeyGetParams {
	return &PublickeyGetParams{
		timeout: timeout,
	}
}

// NewPublickeyGetParamsWithContext creates a new PublickeyGetParams object
// with the ability to set a context for a request.
func NewPublickeyGetParamsWithContext(ctx context.Context) *PublickeyGetParams {
	return &PublickeyGetParams{
		Context: ctx,
	}
}

// NewPublickeyGetParamsWithHTTPClient creates a new PublickeyGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewPublickeyGetParamsWithHTTPClient(client *http.Client) *PublickeyGetParams {
	return &PublickeyGetParams{
		HTTPClient: client,
	}
}

/*
PublickeyGetParams contains all the parameters to send to the API endpoint

	for the publickey get operation.

	Typically these are written to a http.Request.
*/
type PublickeyGetParams struct {

	/* AccountName.

	   User account name
	*/
	AccountNamePathParameter string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* Index.

	   Index number for the public key (where there are multiple keys for the same account).
	*/
	IndexPathParameter int64

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* OwnerUUID.

	   Account owner UUID
	*/
	OwnerUUIDPathParameter string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the publickey get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PublickeyGetParams) WithDefaults() *PublickeyGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the publickey get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PublickeyGetParams) SetDefaults() {
	var (
		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := PublickeyGetParams{
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the publickey get params
func (o *PublickeyGetParams) WithTimeout(timeout time.Duration) *PublickeyGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the publickey get params
func (o *PublickeyGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the publickey get params
func (o *PublickeyGetParams) WithContext(ctx context.Context) *PublickeyGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the publickey get params
func (o *PublickeyGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the publickey get params
func (o *PublickeyGetParams) WithHTTPClient(client *http.Client) *PublickeyGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the publickey get params
func (o *PublickeyGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountNamePathParameter adds the accountName to the publickey get params
func (o *PublickeyGetParams) WithAccountNamePathParameter(accountName string) *PublickeyGetParams {
	o.SetAccountNamePathParameter(accountName)
	return o
}

// SetAccountNamePathParameter adds the accountName to the publickey get params
func (o *PublickeyGetParams) SetAccountNamePathParameter(accountName string) {
	o.AccountNamePathParameter = accountName
}

// WithFieldsQueryParameter adds the fields to the publickey get params
func (o *PublickeyGetParams) WithFieldsQueryParameter(fields []string) *PublickeyGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the publickey get params
func (o *PublickeyGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIndexPathParameter adds the index to the publickey get params
func (o *PublickeyGetParams) WithIndexPathParameter(index int64) *PublickeyGetParams {
	o.SetIndexPathParameter(index)
	return o
}

// SetIndexPathParameter adds the index to the publickey get params
func (o *PublickeyGetParams) SetIndexPathParameter(index int64) {
	o.IndexPathParameter = index
}

// WithMaxRecordsQueryParameter adds the maxRecords to the publickey get params
func (o *PublickeyGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *PublickeyGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the publickey get params
func (o *PublickeyGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the publickey get params
func (o *PublickeyGetParams) WithOrderByQueryParameter(orderBy []string) *PublickeyGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the publickey get params
func (o *PublickeyGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithOwnerUUIDPathParameter adds the ownerUUID to the publickey get params
func (o *PublickeyGetParams) WithOwnerUUIDPathParameter(ownerUUID string) *PublickeyGetParams {
	o.SetOwnerUUIDPathParameter(ownerUUID)
	return o
}

// SetOwnerUUIDPathParameter adds the ownerUuid to the publickey get params
func (o *PublickeyGetParams) SetOwnerUUIDPathParameter(ownerUUID string) {
	o.OwnerUUIDPathParameter = ownerUUID
}

// WithReturnRecordsQueryParameter adds the returnRecords to the publickey get params
func (o *PublickeyGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *PublickeyGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the publickey get params
func (o *PublickeyGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the publickey get params
func (o *PublickeyGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *PublickeyGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the publickey get params
func (o *PublickeyGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WriteToRequest writes these params to a swagger request
func (o *PublickeyGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param account.name
	if err := r.SetPathParam("account.name", o.AccountNamePathParameter); err != nil {
		return err
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param index
	if err := r.SetPathParam("index", swag.FormatInt64(o.IndexPathParameter)); err != nil {
		return err
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	// path param owner.uuid
	if err := r.SetPathParam("owner.uuid", o.OwnerUUIDPathParameter); err != nil {
		return err
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamPublickeyGet binds the parameter fields
func (o *PublickeyGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamPublickeyGet binds the parameter order_by
func (o *PublickeyGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
