// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// SecurityConfigModifyReader is a Reader for the SecurityConfigModify structure.
type SecurityConfigModifyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SecurityConfigModifyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewSecurityConfigModifyAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewSecurityConfigModifyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewSecurityConfigModifyAccepted creates a SecurityConfigModifyAccepted with default headers values
func NewSecurityConfigModifyAccepted() *SecurityConfigModifyAccepted {
	return &SecurityConfigModifyAccepted{}
}

/*
SecurityConfigModifyAccepted describes a response with status code 202, with default header values.

Accepted
*/
type SecurityConfigModifyAccepted struct {
	Payload *models.JobLinkResponse
}

// IsSuccess returns true when this security config modify accepted response has a 2xx status code
func (o *SecurityConfigModifyAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this security config modify accepted response has a 3xx status code
func (o *SecurityConfigModifyAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this security config modify accepted response has a 4xx status code
func (o *SecurityConfigModifyAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this security config modify accepted response has a 5xx status code
func (o *SecurityConfigModifyAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this security config modify accepted response a status code equal to that given
func (o *SecurityConfigModifyAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *SecurityConfigModifyAccepted) Error() string {
	return fmt.Sprintf("[PATCH /security][%d] securityConfigModifyAccepted  %+v", 202, o.Payload)
}

func (o *SecurityConfigModifyAccepted) String() string {
	return fmt.Sprintf("[PATCH /security][%d] securityConfigModifyAccepted  %+v", 202, o.Payload)
}

func (o *SecurityConfigModifyAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *SecurityConfigModifyAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSecurityConfigModifyDefault creates a SecurityConfigModifyDefault with default headers values
func NewSecurityConfigModifyDefault(code int) *SecurityConfigModifyDefault {
	return &SecurityConfigModifyDefault{
		_statusCode: code,
	}
}

/*
	SecurityConfigModifyDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

| Error Code | Description |
| ---------- | ----------- |
| 5636142 | This operation is not supported in a mixed-release cluster. |
| 52428817 | SSLv3 is not supported when FIPS is enabled. |
| 52428824 | TLSv1 is not supported when FIPS is enabled. |
| 52428830 | Cannot enable FIPS-compliant mode because the configured minimum security strength for certificates is not compatible. |
| 52428832 | TLSv1.1 is not supported when FIPS is enabled. |
| 52559974 | Cannot enable FIPS-compliant mode because a certificate that is not FIPS-compliant is in use. |
| 196608081 | Cannot start software encryption conversion while there are data volumes in the cluster. |
| 196608082 | The operation is not valid when the MetroCluster is in switchover mode. |
*/
type SecurityConfigModifyDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the security config modify default response
func (o *SecurityConfigModifyDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this security config modify default response has a 2xx status code
func (o *SecurityConfigModifyDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this security config modify default response has a 3xx status code
func (o *SecurityConfigModifyDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this security config modify default response has a 4xx status code
func (o *SecurityConfigModifyDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this security config modify default response has a 5xx status code
func (o *SecurityConfigModifyDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this security config modify default response a status code equal to that given
func (o *SecurityConfigModifyDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *SecurityConfigModifyDefault) Error() string {
	return fmt.Sprintf("[PATCH /security][%d] security_config_modify default  %+v", o._statusCode, o.Payload)
}

func (o *SecurityConfigModifyDefault) String() string {
	return fmt.Sprintf("[PATCH /security][%d] security_config_modify default  %+v", o._statusCode, o.Payload)
}

func (o *SecurityConfigModifyDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SecurityConfigModifyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
