// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewSecurityKeyManagerDeleteParams creates a new SecurityKeyManagerDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSecurityKeyManagerDeleteParams() *SecurityKeyManagerDeleteParams {
	return &SecurityKeyManagerDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSecurityKeyManagerDeleteParamsWithTimeout creates a new SecurityKeyManagerDeleteParams object
// with the ability to set a timeout on a request.
func NewSecurityKeyManagerDeleteParamsWithTimeout(timeout time.Duration) *SecurityKeyManagerDeleteParams {
	return &SecurityKeyManagerDeleteParams{
		timeout: timeout,
	}
}

// NewSecurityKeyManagerDeleteParamsWithContext creates a new SecurityKeyManagerDeleteParams object
// with the ability to set a context for a request.
func NewSecurityKeyManagerDeleteParamsWithContext(ctx context.Context) *SecurityKeyManagerDeleteParams {
	return &SecurityKeyManagerDeleteParams{
		Context: ctx,
	}
}

// NewSecurityKeyManagerDeleteParamsWithHTTPClient creates a new SecurityKeyManagerDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewSecurityKeyManagerDeleteParamsWithHTTPClient(client *http.Client) *SecurityKeyManagerDeleteParams {
	return &SecurityKeyManagerDeleteParams{
		HTTPClient: client,
	}
}

/*
SecurityKeyManagerDeleteParams contains all the parameters to send to the API endpoint

	for the security key manager delete operation.

	Typically these are written to a http.Request.
*/
type SecurityKeyManagerDeleteParams struct {

	/* UUID.

	   Key manager UUID
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the security key manager delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SecurityKeyManagerDeleteParams) WithDefaults() *SecurityKeyManagerDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the security key manager delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SecurityKeyManagerDeleteParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the security key manager delete params
func (o *SecurityKeyManagerDeleteParams) WithTimeout(timeout time.Duration) *SecurityKeyManagerDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the security key manager delete params
func (o *SecurityKeyManagerDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the security key manager delete params
func (o *SecurityKeyManagerDeleteParams) WithContext(ctx context.Context) *SecurityKeyManagerDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the security key manager delete params
func (o *SecurityKeyManagerDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the security key manager delete params
func (o *SecurityKeyManagerDeleteParams) WithHTTPClient(client *http.Client) *SecurityKeyManagerDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the security key manager delete params
func (o *SecurityKeyManagerDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithUUIDPathParameter adds the uuid to the security key manager delete params
func (o *SecurityKeyManagerDeleteParams) WithUUIDPathParameter(uuid string) *SecurityKeyManagerDeleteParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the security key manager delete params
func (o *SecurityKeyManagerDeleteParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *SecurityKeyManagerDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
