// Code generated by go-swagger; DO NOT EDIT.

package security

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewSecurityKeyManagerKeyServersGetParams creates a new SecurityKeyManagerKeyServersGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSecurityKeyManagerKeyServersGetParams() *SecurityKeyManagerKeyServersGetParams {
	return &SecurityKeyManagerKeyServersGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSecurityKeyManagerKeyServersGetParamsWithTimeout creates a new SecurityKeyManagerKeyServersGetParams object
// with the ability to set a timeout on a request.
func NewSecurityKeyManagerKeyServersGetParamsWithTimeout(timeout time.Duration) *SecurityKeyManagerKeyServersGetParams {
	return &SecurityKeyManagerKeyServersGetParams{
		timeout: timeout,
	}
}

// NewSecurityKeyManagerKeyServersGetParamsWithContext creates a new SecurityKeyManagerKeyServersGetParams object
// with the ability to set a context for a request.
func NewSecurityKeyManagerKeyServersGetParamsWithContext(ctx context.Context) *SecurityKeyManagerKeyServersGetParams {
	return &SecurityKeyManagerKeyServersGetParams{
		Context: ctx,
	}
}

// NewSecurityKeyManagerKeyServersGetParamsWithHTTPClient creates a new SecurityKeyManagerKeyServersGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewSecurityKeyManagerKeyServersGetParamsWithHTTPClient(client *http.Client) *SecurityKeyManagerKeyServersGetParams {
	return &SecurityKeyManagerKeyServersGetParams{
		HTTPClient: client,
	}
}

/*
SecurityKeyManagerKeyServersGetParams contains all the parameters to send to the API endpoint

	for the security key manager key servers get operation.

	Typically these are written to a http.Request.
*/
type SecurityKeyManagerKeyServersGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* Server.

	   Primary Key server configured in the key manager.
	*/
	ServerPathParameter string

	/* UUID.

	   External key manager UUID
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the security key manager key servers get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SecurityKeyManagerKeyServersGetParams) WithDefaults() *SecurityKeyManagerKeyServersGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the security key manager key servers get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SecurityKeyManagerKeyServersGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the security key manager key servers get params
func (o *SecurityKeyManagerKeyServersGetParams) WithTimeout(timeout time.Duration) *SecurityKeyManagerKeyServersGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the security key manager key servers get params
func (o *SecurityKeyManagerKeyServersGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the security key manager key servers get params
func (o *SecurityKeyManagerKeyServersGetParams) WithContext(ctx context.Context) *SecurityKeyManagerKeyServersGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the security key manager key servers get params
func (o *SecurityKeyManagerKeyServersGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the security key manager key servers get params
func (o *SecurityKeyManagerKeyServersGetParams) WithHTTPClient(client *http.Client) *SecurityKeyManagerKeyServersGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the security key manager key servers get params
func (o *SecurityKeyManagerKeyServersGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the security key manager key servers get params
func (o *SecurityKeyManagerKeyServersGetParams) WithFieldsQueryParameter(fields []string) *SecurityKeyManagerKeyServersGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the security key manager key servers get params
func (o *SecurityKeyManagerKeyServersGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithServerPathParameter adds the server to the security key manager key servers get params
func (o *SecurityKeyManagerKeyServersGetParams) WithServerPathParameter(server string) *SecurityKeyManagerKeyServersGetParams {
	o.SetServerPathParameter(server)
	return o
}

// SetServerPathParameter adds the server to the security key manager key servers get params
func (o *SecurityKeyManagerKeyServersGetParams) SetServerPathParameter(server string) {
	o.ServerPathParameter = server
}

// WithUUIDPathParameter adds the uuid to the security key manager key servers get params
func (o *SecurityKeyManagerKeyServersGetParams) WithUUIDPathParameter(uuid string) *SecurityKeyManagerKeyServersGetParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the security key manager key servers get params
func (o *SecurityKeyManagerKeyServersGetParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *SecurityKeyManagerKeyServersGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param server
	if err := r.SetPathParam("server", o.ServerPathParameter); err != nil {
		return err
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamSecurityKeyManagerKeyServersGet binds the parameter fields
func (o *SecurityKeyManagerKeyServersGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
