// Code generated by go-swagger; DO NOT EDIT.

package snaplock

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// SnaplockLegalHoldOperationGetReader is a Reader for the SnaplockLegalHoldOperationGet structure.
type SnaplockLegalHoldOperationGetReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SnaplockLegalHoldOperationGetReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewSnaplockLegalHoldOperationGetOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewSnaplockLegalHoldOperationGetDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewSnaplockLegalHoldOperationGetOK creates a SnaplockLegalHoldOperationGetOK with default headers values
func NewSnaplockLegalHoldOperationGetOK() *SnaplockLegalHoldOperationGetOK {
	return &SnaplockLegalHoldOperationGetOK{}
}

/*
SnaplockLegalHoldOperationGetOK describes a response with status code 200, with default header values.

OK
*/
type SnaplockLegalHoldOperationGetOK struct {
	Payload *models.SnaplockLegalHoldOperation
}

// IsSuccess returns true when this snaplock legal hold operation get o k response has a 2xx status code
func (o *SnaplockLegalHoldOperationGetOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this snaplock legal hold operation get o k response has a 3xx status code
func (o *SnaplockLegalHoldOperationGetOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this snaplock legal hold operation get o k response has a 4xx status code
func (o *SnaplockLegalHoldOperationGetOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this snaplock legal hold operation get o k response has a 5xx status code
func (o *SnaplockLegalHoldOperationGetOK) IsServerError() bool {
	return false
}

// IsCode returns true when this snaplock legal hold operation get o k response a status code equal to that given
func (o *SnaplockLegalHoldOperationGetOK) IsCode(code int) bool {
	return code == 200
}

func (o *SnaplockLegalHoldOperationGetOK) Error() string {
	return fmt.Sprintf("[GET /storage/snaplock/litigations/{litigation.id}/operations/{id}][%d] snaplockLegalHoldOperationGetOK  %+v", 200, o.Payload)
}

func (o *SnaplockLegalHoldOperationGetOK) String() string {
	return fmt.Sprintf("[GET /storage/snaplock/litigations/{litigation.id}/operations/{id}][%d] snaplockLegalHoldOperationGetOK  %+v", 200, o.Payload)
}

func (o *SnaplockLegalHoldOperationGetOK) GetPayload() *models.SnaplockLegalHoldOperation {
	return o.Payload
}

func (o *SnaplockLegalHoldOperationGetOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.SnaplockLegalHoldOperation)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSnaplockLegalHoldOperationGetDefault creates a SnaplockLegalHoldOperationGetDefault with default headers values
func NewSnaplockLegalHoldOperationGetDefault(code int) *SnaplockLegalHoldOperationGetDefault {
	return &SnaplockLegalHoldOperationGetDefault{
		_statusCode: code,
	}
}

/*
	SnaplockLegalHoldOperationGetDefault describes a response with status code -1, with default header values.

	ONTAP Error Response codes

| Error code  |  Description |
|-------------|--------------|
| 14090346    | Internal Error. Wait a few minutes, then try the command again  |
| 14090343    | Invalid Field  |
*/
type SnaplockLegalHoldOperationGetDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the snaplock legal hold operation get default response
func (o *SnaplockLegalHoldOperationGetDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this snaplock legal hold operation get default response has a 2xx status code
func (o *SnaplockLegalHoldOperationGetDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this snaplock legal hold operation get default response has a 3xx status code
func (o *SnaplockLegalHoldOperationGetDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this snaplock legal hold operation get default response has a 4xx status code
func (o *SnaplockLegalHoldOperationGetDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this snaplock legal hold operation get default response has a 5xx status code
func (o *SnaplockLegalHoldOperationGetDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this snaplock legal hold operation get default response a status code equal to that given
func (o *SnaplockLegalHoldOperationGetDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *SnaplockLegalHoldOperationGetDefault) Error() string {
	return fmt.Sprintf("[GET /storage/snaplock/litigations/{litigation.id}/operations/{id}][%d] snaplock_legal_hold_operation_get default  %+v", o._statusCode, o.Payload)
}

func (o *SnaplockLegalHoldOperationGetDefault) String() string {
	return fmt.Sprintf("[GET /storage/snaplock/litigations/{litigation.id}/operations/{id}][%d] snaplock_legal_hold_operation_get default  %+v", o._statusCode, o.Payload)
}

func (o *SnaplockLegalHoldOperationGetDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SnaplockLegalHoldOperationGetDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
