// Code generated by go-swagger; DO NOT EDIT.

package snaplock

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewSnaplockLogGetParams creates a new SnaplockLogGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewSnaplockLogGetParams() *SnaplockLogGetParams {
	return &SnaplockLogGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewSnaplockLogGetParamsWithTimeout creates a new SnaplockLogGetParams object
// with the ability to set a timeout on a request.
func NewSnaplockLogGetParamsWithTimeout(timeout time.Duration) *SnaplockLogGetParams {
	return &SnaplockLogGetParams{
		timeout: timeout,
	}
}

// NewSnaplockLogGetParamsWithContext creates a new SnaplockLogGetParams object
// with the ability to set a context for a request.
func NewSnaplockLogGetParamsWithContext(ctx context.Context) *SnaplockLogGetParams {
	return &SnaplockLogGetParams{
		Context: ctx,
	}
}

// NewSnaplockLogGetParamsWithHTTPClient creates a new SnaplockLogGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewSnaplockLogGetParamsWithHTTPClient(client *http.Client) *SnaplockLogGetParams {
	return &SnaplockLogGetParams{
		HTTPClient: client,
	}
}

/*
SnaplockLogGetParams contains all the parameters to send to the API endpoint

	for the snaplock log get operation.

	Typically these are written to a http.Request.
*/
type SnaplockLogGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* SvmUUID.

	   SVM UUID
	*/
	SVMUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the snaplock log get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SnaplockLogGetParams) WithDefaults() *SnaplockLogGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the snaplock log get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *SnaplockLogGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the snaplock log get params
func (o *SnaplockLogGetParams) WithTimeout(timeout time.Duration) *SnaplockLogGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the snaplock log get params
func (o *SnaplockLogGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the snaplock log get params
func (o *SnaplockLogGetParams) WithContext(ctx context.Context) *SnaplockLogGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the snaplock log get params
func (o *SnaplockLogGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the snaplock log get params
func (o *SnaplockLogGetParams) WithHTTPClient(client *http.Client) *SnaplockLogGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the snaplock log get params
func (o *SnaplockLogGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the snaplock log get params
func (o *SnaplockLogGetParams) WithFieldsQueryParameter(fields []string) *SnaplockLogGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the snaplock log get params
func (o *SnaplockLogGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithSVMUUIDPathParameter adds the svmUUID to the snaplock log get params
func (o *SnaplockLogGetParams) WithSVMUUIDPathParameter(svmUUID string) *SnaplockLogGetParams {
	o.SetSVMUUIDPathParameter(svmUUID)
	return o
}

// SetSVMUUIDPathParameter adds the svmUuid to the snaplock log get params
func (o *SnaplockLogGetParams) SetSVMUUIDPathParameter(svmUUID string) {
	o.SVMUUIDPathParameter = svmUUID
}

// WriteToRequest writes these params to a swagger request
func (o *SnaplockLogGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param svm.uuid
	if err := r.SetPathParam("svm.uuid", o.SVMUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamSnaplockLogGet binds the parameter fields
func (o *SnaplockLogGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
