// Code generated by go-swagger; DO NOT EDIT.

package snapmirror

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// SnapmirrorPolicyModifyReader is a Reader for the SnapmirrorPolicyModify structure.
type SnapmirrorPolicyModifyReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *SnapmirrorPolicyModifyReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewSnapmirrorPolicyModifyAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewSnapmirrorPolicyModifyDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewSnapmirrorPolicyModifyAccepted creates a SnapmirrorPolicyModifyAccepted with default headers values
func NewSnapmirrorPolicyModifyAccepted() *SnapmirrorPolicyModifyAccepted {
	return &SnapmirrorPolicyModifyAccepted{}
}

/*
SnapmirrorPolicyModifyAccepted describes a response with status code 202, with default header values.

Accepted
*/
type SnapmirrorPolicyModifyAccepted struct {
	Payload *models.JobLinkResponse
}

// IsSuccess returns true when this snapmirror policy modify accepted response has a 2xx status code
func (o *SnapmirrorPolicyModifyAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this snapmirror policy modify accepted response has a 3xx status code
func (o *SnapmirrorPolicyModifyAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this snapmirror policy modify accepted response has a 4xx status code
func (o *SnapmirrorPolicyModifyAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this snapmirror policy modify accepted response has a 5xx status code
func (o *SnapmirrorPolicyModifyAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this snapmirror policy modify accepted response a status code equal to that given
func (o *SnapmirrorPolicyModifyAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *SnapmirrorPolicyModifyAccepted) Error() string {
	return fmt.Sprintf("[PATCH /snapmirror/policies/{uuid}][%d] snapmirrorPolicyModifyAccepted  %+v", 202, o.Payload)
}

func (o *SnapmirrorPolicyModifyAccepted) String() string {
	return fmt.Sprintf("[PATCH /snapmirror/policies/{uuid}][%d] snapmirrorPolicyModifyAccepted  %+v", 202, o.Payload)
}

func (o *SnapmirrorPolicyModifyAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *SnapmirrorPolicyModifyAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewSnapmirrorPolicyModifyDefault creates a SnapmirrorPolicyModifyDefault with default headers values
func NewSnapmirrorPolicyModifyDefault(code int) *SnapmirrorPolicyModifyDefault {
	return &SnapmirrorPolicyModifyDefault{
		_statusCode: code,
	}
}

/*
	SnapmirrorPolicyModifyDefault describes a response with status code -1, with default header values.

	ONTAP Error Response codes

| Error code  |  Description |
|-------------|--------------|
| 6619714     | Schedule specified is an interval schedule. SnapMirror does not support interval schedules. |
| 13303842    | SnapMirror policy is not supported.|
| 13303843    | Conflicting values between SnapMirror policy and SnapMirror relationships for either 'transfer_schedule, throttle or identity_preservation' properties |
| 13303850    | Invalid input parameter |
| 13303887    | Failed to create SnapMirror policy. Reason: Maximum number of allowed retention rules reached |
| 13304050    | Retention cannot be empty for a SnapMirror policy with 'create_snapshot_on_source' set to false. |
*/
type SnapmirrorPolicyModifyDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the snapmirror policy modify default response
func (o *SnapmirrorPolicyModifyDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this snapmirror policy modify default response has a 2xx status code
func (o *SnapmirrorPolicyModifyDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this snapmirror policy modify default response has a 3xx status code
func (o *SnapmirrorPolicyModifyDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this snapmirror policy modify default response has a 4xx status code
func (o *SnapmirrorPolicyModifyDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this snapmirror policy modify default response has a 5xx status code
func (o *SnapmirrorPolicyModifyDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this snapmirror policy modify default response a status code equal to that given
func (o *SnapmirrorPolicyModifyDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *SnapmirrorPolicyModifyDefault) Error() string {
	return fmt.Sprintf("[PATCH /snapmirror/policies/{uuid}][%d] snapmirror_policy_modify default  %+v", o._statusCode, o.Payload)
}

func (o *SnapmirrorPolicyModifyDefault) String() string {
	return fmt.Sprintf("[PATCH /snapmirror/policies/{uuid}][%d] snapmirror_policy_modify default  %+v", o._statusCode, o.Payload)
}

func (o *SnapmirrorPolicyModifyDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *SnapmirrorPolicyModifyDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
