// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewAggregateGetParams creates a new AggregateGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAggregateGetParams() *AggregateGetParams {
	return &AggregateGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAggregateGetParamsWithTimeout creates a new AggregateGetParams object
// with the ability to set a timeout on a request.
func NewAggregateGetParamsWithTimeout(timeout time.Duration) *AggregateGetParams {
	return &AggregateGetParams{
		timeout: timeout,
	}
}

// NewAggregateGetParamsWithContext creates a new AggregateGetParams object
// with the ability to set a context for a request.
func NewAggregateGetParamsWithContext(ctx context.Context) *AggregateGetParams {
	return &AggregateGetParams{
		Context: ctx,
	}
}

// NewAggregateGetParamsWithHTTPClient creates a new AggregateGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewAggregateGetParamsWithHTTPClient(client *http.Client) *AggregateGetParams {
	return &AggregateGetParams{
		HTTPClient: client,
	}
}

/*
AggregateGetParams contains all the parameters to send to the API endpoint

	for the aggregate get operation.

	Typically these are written to a http.Request.
*/
type AggregateGetParams struct {

	/* AutoProvisionPolicy.

	   If set to expand, a query is run on the system for the recommended optimal expansion layout of the aggregate.
	*/
	AutoProvisionPolicyQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* UUID.

	   Aggregate UUID
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the aggregate get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AggregateGetParams) WithDefaults() *AggregateGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the aggregate get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AggregateGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the aggregate get params
func (o *AggregateGetParams) WithTimeout(timeout time.Duration) *AggregateGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the aggregate get params
func (o *AggregateGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the aggregate get params
func (o *AggregateGetParams) WithContext(ctx context.Context) *AggregateGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the aggregate get params
func (o *AggregateGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the aggregate get params
func (o *AggregateGetParams) WithHTTPClient(client *http.Client) *AggregateGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the aggregate get params
func (o *AggregateGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAutoProvisionPolicyQueryParameter adds the autoProvisionPolicy to the aggregate get params
func (o *AggregateGetParams) WithAutoProvisionPolicyQueryParameter(autoProvisionPolicy *string) *AggregateGetParams {
	o.SetAutoProvisionPolicyQueryParameter(autoProvisionPolicy)
	return o
}

// SetAutoProvisionPolicyQueryParameter adds the autoProvisionPolicy to the aggregate get params
func (o *AggregateGetParams) SetAutoProvisionPolicyQueryParameter(autoProvisionPolicy *string) {
	o.AutoProvisionPolicyQueryParameter = autoProvisionPolicy
}

// WithFieldsQueryParameter adds the fields to the aggregate get params
func (o *AggregateGetParams) WithFieldsQueryParameter(fields []string) *AggregateGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the aggregate get params
func (o *AggregateGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithUUIDPathParameter adds the uuid to the aggregate get params
func (o *AggregateGetParams) WithUUIDPathParameter(uuid string) *AggregateGetParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the aggregate get params
func (o *AggregateGetParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *AggregateGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AutoProvisionPolicyQueryParameter != nil {

		// query param auto_provision_policy
		var qrAutoProvisionPolicy string

		if o.AutoProvisionPolicyQueryParameter != nil {
			qrAutoProvisionPolicy = *o.AutoProvisionPolicyQueryParameter
		}
		qAutoProvisionPolicy := qrAutoProvisionPolicy
		if qAutoProvisionPolicy != "" {

			if err := r.SetQueryParam("auto_provision_policy", qAutoProvisionPolicy); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamAggregateGet binds the parameter fields
func (o *AggregateGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
