// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewAggregatePerformanceMetricsCollectionGetParams creates a new AggregatePerformanceMetricsCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAggregatePerformanceMetricsCollectionGetParams() *AggregatePerformanceMetricsCollectionGetParams {
	return &AggregatePerformanceMetricsCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAggregatePerformanceMetricsCollectionGetParamsWithTimeout creates a new AggregatePerformanceMetricsCollectionGetParams object
// with the ability to set a timeout on a request.
func NewAggregatePerformanceMetricsCollectionGetParamsWithTimeout(timeout time.Duration) *AggregatePerformanceMetricsCollectionGetParams {
	return &AggregatePerformanceMetricsCollectionGetParams{
		timeout: timeout,
	}
}

// NewAggregatePerformanceMetricsCollectionGetParamsWithContext creates a new AggregatePerformanceMetricsCollectionGetParams object
// with the ability to set a context for a request.
func NewAggregatePerformanceMetricsCollectionGetParamsWithContext(ctx context.Context) *AggregatePerformanceMetricsCollectionGetParams {
	return &AggregatePerformanceMetricsCollectionGetParams{
		Context: ctx,
	}
}

// NewAggregatePerformanceMetricsCollectionGetParamsWithHTTPClient creates a new AggregatePerformanceMetricsCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewAggregatePerformanceMetricsCollectionGetParamsWithHTTPClient(client *http.Client) *AggregatePerformanceMetricsCollectionGetParams {
	return &AggregatePerformanceMetricsCollectionGetParams{
		HTTPClient: client,
	}
}

/*
AggregatePerformanceMetricsCollectionGetParams contains all the parameters to send to the API endpoint

	for the aggregate performance metrics collection get operation.

	Typically these are written to a http.Request.
*/
type AggregatePerformanceMetricsCollectionGetParams struct {

	/* Duration.

	   Filter by duration
	*/
	DurationQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* Interval.

	     The time range for the data. Values can be 1h, 1d, 1w, 1m, or 1y.
	The period for each time range is as follows:
	* 1h: Metrics over the most recent hour sampled over 15 seconds.
	* 1d: Metrics over the most recent day sampled over 5 minutes.
	* 1w: Metrics over the most recent week sampled over 30 minutes.
	* 1m: Metrics over the most recent month sampled over 2 hours.
	* 1y: Metrics over the most recent year sampled over a day.


	     Default: "1h"
	*/
	IntervalQueryParameter *string

	/* IopsOther.

	   Filter by iops.other
	*/
	IopsOtherQueryParameter *int64

	/* IopsRead.

	   Filter by iops.read
	*/
	IopsReadQueryParameter *int64

	/* IopsTotal.

	   Filter by iops.total
	*/
	IopsTotalQueryParameter *int64

	/* IopsWrite.

	   Filter by iops.write
	*/
	IopsWriteQueryParameter *int64

	/* LatencyOther.

	   Filter by latency.other
	*/
	LatencyOtherQueryParameter *int64

	/* LatencyRead.

	   Filter by latency.read
	*/
	LatencyReadQueryParameter *int64

	/* LatencyTotal.

	   Filter by latency.total
	*/
	LatencyTotalQueryParameter *int64

	/* LatencyWrite.

	   Filter by latency.write
	*/
	LatencyWriteQueryParameter *int64

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* Status.

	   Filter by status
	*/
	StatusQueryParameter *string

	/* ThroughputOther.

	   Filter by throughput.other
	*/
	ThroughputOtherQueryParameter *int64

	/* ThroughputRead.

	   Filter by throughput.read
	*/
	ThroughputReadQueryParameter *int64

	/* ThroughputTotal.

	   Filter by throughput.total
	*/
	ThroughputTotalQueryParameter *int64

	/* ThroughputWrite.

	   Filter by throughput.write
	*/
	ThroughputWriteQueryParameter *int64

	/* Timestamp.

	   Filter by timestamp
	*/
	TimestampQueryParameter *string

	/* UUID.

	   Unique identifier of the aggregate.
	*/
	UUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the aggregate performance metrics collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AggregatePerformanceMetricsCollectionGetParams) WithDefaults() *AggregatePerformanceMetricsCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the aggregate performance metrics collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AggregatePerformanceMetricsCollectionGetParams) SetDefaults() {
	var (
		intervalQueryParameterDefault = string("1h")

		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := AggregatePerformanceMetricsCollectionGetParams{
		IntervalQueryParameter:      &intervalQueryParameterDefault,
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithTimeout(timeout time.Duration) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithContext(ctx context.Context) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithHTTPClient(client *http.Client) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithDurationQueryParameter adds the duration to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithDurationQueryParameter(duration *string) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetDurationQueryParameter(duration)
	return o
}

// SetDurationQueryParameter adds the duration to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetDurationQueryParameter(duration *string) {
	o.DurationQueryParameter = duration
}

// WithFieldsQueryParameter adds the fields to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithFieldsQueryParameter(fields []string) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithIntervalQueryParameter adds the interval to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithIntervalQueryParameter(interval *string) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetIntervalQueryParameter(interval)
	return o
}

// SetIntervalQueryParameter adds the interval to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetIntervalQueryParameter(interval *string) {
	o.IntervalQueryParameter = interval
}

// WithIopsOtherQueryParameter adds the iopsOther to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithIopsOtherQueryParameter(iopsOther *int64) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetIopsOtherQueryParameter(iopsOther)
	return o
}

// SetIopsOtherQueryParameter adds the iopsOther to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetIopsOtherQueryParameter(iopsOther *int64) {
	o.IopsOtherQueryParameter = iopsOther
}

// WithIopsReadQueryParameter adds the iopsRead to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithIopsReadQueryParameter(iopsRead *int64) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetIopsReadQueryParameter(iopsRead)
	return o
}

// SetIopsReadQueryParameter adds the iopsRead to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetIopsReadQueryParameter(iopsRead *int64) {
	o.IopsReadQueryParameter = iopsRead
}

// WithIopsTotalQueryParameter adds the iopsTotal to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithIopsTotalQueryParameter(iopsTotal *int64) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetIopsTotalQueryParameter(iopsTotal)
	return o
}

// SetIopsTotalQueryParameter adds the iopsTotal to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetIopsTotalQueryParameter(iopsTotal *int64) {
	o.IopsTotalQueryParameter = iopsTotal
}

// WithIopsWriteQueryParameter adds the iopsWrite to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithIopsWriteQueryParameter(iopsWrite *int64) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetIopsWriteQueryParameter(iopsWrite)
	return o
}

// SetIopsWriteQueryParameter adds the iopsWrite to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetIopsWriteQueryParameter(iopsWrite *int64) {
	o.IopsWriteQueryParameter = iopsWrite
}

// WithLatencyOtherQueryParameter adds the latencyOther to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithLatencyOtherQueryParameter(latencyOther *int64) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetLatencyOtherQueryParameter(latencyOther)
	return o
}

// SetLatencyOtherQueryParameter adds the latencyOther to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetLatencyOtherQueryParameter(latencyOther *int64) {
	o.LatencyOtherQueryParameter = latencyOther
}

// WithLatencyReadQueryParameter adds the latencyRead to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithLatencyReadQueryParameter(latencyRead *int64) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetLatencyReadQueryParameter(latencyRead)
	return o
}

// SetLatencyReadQueryParameter adds the latencyRead to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetLatencyReadQueryParameter(latencyRead *int64) {
	o.LatencyReadQueryParameter = latencyRead
}

// WithLatencyTotalQueryParameter adds the latencyTotal to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithLatencyTotalQueryParameter(latencyTotal *int64) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetLatencyTotalQueryParameter(latencyTotal)
	return o
}

// SetLatencyTotalQueryParameter adds the latencyTotal to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetLatencyTotalQueryParameter(latencyTotal *int64) {
	o.LatencyTotalQueryParameter = latencyTotal
}

// WithLatencyWriteQueryParameter adds the latencyWrite to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithLatencyWriteQueryParameter(latencyWrite *int64) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetLatencyWriteQueryParameter(latencyWrite)
	return o
}

// SetLatencyWriteQueryParameter adds the latencyWrite to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetLatencyWriteQueryParameter(latencyWrite *int64) {
	o.LatencyWriteQueryParameter = latencyWrite
}

// WithMaxRecordsQueryParameter adds the maxRecords to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithStatusQueryParameter adds the status to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithStatusQueryParameter(status *string) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetStatusQueryParameter(status)
	return o
}

// SetStatusQueryParameter adds the status to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetStatusQueryParameter(status *string) {
	o.StatusQueryParameter = status
}

// WithThroughputOtherQueryParameter adds the throughputOther to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithThroughputOtherQueryParameter(throughputOther *int64) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetThroughputOtherQueryParameter(throughputOther)
	return o
}

// SetThroughputOtherQueryParameter adds the throughputOther to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetThroughputOtherQueryParameter(throughputOther *int64) {
	o.ThroughputOtherQueryParameter = throughputOther
}

// WithThroughputReadQueryParameter adds the throughputRead to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithThroughputReadQueryParameter(throughputRead *int64) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetThroughputReadQueryParameter(throughputRead)
	return o
}

// SetThroughputReadQueryParameter adds the throughputRead to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetThroughputReadQueryParameter(throughputRead *int64) {
	o.ThroughputReadQueryParameter = throughputRead
}

// WithThroughputTotalQueryParameter adds the throughputTotal to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithThroughputTotalQueryParameter(throughputTotal *int64) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetThroughputTotalQueryParameter(throughputTotal)
	return o
}

// SetThroughputTotalQueryParameter adds the throughputTotal to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetThroughputTotalQueryParameter(throughputTotal *int64) {
	o.ThroughputTotalQueryParameter = throughputTotal
}

// WithThroughputWriteQueryParameter adds the throughputWrite to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithThroughputWriteQueryParameter(throughputWrite *int64) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetThroughputWriteQueryParameter(throughputWrite)
	return o
}

// SetThroughputWriteQueryParameter adds the throughputWrite to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetThroughputWriteQueryParameter(throughputWrite *int64) {
	o.ThroughputWriteQueryParameter = throughputWrite
}

// WithTimestampQueryParameter adds the timestamp to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithTimestampQueryParameter(timestamp *string) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetTimestampQueryParameter(timestamp)
	return o
}

// SetTimestampQueryParameter adds the timestamp to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetTimestampQueryParameter(timestamp *string) {
	o.TimestampQueryParameter = timestamp
}

// WithUUIDPathParameter adds the uuid to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) WithUUIDPathParameter(uuid string) *AggregatePerformanceMetricsCollectionGetParams {
	o.SetUUIDPathParameter(uuid)
	return o
}

// SetUUIDPathParameter adds the uuid to the aggregate performance metrics collection get params
func (o *AggregatePerformanceMetricsCollectionGetParams) SetUUIDPathParameter(uuid string) {
	o.UUIDPathParameter = uuid
}

// WriteToRequest writes these params to a swagger request
func (o *AggregatePerformanceMetricsCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.DurationQueryParameter != nil {

		// query param duration
		var qrDuration string

		if o.DurationQueryParameter != nil {
			qrDuration = *o.DurationQueryParameter
		}
		qDuration := qrDuration
		if qDuration != "" {

			if err := r.SetQueryParam("duration", qDuration); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.IntervalQueryParameter != nil {

		// query param interval
		var qrInterval string

		if o.IntervalQueryParameter != nil {
			qrInterval = *o.IntervalQueryParameter
		}
		qInterval := qrInterval
		if qInterval != "" {

			if err := r.SetQueryParam("interval", qInterval); err != nil {
				return err
			}
		}
	}

	if o.IopsOtherQueryParameter != nil {

		// query param iops.other
		var qrIopsOther int64

		if o.IopsOtherQueryParameter != nil {
			qrIopsOther = *o.IopsOtherQueryParameter
		}
		qIopsOther := swag.FormatInt64(qrIopsOther)
		if qIopsOther != "" {

			if err := r.SetQueryParam("iops.other", qIopsOther); err != nil {
				return err
			}
		}
	}

	if o.IopsReadQueryParameter != nil {

		// query param iops.read
		var qrIopsRead int64

		if o.IopsReadQueryParameter != nil {
			qrIopsRead = *o.IopsReadQueryParameter
		}
		qIopsRead := swag.FormatInt64(qrIopsRead)
		if qIopsRead != "" {

			if err := r.SetQueryParam("iops.read", qIopsRead); err != nil {
				return err
			}
		}
	}

	if o.IopsTotalQueryParameter != nil {

		// query param iops.total
		var qrIopsTotal int64

		if o.IopsTotalQueryParameter != nil {
			qrIopsTotal = *o.IopsTotalQueryParameter
		}
		qIopsTotal := swag.FormatInt64(qrIopsTotal)
		if qIopsTotal != "" {

			if err := r.SetQueryParam("iops.total", qIopsTotal); err != nil {
				return err
			}
		}
	}

	if o.IopsWriteQueryParameter != nil {

		// query param iops.write
		var qrIopsWrite int64

		if o.IopsWriteQueryParameter != nil {
			qrIopsWrite = *o.IopsWriteQueryParameter
		}
		qIopsWrite := swag.FormatInt64(qrIopsWrite)
		if qIopsWrite != "" {

			if err := r.SetQueryParam("iops.write", qIopsWrite); err != nil {
				return err
			}
		}
	}

	if o.LatencyOtherQueryParameter != nil {

		// query param latency.other
		var qrLatencyOther int64

		if o.LatencyOtherQueryParameter != nil {
			qrLatencyOther = *o.LatencyOtherQueryParameter
		}
		qLatencyOther := swag.FormatInt64(qrLatencyOther)
		if qLatencyOther != "" {

			if err := r.SetQueryParam("latency.other", qLatencyOther); err != nil {
				return err
			}
		}
	}

	if o.LatencyReadQueryParameter != nil {

		// query param latency.read
		var qrLatencyRead int64

		if o.LatencyReadQueryParameter != nil {
			qrLatencyRead = *o.LatencyReadQueryParameter
		}
		qLatencyRead := swag.FormatInt64(qrLatencyRead)
		if qLatencyRead != "" {

			if err := r.SetQueryParam("latency.read", qLatencyRead); err != nil {
				return err
			}
		}
	}

	if o.LatencyTotalQueryParameter != nil {

		// query param latency.total
		var qrLatencyTotal int64

		if o.LatencyTotalQueryParameter != nil {
			qrLatencyTotal = *o.LatencyTotalQueryParameter
		}
		qLatencyTotal := swag.FormatInt64(qrLatencyTotal)
		if qLatencyTotal != "" {

			if err := r.SetQueryParam("latency.total", qLatencyTotal); err != nil {
				return err
			}
		}
	}

	if o.LatencyWriteQueryParameter != nil {

		// query param latency.write
		var qrLatencyWrite int64

		if o.LatencyWriteQueryParameter != nil {
			qrLatencyWrite = *o.LatencyWriteQueryParameter
		}
		qLatencyWrite := swag.FormatInt64(qrLatencyWrite)
		if qLatencyWrite != "" {

			if err := r.SetQueryParam("latency.write", qLatencyWrite); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.StatusQueryParameter != nil {

		// query param status
		var qrStatus string

		if o.StatusQueryParameter != nil {
			qrStatus = *o.StatusQueryParameter
		}
		qStatus := qrStatus
		if qStatus != "" {

			if err := r.SetQueryParam("status", qStatus); err != nil {
				return err
			}
		}
	}

	if o.ThroughputOtherQueryParameter != nil {

		// query param throughput.other
		var qrThroughputOther int64

		if o.ThroughputOtherQueryParameter != nil {
			qrThroughputOther = *o.ThroughputOtherQueryParameter
		}
		qThroughputOther := swag.FormatInt64(qrThroughputOther)
		if qThroughputOther != "" {

			if err := r.SetQueryParam("throughput.other", qThroughputOther); err != nil {
				return err
			}
		}
	}

	if o.ThroughputReadQueryParameter != nil {

		// query param throughput.read
		var qrThroughputRead int64

		if o.ThroughputReadQueryParameter != nil {
			qrThroughputRead = *o.ThroughputReadQueryParameter
		}
		qThroughputRead := swag.FormatInt64(qrThroughputRead)
		if qThroughputRead != "" {

			if err := r.SetQueryParam("throughput.read", qThroughputRead); err != nil {
				return err
			}
		}
	}

	if o.ThroughputTotalQueryParameter != nil {

		// query param throughput.total
		var qrThroughputTotal int64

		if o.ThroughputTotalQueryParameter != nil {
			qrThroughputTotal = *o.ThroughputTotalQueryParameter
		}
		qThroughputTotal := swag.FormatInt64(qrThroughputTotal)
		if qThroughputTotal != "" {

			if err := r.SetQueryParam("throughput.total", qThroughputTotal); err != nil {
				return err
			}
		}
	}

	if o.ThroughputWriteQueryParameter != nil {

		// query param throughput.write
		var qrThroughputWrite int64

		if o.ThroughputWriteQueryParameter != nil {
			qrThroughputWrite = *o.ThroughputWriteQueryParameter
		}
		qThroughputWrite := swag.FormatInt64(qrThroughputWrite)
		if qThroughputWrite != "" {

			if err := r.SetQueryParam("throughput.write", qThroughputWrite); err != nil {
				return err
			}
		}
	}

	if o.TimestampQueryParameter != nil {

		// query param timestamp
		var qrTimestamp string

		if o.TimestampQueryParameter != nil {
			qrTimestamp = *o.TimestampQueryParameter
		}
		qTimestamp := qrTimestamp
		if qTimestamp != "" {

			if err := r.SetQueryParam("timestamp", qTimestamp); err != nil {
				return err
			}
		}
	}

	// path param uuid
	if err := r.SetPathParam("uuid", o.UUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamAggregatePerformanceMetricsCollectionGet binds the parameter fields
func (o *AggregatePerformanceMetricsCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamAggregatePerformanceMetricsCollectionGet binds the parameter order_by
func (o *AggregatePerformanceMetricsCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
