// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/netapp/trident/storage_drivers/ontap/api/rest/models"
)

// FlexcacheCreateReader is a Reader for the FlexcacheCreate structure.
type FlexcacheCreateReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *FlexcacheCreateReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 202:
		result := NewFlexcacheCreateAccepted()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	default:
		result := NewFlexcacheCreateDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewFlexcacheCreateAccepted creates a FlexcacheCreateAccepted with default headers values
func NewFlexcacheCreateAccepted() *FlexcacheCreateAccepted {
	return &FlexcacheCreateAccepted{}
}

/*
FlexcacheCreateAccepted describes a response with status code 202, with default header values.

Accepted
*/
type FlexcacheCreateAccepted struct {
	Payload *models.JobLinkResponse
}

// IsSuccess returns true when this flexcache create accepted response has a 2xx status code
func (o *FlexcacheCreateAccepted) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this flexcache create accepted response has a 3xx status code
func (o *FlexcacheCreateAccepted) IsRedirect() bool {
	return false
}

// IsClientError returns true when this flexcache create accepted response has a 4xx status code
func (o *FlexcacheCreateAccepted) IsClientError() bool {
	return false
}

// IsServerError returns true when this flexcache create accepted response has a 5xx status code
func (o *FlexcacheCreateAccepted) IsServerError() bool {
	return false
}

// IsCode returns true when this flexcache create accepted response a status code equal to that given
func (o *FlexcacheCreateAccepted) IsCode(code int) bool {
	return code == 202
}

func (o *FlexcacheCreateAccepted) Error() string {
	return fmt.Sprintf("[POST /storage/flexcache/flexcaches][%d] flexcacheCreateAccepted  %+v", 202, o.Payload)
}

func (o *FlexcacheCreateAccepted) String() string {
	return fmt.Sprintf("[POST /storage/flexcache/flexcaches][%d] flexcacheCreateAccepted  %+v", 202, o.Payload)
}

func (o *FlexcacheCreateAccepted) GetPayload() *models.JobLinkResponse {
	return o.Payload
}

func (o *FlexcacheCreateAccepted) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.JobLinkResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewFlexcacheCreateDefault creates a FlexcacheCreateDefault with default headers values
func NewFlexcacheCreateDefault(code int) *FlexcacheCreateDefault {
	return &FlexcacheCreateDefault{
		_statusCode: code,
	}
}

/*
	FlexcacheCreateDefault describes a response with status code -1, with default header values.

	ONTAP Error Response Codes

| Error Code | Description |
| ---------- | ----------- |
| 66846870   | Either the SVM name or origin volume name is missing |
| 66846871   | Constituents per aggregate are specified but aggregate name is missing |
| 66846872   | More than one origin volume is specified |
| 66846873   | The specified SVM UUID is incorrect for the specified SVM name |
| 66846874   | The specified aggregate UUID is incorrect for the specified aggregate name |
| 66846875   | The specified aggregate name does not exist |
| 66846876   | The specified SVM does not exist or is not peered |
| 66846877   | The specified origin SVM name is of zero length  |
| 66846878   | The specified SVM UUID is invalid |
| 66846730   | Failed to create a FlexCache volume |
| 66846760   | The specified SVM is not a data Vserver |
| 66846787   | The specified aggregate is a SnapLock aggregate |
| 66846812   | The specified aggregate is a Composite aggregate |
| 66846812   | The specified junction path is under a FlexCache volume |
| 66846834   | FlexCache encryption requires a cluster version of 9.6 or higher |
| 66846835   | A volume encryption license is not found |
*/
type FlexcacheCreateDefault struct {
	_statusCode int

	Payload *models.ErrorResponse
}

// Code gets the status code for the flexcache create default response
func (o *FlexcacheCreateDefault) Code() int {
	return o._statusCode
}

// IsSuccess returns true when this flexcache create default response has a 2xx status code
func (o *FlexcacheCreateDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this flexcache create default response has a 3xx status code
func (o *FlexcacheCreateDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this flexcache create default response has a 4xx status code
func (o *FlexcacheCreateDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this flexcache create default response has a 5xx status code
func (o *FlexcacheCreateDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this flexcache create default response a status code equal to that given
func (o *FlexcacheCreateDefault) IsCode(code int) bool {
	return o._statusCode == code
}

func (o *FlexcacheCreateDefault) Error() string {
	return fmt.Sprintf("[POST /storage/flexcache/flexcaches][%d] flexcache_create default  %+v", o._statusCode, o.Payload)
}

func (o *FlexcacheCreateDefault) String() string {
	return fmt.Sprintf("[POST /storage/flexcache/flexcaches][%d] flexcache_create default  %+v", o._statusCode, o.Payload)
}

func (o *FlexcacheCreateDefault) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *FlexcacheCreateDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
