// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewQtreeDeleteParams creates a new QtreeDeleteParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewQtreeDeleteParams() *QtreeDeleteParams {
	return &QtreeDeleteParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewQtreeDeleteParamsWithTimeout creates a new QtreeDeleteParams object
// with the ability to set a timeout on a request.
func NewQtreeDeleteParamsWithTimeout(timeout time.Duration) *QtreeDeleteParams {
	return &QtreeDeleteParams{
		timeout: timeout,
	}
}

// NewQtreeDeleteParamsWithContext creates a new QtreeDeleteParams object
// with the ability to set a context for a request.
func NewQtreeDeleteParamsWithContext(ctx context.Context) *QtreeDeleteParams {
	return &QtreeDeleteParams{
		Context: ctx,
	}
}

// NewQtreeDeleteParamsWithHTTPClient creates a new QtreeDeleteParams object
// with the ability to set a custom HTTPClient for a request.
func NewQtreeDeleteParamsWithHTTPClient(client *http.Client) *QtreeDeleteParams {
	return &QtreeDeleteParams{
		HTTPClient: client,
	}
}

/*
QtreeDeleteParams contains all the parameters to send to the API endpoint

	for the qtree delete operation.

	Typically these are written to a http.Request.
*/
type QtreeDeleteParams struct {

	/* ID.

	   Qtree ID
	*/
	IDPathParameter string

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning. When doing a POST, PATCH, or DELETE operation on a single record, the default is 0 seconds.  This means that if an asynchronous operation is started, the server immediately returns HTTP code 202 (Accepted) along with a link to the job.  If a non-zero value is specified for POST, PATCH, or DELETE operations, ONTAP waits that length of time to see if the job completes so it can return something other than 202.
	*/
	ReturnTimeoutQueryParameter *int64

	/* VolumeUUID.

	   Volume UUID
	*/
	VolumeUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the qtree delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *QtreeDeleteParams) WithDefaults() *QtreeDeleteParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the qtree delete params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *QtreeDeleteParams) SetDefaults() {
	var (
		returnTimeoutQueryParameterDefault = int64(0)
	)

	val := QtreeDeleteParams{
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the qtree delete params
func (o *QtreeDeleteParams) WithTimeout(timeout time.Duration) *QtreeDeleteParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the qtree delete params
func (o *QtreeDeleteParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the qtree delete params
func (o *QtreeDeleteParams) WithContext(ctx context.Context) *QtreeDeleteParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the qtree delete params
func (o *QtreeDeleteParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the qtree delete params
func (o *QtreeDeleteParams) WithHTTPClient(client *http.Client) *QtreeDeleteParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the qtree delete params
func (o *QtreeDeleteParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIDPathParameter adds the id to the qtree delete params
func (o *QtreeDeleteParams) WithIDPathParameter(id string) *QtreeDeleteParams {
	o.SetIDPathParameter(id)
	return o
}

// SetIDPathParameter adds the id to the qtree delete params
func (o *QtreeDeleteParams) SetIDPathParameter(id string) {
	o.IDPathParameter = id
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the qtree delete params
func (o *QtreeDeleteParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *QtreeDeleteParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the qtree delete params
func (o *QtreeDeleteParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithVolumeUUIDPathParameter adds the volumeUUID to the qtree delete params
func (o *QtreeDeleteParams) WithVolumeUUIDPathParameter(volumeUUID string) *QtreeDeleteParams {
	o.SetVolumeUUIDPathParameter(volumeUUID)
	return o
}

// SetVolumeUUIDPathParameter adds the volumeUuid to the qtree delete params
func (o *QtreeDeleteParams) SetVolumeUUIDPathParameter(volumeUUID string) {
	o.VolumeUUIDPathParameter = volumeUUID
}

// WriteToRequest writes these params to a swagger request
func (o *QtreeDeleteParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.IDPathParameter); err != nil {
		return err
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	// path param volume.uuid
	if err := r.SetPathParam("volume.uuid", o.VolumeUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
