// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewStorageSwitchGetParams creates a new StorageSwitchGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewStorageSwitchGetParams() *StorageSwitchGetParams {
	return &StorageSwitchGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewStorageSwitchGetParamsWithTimeout creates a new StorageSwitchGetParams object
// with the ability to set a timeout on a request.
func NewStorageSwitchGetParamsWithTimeout(timeout time.Duration) *StorageSwitchGetParams {
	return &StorageSwitchGetParams{
		timeout: timeout,
	}
}

// NewStorageSwitchGetParamsWithContext creates a new StorageSwitchGetParams object
// with the ability to set a context for a request.
func NewStorageSwitchGetParamsWithContext(ctx context.Context) *StorageSwitchGetParams {
	return &StorageSwitchGetParams{
		Context: ctx,
	}
}

// NewStorageSwitchGetParamsWithHTTPClient creates a new StorageSwitchGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewStorageSwitchGetParamsWithHTTPClient(client *http.Client) *StorageSwitchGetParams {
	return &StorageSwitchGetParams{
		HTTPClient: client,
	}
}

/*
StorageSwitchGetParams contains all the parameters to send to the API endpoint

	for the storage switch get operation.

	Typically these are written to a http.Request.
*/
type StorageSwitchGetParams struct {

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	// Name.
	NamePathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the storage switch get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StorageSwitchGetParams) WithDefaults() *StorageSwitchGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the storage switch get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *StorageSwitchGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the storage switch get params
func (o *StorageSwitchGetParams) WithTimeout(timeout time.Duration) *StorageSwitchGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the storage switch get params
func (o *StorageSwitchGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the storage switch get params
func (o *StorageSwitchGetParams) WithContext(ctx context.Context) *StorageSwitchGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the storage switch get params
func (o *StorageSwitchGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the storage switch get params
func (o *StorageSwitchGetParams) WithHTTPClient(client *http.Client) *StorageSwitchGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the storage switch get params
func (o *StorageSwitchGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFieldsQueryParameter adds the fields to the storage switch get params
func (o *StorageSwitchGetParams) WithFieldsQueryParameter(fields []string) *StorageSwitchGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the storage switch get params
func (o *StorageSwitchGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithNamePathParameter adds the name to the storage switch get params
func (o *StorageSwitchGetParams) WithNamePathParameter(name string) *StorageSwitchGetParams {
	o.SetNamePathParameter(name)
	return o
}

// SetNamePathParameter adds the name to the storage switch get params
func (o *StorageSwitchGetParams) SetNamePathParameter(name string) {
	o.NamePathParameter = name
}

// WriteToRequest writes these params to a swagger request
func (o *StorageSwitchGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	// path param name
	if err := r.SetPathParam("name", o.NamePathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamStorageSwitchGet binds the parameter fields
func (o *StorageSwitchGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}
