// Code generated by go-swagger; DO NOT EDIT.

package storage

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewVolumeMetricsCollectionGetParams creates a new VolumeMetricsCollectionGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewVolumeMetricsCollectionGetParams() *VolumeMetricsCollectionGetParams {
	return &VolumeMetricsCollectionGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewVolumeMetricsCollectionGetParamsWithTimeout creates a new VolumeMetricsCollectionGetParams object
// with the ability to set a timeout on a request.
func NewVolumeMetricsCollectionGetParamsWithTimeout(timeout time.Duration) *VolumeMetricsCollectionGetParams {
	return &VolumeMetricsCollectionGetParams{
		timeout: timeout,
	}
}

// NewVolumeMetricsCollectionGetParamsWithContext creates a new VolumeMetricsCollectionGetParams object
// with the ability to set a context for a request.
func NewVolumeMetricsCollectionGetParamsWithContext(ctx context.Context) *VolumeMetricsCollectionGetParams {
	return &VolumeMetricsCollectionGetParams{
		Context: ctx,
	}
}

// NewVolumeMetricsCollectionGetParamsWithHTTPClient creates a new VolumeMetricsCollectionGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewVolumeMetricsCollectionGetParamsWithHTTPClient(client *http.Client) *VolumeMetricsCollectionGetParams {
	return &VolumeMetricsCollectionGetParams{
		HTTPClient: client,
	}
}

/*
VolumeMetricsCollectionGetParams contains all the parameters to send to the API endpoint

	for the volume metrics collection get operation.

	Typically these are written to a http.Request.
*/
type VolumeMetricsCollectionGetParams struct {

	/* CloudDuration.

	   Filter by cloud.duration
	*/
	CloudDurationQueryParameter *string

	/* CloudIopsOther.

	   Filter by cloud.iops.other
	*/
	CloudIopsOtherQueryParameter *int64

	/* CloudIopsRead.

	   Filter by cloud.iops.read
	*/
	CloudIopsReadQueryParameter *int64

	/* CloudIopsTotal.

	   Filter by cloud.iops.total
	*/
	CloudIopsTotalQueryParameter *int64

	/* CloudIopsWrite.

	   Filter by cloud.iops.write
	*/
	CloudIopsWriteQueryParameter *int64

	/* CloudLatencyOther.

	   Filter by cloud.latency.other
	*/
	CloudLatencyOtherQueryParameter *int64

	/* CloudLatencyRead.

	   Filter by cloud.latency.read
	*/
	CloudLatencyReadQueryParameter *int64

	/* CloudLatencyTotal.

	   Filter by cloud.latency.total
	*/
	CloudLatencyTotalQueryParameter *int64

	/* CloudLatencyWrite.

	   Filter by cloud.latency.write
	*/
	CloudLatencyWriteQueryParameter *int64

	/* CloudStatus.

	   Filter by cloud.status
	*/
	CloudStatusQueryParameter *string

	/* CloudTimestamp.

	   Filter by cloud.timestamp
	*/
	CloudTimestampQueryParameter *string

	/* Duration.

	   Filter by duration
	*/
	DurationQueryParameter *string

	/* Fields.

	   Specify the fields to return.
	*/
	FieldsQueryParameter []string

	/* FlexcacheBandwidthSavings.

	   Filter by flexcache.bandwidth_savings
	*/
	FlexcacheBandwidthSavingsQueryParameter *int64

	/* FlexcacheCacheMissPercent.

	   Filter by flexcache.cache_miss_percent
	*/
	FlexcacheCacheMissPercentQueryParameter *int64

	/* FlexcacheDuration.

	   Filter by flexcache.duration
	*/
	FlexcacheDurationQueryParameter *string

	/* FlexcacheStatus.

	   Filter by flexcache.status
	*/
	FlexcacheStatusQueryParameter *string

	/* FlexcacheTimestamp.

	   Filter by flexcache.timestamp
	*/
	FlexcacheTimestampQueryParameter *string

	/* Interval.

	     The time range for the data. Examples can be 1h, 1d, 1m, 1w, 1y.
	The period for each time range is as follows:
	* 1h: Metrics over the most recent hour sampled over 15 seconds.
	* 1d: Metrics over the most recent day sampled over 5 minutes.
	* 1w: Metrics over the most recent week sampled over 30 minutes.
	* 1m: Metrics over the most recent month sampled over 2 hours.
	* 1y: Metrics over the most recent year sampled over a day.


	     Default: "1h"
	*/
	IntervalQueryParameter *string

	/* IopsOther.

	   Filter by iops.other
	*/
	IopsOtherQueryParameter *int64

	/* IopsRead.

	   Filter by iops.read
	*/
	IopsReadQueryParameter *int64

	/* IopsTotal.

	   Filter by iops.total
	*/
	IopsTotalQueryParameter *int64

	/* IopsWrite.

	   Filter by iops.write
	*/
	IopsWriteQueryParameter *int64

	/* LatencyOther.

	   Filter by latency.other
	*/
	LatencyOtherQueryParameter *int64

	/* LatencyRead.

	   Filter by latency.read
	*/
	LatencyReadQueryParameter *int64

	/* LatencyTotal.

	   Filter by latency.total
	*/
	LatencyTotalQueryParameter *int64

	/* LatencyWrite.

	   Filter by latency.write
	*/
	LatencyWriteQueryParameter *int64

	/* MaxRecords.

	   Limit the number of records returned.
	*/
	MaxRecordsQueryParameter *int64

	/* OrderBy.

	   Order results by specified fields and optional [asc|desc] direction. Default direction is 'asc' for ascending.
	*/
	OrderByQueryParameter []string

	/* ReturnRecords.

	   The default is true for GET calls.  When set to false, only the number of records is returned.

	   Default: true
	*/
	ReturnRecordsQueryParameter *bool

	/* ReturnTimeout.

	   The number of seconds to allow the call to execute before returning.  When iterating over a collection, the default is 15 seconds.  ONTAP returns earlier if either max records or the end of the collection is reached.

	   Default: 15
	*/
	ReturnTimeoutQueryParameter *int64

	/* Status.

	   Filter by status
	*/
	StatusQueryParameter *string

	/* ThroughputOther.

	   Filter by throughput.other
	*/
	ThroughputOtherQueryParameter *int64

	/* ThroughputRead.

	   Filter by throughput.read
	*/
	ThroughputReadQueryParameter *int64

	/* ThroughputTotal.

	   Filter by throughput.total
	*/
	ThroughputTotalQueryParameter *int64

	/* ThroughputWrite.

	   Filter by throughput.write
	*/
	ThroughputWriteQueryParameter *int64

	/* Timestamp.

	   Filter by timestamp
	*/
	TimestampQueryParameter *string

	/* VolumeUUID.

	   Unique identifier of the volume.
	*/
	VolumeUUIDPathParameter string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the volume metrics collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VolumeMetricsCollectionGetParams) WithDefaults() *VolumeMetricsCollectionGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the volume metrics collection get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *VolumeMetricsCollectionGetParams) SetDefaults() {
	var (
		intervalQueryParameterDefault = string("1h")

		returnRecordsQueryParameterDefault = bool(true)

		returnTimeoutQueryParameterDefault = int64(15)
	)

	val := VolumeMetricsCollectionGetParams{
		IntervalQueryParameter:      &intervalQueryParameterDefault,
		ReturnRecordsQueryParameter: &returnRecordsQueryParameterDefault,
		ReturnTimeoutQueryParameter: &returnTimeoutQueryParameterDefault,
	}

	val.timeout = o.timeout
	val.Context = o.Context
	val.HTTPClient = o.HTTPClient
	*o = val
}

// WithTimeout adds the timeout to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithTimeout(timeout time.Duration) *VolumeMetricsCollectionGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithContext(ctx context.Context) *VolumeMetricsCollectionGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithHTTPClient(client *http.Client) *VolumeMetricsCollectionGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCloudDurationQueryParameter adds the cloudDuration to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithCloudDurationQueryParameter(cloudDuration *string) *VolumeMetricsCollectionGetParams {
	o.SetCloudDurationQueryParameter(cloudDuration)
	return o
}

// SetCloudDurationQueryParameter adds the cloudDuration to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetCloudDurationQueryParameter(cloudDuration *string) {
	o.CloudDurationQueryParameter = cloudDuration
}

// WithCloudIopsOtherQueryParameter adds the cloudIopsOther to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithCloudIopsOtherQueryParameter(cloudIopsOther *int64) *VolumeMetricsCollectionGetParams {
	o.SetCloudIopsOtherQueryParameter(cloudIopsOther)
	return o
}

// SetCloudIopsOtherQueryParameter adds the cloudIopsOther to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetCloudIopsOtherQueryParameter(cloudIopsOther *int64) {
	o.CloudIopsOtherQueryParameter = cloudIopsOther
}

// WithCloudIopsReadQueryParameter adds the cloudIopsRead to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithCloudIopsReadQueryParameter(cloudIopsRead *int64) *VolumeMetricsCollectionGetParams {
	o.SetCloudIopsReadQueryParameter(cloudIopsRead)
	return o
}

// SetCloudIopsReadQueryParameter adds the cloudIopsRead to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetCloudIopsReadQueryParameter(cloudIopsRead *int64) {
	o.CloudIopsReadQueryParameter = cloudIopsRead
}

// WithCloudIopsTotalQueryParameter adds the cloudIopsTotal to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithCloudIopsTotalQueryParameter(cloudIopsTotal *int64) *VolumeMetricsCollectionGetParams {
	o.SetCloudIopsTotalQueryParameter(cloudIopsTotal)
	return o
}

// SetCloudIopsTotalQueryParameter adds the cloudIopsTotal to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetCloudIopsTotalQueryParameter(cloudIopsTotal *int64) {
	o.CloudIopsTotalQueryParameter = cloudIopsTotal
}

// WithCloudIopsWriteQueryParameter adds the cloudIopsWrite to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithCloudIopsWriteQueryParameter(cloudIopsWrite *int64) *VolumeMetricsCollectionGetParams {
	o.SetCloudIopsWriteQueryParameter(cloudIopsWrite)
	return o
}

// SetCloudIopsWriteQueryParameter adds the cloudIopsWrite to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetCloudIopsWriteQueryParameter(cloudIopsWrite *int64) {
	o.CloudIopsWriteQueryParameter = cloudIopsWrite
}

// WithCloudLatencyOtherQueryParameter adds the cloudLatencyOther to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithCloudLatencyOtherQueryParameter(cloudLatencyOther *int64) *VolumeMetricsCollectionGetParams {
	o.SetCloudLatencyOtherQueryParameter(cloudLatencyOther)
	return o
}

// SetCloudLatencyOtherQueryParameter adds the cloudLatencyOther to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetCloudLatencyOtherQueryParameter(cloudLatencyOther *int64) {
	o.CloudLatencyOtherQueryParameter = cloudLatencyOther
}

// WithCloudLatencyReadQueryParameter adds the cloudLatencyRead to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithCloudLatencyReadQueryParameter(cloudLatencyRead *int64) *VolumeMetricsCollectionGetParams {
	o.SetCloudLatencyReadQueryParameter(cloudLatencyRead)
	return o
}

// SetCloudLatencyReadQueryParameter adds the cloudLatencyRead to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetCloudLatencyReadQueryParameter(cloudLatencyRead *int64) {
	o.CloudLatencyReadQueryParameter = cloudLatencyRead
}

// WithCloudLatencyTotalQueryParameter adds the cloudLatencyTotal to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithCloudLatencyTotalQueryParameter(cloudLatencyTotal *int64) *VolumeMetricsCollectionGetParams {
	o.SetCloudLatencyTotalQueryParameter(cloudLatencyTotal)
	return o
}

// SetCloudLatencyTotalQueryParameter adds the cloudLatencyTotal to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetCloudLatencyTotalQueryParameter(cloudLatencyTotal *int64) {
	o.CloudLatencyTotalQueryParameter = cloudLatencyTotal
}

// WithCloudLatencyWriteQueryParameter adds the cloudLatencyWrite to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithCloudLatencyWriteQueryParameter(cloudLatencyWrite *int64) *VolumeMetricsCollectionGetParams {
	o.SetCloudLatencyWriteQueryParameter(cloudLatencyWrite)
	return o
}

// SetCloudLatencyWriteQueryParameter adds the cloudLatencyWrite to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetCloudLatencyWriteQueryParameter(cloudLatencyWrite *int64) {
	o.CloudLatencyWriteQueryParameter = cloudLatencyWrite
}

// WithCloudStatusQueryParameter adds the cloudStatus to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithCloudStatusQueryParameter(cloudStatus *string) *VolumeMetricsCollectionGetParams {
	o.SetCloudStatusQueryParameter(cloudStatus)
	return o
}

// SetCloudStatusQueryParameter adds the cloudStatus to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetCloudStatusQueryParameter(cloudStatus *string) {
	o.CloudStatusQueryParameter = cloudStatus
}

// WithCloudTimestampQueryParameter adds the cloudTimestamp to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithCloudTimestampQueryParameter(cloudTimestamp *string) *VolumeMetricsCollectionGetParams {
	o.SetCloudTimestampQueryParameter(cloudTimestamp)
	return o
}

// SetCloudTimestampQueryParameter adds the cloudTimestamp to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetCloudTimestampQueryParameter(cloudTimestamp *string) {
	o.CloudTimestampQueryParameter = cloudTimestamp
}

// WithDurationQueryParameter adds the duration to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithDurationQueryParameter(duration *string) *VolumeMetricsCollectionGetParams {
	o.SetDurationQueryParameter(duration)
	return o
}

// SetDurationQueryParameter adds the duration to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetDurationQueryParameter(duration *string) {
	o.DurationQueryParameter = duration
}

// WithFieldsQueryParameter adds the fields to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithFieldsQueryParameter(fields []string) *VolumeMetricsCollectionGetParams {
	o.SetFieldsQueryParameter(fields)
	return o
}

// SetFieldsQueryParameter adds the fields to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetFieldsQueryParameter(fields []string) {
	o.FieldsQueryParameter = fields
}

// WithFlexcacheBandwidthSavingsQueryParameter adds the flexcacheBandwidthSavings to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithFlexcacheBandwidthSavingsQueryParameter(flexcacheBandwidthSavings *int64) *VolumeMetricsCollectionGetParams {
	o.SetFlexcacheBandwidthSavingsQueryParameter(flexcacheBandwidthSavings)
	return o
}

// SetFlexcacheBandwidthSavingsQueryParameter adds the flexcacheBandwidthSavings to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetFlexcacheBandwidthSavingsQueryParameter(flexcacheBandwidthSavings *int64) {
	o.FlexcacheBandwidthSavingsQueryParameter = flexcacheBandwidthSavings
}

// WithFlexcacheCacheMissPercentQueryParameter adds the flexcacheCacheMissPercent to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithFlexcacheCacheMissPercentQueryParameter(flexcacheCacheMissPercent *int64) *VolumeMetricsCollectionGetParams {
	o.SetFlexcacheCacheMissPercentQueryParameter(flexcacheCacheMissPercent)
	return o
}

// SetFlexcacheCacheMissPercentQueryParameter adds the flexcacheCacheMissPercent to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetFlexcacheCacheMissPercentQueryParameter(flexcacheCacheMissPercent *int64) {
	o.FlexcacheCacheMissPercentQueryParameter = flexcacheCacheMissPercent
}

// WithFlexcacheDurationQueryParameter adds the flexcacheDuration to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithFlexcacheDurationQueryParameter(flexcacheDuration *string) *VolumeMetricsCollectionGetParams {
	o.SetFlexcacheDurationQueryParameter(flexcacheDuration)
	return o
}

// SetFlexcacheDurationQueryParameter adds the flexcacheDuration to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetFlexcacheDurationQueryParameter(flexcacheDuration *string) {
	o.FlexcacheDurationQueryParameter = flexcacheDuration
}

// WithFlexcacheStatusQueryParameter adds the flexcacheStatus to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithFlexcacheStatusQueryParameter(flexcacheStatus *string) *VolumeMetricsCollectionGetParams {
	o.SetFlexcacheStatusQueryParameter(flexcacheStatus)
	return o
}

// SetFlexcacheStatusQueryParameter adds the flexcacheStatus to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetFlexcacheStatusQueryParameter(flexcacheStatus *string) {
	o.FlexcacheStatusQueryParameter = flexcacheStatus
}

// WithFlexcacheTimestampQueryParameter adds the flexcacheTimestamp to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithFlexcacheTimestampQueryParameter(flexcacheTimestamp *string) *VolumeMetricsCollectionGetParams {
	o.SetFlexcacheTimestampQueryParameter(flexcacheTimestamp)
	return o
}

// SetFlexcacheTimestampQueryParameter adds the flexcacheTimestamp to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetFlexcacheTimestampQueryParameter(flexcacheTimestamp *string) {
	o.FlexcacheTimestampQueryParameter = flexcacheTimestamp
}

// WithIntervalQueryParameter adds the interval to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithIntervalQueryParameter(interval *string) *VolumeMetricsCollectionGetParams {
	o.SetIntervalQueryParameter(interval)
	return o
}

// SetIntervalQueryParameter adds the interval to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetIntervalQueryParameter(interval *string) {
	o.IntervalQueryParameter = interval
}

// WithIopsOtherQueryParameter adds the iopsOther to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithIopsOtherQueryParameter(iopsOther *int64) *VolumeMetricsCollectionGetParams {
	o.SetIopsOtherQueryParameter(iopsOther)
	return o
}

// SetIopsOtherQueryParameter adds the iopsOther to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetIopsOtherQueryParameter(iopsOther *int64) {
	o.IopsOtherQueryParameter = iopsOther
}

// WithIopsReadQueryParameter adds the iopsRead to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithIopsReadQueryParameter(iopsRead *int64) *VolumeMetricsCollectionGetParams {
	o.SetIopsReadQueryParameter(iopsRead)
	return o
}

// SetIopsReadQueryParameter adds the iopsRead to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetIopsReadQueryParameter(iopsRead *int64) {
	o.IopsReadQueryParameter = iopsRead
}

// WithIopsTotalQueryParameter adds the iopsTotal to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithIopsTotalQueryParameter(iopsTotal *int64) *VolumeMetricsCollectionGetParams {
	o.SetIopsTotalQueryParameter(iopsTotal)
	return o
}

// SetIopsTotalQueryParameter adds the iopsTotal to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetIopsTotalQueryParameter(iopsTotal *int64) {
	o.IopsTotalQueryParameter = iopsTotal
}

// WithIopsWriteQueryParameter adds the iopsWrite to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithIopsWriteQueryParameter(iopsWrite *int64) *VolumeMetricsCollectionGetParams {
	o.SetIopsWriteQueryParameter(iopsWrite)
	return o
}

// SetIopsWriteQueryParameter adds the iopsWrite to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetIopsWriteQueryParameter(iopsWrite *int64) {
	o.IopsWriteQueryParameter = iopsWrite
}

// WithLatencyOtherQueryParameter adds the latencyOther to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithLatencyOtherQueryParameter(latencyOther *int64) *VolumeMetricsCollectionGetParams {
	o.SetLatencyOtherQueryParameter(latencyOther)
	return o
}

// SetLatencyOtherQueryParameter adds the latencyOther to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetLatencyOtherQueryParameter(latencyOther *int64) {
	o.LatencyOtherQueryParameter = latencyOther
}

// WithLatencyReadQueryParameter adds the latencyRead to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithLatencyReadQueryParameter(latencyRead *int64) *VolumeMetricsCollectionGetParams {
	o.SetLatencyReadQueryParameter(latencyRead)
	return o
}

// SetLatencyReadQueryParameter adds the latencyRead to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetLatencyReadQueryParameter(latencyRead *int64) {
	o.LatencyReadQueryParameter = latencyRead
}

// WithLatencyTotalQueryParameter adds the latencyTotal to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithLatencyTotalQueryParameter(latencyTotal *int64) *VolumeMetricsCollectionGetParams {
	o.SetLatencyTotalQueryParameter(latencyTotal)
	return o
}

// SetLatencyTotalQueryParameter adds the latencyTotal to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetLatencyTotalQueryParameter(latencyTotal *int64) {
	o.LatencyTotalQueryParameter = latencyTotal
}

// WithLatencyWriteQueryParameter adds the latencyWrite to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithLatencyWriteQueryParameter(latencyWrite *int64) *VolumeMetricsCollectionGetParams {
	o.SetLatencyWriteQueryParameter(latencyWrite)
	return o
}

// SetLatencyWriteQueryParameter adds the latencyWrite to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetLatencyWriteQueryParameter(latencyWrite *int64) {
	o.LatencyWriteQueryParameter = latencyWrite
}

// WithMaxRecordsQueryParameter adds the maxRecords to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithMaxRecordsQueryParameter(maxRecords *int64) *VolumeMetricsCollectionGetParams {
	o.SetMaxRecordsQueryParameter(maxRecords)
	return o
}

// SetMaxRecordsQueryParameter adds the maxRecords to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetMaxRecordsQueryParameter(maxRecords *int64) {
	o.MaxRecordsQueryParameter = maxRecords
}

// WithOrderByQueryParameter adds the orderBy to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithOrderByQueryParameter(orderBy []string) *VolumeMetricsCollectionGetParams {
	o.SetOrderByQueryParameter(orderBy)
	return o
}

// SetOrderByQueryParameter adds the orderBy to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetOrderByQueryParameter(orderBy []string) {
	o.OrderByQueryParameter = orderBy
}

// WithReturnRecordsQueryParameter adds the returnRecords to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithReturnRecordsQueryParameter(returnRecords *bool) *VolumeMetricsCollectionGetParams {
	o.SetReturnRecordsQueryParameter(returnRecords)
	return o
}

// SetReturnRecordsQueryParameter adds the returnRecords to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetReturnRecordsQueryParameter(returnRecords *bool) {
	o.ReturnRecordsQueryParameter = returnRecords
}

// WithReturnTimeoutQueryParameter adds the returnTimeout to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithReturnTimeoutQueryParameter(returnTimeout *int64) *VolumeMetricsCollectionGetParams {
	o.SetReturnTimeoutQueryParameter(returnTimeout)
	return o
}

// SetReturnTimeoutQueryParameter adds the returnTimeout to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetReturnTimeoutQueryParameter(returnTimeout *int64) {
	o.ReturnTimeoutQueryParameter = returnTimeout
}

// WithStatusQueryParameter adds the status to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithStatusQueryParameter(status *string) *VolumeMetricsCollectionGetParams {
	o.SetStatusQueryParameter(status)
	return o
}

// SetStatusQueryParameter adds the status to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetStatusQueryParameter(status *string) {
	o.StatusQueryParameter = status
}

// WithThroughputOtherQueryParameter adds the throughputOther to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithThroughputOtherQueryParameter(throughputOther *int64) *VolumeMetricsCollectionGetParams {
	o.SetThroughputOtherQueryParameter(throughputOther)
	return o
}

// SetThroughputOtherQueryParameter adds the throughputOther to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetThroughputOtherQueryParameter(throughputOther *int64) {
	o.ThroughputOtherQueryParameter = throughputOther
}

// WithThroughputReadQueryParameter adds the throughputRead to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithThroughputReadQueryParameter(throughputRead *int64) *VolumeMetricsCollectionGetParams {
	o.SetThroughputReadQueryParameter(throughputRead)
	return o
}

// SetThroughputReadQueryParameter adds the throughputRead to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetThroughputReadQueryParameter(throughputRead *int64) {
	o.ThroughputReadQueryParameter = throughputRead
}

// WithThroughputTotalQueryParameter adds the throughputTotal to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithThroughputTotalQueryParameter(throughputTotal *int64) *VolumeMetricsCollectionGetParams {
	o.SetThroughputTotalQueryParameter(throughputTotal)
	return o
}

// SetThroughputTotalQueryParameter adds the throughputTotal to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetThroughputTotalQueryParameter(throughputTotal *int64) {
	o.ThroughputTotalQueryParameter = throughputTotal
}

// WithThroughputWriteQueryParameter adds the throughputWrite to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithThroughputWriteQueryParameter(throughputWrite *int64) *VolumeMetricsCollectionGetParams {
	o.SetThroughputWriteQueryParameter(throughputWrite)
	return o
}

// SetThroughputWriteQueryParameter adds the throughputWrite to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetThroughputWriteQueryParameter(throughputWrite *int64) {
	o.ThroughputWriteQueryParameter = throughputWrite
}

// WithTimestampQueryParameter adds the timestamp to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithTimestampQueryParameter(timestamp *string) *VolumeMetricsCollectionGetParams {
	o.SetTimestampQueryParameter(timestamp)
	return o
}

// SetTimestampQueryParameter adds the timestamp to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetTimestampQueryParameter(timestamp *string) {
	o.TimestampQueryParameter = timestamp
}

// WithVolumeUUIDPathParameter adds the volumeUUID to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) WithVolumeUUIDPathParameter(volumeUUID string) *VolumeMetricsCollectionGetParams {
	o.SetVolumeUUIDPathParameter(volumeUUID)
	return o
}

// SetVolumeUUIDPathParameter adds the volumeUuid to the volume metrics collection get params
func (o *VolumeMetricsCollectionGetParams) SetVolumeUUIDPathParameter(volumeUUID string) {
	o.VolumeUUIDPathParameter = volumeUUID
}

// WriteToRequest writes these params to a swagger request
func (o *VolumeMetricsCollectionGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CloudDurationQueryParameter != nil {

		// query param cloud.duration
		var qrCloudDuration string

		if o.CloudDurationQueryParameter != nil {
			qrCloudDuration = *o.CloudDurationQueryParameter
		}
		qCloudDuration := qrCloudDuration
		if qCloudDuration != "" {

			if err := r.SetQueryParam("cloud.duration", qCloudDuration); err != nil {
				return err
			}
		}
	}

	if o.CloudIopsOtherQueryParameter != nil {

		// query param cloud.iops.other
		var qrCloudIopsOther int64

		if o.CloudIopsOtherQueryParameter != nil {
			qrCloudIopsOther = *o.CloudIopsOtherQueryParameter
		}
		qCloudIopsOther := swag.FormatInt64(qrCloudIopsOther)
		if qCloudIopsOther != "" {

			if err := r.SetQueryParam("cloud.iops.other", qCloudIopsOther); err != nil {
				return err
			}
		}
	}

	if o.CloudIopsReadQueryParameter != nil {

		// query param cloud.iops.read
		var qrCloudIopsRead int64

		if o.CloudIopsReadQueryParameter != nil {
			qrCloudIopsRead = *o.CloudIopsReadQueryParameter
		}
		qCloudIopsRead := swag.FormatInt64(qrCloudIopsRead)
		if qCloudIopsRead != "" {

			if err := r.SetQueryParam("cloud.iops.read", qCloudIopsRead); err != nil {
				return err
			}
		}
	}

	if o.CloudIopsTotalQueryParameter != nil {

		// query param cloud.iops.total
		var qrCloudIopsTotal int64

		if o.CloudIopsTotalQueryParameter != nil {
			qrCloudIopsTotal = *o.CloudIopsTotalQueryParameter
		}
		qCloudIopsTotal := swag.FormatInt64(qrCloudIopsTotal)
		if qCloudIopsTotal != "" {

			if err := r.SetQueryParam("cloud.iops.total", qCloudIopsTotal); err != nil {
				return err
			}
		}
	}

	if o.CloudIopsWriteQueryParameter != nil {

		// query param cloud.iops.write
		var qrCloudIopsWrite int64

		if o.CloudIopsWriteQueryParameter != nil {
			qrCloudIopsWrite = *o.CloudIopsWriteQueryParameter
		}
		qCloudIopsWrite := swag.FormatInt64(qrCloudIopsWrite)
		if qCloudIopsWrite != "" {

			if err := r.SetQueryParam("cloud.iops.write", qCloudIopsWrite); err != nil {
				return err
			}
		}
	}

	if o.CloudLatencyOtherQueryParameter != nil {

		// query param cloud.latency.other
		var qrCloudLatencyOther int64

		if o.CloudLatencyOtherQueryParameter != nil {
			qrCloudLatencyOther = *o.CloudLatencyOtherQueryParameter
		}
		qCloudLatencyOther := swag.FormatInt64(qrCloudLatencyOther)
		if qCloudLatencyOther != "" {

			if err := r.SetQueryParam("cloud.latency.other", qCloudLatencyOther); err != nil {
				return err
			}
		}
	}

	if o.CloudLatencyReadQueryParameter != nil {

		// query param cloud.latency.read
		var qrCloudLatencyRead int64

		if o.CloudLatencyReadQueryParameter != nil {
			qrCloudLatencyRead = *o.CloudLatencyReadQueryParameter
		}
		qCloudLatencyRead := swag.FormatInt64(qrCloudLatencyRead)
		if qCloudLatencyRead != "" {

			if err := r.SetQueryParam("cloud.latency.read", qCloudLatencyRead); err != nil {
				return err
			}
		}
	}

	if o.CloudLatencyTotalQueryParameter != nil {

		// query param cloud.latency.total
		var qrCloudLatencyTotal int64

		if o.CloudLatencyTotalQueryParameter != nil {
			qrCloudLatencyTotal = *o.CloudLatencyTotalQueryParameter
		}
		qCloudLatencyTotal := swag.FormatInt64(qrCloudLatencyTotal)
		if qCloudLatencyTotal != "" {

			if err := r.SetQueryParam("cloud.latency.total", qCloudLatencyTotal); err != nil {
				return err
			}
		}
	}

	if o.CloudLatencyWriteQueryParameter != nil {

		// query param cloud.latency.write
		var qrCloudLatencyWrite int64

		if o.CloudLatencyWriteQueryParameter != nil {
			qrCloudLatencyWrite = *o.CloudLatencyWriteQueryParameter
		}
		qCloudLatencyWrite := swag.FormatInt64(qrCloudLatencyWrite)
		if qCloudLatencyWrite != "" {

			if err := r.SetQueryParam("cloud.latency.write", qCloudLatencyWrite); err != nil {
				return err
			}
		}
	}

	if o.CloudStatusQueryParameter != nil {

		// query param cloud.status
		var qrCloudStatus string

		if o.CloudStatusQueryParameter != nil {
			qrCloudStatus = *o.CloudStatusQueryParameter
		}
		qCloudStatus := qrCloudStatus
		if qCloudStatus != "" {

			if err := r.SetQueryParam("cloud.status", qCloudStatus); err != nil {
				return err
			}
		}
	}

	if o.CloudTimestampQueryParameter != nil {

		// query param cloud.timestamp
		var qrCloudTimestamp string

		if o.CloudTimestampQueryParameter != nil {
			qrCloudTimestamp = *o.CloudTimestampQueryParameter
		}
		qCloudTimestamp := qrCloudTimestamp
		if qCloudTimestamp != "" {

			if err := r.SetQueryParam("cloud.timestamp", qCloudTimestamp); err != nil {
				return err
			}
		}
	}

	if o.DurationQueryParameter != nil {

		// query param duration
		var qrDuration string

		if o.DurationQueryParameter != nil {
			qrDuration = *o.DurationQueryParameter
		}
		qDuration := qrDuration
		if qDuration != "" {

			if err := r.SetQueryParam("duration", qDuration); err != nil {
				return err
			}
		}
	}

	if o.FieldsQueryParameter != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.FlexcacheBandwidthSavingsQueryParameter != nil {

		// query param flexcache.bandwidth_savings
		var qrFlexcacheBandwidthSavings int64

		if o.FlexcacheBandwidthSavingsQueryParameter != nil {
			qrFlexcacheBandwidthSavings = *o.FlexcacheBandwidthSavingsQueryParameter
		}
		qFlexcacheBandwidthSavings := swag.FormatInt64(qrFlexcacheBandwidthSavings)
		if qFlexcacheBandwidthSavings != "" {

			if err := r.SetQueryParam("flexcache.bandwidth_savings", qFlexcacheBandwidthSavings); err != nil {
				return err
			}
		}
	}

	if o.FlexcacheCacheMissPercentQueryParameter != nil {

		// query param flexcache.cache_miss_percent
		var qrFlexcacheCacheMissPercent int64

		if o.FlexcacheCacheMissPercentQueryParameter != nil {
			qrFlexcacheCacheMissPercent = *o.FlexcacheCacheMissPercentQueryParameter
		}
		qFlexcacheCacheMissPercent := swag.FormatInt64(qrFlexcacheCacheMissPercent)
		if qFlexcacheCacheMissPercent != "" {

			if err := r.SetQueryParam("flexcache.cache_miss_percent", qFlexcacheCacheMissPercent); err != nil {
				return err
			}
		}
	}

	if o.FlexcacheDurationQueryParameter != nil {

		// query param flexcache.duration
		var qrFlexcacheDuration string

		if o.FlexcacheDurationQueryParameter != nil {
			qrFlexcacheDuration = *o.FlexcacheDurationQueryParameter
		}
		qFlexcacheDuration := qrFlexcacheDuration
		if qFlexcacheDuration != "" {

			if err := r.SetQueryParam("flexcache.duration", qFlexcacheDuration); err != nil {
				return err
			}
		}
	}

	if o.FlexcacheStatusQueryParameter != nil {

		// query param flexcache.status
		var qrFlexcacheStatus string

		if o.FlexcacheStatusQueryParameter != nil {
			qrFlexcacheStatus = *o.FlexcacheStatusQueryParameter
		}
		qFlexcacheStatus := qrFlexcacheStatus
		if qFlexcacheStatus != "" {

			if err := r.SetQueryParam("flexcache.status", qFlexcacheStatus); err != nil {
				return err
			}
		}
	}

	if o.FlexcacheTimestampQueryParameter != nil {

		// query param flexcache.timestamp
		var qrFlexcacheTimestamp string

		if o.FlexcacheTimestampQueryParameter != nil {
			qrFlexcacheTimestamp = *o.FlexcacheTimestampQueryParameter
		}
		qFlexcacheTimestamp := qrFlexcacheTimestamp
		if qFlexcacheTimestamp != "" {

			if err := r.SetQueryParam("flexcache.timestamp", qFlexcacheTimestamp); err != nil {
				return err
			}
		}
	}

	if o.IntervalQueryParameter != nil {

		// query param interval
		var qrInterval string

		if o.IntervalQueryParameter != nil {
			qrInterval = *o.IntervalQueryParameter
		}
		qInterval := qrInterval
		if qInterval != "" {

			if err := r.SetQueryParam("interval", qInterval); err != nil {
				return err
			}
		}
	}

	if o.IopsOtherQueryParameter != nil {

		// query param iops.other
		var qrIopsOther int64

		if o.IopsOtherQueryParameter != nil {
			qrIopsOther = *o.IopsOtherQueryParameter
		}
		qIopsOther := swag.FormatInt64(qrIopsOther)
		if qIopsOther != "" {

			if err := r.SetQueryParam("iops.other", qIopsOther); err != nil {
				return err
			}
		}
	}

	if o.IopsReadQueryParameter != nil {

		// query param iops.read
		var qrIopsRead int64

		if o.IopsReadQueryParameter != nil {
			qrIopsRead = *o.IopsReadQueryParameter
		}
		qIopsRead := swag.FormatInt64(qrIopsRead)
		if qIopsRead != "" {

			if err := r.SetQueryParam("iops.read", qIopsRead); err != nil {
				return err
			}
		}
	}

	if o.IopsTotalQueryParameter != nil {

		// query param iops.total
		var qrIopsTotal int64

		if o.IopsTotalQueryParameter != nil {
			qrIopsTotal = *o.IopsTotalQueryParameter
		}
		qIopsTotal := swag.FormatInt64(qrIopsTotal)
		if qIopsTotal != "" {

			if err := r.SetQueryParam("iops.total", qIopsTotal); err != nil {
				return err
			}
		}
	}

	if o.IopsWriteQueryParameter != nil {

		// query param iops.write
		var qrIopsWrite int64

		if o.IopsWriteQueryParameter != nil {
			qrIopsWrite = *o.IopsWriteQueryParameter
		}
		qIopsWrite := swag.FormatInt64(qrIopsWrite)
		if qIopsWrite != "" {

			if err := r.SetQueryParam("iops.write", qIopsWrite); err != nil {
				return err
			}
		}
	}

	if o.LatencyOtherQueryParameter != nil {

		// query param latency.other
		var qrLatencyOther int64

		if o.LatencyOtherQueryParameter != nil {
			qrLatencyOther = *o.LatencyOtherQueryParameter
		}
		qLatencyOther := swag.FormatInt64(qrLatencyOther)
		if qLatencyOther != "" {

			if err := r.SetQueryParam("latency.other", qLatencyOther); err != nil {
				return err
			}
		}
	}

	if o.LatencyReadQueryParameter != nil {

		// query param latency.read
		var qrLatencyRead int64

		if o.LatencyReadQueryParameter != nil {
			qrLatencyRead = *o.LatencyReadQueryParameter
		}
		qLatencyRead := swag.FormatInt64(qrLatencyRead)
		if qLatencyRead != "" {

			if err := r.SetQueryParam("latency.read", qLatencyRead); err != nil {
				return err
			}
		}
	}

	if o.LatencyTotalQueryParameter != nil {

		// query param latency.total
		var qrLatencyTotal int64

		if o.LatencyTotalQueryParameter != nil {
			qrLatencyTotal = *o.LatencyTotalQueryParameter
		}
		qLatencyTotal := swag.FormatInt64(qrLatencyTotal)
		if qLatencyTotal != "" {

			if err := r.SetQueryParam("latency.total", qLatencyTotal); err != nil {
				return err
			}
		}
	}

	if o.LatencyWriteQueryParameter != nil {

		// query param latency.write
		var qrLatencyWrite int64

		if o.LatencyWriteQueryParameter != nil {
			qrLatencyWrite = *o.LatencyWriteQueryParameter
		}
		qLatencyWrite := swag.FormatInt64(qrLatencyWrite)
		if qLatencyWrite != "" {

			if err := r.SetQueryParam("latency.write", qLatencyWrite); err != nil {
				return err
			}
		}
	}

	if o.MaxRecordsQueryParameter != nil {

		// query param max_records
		var qrMaxRecords int64

		if o.MaxRecordsQueryParameter != nil {
			qrMaxRecords = *o.MaxRecordsQueryParameter
		}
		qMaxRecords := swag.FormatInt64(qrMaxRecords)
		if qMaxRecords != "" {

			if err := r.SetQueryParam("max_records", qMaxRecords); err != nil {
				return err
			}
		}
	}

	if o.OrderByQueryParameter != nil {

		// binding items for order_by
		joinedOrderBy := o.bindParamOrderBy(reg)

		// query array param order_by
		if err := r.SetQueryParam("order_by", joinedOrderBy...); err != nil {
			return err
		}
	}

	if o.ReturnRecordsQueryParameter != nil {

		// query param return_records
		var qrReturnRecords bool

		if o.ReturnRecordsQueryParameter != nil {
			qrReturnRecords = *o.ReturnRecordsQueryParameter
		}
		qReturnRecords := swag.FormatBool(qrReturnRecords)
		if qReturnRecords != "" {

			if err := r.SetQueryParam("return_records", qReturnRecords); err != nil {
				return err
			}
		}
	}

	if o.ReturnTimeoutQueryParameter != nil {

		// query param return_timeout
		var qrReturnTimeout int64

		if o.ReturnTimeoutQueryParameter != nil {
			qrReturnTimeout = *o.ReturnTimeoutQueryParameter
		}
		qReturnTimeout := swag.FormatInt64(qrReturnTimeout)
		if qReturnTimeout != "" {

			if err := r.SetQueryParam("return_timeout", qReturnTimeout); err != nil {
				return err
			}
		}
	}

	if o.StatusQueryParameter != nil {

		// query param status
		var qrStatus string

		if o.StatusQueryParameter != nil {
			qrStatus = *o.StatusQueryParameter
		}
		qStatus := qrStatus
		if qStatus != "" {

			if err := r.SetQueryParam("status", qStatus); err != nil {
				return err
			}
		}
	}

	if o.ThroughputOtherQueryParameter != nil {

		// query param throughput.other
		var qrThroughputOther int64

		if o.ThroughputOtherQueryParameter != nil {
			qrThroughputOther = *o.ThroughputOtherQueryParameter
		}
		qThroughputOther := swag.FormatInt64(qrThroughputOther)
		if qThroughputOther != "" {

			if err := r.SetQueryParam("throughput.other", qThroughputOther); err != nil {
				return err
			}
		}
	}

	if o.ThroughputReadQueryParameter != nil {

		// query param throughput.read
		var qrThroughputRead int64

		if o.ThroughputReadQueryParameter != nil {
			qrThroughputRead = *o.ThroughputReadQueryParameter
		}
		qThroughputRead := swag.FormatInt64(qrThroughputRead)
		if qThroughputRead != "" {

			if err := r.SetQueryParam("throughput.read", qThroughputRead); err != nil {
				return err
			}
		}
	}

	if o.ThroughputTotalQueryParameter != nil {

		// query param throughput.total
		var qrThroughputTotal int64

		if o.ThroughputTotalQueryParameter != nil {
			qrThroughputTotal = *o.ThroughputTotalQueryParameter
		}
		qThroughputTotal := swag.FormatInt64(qrThroughputTotal)
		if qThroughputTotal != "" {

			if err := r.SetQueryParam("throughput.total", qThroughputTotal); err != nil {
				return err
			}
		}
	}

	if o.ThroughputWriteQueryParameter != nil {

		// query param throughput.write
		var qrThroughputWrite int64

		if o.ThroughputWriteQueryParameter != nil {
			qrThroughputWrite = *o.ThroughputWriteQueryParameter
		}
		qThroughputWrite := swag.FormatInt64(qrThroughputWrite)
		if qThroughputWrite != "" {

			if err := r.SetQueryParam("throughput.write", qThroughputWrite); err != nil {
				return err
			}
		}
	}

	if o.TimestampQueryParameter != nil {

		// query param timestamp
		var qrTimestamp string

		if o.TimestampQueryParameter != nil {
			qrTimestamp = *o.TimestampQueryParameter
		}
		qTimestamp := qrTimestamp
		if qTimestamp != "" {

			if err := r.SetQueryParam("timestamp", qTimestamp); err != nil {
				return err
			}
		}
	}

	// path param volume.uuid
	if err := r.SetPathParam("volume.uuid", o.VolumeUUIDPathParameter); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamVolumeMetricsCollectionGet binds the parameter fields
func (o *VolumeMetricsCollectionGetParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.FieldsQueryParameter

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "csv"
	fieldsIS := swag.JoinByFormat(fieldsIC, "csv")

	return fieldsIS
}

// bindParamVolumeMetricsCollectionGet binds the parameter order_by
func (o *VolumeMetricsCollectionGetParams) bindParamOrderBy(formats strfmt.Registry) []string {
	orderByIR := o.OrderByQueryParameter

	var orderByIC []string
	for _, orderByIIR := range orderByIR { // explode []string

		orderByIIV := orderByIIR // string as string
		orderByIC = append(orderByIC, orderByIIV)
	}

	// items.CollectionFormat: "csv"
	orderByIS := swag.JoinByFormat(orderByIC, "csv")

	return orderByIS
}
