// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// ClusterSSHServer cluster ssh server
//
// swagger:model cluster_ssh_server
type ClusterSSHServer struct {

	// links
	Links *ClusterSSHServerLinks `json:"_links,omitempty"`

	// Ciphers for encrypting the data.
	// Example: ["aes256_ctr","aes192_ctr","aes128_ctr"]
	Ciphers []Cipher `json:"ciphers,omitempty"`

	// Maximum connections allowed per second.
	// Maximum: 70
	// Minimum: 1
	ConnectionsPerSecond int64 `json:"connections_per_second,omitempty"`

	// Key exchange algorithms.
	// Example: ["diffie_hellman_group_exchange_sha256","diffie_hellman_group14_sha1"]
	KeyExchangeAlgorithms []KeyExchangeAlgorithm `json:"key_exchange_algorithms,omitempty"`

	// MAC algorithms.
	// Example: ["hmac_sha1","hmac_sha2_512_etm"]
	MacAlgorithms []MacAlgorithm `json:"mac_algorithms,omitempty"`

	// Maximum authentication retries allowed before closing the connection.
	// Maximum: 6
	// Minimum: 2
	MaxAuthenticationRetryCount int64 `json:"max_authentication_retry_count,omitempty"`

	// Maximum possible simultaneous connections.
	// Maximum: 128
	// Minimum: 1
	MaxInstances int64 `json:"max_instances,omitempty"`

	// Maximum connections from the same client host.
	// Maximum: 64
	// Minimum: 1
	PerSourceLimit int64 `json:"per_source_limit,omitempty"`
}

// Validate validates this cluster ssh server
func (m *ClusterSSHServer) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCiphers(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateConnectionsPerSecond(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateKeyExchangeAlgorithms(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateMacAlgorithms(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateMaxAuthenticationRetryCount(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateMaxInstances(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePerSourceLimit(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ClusterSSHServer) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *ClusterSSHServer) validateCiphers(formats strfmt.Registry) error {
	if swag.IsZero(m.Ciphers) { // not required
		return nil
	}

	for i := 0; i < len(m.Ciphers); i++ {

		if err := m.Ciphers[i].Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ciphers" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

func (m *ClusterSSHServer) validateConnectionsPerSecond(formats strfmt.Registry) error {
	if swag.IsZero(m.ConnectionsPerSecond) { // not required
		return nil
	}

	if err := validate.MinimumInt("connections_per_second", "body", m.ConnectionsPerSecond, 1, false); err != nil {
		return err
	}

	if err := validate.MaximumInt("connections_per_second", "body", m.ConnectionsPerSecond, 70, false); err != nil {
		return err
	}

	return nil
}

func (m *ClusterSSHServer) validateKeyExchangeAlgorithms(formats strfmt.Registry) error {
	if swag.IsZero(m.KeyExchangeAlgorithms) { // not required
		return nil
	}

	for i := 0; i < len(m.KeyExchangeAlgorithms); i++ {

		if err := m.KeyExchangeAlgorithms[i].Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("key_exchange_algorithms" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

func (m *ClusterSSHServer) validateMacAlgorithms(formats strfmt.Registry) error {
	if swag.IsZero(m.MacAlgorithms) { // not required
		return nil
	}

	for i := 0; i < len(m.MacAlgorithms); i++ {

		if err := m.MacAlgorithms[i].Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("mac_algorithms" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

func (m *ClusterSSHServer) validateMaxAuthenticationRetryCount(formats strfmt.Registry) error {
	if swag.IsZero(m.MaxAuthenticationRetryCount) { // not required
		return nil
	}

	if err := validate.MinimumInt("max_authentication_retry_count", "body", m.MaxAuthenticationRetryCount, 2, false); err != nil {
		return err
	}

	if err := validate.MaximumInt("max_authentication_retry_count", "body", m.MaxAuthenticationRetryCount, 6, false); err != nil {
		return err
	}

	return nil
}

func (m *ClusterSSHServer) validateMaxInstances(formats strfmt.Registry) error {
	if swag.IsZero(m.MaxInstances) { // not required
		return nil
	}

	if err := validate.MinimumInt("max_instances", "body", m.MaxInstances, 1, false); err != nil {
		return err
	}

	if err := validate.MaximumInt("max_instances", "body", m.MaxInstances, 128, false); err != nil {
		return err
	}

	return nil
}

func (m *ClusterSSHServer) validatePerSourceLimit(formats strfmt.Registry) error {
	if swag.IsZero(m.PerSourceLimit) { // not required
		return nil
	}

	if err := validate.MinimumInt("per_source_limit", "body", m.PerSourceLimit, 1, false); err != nil {
		return err
	}

	if err := validate.MaximumInt("per_source_limit", "body", m.PerSourceLimit, 64, false); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this cluster ssh server based on the context it is used
func (m *ClusterSSHServer) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateCiphers(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateKeyExchangeAlgorithms(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateMacAlgorithms(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ClusterSSHServer) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *ClusterSSHServer) contextValidateCiphers(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Ciphers); i++ {

		if err := m.Ciphers[i].ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ciphers" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

func (m *ClusterSSHServer) contextValidateKeyExchangeAlgorithms(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.KeyExchangeAlgorithms); i++ {

		if err := m.KeyExchangeAlgorithms[i].ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("key_exchange_algorithms" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

func (m *ClusterSSHServer) contextValidateMacAlgorithms(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.MacAlgorithms); i++ {

		if err := m.MacAlgorithms[i].ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("mac_algorithms" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *ClusterSSHServer) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ClusterSSHServer) UnmarshalBinary(b []byte) error {
	var res ClusterSSHServer
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ClusterSSHServerLinks cluster SSH server links
//
// swagger:model ClusterSSHServerLinks
type ClusterSSHServerLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this cluster SSH server links
func (m *ClusterSSHServerLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ClusterSSHServerLinks) validateSelf(formats strfmt.Registry) error {
	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this cluster SSH server links based on the context it is used
func (m *ClusterSSHServerLinks) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSelf(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ClusterSSHServerLinks) contextValidateSelf(ctx context.Context, formats strfmt.Registry) error {

	if m.Self != nil {
		if err := m.Self.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ClusterSSHServerLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ClusterSSHServerLinks) UnmarshalBinary(b []byte) error {
	var res ClusterSSHServerLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
