// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// HwAssist The hardware assist information.
//
// swagger:model hw_assist
type HwAssist struct {

	// status
	Status *HwAssistStatusType `json:"status,omitempty"`
}

// Validate validates this hw assist
func (m *HwAssist) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateStatus(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *HwAssist) validateStatus(formats strfmt.Registry) error {
	if swag.IsZero(m.Status) { // not required
		return nil
	}

	if m.Status != nil {
		if err := m.Status.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("status")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this hw assist based on the context it is used
func (m *HwAssist) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateStatus(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *HwAssist) contextValidateStatus(ctx context.Context, formats strfmt.Registry) error {

	if m.Status != nil {
		if err := m.Status.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("status")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *HwAssist) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *HwAssist) UnmarshalBinary(b []byte) error {
	var res HwAssist
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// HwAssistStatusType hw assist status type
//
// swagger:model HwAssistStatusType
type HwAssistStatusType struct {

	// Indicates whether hardware assist is enabled on the node.
	Enabled bool `json:"enabled,omitempty"`

	// local
	Local *HwAssistStatusLocal `json:"local,omitempty"`

	// partner
	Partner *HwAssistStatusPartner `json:"partner,omitempty"`
}

// Validate validates this hw assist status type
func (m *HwAssistStatusType) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLocal(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePartner(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *HwAssistStatusType) validateLocal(formats strfmt.Registry) error {
	if swag.IsZero(m.Local) { // not required
		return nil
	}

	if m.Local != nil {
		if err := m.Local.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("status" + "." + "local")
			}
			return err
		}
	}

	return nil
}

func (m *HwAssistStatusType) validatePartner(formats strfmt.Registry) error {
	if swag.IsZero(m.Partner) { // not required
		return nil
	}

	if m.Partner != nil {
		if err := m.Partner.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("status" + "." + "partner")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this hw assist status type based on the context it is used
func (m *HwAssistStatusType) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLocal(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidatePartner(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *HwAssistStatusType) contextValidateLocal(ctx context.Context, formats strfmt.Registry) error {

	if m.Local != nil {
		if err := m.Local.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("status" + "." + "local")
			}
			return err
		}
	}

	return nil
}

func (m *HwAssistStatusType) contextValidatePartner(ctx context.Context, formats strfmt.Registry) error {

	if m.Partner != nil {
		if err := m.Partner.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("status" + "." + "partner")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *HwAssistStatusType) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *HwAssistStatusType) UnmarshalBinary(b []byte) error {
	var res HwAssistStatusType
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// HwAssistStatusLocal hw assist status local
//
// swagger:model HwAssistStatusLocal
type HwAssistStatusLocal struct {

	// The hardware assist IP address.
	IP string `json:"ip,omitempty"`

	// The hardware assist port.
	Port int64 `json:"port,omitempty"`

	// The hardware assist monitor status.
	// Enum: [active inactive]
	State string `json:"state,omitempty"`
}

// Validate validates this hw assist status local
func (m *HwAssistStatusLocal) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var hwAssistStatusLocalTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["active","inactive"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		hwAssistStatusLocalTypeStatePropEnum = append(hwAssistStatusLocalTypeStatePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// HwAssistStatusLocal
	// HwAssistStatusLocal
	// state
	// State
	// active
	// END DEBUGGING
	// HwAssistStatusLocalStateActive captures enum value "active"
	HwAssistStatusLocalStateActive string = "active"

	// BEGIN DEBUGGING
	// HwAssistStatusLocal
	// HwAssistStatusLocal
	// state
	// State
	// inactive
	// END DEBUGGING
	// HwAssistStatusLocalStateInactive captures enum value "inactive"
	HwAssistStatusLocalStateInactive string = "inactive"
)

// prop value enum
func (m *HwAssistStatusLocal) validateStateEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, hwAssistStatusLocalTypeStatePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *HwAssistStatusLocal) validateState(formats strfmt.Registry) error {
	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("status"+"."+"local"+"."+"state", "body", m.State); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this hw assist status local based on context it is used
func (m *HwAssistStatusLocal) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *HwAssistStatusLocal) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *HwAssistStatusLocal) UnmarshalBinary(b []byte) error {
	var res HwAssistStatusLocal
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// HwAssistStatusPartner hw assist status partner
//
// swagger:model HwAssistStatusPartner
type HwAssistStatusPartner struct {

	// The hardware assist IP address.
	IP string `json:"ip,omitempty"`

	// The hardware assist port.
	Port int64 `json:"port,omitempty"`

	// The hardware assist monitor status.
	// Enum: [active inactive]
	State string `json:"state,omitempty"`
}

// Validate validates this hw assist status partner
func (m *HwAssistStatusPartner) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var hwAssistStatusPartnerTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["active","inactive"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		hwAssistStatusPartnerTypeStatePropEnum = append(hwAssistStatusPartnerTypeStatePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// HwAssistStatusPartner
	// HwAssistStatusPartner
	// state
	// State
	// active
	// END DEBUGGING
	// HwAssistStatusPartnerStateActive captures enum value "active"
	HwAssistStatusPartnerStateActive string = "active"

	// BEGIN DEBUGGING
	// HwAssistStatusPartner
	// HwAssistStatusPartner
	// state
	// State
	// inactive
	// END DEBUGGING
	// HwAssistStatusPartnerStateInactive captures enum value "inactive"
	HwAssistStatusPartnerStateInactive string = "inactive"
)

// prop value enum
func (m *HwAssistStatusPartner) validateStateEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, hwAssistStatusPartnerTypeStatePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *HwAssistStatusPartner) validateState(formats strfmt.Registry) error {
	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("status"+"."+"partner"+"."+"state", "body", m.State); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this hw assist status partner based on context it is used
func (m *HwAssistStatusPartner) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *HwAssistStatusPartner) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *HwAssistStatusPartner) UnmarshalBinary(b []byte) error {
	var res HwAssistStatusPartner
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
