// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// KeyManagerConfig Manages the various key manager configuration options.
//
// swagger:model key_manager_config
type KeyManagerConfig struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// Indicates whether the Common Criteria Mode configuration is enabled.
	CcModeEnabled bool `json:"cc_mode_enabled,omitempty"`

	// Cloud key manager connection retry count. Supported value range of 0-10.
	// Example: 3
	CloudKmsRetryCount int64 `json:"cloud_kms_retry_count,omitempty"`

	// Health Monitor Polling Period, in minutes. Supported value range of 15-30 minutes.
	// Example: 20
	HealthMonitorPollingInterval int64 `json:"health_monitor_polling_interval,omitempty"`

	// Current cluster-wide passphrase. This is a required field when setting the cc_mode_enabled field value to true. This is not audited.
	// Example: The cluster passphrase of length 64-256 ASCII characters.
	// Format: password
	Passphrase strfmt.Password `json:"passphrase,omitempty"`
}

// Validate validates this key manager config
func (m *KeyManagerConfig) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePassphrase(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *KeyManagerConfig) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *KeyManagerConfig) validatePassphrase(formats strfmt.Registry) error {
	if swag.IsZero(m.Passphrase) { // not required
		return nil
	}

	if err := validate.FormatOf("passphrase", "body", "password", m.Passphrase.String(), formats); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this key manager config based on the context it is used
func (m *KeyManagerConfig) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *KeyManagerConfig) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *KeyManagerConfig) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *KeyManagerConfig) UnmarshalBinary(b []byte) error {
	var res KeyManagerConfig
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
