// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// NvmeInterface NVMe interfaces are network interfaces configured to support an NVMe over Fabrics (NVMe-oF) protocol. The NVMe interfaces are Fibre Channel interfaces supporting an NVMe-oF data protocol. Regardless of the underlying physical and data protocol, NVMe interfaces are treated equally for host-side application configuration. This endpoint provides a consolidated view of all NVMe interfaces for the purpose of configuring host-side applications.<br/>
// NVMe interfaces must be created using the protocol-specific endpoints for Fibre Channel interfaces. See [`POST /network/fc/interfaces`](#/networking/fc_interface_create). After creation, the interfaces are available via this interface.
//
// swagger:model nvme_interface
type NvmeInterface struct {

	// links
	Links *NvmeInterfaceLinks `json:"_links,omitempty"`

	// The administrative state of the NVMe interface.
	//
	// Read Only: true
	Enabled *bool `json:"enabled,omitempty"`

	// fc interface
	FcInterface *NvmeInterfaceFcInterface `json:"fc_interface,omitempty"`

	// The underlying interface type of the NVMe interface. This property identifies which of _fc_interface_ and _ip_interface_ will be further populated.
	//
	// Read Only: true
	// Enum: [fc_interface ip_interface]
	InterfaceType string `json:"interface_type,omitempty"`

	// ip interface
	IPInterface *NvmeInterfaceIPInterface `json:"ip_interface,omitempty"`

	// The name of the NVMe interface.
	//
	// Example: lif1
	// Read Only: true
	Name string `json:"name,omitempty"`

	// node
	Node *NvmeInterfaceNode `json:"node,omitempty"`

	// svm
	Svm *NvmeInterfaceSvm `json:"svm,omitempty"`

	// The transport address of the NVMe interface.
	//
	// Example: nn-0x200a00a0989062da:pn-0x200100a0989062da
	// Read Only: true
	TransportAddress string `json:"transport_address,omitempty"`

	// The transport protocols supported by the NVMe interface.
	//
	TransportProtocols []string `json:"transport_protocols,omitempty"`

	// The unique identifier of the NVMe interface.
	//
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	// Read Only: true
	UUID string `json:"uuid,omitempty"`
}

// Validate validates this nvme interface
func (m *NvmeInterface) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateFcInterface(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateInterfaceType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIPInterface(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNode(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSvm(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateTransportProtocols(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterface) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterface) validateFcInterface(formats strfmt.Registry) error {
	if swag.IsZero(m.FcInterface) { // not required
		return nil
	}

	if m.FcInterface != nil {
		if err := m.FcInterface.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fc_interface")
			}
			return err
		}
	}

	return nil
}

var nvmeInterfaceTypeInterfaceTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["fc_interface","ip_interface"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		nvmeInterfaceTypeInterfaceTypePropEnum = append(nvmeInterfaceTypeInterfaceTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// nvme_interface
	// NvmeInterface
	// interface_type
	// InterfaceType
	// fc_interface
	// END DEBUGGING
	// NvmeInterfaceInterfaceTypeFcInterface captures enum value "fc_interface"
	NvmeInterfaceInterfaceTypeFcInterface string = "fc_interface"

	// BEGIN DEBUGGING
	// nvme_interface
	// NvmeInterface
	// interface_type
	// InterfaceType
	// ip_interface
	// END DEBUGGING
	// NvmeInterfaceInterfaceTypeIPInterface captures enum value "ip_interface"
	NvmeInterfaceInterfaceTypeIPInterface string = "ip_interface"
)

// prop value enum
func (m *NvmeInterface) validateInterfaceTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, nvmeInterfaceTypeInterfaceTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *NvmeInterface) validateInterfaceType(formats strfmt.Registry) error {
	if swag.IsZero(m.InterfaceType) { // not required
		return nil
	}

	// value enum
	if err := m.validateInterfaceTypeEnum("interface_type", "body", m.InterfaceType); err != nil {
		return err
	}

	return nil
}

func (m *NvmeInterface) validateIPInterface(formats strfmt.Registry) error {
	if swag.IsZero(m.IPInterface) { // not required
		return nil
	}

	if m.IPInterface != nil {
		if err := m.IPInterface.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ip_interface")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterface) validateNode(formats strfmt.Registry) error {
	if swag.IsZero(m.Node) { // not required
		return nil
	}

	if m.Node != nil {
		if err := m.Node.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterface) validateSvm(formats strfmt.Registry) error {
	if swag.IsZero(m.Svm) { // not required
		return nil
	}

	if m.Svm != nil {
		if err := m.Svm.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm")
			}
			return err
		}
	}

	return nil
}

var nvmeInterfaceTransportProtocolsItemsEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["fc_nvme","nvme_tcp"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		nvmeInterfaceTransportProtocolsItemsEnum = append(nvmeInterfaceTransportProtocolsItemsEnum, v)
	}
}

func (m *NvmeInterface) validateTransportProtocolsItemsEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, nvmeInterfaceTransportProtocolsItemsEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *NvmeInterface) validateTransportProtocols(formats strfmt.Registry) error {
	if swag.IsZero(m.TransportProtocols) { // not required
		return nil
	}

	for i := 0; i < len(m.TransportProtocols); i++ {

		// value enum
		if err := m.validateTransportProtocolsItemsEnum("transport_protocols"+"."+strconv.Itoa(i), "body", m.TransportProtocols[i]); err != nil {
			return err
		}

	}

	return nil
}

// ContextValidate validate this nvme interface based on the context it is used
func (m *NvmeInterface) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateEnabled(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateFcInterface(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateInterfaceType(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateIPInterface(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateName(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateNode(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSvm(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateTransportAddress(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateTransportProtocols(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateUUID(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterface) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterface) contextValidateEnabled(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "enabled", "body", m.Enabled); err != nil {
		return err
	}

	return nil
}

func (m *NvmeInterface) contextValidateFcInterface(ctx context.Context, formats strfmt.Registry) error {

	if m.FcInterface != nil {
		if err := m.FcInterface.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fc_interface")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterface) contextValidateInterfaceType(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "interface_type", "body", string(m.InterfaceType)); err != nil {
		return err
	}

	return nil
}

func (m *NvmeInterface) contextValidateIPInterface(ctx context.Context, formats strfmt.Registry) error {

	if m.IPInterface != nil {
		if err := m.IPInterface.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ip_interface")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterface) contextValidateName(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "name", "body", string(m.Name)); err != nil {
		return err
	}

	return nil
}

func (m *NvmeInterface) contextValidateNode(ctx context.Context, formats strfmt.Registry) error {

	if m.Node != nil {
		if err := m.Node.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterface) contextValidateSvm(ctx context.Context, formats strfmt.Registry) error {

	if m.Svm != nil {
		if err := m.Svm.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterface) contextValidateTransportAddress(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "transport_address", "body", string(m.TransportAddress)); err != nil {
		return err
	}

	return nil
}

func (m *NvmeInterface) contextValidateTransportProtocols(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.TransportProtocols); i++ {

		if err := validate.ReadOnly(ctx, "transport_protocols"+"."+strconv.Itoa(i), "body", string(m.TransportProtocols[i])); err != nil {
			return err
		}

	}

	return nil
}

func (m *NvmeInterface) contextValidateUUID(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "uuid", "body", string(m.UUID)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *NvmeInterface) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NvmeInterface) UnmarshalBinary(b []byte) error {
	var res NvmeInterface
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// NvmeInterfaceFcInterface The attributes specific to a Fibre Channel-based NVMe interface.<br/>
// This is populated when `interface_type` is _fc_interface_.
//
// swagger:model NvmeInterfaceFcInterface
type NvmeInterfaceFcInterface struct {

	// links
	Links *NvmeInterfaceFcInterfaceLinks `json:"_links,omitempty"`

	// port
	Port *NvmeInterfaceFcInterfacePort `json:"port,omitempty"`

	// The WWNN (world wide node name) of the Fibre Channel NVMe interface.
	//
	// Example: 20:00:00:50:56:b4:13:a9
	// Read Only: true
	Wwnn string `json:"wwnn,omitempty"`

	// The WWPN (world wide port name) of the Fibre Channel NVMe interface.
	//
	// Example: 20:00:00:50:56:b4:13:a8
	// Read Only: true
	Wwpn string `json:"wwpn,omitempty"`
}

// Validate validates this nvme interface fc interface
func (m *NvmeInterfaceFcInterface) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePort(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceFcInterface) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fc_interface" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterfaceFcInterface) validatePort(formats strfmt.Registry) error {
	if swag.IsZero(m.Port) { // not required
		return nil
	}

	if m.Port != nil {
		if err := m.Port.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fc_interface" + "." + "port")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this nvme interface fc interface based on the context it is used
func (m *NvmeInterfaceFcInterface) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidatePort(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateWwnn(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateWwpn(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceFcInterface) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fc_interface" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterfaceFcInterface) contextValidatePort(ctx context.Context, formats strfmt.Registry) error {

	if m.Port != nil {
		if err := m.Port.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fc_interface" + "." + "port")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterfaceFcInterface) contextValidateWwnn(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "fc_interface"+"."+"wwnn", "body", string(m.Wwnn)); err != nil {
		return err
	}

	return nil
}

func (m *NvmeInterfaceFcInterface) contextValidateWwpn(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "fc_interface"+"."+"wwpn", "body", string(m.Wwpn)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *NvmeInterfaceFcInterface) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NvmeInterfaceFcInterface) UnmarshalBinary(b []byte) error {
	var res NvmeInterfaceFcInterface
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// NvmeInterfaceFcInterfaceLinks nvme interface fc interface links
//
// swagger:model NvmeInterfaceFcInterfaceLinks
type NvmeInterfaceFcInterfaceLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this nvme interface fc interface links
func (m *NvmeInterfaceFcInterfaceLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceFcInterfaceLinks) validateSelf(formats strfmt.Registry) error {
	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fc_interface" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this nvme interface fc interface links based on the context it is used
func (m *NvmeInterfaceFcInterfaceLinks) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSelf(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceFcInterfaceLinks) contextValidateSelf(ctx context.Context, formats strfmt.Registry) error {

	if m.Self != nil {
		if err := m.Self.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fc_interface" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *NvmeInterfaceFcInterfaceLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NvmeInterfaceFcInterfaceLinks) UnmarshalBinary(b []byte) error {
	var res NvmeInterfaceFcInterfaceLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// NvmeInterfaceFcInterfacePort An FC port is the physical port of an FC adapter on a cluster node that can be connected to an FC network.
//
// swagger:model NvmeInterfaceFcInterfacePort
type NvmeInterfaceFcInterfacePort struct {

	// links
	Links *NvmeInterfaceFcInterfacePortLinks `json:"_links,omitempty"`

	// The name of the FC port.
	//
	// Example: 0a
	Name string `json:"name,omitempty"`

	// node
	Node *NvmeInterfaceFcInterfacePortNode `json:"node,omitempty"`

	// The unique identifier of the FC port.
	//
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	UUID string `json:"uuid,omitempty"`
}

// Validate validates this nvme interface fc interface port
func (m *NvmeInterfaceFcInterfacePort) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNode(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceFcInterfacePort) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fc_interface" + "." + "port" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterfaceFcInterfacePort) validateNode(formats strfmt.Registry) error {
	if swag.IsZero(m.Node) { // not required
		return nil
	}

	if m.Node != nil {
		if err := m.Node.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fc_interface" + "." + "port" + "." + "node")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this nvme interface fc interface port based on the context it is used
func (m *NvmeInterfaceFcInterfacePort) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateNode(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceFcInterfacePort) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fc_interface" + "." + "port" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterfaceFcInterfacePort) contextValidateNode(ctx context.Context, formats strfmt.Registry) error {

	if m.Node != nil {
		if err := m.Node.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fc_interface" + "." + "port" + "." + "node")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *NvmeInterfaceFcInterfacePort) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NvmeInterfaceFcInterfacePort) UnmarshalBinary(b []byte) error {
	var res NvmeInterfaceFcInterfacePort
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// NvmeInterfaceFcInterfacePortLinks nvme interface fc interface port links
//
// swagger:model NvmeInterfaceFcInterfacePortLinks
type NvmeInterfaceFcInterfacePortLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this nvme interface fc interface port links
func (m *NvmeInterfaceFcInterfacePortLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceFcInterfacePortLinks) validateSelf(formats strfmt.Registry) error {
	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fc_interface" + "." + "port" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this nvme interface fc interface port links based on the context it is used
func (m *NvmeInterfaceFcInterfacePortLinks) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSelf(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceFcInterfacePortLinks) contextValidateSelf(ctx context.Context, formats strfmt.Registry) error {

	if m.Self != nil {
		if err := m.Self.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("fc_interface" + "." + "port" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *NvmeInterfaceFcInterfacePortLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NvmeInterfaceFcInterfacePortLinks) UnmarshalBinary(b []byte) error {
	var res NvmeInterfaceFcInterfacePortLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// NvmeInterfaceFcInterfacePortNode The node on which the FC port is located.
//
// swagger:model NvmeInterfaceFcInterfacePortNode
type NvmeInterfaceFcInterfacePortNode struct {

	// The name of the node on which the FC port is located.
	//
	// Example: node1
	Name string `json:"name,omitempty"`
}

// Validate validates this nvme interface fc interface port node
func (m *NvmeInterfaceFcInterfacePortNode) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this nvme interface fc interface port node based on context it is used
func (m *NvmeInterfaceFcInterfacePortNode) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *NvmeInterfaceFcInterfacePortNode) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NvmeInterfaceFcInterfacePortNode) UnmarshalBinary(b []byte) error {
	var res NvmeInterfaceFcInterfacePortNode
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// NvmeInterfaceIPInterface The attributes specific to an IP-based NVMe interface.<br/>
// This is populated when `interface_type` is _ip_interface_.
//
// swagger:model NvmeInterfaceIPInterface
type NvmeInterfaceIPInterface struct {

	// links
	Links *SelfLink `json:"_links,omitempty"`

	// ip
	IP *NvmeInterfaceIPInterfaceIP `json:"ip,omitempty"`

	// location
	Location *NvmeInterfaceIPInterfaceLocation `json:"location,omitempty"`
}

// Validate validates this nvme interface IP interface
func (m *NvmeInterfaceIPInterface) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIP(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLocation(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceIPInterface) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ip_interface" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterfaceIPInterface) validateIP(formats strfmt.Registry) error {
	if swag.IsZero(m.IP) { // not required
		return nil
	}

	if m.IP != nil {
		if err := m.IP.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ip_interface" + "." + "ip")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterfaceIPInterface) validateLocation(formats strfmt.Registry) error {
	if swag.IsZero(m.Location) { // not required
		return nil
	}

	if m.Location != nil {
		if err := m.Location.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ip_interface" + "." + "location")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this nvme interface IP interface based on the context it is used
func (m *NvmeInterfaceIPInterface) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateIP(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLocation(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceIPInterface) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ip_interface" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterfaceIPInterface) contextValidateIP(ctx context.Context, formats strfmt.Registry) error {

	if m.IP != nil {
		if err := m.IP.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ip_interface" + "." + "ip")
			}
			return err
		}
	}

	return nil
}

func (m *NvmeInterfaceIPInterface) contextValidateLocation(ctx context.Context, formats strfmt.Registry) error {

	if m.Location != nil {
		if err := m.Location.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ip_interface" + "." + "location")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *NvmeInterfaceIPInterface) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NvmeInterfaceIPInterface) UnmarshalBinary(b []byte) error {
	var res NvmeInterfaceIPInterface
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// NvmeInterfaceIPInterfaceIP nvme interface IP interface IP
//
// swagger:model NvmeInterfaceIPInterfaceIP
type NvmeInterfaceIPInterfaceIP struct {

	// address
	// Read Only: true
	Address IPAddressReadonly `json:"address,omitempty"`
}

// Validate validates this nvme interface IP interface IP
func (m *NvmeInterfaceIPInterfaceIP) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAddress(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceIPInterfaceIP) validateAddress(formats strfmt.Registry) error {
	if swag.IsZero(m.Address) { // not required
		return nil
	}

	if err := m.Address.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("ip_interface" + "." + "ip" + "." + "address")
		}
		return err
	}

	return nil
}

// ContextValidate validate this nvme interface IP interface IP based on the context it is used
func (m *NvmeInterfaceIPInterfaceIP) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateAddress(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceIPInterfaceIP) contextValidateAddress(ctx context.Context, formats strfmt.Registry) error {

	if err := m.Address.ContextValidate(ctx, formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("ip_interface" + "." + "ip" + "." + "address")
		}
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *NvmeInterfaceIPInterfaceIP) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NvmeInterfaceIPInterfaceIP) UnmarshalBinary(b []byte) error {
	var res NvmeInterfaceIPInterfaceIP
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// NvmeInterfaceIPInterfaceLocation nvme interface IP interface location
//
// swagger:model NvmeInterfaceIPInterfaceLocation
type NvmeInterfaceIPInterfaceLocation struct {

	// port
	// Read Only: true
	Port *PortReference `json:"port,omitempty"`
}

// Validate validates this nvme interface IP interface location
func (m *NvmeInterfaceIPInterfaceLocation) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validatePort(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceIPInterfaceLocation) validatePort(formats strfmt.Registry) error {
	if swag.IsZero(m.Port) { // not required
		return nil
	}

	if m.Port != nil {
		if err := m.Port.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ip_interface" + "." + "location" + "." + "port")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this nvme interface IP interface location based on the context it is used
func (m *NvmeInterfaceIPInterfaceLocation) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidatePort(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceIPInterfaceLocation) contextValidatePort(ctx context.Context, formats strfmt.Registry) error {

	if m.Port != nil {
		if err := m.Port.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ip_interface" + "." + "location" + "." + "port")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *NvmeInterfaceIPInterfaceLocation) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NvmeInterfaceIPInterfaceLocation) UnmarshalBinary(b []byte) error {
	var res NvmeInterfaceIPInterfaceLocation
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// NvmeInterfaceLinks nvme interface links
//
// swagger:model NvmeInterfaceLinks
type NvmeInterfaceLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this nvme interface links
func (m *NvmeInterfaceLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceLinks) validateSelf(formats strfmt.Registry) error {
	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this nvme interface links based on the context it is used
func (m *NvmeInterfaceLinks) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSelf(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceLinks) contextValidateSelf(ctx context.Context, formats strfmt.Registry) error {

	if m.Self != nil {
		if err := m.Self.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *NvmeInterfaceLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NvmeInterfaceLinks) UnmarshalBinary(b []byte) error {
	var res NvmeInterfaceLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// NvmeInterfaceNode nvme interface node
//
// swagger:model NvmeInterfaceNode
type NvmeInterfaceNode struct {

	// links
	Links *NvmeInterfaceNodeLinks `json:"_links,omitempty"`

	// name
	// Example: node1
	Name string `json:"name,omitempty"`

	// uuid
	// Example: 1cd8a442-86d1-11e0-ae1c-123478563412
	UUID string `json:"uuid,omitempty"`
}

// Validate validates this nvme interface node
func (m *NvmeInterfaceNode) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceNode) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this nvme interface node based on the context it is used
func (m *NvmeInterfaceNode) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceNode) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *NvmeInterfaceNode) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NvmeInterfaceNode) UnmarshalBinary(b []byte) error {
	var res NvmeInterfaceNode
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// NvmeInterfaceNodeLinks nvme interface node links
//
// swagger:model NvmeInterfaceNodeLinks
type NvmeInterfaceNodeLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this nvme interface node links
func (m *NvmeInterfaceNodeLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceNodeLinks) validateSelf(formats strfmt.Registry) error {
	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this nvme interface node links based on the context it is used
func (m *NvmeInterfaceNodeLinks) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSelf(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceNodeLinks) contextValidateSelf(ctx context.Context, formats strfmt.Registry) error {

	if m.Self != nil {
		if err := m.Self.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("node" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *NvmeInterfaceNodeLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NvmeInterfaceNodeLinks) UnmarshalBinary(b []byte) error {
	var res NvmeInterfaceNodeLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// NvmeInterfaceSvm nvme interface svm
//
// swagger:model NvmeInterfaceSvm
type NvmeInterfaceSvm struct {

	// links
	Links *NvmeInterfaceSvmLinks `json:"_links,omitempty"`

	// The name of the SVM.
	//
	// Example: svm1
	Name string `json:"name,omitempty"`

	// The unique identifier of the SVM.
	//
	// Example: 02c9e252-41be-11e9-81d5-00a0986138f7
	UUID string `json:"uuid,omitempty"`
}

// Validate validates this nvme interface svm
func (m *NvmeInterfaceSvm) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLinks(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceSvm) validateLinks(formats strfmt.Registry) error {
	if swag.IsZero(m.Links) { // not required
		return nil
	}

	if m.Links != nil {
		if err := m.Links.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this nvme interface svm based on the context it is used
func (m *NvmeInterfaceSvm) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateLinks(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceSvm) contextValidateLinks(ctx context.Context, formats strfmt.Registry) error {

	if m.Links != nil {
		if err := m.Links.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *NvmeInterfaceSvm) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NvmeInterfaceSvm) UnmarshalBinary(b []byte) error {
	var res NvmeInterfaceSvm
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// NvmeInterfaceSvmLinks nvme interface svm links
//
// swagger:model NvmeInterfaceSvmLinks
type NvmeInterfaceSvmLinks struct {

	// self
	Self *Href `json:"self,omitempty"`
}

// Validate validates this nvme interface svm links
func (m *NvmeInterfaceSvmLinks) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateSelf(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceSvmLinks) validateSelf(formats strfmt.Registry) error {
	if swag.IsZero(m.Self) { // not required
		return nil
	}

	if m.Self != nil {
		if err := m.Self.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this nvme interface svm links based on the context it is used
func (m *NvmeInterfaceSvmLinks) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSelf(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *NvmeInterfaceSvmLinks) contextValidateSelf(ctx context.Context, formats strfmt.Registry) error {

	if m.Self != nil {
		if err := m.Self.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("svm" + "." + "_links" + "." + "self")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *NvmeInterfaceSvmLinks) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *NvmeInterfaceSvmLinks) UnmarshalBinary(b []byte) error {
	var res NvmeInterfaceSvmLinks
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
