// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// OracleRacOnSanNewIgroups The list of initiator groups to create.
//
// swagger:model oracle_rac_on_san_new_igroups
type OracleRacOnSanNewIgroups struct {

	// A comment available for use by the administrator.
	Comment string `json:"comment,omitempty"`

	// igroups
	Igroups []*OracleRacOnSanNewIgroupsIgroupsItems0 `json:"igroups,omitempty"`

	// initiator objects
	InitiatorObjects []*OracleRacOnSanNewIgroupsInitiatorObjectsItems0 `json:"initiator_objects,omitempty"`

	// initiators
	Initiators []string `json:"initiators,omitempty"`

	// The name of the new initiator group.
	// Required: true
	// Max Length: 96
	// Min Length: 1
	Name *string `json:"name"`

	// The name of the host OS accessing the application. The default value is the host OS that is running the application.
	// Enum: [aix hpux hyper_v linux solaris vmware windows xen]
	OsType string `json:"os_type,omitempty"`

	// The protocol of the new initiator group.
	// Enum: [fcp iscsi mixed]
	Protocol *string `json:"protocol,omitempty"`
}

// Validate validates this oracle rac on san new igroups
func (m *OracleRacOnSanNewIgroups) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateIgroups(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateInitiatorObjects(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateOsType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateProtocol(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *OracleRacOnSanNewIgroups) validateIgroups(formats strfmt.Registry) error {
	if swag.IsZero(m.Igroups) { // not required
		return nil
	}

	for i := 0; i < len(m.Igroups); i++ {
		if swag.IsZero(m.Igroups[i]) { // not required
			continue
		}

		if m.Igroups[i] != nil {
			if err := m.Igroups[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("igroups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *OracleRacOnSanNewIgroups) validateInitiatorObjects(formats strfmt.Registry) error {
	if swag.IsZero(m.InitiatorObjects) { // not required
		return nil
	}

	for i := 0; i < len(m.InitiatorObjects); i++ {
		if swag.IsZero(m.InitiatorObjects[i]) { // not required
			continue
		}

		if m.InitiatorObjects[i] != nil {
			if err := m.InitiatorObjects[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("initiator_objects" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *OracleRacOnSanNewIgroups) validateName(formats strfmt.Registry) error {

	if err := validate.Required("name", "body", m.Name); err != nil {
		return err
	}

	if err := validate.MinLength("name", "body", *m.Name, 1); err != nil {
		return err
	}

	if err := validate.MaxLength("name", "body", *m.Name, 96); err != nil {
		return err
	}

	return nil
}

var oracleRacOnSanNewIgroupsTypeOsTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["aix","hpux","hyper_v","linux","solaris","vmware","windows","xen"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		oracleRacOnSanNewIgroupsTypeOsTypePropEnum = append(oracleRacOnSanNewIgroupsTypeOsTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// oracle_rac_on_san_new_igroups
	// OracleRacOnSanNewIgroups
	// os_type
	// OsType
	// aix
	// END DEBUGGING
	// OracleRacOnSanNewIgroupsOsTypeAix captures enum value "aix"
	OracleRacOnSanNewIgroupsOsTypeAix string = "aix"

	// BEGIN DEBUGGING
	// oracle_rac_on_san_new_igroups
	// OracleRacOnSanNewIgroups
	// os_type
	// OsType
	// hpux
	// END DEBUGGING
	// OracleRacOnSanNewIgroupsOsTypeHpux captures enum value "hpux"
	OracleRacOnSanNewIgroupsOsTypeHpux string = "hpux"

	// BEGIN DEBUGGING
	// oracle_rac_on_san_new_igroups
	// OracleRacOnSanNewIgroups
	// os_type
	// OsType
	// hyper_v
	// END DEBUGGING
	// OracleRacOnSanNewIgroupsOsTypeHyperv captures enum value "hyper_v"
	OracleRacOnSanNewIgroupsOsTypeHyperv string = "hyper_v"

	// BEGIN DEBUGGING
	// oracle_rac_on_san_new_igroups
	// OracleRacOnSanNewIgroups
	// os_type
	// OsType
	// linux
	// END DEBUGGING
	// OracleRacOnSanNewIgroupsOsTypeLinux captures enum value "linux"
	OracleRacOnSanNewIgroupsOsTypeLinux string = "linux"

	// BEGIN DEBUGGING
	// oracle_rac_on_san_new_igroups
	// OracleRacOnSanNewIgroups
	// os_type
	// OsType
	// solaris
	// END DEBUGGING
	// OracleRacOnSanNewIgroupsOsTypeSolaris captures enum value "solaris"
	OracleRacOnSanNewIgroupsOsTypeSolaris string = "solaris"

	// BEGIN DEBUGGING
	// oracle_rac_on_san_new_igroups
	// OracleRacOnSanNewIgroups
	// os_type
	// OsType
	// vmware
	// END DEBUGGING
	// OracleRacOnSanNewIgroupsOsTypeVmware captures enum value "vmware"
	OracleRacOnSanNewIgroupsOsTypeVmware string = "vmware"

	// BEGIN DEBUGGING
	// oracle_rac_on_san_new_igroups
	// OracleRacOnSanNewIgroups
	// os_type
	// OsType
	// windows
	// END DEBUGGING
	// OracleRacOnSanNewIgroupsOsTypeWindows captures enum value "windows"
	OracleRacOnSanNewIgroupsOsTypeWindows string = "windows"

	// BEGIN DEBUGGING
	// oracle_rac_on_san_new_igroups
	// OracleRacOnSanNewIgroups
	// os_type
	// OsType
	// xen
	// END DEBUGGING
	// OracleRacOnSanNewIgroupsOsTypeXen captures enum value "xen"
	OracleRacOnSanNewIgroupsOsTypeXen string = "xen"
)

// prop value enum
func (m *OracleRacOnSanNewIgroups) validateOsTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, oracleRacOnSanNewIgroupsTypeOsTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *OracleRacOnSanNewIgroups) validateOsType(formats strfmt.Registry) error {
	if swag.IsZero(m.OsType) { // not required
		return nil
	}

	// value enum
	if err := m.validateOsTypeEnum("os_type", "body", m.OsType); err != nil {
		return err
	}

	return nil
}

var oracleRacOnSanNewIgroupsTypeProtocolPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["fcp","iscsi","mixed"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		oracleRacOnSanNewIgroupsTypeProtocolPropEnum = append(oracleRacOnSanNewIgroupsTypeProtocolPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// oracle_rac_on_san_new_igroups
	// OracleRacOnSanNewIgroups
	// protocol
	// Protocol
	// fcp
	// END DEBUGGING
	// OracleRacOnSanNewIgroupsProtocolFcp captures enum value "fcp"
	OracleRacOnSanNewIgroupsProtocolFcp string = "fcp"

	// BEGIN DEBUGGING
	// oracle_rac_on_san_new_igroups
	// OracleRacOnSanNewIgroups
	// protocol
	// Protocol
	// iscsi
	// END DEBUGGING
	// OracleRacOnSanNewIgroupsProtocolIscsi captures enum value "iscsi"
	OracleRacOnSanNewIgroupsProtocolIscsi string = "iscsi"

	// BEGIN DEBUGGING
	// oracle_rac_on_san_new_igroups
	// OracleRacOnSanNewIgroups
	// protocol
	// Protocol
	// mixed
	// END DEBUGGING
	// OracleRacOnSanNewIgroupsProtocolMixed captures enum value "mixed"
	OracleRacOnSanNewIgroupsProtocolMixed string = "mixed"
)

// prop value enum
func (m *OracleRacOnSanNewIgroups) validateProtocolEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, oracleRacOnSanNewIgroupsTypeProtocolPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *OracleRacOnSanNewIgroups) validateProtocol(formats strfmt.Registry) error {
	if swag.IsZero(m.Protocol) { // not required
		return nil
	}

	// value enum
	if err := m.validateProtocolEnum("protocol", "body", *m.Protocol); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this oracle rac on san new igroups based on the context it is used
func (m *OracleRacOnSanNewIgroups) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateIgroups(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateInitiatorObjects(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *OracleRacOnSanNewIgroups) contextValidateIgroups(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Igroups); i++ {

		if m.Igroups[i] != nil {
			if err := m.Igroups[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("igroups" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *OracleRacOnSanNewIgroups) contextValidateInitiatorObjects(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.InitiatorObjects); i++ {

		if m.InitiatorObjects[i] != nil {
			if err := m.InitiatorObjects[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("initiator_objects" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *OracleRacOnSanNewIgroups) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *OracleRacOnSanNewIgroups) UnmarshalBinary(b []byte) error {
	var res OracleRacOnSanNewIgroups
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// OracleRacOnSanNewIgroupsIgroupsItems0 oracle rac on san new igroups igroups items0
//
// swagger:model OracleRacOnSanNewIgroupsIgroupsItems0
type OracleRacOnSanNewIgroupsIgroupsItems0 struct {

	// The name of an igroup to nest within a parent igroup. Mutually exclusive with initiators and initiator_objects.
	Name string `json:"name,omitempty"`

	// The UUID of an igroup to nest within a parent igroup Usage: &lt;UUID&gt;
	UUID string `json:"uuid,omitempty"`
}

// Validate validates this oracle rac on san new igroups igroups items0
func (m *OracleRacOnSanNewIgroupsIgroupsItems0) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this oracle rac on san new igroups igroups items0 based on context it is used
func (m *OracleRacOnSanNewIgroupsIgroupsItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *OracleRacOnSanNewIgroupsIgroupsItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *OracleRacOnSanNewIgroupsIgroupsItems0) UnmarshalBinary(b []byte) error {
	var res OracleRacOnSanNewIgroupsIgroupsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// OracleRacOnSanNewIgroupsInitiatorObjectsItems0 oracle rac on san new igroups initiator objects items0
//
// swagger:model OracleRacOnSanNewIgroupsInitiatorObjectsItems0
type OracleRacOnSanNewIgroupsInitiatorObjectsItems0 struct {

	// A comment available for use by the administrator.
	Comment string `json:"comment,omitempty"`

	// The WWPN, IQN, or Alias of the initiator. Mutually exclusive with nested igroups and the initiators array.
	Name string `json:"name,omitempty"`
}

// Validate validates this oracle rac on san new igroups initiator objects items0
func (m *OracleRacOnSanNewIgroupsInitiatorObjectsItems0) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this oracle rac on san new igroups initiator objects items0 based on context it is used
func (m *OracleRacOnSanNewIgroupsInitiatorObjectsItems0) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *OracleRacOnSanNewIgroupsInitiatorObjectsItems0) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *OracleRacOnSanNewIgroupsInitiatorObjectsItems0) UnmarshalBinary(b []byte) error {
	var res OracleRacOnSanNewIgroupsInitiatorObjectsItems0
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
