// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// ServiceProcessor service processor
//
// swagger:model service_processor
type ServiceProcessor struct {

	// api service
	APIService *ServiceProcessorAPIService `json:"api_service,omitempty"`

	// auto config
	AutoConfig *ServiceProcessorAutoConfig `json:"auto_config,omitempty"`

	// Indicates whether the service processor can be automatically updated from ONTAP.
	AutoupdateEnabled bool `json:"autoupdate_enabled,omitempty"`

	// backup
	Backup *ServiceProcessorBackup `json:"backup,omitempty"`

	// Set to "true" to use DHCP to configure an IPv4 interface. Do not provide values for address, netmask and gateway when set to "true".
	DhcpEnabled bool `json:"dhcp_enabled,omitempty"`

	// The version of firmware installed.
	// Read Only: true
	FirmwareVersion string `json:"firmware_version,omitempty"`

	// ipv4 interface
	IPV4Interface *ServiceProcessorIPV4Interface `json:"ipv4_interface,omitempty"`

	// ipv6 interface
	IPV6Interface *ServiceProcessorIPV6Interface `json:"ipv6_interface,omitempty"`

	// Indicates whether the service processor network is configured.
	// Read Only: true
	IsIPConfigured *bool `json:"is_ip_configured,omitempty"`

	// Provides the "update status" of the last service processor update.
	// Read Only: true
	// Enum: [failed passed]
	LastUpdateState string `json:"last_update_state,omitempty"`

	// link status
	// Read Only: true
	// Enum: [up down disabled unknown]
	LinkStatus string `json:"link_status,omitempty"`

	// mac address
	// Read Only: true
	MacAddress string `json:"mac_address,omitempty"`

	// primary
	Primary *ServiceProcessorPrimary `json:"primary,omitempty"`

	// ssh info
	SSHInfo *ServiceProcessorSSHInfo `json:"ssh_info,omitempty"`

	// state
	// Read Only: true
	// Enum: [online offline degraded rebooting unknown updating node_offline sp_daemon_offline]
	State string `json:"state,omitempty"`

	// type
	// Read Only: true
	// Enum: [sp none bmc]
	Type string `json:"type,omitempty"`
}

// Validate validates this service processor
func (m *ServiceProcessor) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAPIService(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAutoConfig(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateBackup(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIPV4Interface(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIPV6Interface(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLastUpdateState(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateLinkStatus(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePrimary(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSSHInfo(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ServiceProcessor) validateAPIService(formats strfmt.Registry) error {
	if swag.IsZero(m.APIService) { // not required
		return nil
	}

	if m.APIService != nil {
		if err := m.APIService.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("api_service")
			}
			return err
		}
	}

	return nil
}

func (m *ServiceProcessor) validateAutoConfig(formats strfmt.Registry) error {
	if swag.IsZero(m.AutoConfig) { // not required
		return nil
	}

	if m.AutoConfig != nil {
		if err := m.AutoConfig.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("auto_config")
			}
			return err
		}
	}

	return nil
}

func (m *ServiceProcessor) validateBackup(formats strfmt.Registry) error {
	if swag.IsZero(m.Backup) { // not required
		return nil
	}

	if m.Backup != nil {
		if err := m.Backup.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("backup")
			}
			return err
		}
	}

	return nil
}

func (m *ServiceProcessor) validateIPV4Interface(formats strfmt.Registry) error {
	if swag.IsZero(m.IPV4Interface) { // not required
		return nil
	}

	if m.IPV4Interface != nil {
		if err := m.IPV4Interface.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ipv4_interface")
			}
			return err
		}
	}

	return nil
}

func (m *ServiceProcessor) validateIPV6Interface(formats strfmt.Registry) error {
	if swag.IsZero(m.IPV6Interface) { // not required
		return nil
	}

	if m.IPV6Interface != nil {
		if err := m.IPV6Interface.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ipv6_interface")
			}
			return err
		}
	}

	return nil
}

var serviceProcessorTypeLastUpdateStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["failed","passed"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		serviceProcessorTypeLastUpdateStatePropEnum = append(serviceProcessorTypeLastUpdateStatePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// last_update_state
	// LastUpdateState
	// failed
	// END DEBUGGING
	// ServiceProcessorLastUpdateStateFailed captures enum value "failed"
	ServiceProcessorLastUpdateStateFailed string = "failed"

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// last_update_state
	// LastUpdateState
	// passed
	// END DEBUGGING
	// ServiceProcessorLastUpdateStatePassed captures enum value "passed"
	ServiceProcessorLastUpdateStatePassed string = "passed"
)

// prop value enum
func (m *ServiceProcessor) validateLastUpdateStateEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, serviceProcessorTypeLastUpdateStatePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ServiceProcessor) validateLastUpdateState(formats strfmt.Registry) error {
	if swag.IsZero(m.LastUpdateState) { // not required
		return nil
	}

	// value enum
	if err := m.validateLastUpdateStateEnum("last_update_state", "body", m.LastUpdateState); err != nil {
		return err
	}

	return nil
}

var serviceProcessorTypeLinkStatusPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["up","down","disabled","unknown"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		serviceProcessorTypeLinkStatusPropEnum = append(serviceProcessorTypeLinkStatusPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// link_status
	// LinkStatus
	// up
	// END DEBUGGING
	// ServiceProcessorLinkStatusUp captures enum value "up"
	ServiceProcessorLinkStatusUp string = "up"

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// link_status
	// LinkStatus
	// down
	// END DEBUGGING
	// ServiceProcessorLinkStatusDown captures enum value "down"
	ServiceProcessorLinkStatusDown string = "down"

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// link_status
	// LinkStatus
	// disabled
	// END DEBUGGING
	// ServiceProcessorLinkStatusDisabled captures enum value "disabled"
	ServiceProcessorLinkStatusDisabled string = "disabled"

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// link_status
	// LinkStatus
	// unknown
	// END DEBUGGING
	// ServiceProcessorLinkStatusUnknown captures enum value "unknown"
	ServiceProcessorLinkStatusUnknown string = "unknown"
)

// prop value enum
func (m *ServiceProcessor) validateLinkStatusEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, serviceProcessorTypeLinkStatusPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ServiceProcessor) validateLinkStatus(formats strfmt.Registry) error {
	if swag.IsZero(m.LinkStatus) { // not required
		return nil
	}

	// value enum
	if err := m.validateLinkStatusEnum("link_status", "body", m.LinkStatus); err != nil {
		return err
	}

	return nil
}

func (m *ServiceProcessor) validatePrimary(formats strfmt.Registry) error {
	if swag.IsZero(m.Primary) { // not required
		return nil
	}

	if m.Primary != nil {
		if err := m.Primary.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("primary")
			}
			return err
		}
	}

	return nil
}

func (m *ServiceProcessor) validateSSHInfo(formats strfmt.Registry) error {
	if swag.IsZero(m.SSHInfo) { // not required
		return nil
	}

	if m.SSHInfo != nil {
		if err := m.SSHInfo.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ssh_info")
			}
			return err
		}
	}

	return nil
}

var serviceProcessorTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["online","offline","degraded","rebooting","unknown","updating","node_offline","sp_daemon_offline"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		serviceProcessorTypeStatePropEnum = append(serviceProcessorTypeStatePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// state
	// State
	// online
	// END DEBUGGING
	// ServiceProcessorStateOnline captures enum value "online"
	ServiceProcessorStateOnline string = "online"

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// state
	// State
	// offline
	// END DEBUGGING
	// ServiceProcessorStateOffline captures enum value "offline"
	ServiceProcessorStateOffline string = "offline"

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// state
	// State
	// degraded
	// END DEBUGGING
	// ServiceProcessorStateDegraded captures enum value "degraded"
	ServiceProcessorStateDegraded string = "degraded"

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// state
	// State
	// rebooting
	// END DEBUGGING
	// ServiceProcessorStateRebooting captures enum value "rebooting"
	ServiceProcessorStateRebooting string = "rebooting"

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// state
	// State
	// unknown
	// END DEBUGGING
	// ServiceProcessorStateUnknown captures enum value "unknown"
	ServiceProcessorStateUnknown string = "unknown"

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// state
	// State
	// updating
	// END DEBUGGING
	// ServiceProcessorStateUpdating captures enum value "updating"
	ServiceProcessorStateUpdating string = "updating"

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// state
	// State
	// node_offline
	// END DEBUGGING
	// ServiceProcessorStateNodeOffline captures enum value "node_offline"
	ServiceProcessorStateNodeOffline string = "node_offline"

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// state
	// State
	// sp_daemon_offline
	// END DEBUGGING
	// ServiceProcessorStateSpDaemonOffline captures enum value "sp_daemon_offline"
	ServiceProcessorStateSpDaemonOffline string = "sp_daemon_offline"
)

// prop value enum
func (m *ServiceProcessor) validateStateEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, serviceProcessorTypeStatePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ServiceProcessor) validateState(formats strfmt.Registry) error {
	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("state", "body", m.State); err != nil {
		return err
	}

	return nil
}

var serviceProcessorTypeTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["sp","none","bmc"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		serviceProcessorTypeTypePropEnum = append(serviceProcessorTypeTypePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// type
	// Type
	// sp
	// END DEBUGGING
	// ServiceProcessorTypeSp captures enum value "sp"
	ServiceProcessorTypeSp string = "sp"

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// type
	// Type
	// none
	// END DEBUGGING
	// ServiceProcessorTypeNone captures enum value "none"
	ServiceProcessorTypeNone string = "none"

	// BEGIN DEBUGGING
	// service_processor
	// ServiceProcessor
	// type
	// Type
	// bmc
	// END DEBUGGING
	// ServiceProcessorTypeBmc captures enum value "bmc"
	ServiceProcessorTypeBmc string = "bmc"
)

// prop value enum
func (m *ServiceProcessor) validateTypeEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, serviceProcessorTypeTypePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ServiceProcessor) validateType(formats strfmt.Registry) error {
	if swag.IsZero(m.Type) { // not required
		return nil
	}

	// value enum
	if err := m.validateTypeEnum("type", "body", m.Type); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this service processor based on the context it is used
func (m *ServiceProcessor) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateAPIService(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateAutoConfig(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateBackup(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateFirmwareVersion(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateIPV4Interface(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateIPV6Interface(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateIsIPConfigured(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLastUpdateState(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLinkStatus(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateMacAddress(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidatePrimary(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateSSHInfo(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateState(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateType(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ServiceProcessor) contextValidateAPIService(ctx context.Context, formats strfmt.Registry) error {

	if m.APIService != nil {
		if err := m.APIService.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("api_service")
			}
			return err
		}
	}

	return nil
}

func (m *ServiceProcessor) contextValidateAutoConfig(ctx context.Context, formats strfmt.Registry) error {

	if m.AutoConfig != nil {
		if err := m.AutoConfig.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("auto_config")
			}
			return err
		}
	}

	return nil
}

func (m *ServiceProcessor) contextValidateBackup(ctx context.Context, formats strfmt.Registry) error {

	if m.Backup != nil {
		if err := m.Backup.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("backup")
			}
			return err
		}
	}

	return nil
}

func (m *ServiceProcessor) contextValidateFirmwareVersion(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "firmware_version", "body", string(m.FirmwareVersion)); err != nil {
		return err
	}

	return nil
}

func (m *ServiceProcessor) contextValidateIPV4Interface(ctx context.Context, formats strfmt.Registry) error {

	if m.IPV4Interface != nil {
		if err := m.IPV4Interface.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ipv4_interface")
			}
			return err
		}
	}

	return nil
}

func (m *ServiceProcessor) contextValidateIPV6Interface(ctx context.Context, formats strfmt.Registry) error {

	if m.IPV6Interface != nil {
		if err := m.IPV6Interface.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ipv6_interface")
			}
			return err
		}
	}

	return nil
}

func (m *ServiceProcessor) contextValidateIsIPConfigured(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "is_ip_configured", "body", m.IsIPConfigured); err != nil {
		return err
	}

	return nil
}

func (m *ServiceProcessor) contextValidateLastUpdateState(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "last_update_state", "body", string(m.LastUpdateState)); err != nil {
		return err
	}

	return nil
}

func (m *ServiceProcessor) contextValidateLinkStatus(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "link_status", "body", string(m.LinkStatus)); err != nil {
		return err
	}

	return nil
}

func (m *ServiceProcessor) contextValidateMacAddress(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "mac_address", "body", string(m.MacAddress)); err != nil {
		return err
	}

	return nil
}

func (m *ServiceProcessor) contextValidatePrimary(ctx context.Context, formats strfmt.Registry) error {

	if m.Primary != nil {
		if err := m.Primary.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("primary")
			}
			return err
		}
	}

	return nil
}

func (m *ServiceProcessor) contextValidateSSHInfo(ctx context.Context, formats strfmt.Registry) error {

	if m.SSHInfo != nil {
		if err := m.SSHInfo.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ssh_info")
			}
			return err
		}
	}

	return nil
}

func (m *ServiceProcessor) contextValidateState(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "state", "body", string(m.State)); err != nil {
		return err
	}

	return nil
}

func (m *ServiceProcessor) contextValidateType(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "type", "body", string(m.Type)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ServiceProcessor) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ServiceProcessor) UnmarshalBinary(b []byte) error {
	var res ServiceProcessor
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ServiceProcessorAPIService Provides the properties of the service processor API service.
//
// swagger:model ServiceProcessorAPIService
type ServiceProcessorAPIService struct {

	// Indicates whether the service processor API service is enabled.
	// Read Only: true
	Enabled *bool `json:"enabled,omitempty"`

	// Indicates whether the service processor API service limit access is enabled.
	// Read Only: true
	LimitAccess *bool `json:"limit_access,omitempty"`

	// Indicates the port number of service processor API service.
	// Read Only: true
	Port int64 `json:"port,omitempty"`
}

// Validate validates this service processor API service
func (m *ServiceProcessorAPIService) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validate this service processor API service based on the context it is used
func (m *ServiceProcessorAPIService) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateEnabled(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateLimitAccess(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidatePort(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ServiceProcessorAPIService) contextValidateEnabled(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "api_service"+"."+"enabled", "body", m.Enabled); err != nil {
		return err
	}

	return nil
}

func (m *ServiceProcessorAPIService) contextValidateLimitAccess(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "api_service"+"."+"limit_access", "body", m.LimitAccess); err != nil {
		return err
	}

	return nil
}

func (m *ServiceProcessorAPIService) contextValidatePort(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "api_service"+"."+"port", "body", int64(m.Port)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ServiceProcessorAPIService) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ServiceProcessorAPIService) UnmarshalBinary(b []byte) error {
	var res ServiceProcessorAPIService
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ServiceProcessorAutoConfig Provides the properties of the service processor auto configuration.
//
// swagger:model ServiceProcessorAutoConfig
type ServiceProcessorAutoConfig struct {

	// Indicates the service processor auto configuration IPv4 subnet name. To enable IPv4 auto-config give the subnet name, give the value as null or an empty string "" to disable auto-config.
	// Example: ipv4_mgmt
	IPV4Subnet string `json:"ipv4_subnet,omitempty"`

	// Indicates the service processor auto configuration IPv6 subnet name. To enable IPv6 auto-config give the subnet name, give the value as null or an empty string "" to disable auto-config.
	// Example: ipv6_mgmt
	IPV6Subnet string `json:"ipv6_subnet,omitempty"`
}

// Validate validates this service processor auto config
func (m *ServiceProcessorAutoConfig) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validate this service processor auto config based on the context it is used
func (m *ServiceProcessorAutoConfig) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// MarshalBinary interface implementation
func (m *ServiceProcessorAutoConfig) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ServiceProcessorAutoConfig) UnmarshalBinary(b []byte) error {
	var res ServiceProcessorAutoConfig
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ServiceProcessorBackup Provides the properties of the service processor backup partition.
//
// swagger:model ServiceProcessorBackup
type ServiceProcessorBackup struct {

	// Indicates whether the service processor is currently booted from the backup partition.
	// Read Only: true
	IsCurrent *bool `json:"is_current,omitempty"`

	// Status of the backup partition.
	// Read Only: true
	// Enum: [installed corrupt updating auto_updating none]
	State string `json:"state,omitempty"`

	// Firmware version of the backup partition.
	// Example: 11.6
	// Read Only: true
	Version string `json:"version,omitempty"`
}

// Validate validates this service processor backup
func (m *ServiceProcessorBackup) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var serviceProcessorBackupTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["installed","corrupt","updating","auto_updating","none"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		serviceProcessorBackupTypeStatePropEnum = append(serviceProcessorBackupTypeStatePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ServiceProcessorBackup
	// ServiceProcessorBackup
	// state
	// State
	// installed
	// END DEBUGGING
	// ServiceProcessorBackupStateInstalled captures enum value "installed"
	ServiceProcessorBackupStateInstalled string = "installed"

	// BEGIN DEBUGGING
	// ServiceProcessorBackup
	// ServiceProcessorBackup
	// state
	// State
	// corrupt
	// END DEBUGGING
	// ServiceProcessorBackupStateCorrupt captures enum value "corrupt"
	ServiceProcessorBackupStateCorrupt string = "corrupt"

	// BEGIN DEBUGGING
	// ServiceProcessorBackup
	// ServiceProcessorBackup
	// state
	// State
	// updating
	// END DEBUGGING
	// ServiceProcessorBackupStateUpdating captures enum value "updating"
	ServiceProcessorBackupStateUpdating string = "updating"

	// BEGIN DEBUGGING
	// ServiceProcessorBackup
	// ServiceProcessorBackup
	// state
	// State
	// auto_updating
	// END DEBUGGING
	// ServiceProcessorBackupStateAutoUpdating captures enum value "auto_updating"
	ServiceProcessorBackupStateAutoUpdating string = "auto_updating"

	// BEGIN DEBUGGING
	// ServiceProcessorBackup
	// ServiceProcessorBackup
	// state
	// State
	// none
	// END DEBUGGING
	// ServiceProcessorBackupStateNone captures enum value "none"
	ServiceProcessorBackupStateNone string = "none"
)

// prop value enum
func (m *ServiceProcessorBackup) validateStateEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, serviceProcessorBackupTypeStatePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ServiceProcessorBackup) validateState(formats strfmt.Registry) error {
	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("backup"+"."+"state", "body", m.State); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this service processor backup based on the context it is used
func (m *ServiceProcessorBackup) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateIsCurrent(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateState(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateVersion(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ServiceProcessorBackup) contextValidateIsCurrent(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "backup"+"."+"is_current", "body", m.IsCurrent); err != nil {
		return err
	}

	return nil
}

func (m *ServiceProcessorBackup) contextValidateState(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "backup"+"."+"state", "body", string(m.State)); err != nil {
		return err
	}

	return nil
}

func (m *ServiceProcessorBackup) contextValidateVersion(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "backup"+"."+"version", "body", string(m.Version)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ServiceProcessorBackup) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ServiceProcessorBackup) UnmarshalBinary(b []byte) error {
	var res ServiceProcessorBackup
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ServiceProcessorIPV4Interface Object to setup an interface along with its default router.
//
// swagger:model ServiceProcessorIPV4Interface
type ServiceProcessorIPV4Interface struct {

	// IPv4 or IPv6 address
	// Example: 10.10.10.7
	Address string `json:"address,omitempty"`

	// The IPv4 or IPv6 address of the default router.
	// Example: 10.1.1.1
	Gateway string `json:"gateway,omitempty"`

	// netmask
	Netmask IPNetmask `json:"netmask,omitempty"`
}

// Validate validates this service processor IP v4 interface
func (m *ServiceProcessorIPV4Interface) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateNetmask(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ServiceProcessorIPV4Interface) validateNetmask(formats strfmt.Registry) error {
	if swag.IsZero(m.Netmask) { // not required
		return nil
	}

	if err := m.Netmask.Validate(formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("ipv4_interface" + "." + "netmask")
		}
		return err
	}

	return nil
}

// ContextValidate validate this service processor IP v4 interface based on the context it is used
func (m *ServiceProcessorIPV4Interface) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateNetmask(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ServiceProcessorIPV4Interface) contextValidateNetmask(ctx context.Context, formats strfmt.Registry) error {

	if err := m.Netmask.ContextValidate(ctx, formats); err != nil {
		if ve, ok := err.(*errors.Validation); ok {
			return ve.ValidateName("ipv4_interface" + "." + "netmask")
		}
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ServiceProcessorIPV4Interface) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ServiceProcessorIPV4Interface) UnmarshalBinary(b []byte) error {
	var res ServiceProcessorIPV4Interface
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ServiceProcessorIPV6Interface Object to setup an interface along with its default router.
//
// swagger:model ServiceProcessorIPV6Interface
type ServiceProcessorIPV6Interface struct {

	// IPv6 address
	// Example: fd20:8b1e:b255:5011:10:141:4:97
	Address string `json:"address,omitempty"`

	// The IPv6 address of the default router.
	// Example: fd20:8b1e:b255:5011:10::1
	Gateway string `json:"gateway,omitempty"`

	// The IPv6 netmask/prefix length. The default value is 64 with a valid range of 1 to 127.
	// Example: 64
	Netmask int64 `json:"netmask,omitempty"`
}

// Validate validates this service processor IP v6 interface
func (m *ServiceProcessorIPV6Interface) Validate(formats strfmt.Registry) error {
	return nil
}

// ContextValidate validates this service processor IP v6 interface based on context it is used
func (m *ServiceProcessorIPV6Interface) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *ServiceProcessorIPV6Interface) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ServiceProcessorIPV6Interface) UnmarshalBinary(b []byte) error {
	var res ServiceProcessorIPV6Interface
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ServiceProcessorPrimary Provides the properties of the service processor primary partition.
//
// swagger:model ServiceProcessorPrimary
type ServiceProcessorPrimary struct {

	// Indicates whether the service processor is currently booted from the primary partition.
	// Read Only: true
	IsCurrent *bool `json:"is_current,omitempty"`

	// Status of the primary partition.
	// Read Only: true
	// Enum: [installed corrupt updating auto_updating none]
	State string `json:"state,omitempty"`

	// Firmware version of the primary partition.
	// Example: 11.6
	// Read Only: true
	Version string `json:"version,omitempty"`
}

// Validate validates this service processor primary
func (m *ServiceProcessorPrimary) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateState(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var serviceProcessorPrimaryTypeStatePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["installed","corrupt","updating","auto_updating","none"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		serviceProcessorPrimaryTypeStatePropEnum = append(serviceProcessorPrimaryTypeStatePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// ServiceProcessorPrimary
	// ServiceProcessorPrimary
	// state
	// State
	// installed
	// END DEBUGGING
	// ServiceProcessorPrimaryStateInstalled captures enum value "installed"
	ServiceProcessorPrimaryStateInstalled string = "installed"

	// BEGIN DEBUGGING
	// ServiceProcessorPrimary
	// ServiceProcessorPrimary
	// state
	// State
	// corrupt
	// END DEBUGGING
	// ServiceProcessorPrimaryStateCorrupt captures enum value "corrupt"
	ServiceProcessorPrimaryStateCorrupt string = "corrupt"

	// BEGIN DEBUGGING
	// ServiceProcessorPrimary
	// ServiceProcessorPrimary
	// state
	// State
	// updating
	// END DEBUGGING
	// ServiceProcessorPrimaryStateUpdating captures enum value "updating"
	ServiceProcessorPrimaryStateUpdating string = "updating"

	// BEGIN DEBUGGING
	// ServiceProcessorPrimary
	// ServiceProcessorPrimary
	// state
	// State
	// auto_updating
	// END DEBUGGING
	// ServiceProcessorPrimaryStateAutoUpdating captures enum value "auto_updating"
	ServiceProcessorPrimaryStateAutoUpdating string = "auto_updating"

	// BEGIN DEBUGGING
	// ServiceProcessorPrimary
	// ServiceProcessorPrimary
	// state
	// State
	// none
	// END DEBUGGING
	// ServiceProcessorPrimaryStateNone captures enum value "none"
	ServiceProcessorPrimaryStateNone string = "none"
)

// prop value enum
func (m *ServiceProcessorPrimary) validateStateEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, serviceProcessorPrimaryTypeStatePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ServiceProcessorPrimary) validateState(formats strfmt.Registry) error {
	if swag.IsZero(m.State) { // not required
		return nil
	}

	// value enum
	if err := m.validateStateEnum("primary"+"."+"state", "body", m.State); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this service processor primary based on the context it is used
func (m *ServiceProcessorPrimary) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateIsCurrent(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateState(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateVersion(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ServiceProcessorPrimary) contextValidateIsCurrent(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "primary"+"."+"is_current", "body", m.IsCurrent); err != nil {
		return err
	}

	return nil
}

func (m *ServiceProcessorPrimary) contextValidateState(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "primary"+"."+"state", "body", string(m.State)); err != nil {
		return err
	}

	return nil
}

func (m *ServiceProcessorPrimary) contextValidateVersion(ctx context.Context, formats strfmt.Registry) error {

	if err := validate.ReadOnly(ctx, "primary"+"."+"version", "body", string(m.Version)); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ServiceProcessorPrimary) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ServiceProcessorPrimary) UnmarshalBinary(b []byte) error {
	var res ServiceProcessorPrimary
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// ServiceProcessorSSHInfo Service processor SSH allowed IP address configuration applied across the cluster.
//
// swagger:model ServiceProcessorSSHInfo
type ServiceProcessorSSHInfo struct {

	// Allowed IP addresses
	AllowedAddresses []IPAddressAndNetmask `json:"allowed_addresses,omitempty"`
}

// Validate validates this service processor SSH info
func (m *ServiceProcessorSSHInfo) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateAllowedAddresses(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ServiceProcessorSSHInfo) validateAllowedAddresses(formats strfmt.Registry) error {
	if swag.IsZero(m.AllowedAddresses) { // not required
		return nil
	}

	for i := 0; i < len(m.AllowedAddresses); i++ {

		if err := m.AllowedAddresses[i].Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ssh_info" + "." + "allowed_addresses" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

// ContextValidate validate this service processor SSH info based on the context it is used
func (m *ServiceProcessorSSHInfo) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateAllowedAddresses(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ServiceProcessorSSHInfo) contextValidateAllowedAddresses(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.AllowedAddresses); i++ {

		if err := m.AllowedAddresses[i].ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("ssh_info" + "." + "allowed_addresses" + "." + strconv.Itoa(i))
			}
			return err
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *ServiceProcessorSSHInfo) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ServiceProcessorSSHInfo) UnmarshalBinary(b []byte) error {
	var res ServiceProcessorSSHInfo
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
