// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// VdiOnNas A VDI application using NAS.
//
// swagger:model vdi_on_nas
type VdiOnNas struct {

	// desktops
	// Required: true
	Desktops *VdiOnNasDesktops `json:"desktops"`

	// hyper v access
	HypervAccess *VdiOnNasHypervAccess `json:"hyper_v_access,omitempty"`

	// The list of NFS access controls. You must provide either 'host' or 'access' to enable NFS access.
	NfsAccess []*AppNfsAccess `json:"nfs_access,omitempty"`

	// protection type
	ProtectionType *VdiOnNasProtectionType `json:"protection_type,omitempty"`
}

// Validate validates this vdi on nas
func (m *VdiOnNas) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateDesktops(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateHypervAccess(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateNfsAccess(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateProtectionType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VdiOnNas) validateDesktops(formats strfmt.Registry) error {

	if err := validate.Required("desktops", "body", m.Desktops); err != nil {
		return err
	}

	if m.Desktops != nil {
		if err := m.Desktops.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("desktops")
			}
			return err
		}
	}

	return nil
}

func (m *VdiOnNas) validateHypervAccess(formats strfmt.Registry) error {
	if swag.IsZero(m.HypervAccess) { // not required
		return nil
	}

	if m.HypervAccess != nil {
		if err := m.HypervAccess.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("hyper_v_access")
			}
			return err
		}
	}

	return nil
}

func (m *VdiOnNas) validateNfsAccess(formats strfmt.Registry) error {
	if swag.IsZero(m.NfsAccess) { // not required
		return nil
	}

	for i := 0; i < len(m.NfsAccess); i++ {
		if swag.IsZero(m.NfsAccess[i]) { // not required
			continue
		}

		if m.NfsAccess[i] != nil {
			if err := m.NfsAccess[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("nfs_access" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *VdiOnNas) validateProtectionType(formats strfmt.Registry) error {
	if swag.IsZero(m.ProtectionType) { // not required
		return nil
	}

	if m.ProtectionType != nil {
		if err := m.ProtectionType.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("protection_type")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this vdi on nas based on the context it is used
func (m *VdiOnNas) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateDesktops(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateHypervAccess(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateNfsAccess(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateProtectionType(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VdiOnNas) contextValidateDesktops(ctx context.Context, formats strfmt.Registry) error {

	if m.Desktops != nil {
		if err := m.Desktops.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("desktops")
			}
			return err
		}
	}

	return nil
}

func (m *VdiOnNas) contextValidateHypervAccess(ctx context.Context, formats strfmt.Registry) error {

	if m.HypervAccess != nil {
		if err := m.HypervAccess.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("hyper_v_access")
			}
			return err
		}
	}

	return nil
}

func (m *VdiOnNas) contextValidateNfsAccess(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.NfsAccess); i++ {

		if m.NfsAccess[i] != nil {
			if err := m.NfsAccess[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("nfs_access" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

func (m *VdiOnNas) contextValidateProtectionType(ctx context.Context, formats strfmt.Registry) error {

	if m.ProtectionType != nil {
		if err := m.ProtectionType.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("protection_type")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VdiOnNas) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VdiOnNas) UnmarshalBinary(b []byte) error {
	var res VdiOnNas
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VdiOnNasDesktops vdi on nas desktops
//
// swagger:model VdiOnNasDesktops
type VdiOnNasDesktops struct {

	// The number of desktops to support.
	// Maximum: 8000
	// Minimum: 1
	Count int64 `json:"count,omitempty"`

	// The size of the desktops. Usage: {&lt;integer&gt;[KB|MB|GB|TB|PB]}
	// Required: true
	Size *int64 `json:"size"`

	// storage service
	StorageService *VdiOnNasDesktopsStorageService `json:"storage_service,omitempty"`
}

// Validate validates this vdi on nas desktops
func (m *VdiOnNasDesktops) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateCount(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSize(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateStorageService(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VdiOnNasDesktops) validateCount(formats strfmt.Registry) error {
	if swag.IsZero(m.Count) { // not required
		return nil
	}

	if err := validate.MinimumInt("desktops"+"."+"count", "body", m.Count, 1, false); err != nil {
		return err
	}

	if err := validate.MaximumInt("desktops"+"."+"count", "body", m.Count, 8000, false); err != nil {
		return err
	}

	return nil
}

func (m *VdiOnNasDesktops) validateSize(formats strfmt.Registry) error {

	if err := validate.Required("desktops"+"."+"size", "body", m.Size); err != nil {
		return err
	}

	return nil
}

func (m *VdiOnNasDesktops) validateStorageService(formats strfmt.Registry) error {
	if swag.IsZero(m.StorageService) { // not required
		return nil
	}

	if m.StorageService != nil {
		if err := m.StorageService.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("desktops" + "." + "storage_service")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this vdi on nas desktops based on the context it is used
func (m *VdiOnNasDesktops) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateStorageService(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VdiOnNasDesktops) contextValidateStorageService(ctx context.Context, formats strfmt.Registry) error {

	if m.StorageService != nil {
		if err := m.StorageService.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("desktops" + "." + "storage_service")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *VdiOnNasDesktops) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VdiOnNasDesktops) UnmarshalBinary(b []byte) error {
	var res VdiOnNasDesktops
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VdiOnNasDesktopsStorageService vdi on nas desktops storage service
//
// swagger:model VdiOnNasDesktopsStorageService
type VdiOnNasDesktopsStorageService struct {

	// The storage service of the desktops.
	// Enum: [extreme performance value]
	Name *string `json:"name,omitempty"`
}

// Validate validates this vdi on nas desktops storage service
func (m *VdiOnNasDesktopsStorageService) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var vdiOnNasDesktopsStorageServiceTypeNamePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["extreme","performance","value"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		vdiOnNasDesktopsStorageServiceTypeNamePropEnum = append(vdiOnNasDesktopsStorageServiceTypeNamePropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// VdiOnNasDesktopsStorageService
	// VdiOnNasDesktopsStorageService
	// name
	// Name
	// extreme
	// END DEBUGGING
	// VdiOnNasDesktopsStorageServiceNameExtreme captures enum value "extreme"
	VdiOnNasDesktopsStorageServiceNameExtreme string = "extreme"

	// BEGIN DEBUGGING
	// VdiOnNasDesktopsStorageService
	// VdiOnNasDesktopsStorageService
	// name
	// Name
	// performance
	// END DEBUGGING
	// VdiOnNasDesktopsStorageServiceNamePerformance captures enum value "performance"
	VdiOnNasDesktopsStorageServiceNamePerformance string = "performance"

	// BEGIN DEBUGGING
	// VdiOnNasDesktopsStorageService
	// VdiOnNasDesktopsStorageService
	// name
	// Name
	// value
	// END DEBUGGING
	// VdiOnNasDesktopsStorageServiceNameValue captures enum value "value"
	VdiOnNasDesktopsStorageServiceNameValue string = "value"
)

// prop value enum
func (m *VdiOnNasDesktopsStorageService) validateNameEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, vdiOnNasDesktopsStorageServiceTypeNamePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *VdiOnNasDesktopsStorageService) validateName(formats strfmt.Registry) error {
	if swag.IsZero(m.Name) { // not required
		return nil
	}

	// value enum
	if err := m.validateNameEnum("desktops"+"."+"storage_service"+"."+"name", "body", *m.Name); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this vdi on nas desktops storage service based on context it is used
func (m *VdiOnNasDesktopsStorageService) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VdiOnNasDesktopsStorageService) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VdiOnNasDesktopsStorageService) UnmarshalBinary(b []byte) error {
	var res VdiOnNasDesktopsStorageService
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VdiOnNasHypervAccess vdi on nas hyperv access
//
// swagger:model VdiOnNasHypervAccess
type VdiOnNasHypervAccess struct {

	// Hyper-V service account.
	// Max Length: 256
	// Min Length: 1
	ServiceAccount string `json:"service_account,omitempty"`
}

// Validate validates this vdi on nas hyperv access
func (m *VdiOnNasHypervAccess) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateServiceAccount(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *VdiOnNasHypervAccess) validateServiceAccount(formats strfmt.Registry) error {
	if swag.IsZero(m.ServiceAccount) { // not required
		return nil
	}

	if err := validate.MinLength("hyper_v_access"+"."+"service_account", "body", m.ServiceAccount, 1); err != nil {
		return err
	}

	if err := validate.MaxLength("hyper_v_access"+"."+"service_account", "body", m.ServiceAccount, 256); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this vdi on nas hyperv access based on context it is used
func (m *VdiOnNasHypervAccess) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VdiOnNasHypervAccess) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VdiOnNasHypervAccess) UnmarshalBinary(b []byte) error {
	var res VdiOnNasHypervAccess
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}

// VdiOnNasProtectionType vdi on nas protection type
//
// swagger:model VdiOnNasProtectionType
type VdiOnNasProtectionType struct {

	// The local RPO of the application.
	// Enum: [hourly none]
	LocalRpo string `json:"local_rpo,omitempty"`

	// The remote RPO of the application.
	// Enum: [none zero]
	RemoteRpo string `json:"remote_rpo,omitempty"`
}

// Validate validates this vdi on nas protection type
func (m *VdiOnNasProtectionType) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLocalRpo(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateRemoteRpo(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var vdiOnNasProtectionTypeTypeLocalRpoPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["hourly","none"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		vdiOnNasProtectionTypeTypeLocalRpoPropEnum = append(vdiOnNasProtectionTypeTypeLocalRpoPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// VdiOnNasProtectionType
	// VdiOnNasProtectionType
	// local_rpo
	// LocalRpo
	// hourly
	// END DEBUGGING
	// VdiOnNasProtectionTypeLocalRpoHourly captures enum value "hourly"
	VdiOnNasProtectionTypeLocalRpoHourly string = "hourly"

	// BEGIN DEBUGGING
	// VdiOnNasProtectionType
	// VdiOnNasProtectionType
	// local_rpo
	// LocalRpo
	// none
	// END DEBUGGING
	// VdiOnNasProtectionTypeLocalRpoNone captures enum value "none"
	VdiOnNasProtectionTypeLocalRpoNone string = "none"
)

// prop value enum
func (m *VdiOnNasProtectionType) validateLocalRpoEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, vdiOnNasProtectionTypeTypeLocalRpoPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *VdiOnNasProtectionType) validateLocalRpo(formats strfmt.Registry) error {
	if swag.IsZero(m.LocalRpo) { // not required
		return nil
	}

	// value enum
	if err := m.validateLocalRpoEnum("protection_type"+"."+"local_rpo", "body", m.LocalRpo); err != nil {
		return err
	}

	return nil
}

var vdiOnNasProtectionTypeTypeRemoteRpoPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["none","zero"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		vdiOnNasProtectionTypeTypeRemoteRpoPropEnum = append(vdiOnNasProtectionTypeTypeRemoteRpoPropEnum, v)
	}
}

const (

	// BEGIN DEBUGGING
	// VdiOnNasProtectionType
	// VdiOnNasProtectionType
	// remote_rpo
	// RemoteRpo
	// none
	// END DEBUGGING
	// VdiOnNasProtectionTypeRemoteRpoNone captures enum value "none"
	VdiOnNasProtectionTypeRemoteRpoNone string = "none"

	// BEGIN DEBUGGING
	// VdiOnNasProtectionType
	// VdiOnNasProtectionType
	// remote_rpo
	// RemoteRpo
	// zero
	// END DEBUGGING
	// VdiOnNasProtectionTypeRemoteRpoZero captures enum value "zero"
	VdiOnNasProtectionTypeRemoteRpoZero string = "zero"
)

// prop value enum
func (m *VdiOnNasProtectionType) validateRemoteRpoEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, vdiOnNasProtectionTypeTypeRemoteRpoPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *VdiOnNasProtectionType) validateRemoteRpo(formats strfmt.Registry) error {
	if swag.IsZero(m.RemoteRpo) { // not required
		return nil
	}

	// value enum
	if err := m.validateRemoteRpoEnum("protection_type"+"."+"remote_rpo", "body", m.RemoteRpo); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this vdi on nas protection type based on context it is used
func (m *VdiOnNasProtectionType) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *VdiOnNasProtectionType) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *VdiOnNasProtectionType) UnmarshalBinary(b []byte) error {
	var res VdiOnNasProtectionType
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
